<?php
 namespace App\Backup; use App\System\CommandExecutor; use App\System\Command\ChownCommand; use App\System\Command\FindChmodCommand; use App\System\Command\CreateDirectoryCommand; use App\System\Command\DeleteDirectoryCommand; use App\System\Command\WriteFileCommand; use App\System\Command\DeleteFileCommand; use App\System\Command\RcloneCopyCommand; use App\System\Command\RcloneLsJsonCommand; use App\System\Command\RclonePurgeCommand; class Rclone { private const FREQUENCY_DAILY = "\144\x61\x69\x6c\x79"; private const CONFIG_DIRECTORY = "\57\x72\x6f\157\x74\x2f\56\x63\157\x6e\146\151\x67\57\162\x63\x6c\x6f\156\x65\57"; private const CLP_USER_CONFIG_DIRECTORY = "\57\x68\157\x6d\145\x2f\143\154\x70\57\56\143\x6f\156\146\151\147\x2f"; private const CLP_USER = "\x63\x6c\x70"; public const CREDENTIALS_DIRECTORY = "\x2f\x68\157\x6d\x65\57\x63\154\x70\57\56\x63\x6f\x6e\x66\151\x67\57\x72\143\154\157\x6e\145\57\143\162\145\144\x65\x6e\164\x69\141\x6c\163\57"; private const CONFIG_FILE = "\x2f\x72\x6f\157\x74\57\56\143\x6f\x6e\146\x69\147\57\162\143\154\x6f\156\145\x2f\162\143\x6c\x6f\x6e\145\56\x63\x6f\x6e\146"; private const CRON_JOB_FILE = "\x2f\145\x74\143\57\x63\162\x6f\156\56\x64\57\x63\154\x70\55\x72\143\154\157\x6e\145"; private CommandExecutor $commandExecutor; private ?string $configFile = null; private array $flags = []; public function __construct() { $this->commandExecutor = new CommandExecutor(); } public function setConfigFile(string $configFile) : void { $this->configFile = $configFile; } public function getConfigFile() : ?string { goto D1ede; c068a: return $this->configFile; goto Fd427; D1ede: if (!(true === is_null($this->configFile))) { goto c122e; } goto F768b; a9f31: c122e: goto c068a; F768b: $this->configFile = self::CONFIG_FILE; goto a9f31; Fd427: } public function addFlag(string $flag, string $value) { $this->flags[] = ["\x66\154\141\x67" => $flag, "\x76\141\154\x75\145" => $value]; } public function getFlags() : array { return $this->flags; } public function copy(string $source, string $destination) : void { goto F5633; eb81e: $rcloneCopyCommand->setSource($source); goto dc7c1; dc7c1: $rcloneCopyCommand->setDestination($destination); goto Bed65; Ba97d: $this->commandExecutor->execute($rcloneCopyCommand, 21600); goto fb4a2; D0adf: $rcloneCopyCommand = new RcloneCopyCommand(); goto c283e; F5633: $flags = $this->getFlags(); goto C933b; C933b: $configFile = $this->getConfigFile(); goto D0adf; c283e: $rcloneCopyCommand->setConfigFile($configFile); goto eb81e; Bed65: $this->addFlagsToCommand($flags, $rcloneCopyCommand); goto Ba97d; fb4a2: } public function lsJson(?string $remotePath = null, $directoriesOnly = false) : array { goto c30ce; c30ce: $flags = $this->getFlags(); goto C92cd; B28cd: $rcloneLsJsonCommand->setDirectoriesOnly(true); goto C4261; b4b91: if (!(true === $directoriesOnly)) { goto Cf82e; } goto B28cd; C92cd: $configFile = $this->getConfigFile(); goto c0173; aaf21: $rcloneLsJsonCommand->setRemotePath($remotePath); goto b4b91; C4261: Cf82e: goto c5ec8; c5ec8: $this->addFlagsToCommand($flags, $rcloneLsJsonCommand); goto c1f29; c1f29: $this->commandExecutor->execute($rcloneLsJsonCommand, 20); goto e608a; eabaa: return $files; goto E688a; c0173: $rcloneLsJsonCommand = new RcloneLsJsonCommand(); goto F15c3; F15c3: $rcloneLsJsonCommand->setConfigFile($configFile); goto aaf21; e608a: $files = $rcloneLsJsonCommand->getFiles(); goto eabaa; E688a: } public function purge(string $remotePath) { goto C328c; A31f4: $this->addFlagsToCommand($flags, $rclonePurgeCommand); goto cdf71; d549e: $rclonePurgeCommand = new RclonePurgeCommand(); goto Ba66a; C328c: $flags = $this->getFlags(); goto d549e; cdf71: $this->commandExecutor->execute($rclonePurgeCommand, 21600); goto ec2b9; Ba66a: $rclonePurgeCommand->setRemotePath($remotePath); goto A31f4; ec2b9: } public function writeConfig(string $config) : void { goto B93af; aa6c8: $createConfigDirectoryCommand->setDirectory(self::CONFIG_DIRECTORY); goto D3039; B93af: $configFile = $this->getConfigFile(); goto fd0dc; a2521: $this->commandExecutor->execute($createConfigDirectoryCommand); goto c8f44; D3039: $writeConfigFileCommand = new WriteFileCommand(); goto F44e8; c8f44: $this->commandExecutor->execute($writeConfigFileCommand); goto A42b2; e2b38: $writeConfigFileCommand->setContent($config); goto a2521; fd0dc: $createConfigDirectoryCommand = new CreateDirectoryCommand(); goto aa6c8; F44e8: $writeConfigFileCommand->setFile($configFile); goto e2b38; A42b2: } public function writeCredentialsFile(string $file, string $content) : void { goto fbe1d; Cbefb: $chownConfigDirectoryCommand->setRecursive(true); goto eed57; bdc6b: $chownConfigDirectoryCommand->setGroup(self::CLP_USER); goto B59ea; Eb7ca: $chownConfigDirectoryCommand->setFile(self::CLP_USER_CONFIG_DIRECTORY); goto Cbefb; C1525: $chownConfigDirectoryCommand = new ChownCommand(); goto Eb7ca; be1c3: $chmodConfigDirectoryCommand->setFile(self::CLP_USER_CONFIG_DIRECTORY); goto Df59d; Df59d: $chmodConfigDirectoryCommand->setDirectoryChmod(770); goto Dd007; F4e0f: $credentialsDirectoryCommand->setDirectory(self::CREDENTIALS_DIRECTORY); goto C1525; A2b48: $this->commandExecutor->execute($credentialsDirectoryCommand); goto a6d10; da19e: $this->commandExecutor->execute($chmodConfigDirectoryCommand); goto d71ba; eed57: $chownConfigDirectoryCommand->setUser(self::CLP_USER); goto bdc6b; d71ba: file_put_contents($file, $content); goto F1958; Dd007: $chmodConfigDirectoryCommand->setFileChmod(770); goto A2b48; a6d10: $this->commandExecutor->execute($chownConfigDirectoryCommand); goto da19e; B59ea: $chmodConfigDirectoryCommand = new FindChmodCommand(); goto be1c3; fbe1d: $credentialsDirectoryCommand = new CreateDirectoryCommand(); goto F4e0f; F1958: } public function createCronJob(string $frequency, string $executionTime = null) : void { goto C4537; Ae039: db24e: goto f290c; Dd4f6: if (self::FREQUENCY_DAILY == $frequency) { goto db24e; } goto Bedb4; d54d9: $writeCronJobFileCommand = new WriteFileCommand(); goto b62dd; Bedb4: $cronJobContent .= sprintf("\x30\x20\x2a\57\x25\x73\x20\x2a\x20\x2a\x20\x2a\40\x63\154\160\x20\57\165\x73\162\x2f\142\x69\156\x2f\x62\141\x73\150\x20\x2d\143\x20\42\x2f\x75\x73\162\x2f\x62\151\x6e\x2f\x63\154\160\143\x74\154\40\x72\x65\x6d\157\164\145\x2d\142\141\x63\x6b\x75\x70\72\143\x72\145\x61\x74\145\x20\x2d\55\x64\x65\154\x61\171\x3d\x74\x72\x75\x65\42\40\x26\76\x20\x2f\x64\x65\x76\x2f\156\165\x6c\x6c", $frequency); goto b620a; b62dd: $writeCronJobFileCommand->setFile(self::CRON_JOB_FILE); goto d3aea; a076e: $this->commandExecutor->execute($writeCronJobFileCommand); goto D20ec; b620a: goto E78d3; goto Ae039; d3aea: $writeCronJobFileCommand->setContent($cronJobContent); goto a076e; C4537: $cronJobContent = sprintf("\x4d\101\111\114\124\x4f\x3d\42\x22\x25\x73", PHP_EOL); goto Dd4f6; f290c: $cronJobContent .= sprintf("\60\40\45\163\x20\x2a\x20\x2a\x20\52\40\143\154\160\x20\57\x75\x73\162\x2f\x62\151\x6e\x2f\142\x61\163\x68\x20\x2d\143\x20\x22\57\x75\163\162\x2f\x62\x69\156\57\143\x6c\160\143\164\154\40\x72\145\x6d\157\x74\x65\x2d\x62\x61\143\x6b\165\x70\72\x63\162\145\x61\164\x65\40\55\55\x64\145\154\x61\171\75\164\x72\x75\145\42\x20\46\76\40\x2f\144\x65\166\57\156\165\154\x6c", $executionTime); goto fbc60; fbc60: E78d3: goto d54d9; D20ec: } private function addFlagsToCommand(array $flags, $command) : void { goto Ec7b0; d2ce7: B53c3: goto Ae1b0; Ec7b0: if (!(false === empty($flags))) { goto a752e; } goto ad3ce; ad3ce: foreach ($flags as $flagData) { $command->addFlag($flagData["\x66\x6c\x61\x67"], $flagData["\x76\x61\x6c\165\x65"]); D8162: } goto d2ce7; Ae1b0: a752e: goto a0be1; a0be1: } public function deleteCronJob() : void { goto dad08; dad08: $deleteCronJobFileCommand = new DeleteFileCommand(); goto c2285; c2285: $deleteCronJobFileCommand->setFile(self::CRON_JOB_FILE); goto Df8e0; Df8e0: $this->commandExecutor->execute($deleteCronJobFileCommand); goto eb566; eb566: } public function deleteCredentials() : void { goto e0fc9; A32d0: $deleteCredentialsDirectoryCommand->setDirectory(self::CREDENTIALS_DIRECTORY); goto e63d4; e63d4: $this->commandExecutor->execute($deleteCredentialsDirectoryCommand); goto Edbf1; e0fc9: $deleteCredentialsDirectoryCommand = new DeleteDirectoryCommand(); goto A32d0; Edbf1: } }
