<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\Validator\ValidatorInterface; use App\Command\Command as BaseCommand; use App\Entity\Database as DatabaseEntity; use App\System\CommandExecutor; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\System\Command\DeleteOldFilesRecursiveCommand; use App\System\Command\FindChmodCommand; use App\System\Command\ChownCommand; use App\Database\Exporter as DatabaseExporter; class DatabaseBackupCommand extends BaseCommand { private const RETENTION_PERIOD = 7; private SiteEntityManager $siteEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private CommandExecutor $commandExecutor; private ValidatorInterface $validator; private int $retentionPeriod = 0; public function __construct(SiteEntityManager $siteEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, ValidatorInterface $validator) { goto B8e18; Ceb3f: $this->databaseServerEntityManager = $databaseServerEntityManager; goto ab716; B8e18: $this->siteEntityManager = $siteEntityManager; goto C93f6; C0398: $this->validator = $validator; goto E6fbc; E6fbc: parent::__construct(); goto b360a; ab716: $this->commandExecutor = new CommandExecutor(); goto C0398; C93f6: $this->databaseEntityManager = $databaseEntityManager; goto Ceb3f; b360a: } protected function configure() : void { goto cbfa7; d4e88: $this->setDescription("\x63\x6c\160\143\164\154\x20\144\x62\x3a\x62\141\x63\153\165\x70\40\55\x2d\x69\147\x6e\157\x72\x65\104\141\164\141\142\141\163\x65\163\75\47\x64\142\x31\54\x64\x62\62\47\40\55\55\162\145\x74\145\156\164\151\157\156\x50\x65\x72\151\x6f\144\x3d\x37"); goto D2c31; b2b63: $this->addOption("\x72\145\164\x65\x6e\x74\x69\x6f\156\120\x65\162\151\157\144", null, InputOption::VALUE_OPTIONAL, '', self::RETENTION_PERIOD); goto a6411; cbfa7: $this->setName("\144\142\x3a\x62\x61\143\x6b\x75\x70"); goto d4e88; D2c31: $this->addOption("\151\147\x6e\x6f\162\145\104\x61\164\141\x62\141\x73\145\163", null, InputOption::VALUE_OPTIONAL); goto b2b63; a6411: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto c0d9d; b6ce3: $siteEntities = $this->siteEntityManager->findAll(); goto d6a04; C603d: return BaseCommand::SUCCESS; goto Ee0d5; c2c61: cf5a1: goto Cdee1; d6a04: if (!count($siteEntities)) { goto bd137; } goto Addcc; Cdee1: bd137: goto C603d; Addcc: foreach ($siteEntities as $siteEntity) { goto cef85; c2191: ccf4b: goto F389a; cef85: $databaseEntities = $siteEntity->getDatabases(); goto a301c; C3b54: Ef3e2: goto f61cf; F389a: B29e5: goto C3b54; a301c: if (!count($databaseEntities)) { goto B29e5; } goto C4435; C4435: foreach ($databaseEntities as $databaseEntity) { goto C2e16; C2e16: $databaseName = $databaseEntity->getName(); goto e7146; E31a2: A3f3f: goto ddc8d; e7146: if (!(false === in_array($databaseName, $ignoredDatabases))) { goto fc57f; } goto d440d; d440d: $this->createDatabaseDump($databaseEntity); goto e88e9; e88e9: fc57f: goto E31a2; ddc8d: } goto c2191; f61cf: } goto c2c61; A52e4: $ignoredDatabases = explode("\54", $input->getOption("\151\x67\156\x6f\162\x65\x44\x61\x74\141\x62\141\163\145\x73")); goto f4c91; f4c91: $this->retentionPeriod = (int) $input->getOption("\162\x65\x74\145\156\x74\x69\x6f\156\120\145\162\151\157\x64"); goto b6ce3; c0d9d: $this->validateInput($input); goto A52e4; Ee0d5: } catch (\Exception $e) { goto D27e4; D27e4: $errorMessage = $e->getMessage(); goto bf9e9; A0cd7: return BaseCommand::FAILURE; goto b2bfa; bf9e9: $output->writeln(sprintf("\x3c\x65\x72\x72\x6f\x72\76\45\163\74\x2f\145\162\162\157\162\76", $errorMessage)); goto A0cd7; b2bfa: } } private function createDatabaseDump(DatabaseEntity $databaseEntity) : void { try { goto Eb5ec; Faa82: $outputFile = sprintf("\x25\163\57\45\163", rtrim($outputDirectory, "\57"), sprintf("\x25\x73\x5f\x25\x73\56\x73\161\x6c\56\147\x7a", $databaseName, $dateTime->getTimestamp())); goto ceff4; E0d34: $this->resetPermissions($databaseEntity); goto Cb146; B6d75: $databaseName = $databaseEntity->getName(); goto b276a; C5d34: $databaseExporter->export(); goto E0d34; Cb146: $this->cleanUpBackups($databaseEntity); goto C3924; Eb5ec: $dateTime = new \DateTime("\x6e\157\167", new \DateTimeZone("\125\x54\103")); goto C3bdc; D330e: $databaseExporter->setFile($outputFile); goto D94ba; B0d14: $siteUser = $siteEntity->getUser(); goto B6d75; ceff4: $databaseExporter = new DatabaseExporter($databaseEntity); goto D330e; b276a: $backupDirectory = sprintf("\x2f\150\x6f\155\145\57\x25\163\57\x62\x61\143\x6b\165\x70\x73\57\144\141\x74\141\142\141\x73\145\163\57", $siteUser); goto c503b; C3bdc: $siteEntity = $databaseEntity->getSite(); goto B0d14; c503b: $outputDirectory = sprintf("\45\x73\x2f\x25\163\x2f\45\163\57", rtrim($backupDirectory, "\x2f"), $databaseName, $dateTime->format("\131\55\155\55\144")); goto Faa82; D94ba: $databaseExporter->createOutputDirectory(); goto C5d34; C3924: } catch (\Exception $e) { $logger = $this->getLogger(); $logger->exception($e); } } private function resetPermissions(DatabaseEntity $databaseEntity) { goto b0ce2; a9bf9: $backupDirectoryChmodCommand = new FindChmodCommand(); goto Ed607; C2e27: $this->commandExecutor->execute($backupDirectoryChmodCommand); goto f3243; D7e34: $backupDirectoryChownCommand->setRecursive(true); goto D366f; D2225: $backupDirectoryChownCommand->setGroup($siteUser); goto a9bf9; Be56e: $this->commandExecutor->execute($backupDirectoryChownCommand); goto C2e27; b852d: $backupDirectoryChmodCommand->setFileChmod(760); goto Be56e; b0ce2: $siteEntity = $databaseEntity->getSite(); goto b1557; b1557: $siteUser = $siteEntity->getUser(); goto ce4bb; b4aca: $backupDirectoryChownCommand->setFile($backupDirectory); goto D7e34; Ed607: $backupDirectoryChmodCommand->setFile($backupDirectory); goto A572c; ce4bb: $backupDirectory = sprintf("\x2f\x68\157\155\145\57\x25\163\57\142\x61\143\x6b\165\x70\x73\x2f\144\141\164\x61\x62\x61\163\145\x73\57", $siteUser); goto ef5cf; ef5cf: $backupDirectoryChownCommand = new ChownCommand(); goto b4aca; A572c: $backupDirectoryChmodCommand->setDirectoryChmod(750); goto b852d; D366f: $backupDirectoryChownCommand->setUser($siteUser); goto D2225; f3243: } private function cleanUpBackups(DatabaseEntity $databaseEntity) { goto Ade25; B5d11: $databaseBackupDirectory = sprintf("\57\x68\157\155\145\x2f\45\163\x2f\x62\x61\x63\x6b\x75\160\163\57\144\x61\164\141\x62\141\163\x65\163\57", $siteUser); goto A34e7; A34e7: $deleteOldBackupsCommand = new DeleteOldFilesRecursiveCommand(); goto Fab70; Fab70: $deleteOldBackupsCommand->setDirectory($databaseBackupDirectory); goto Bd1ad; Ade25: $siteEntity = $databaseEntity->getSite(); goto A9f2c; Bd1ad: $deleteOldBackupsCommand->setRetentionPeriod($this->retentionPeriod); goto b8289; b8289: $this->commandExecutor->execute($deleteOldBackupsCommand, 360); goto A7576; A9f2c: $siteUser = $siteEntity->getUser(); goto B5d11; A7576: } }
