<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use App\Command\Command as BaseCommand; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Entity\Manager\SshUserManager as SshUserEntityManager; use App\Database\Importer as DatabaseImporter; use App\System\Command\CheckIfFileExistsCommand; use App\System\CommandExecutor; class DatabaseImportCommand extends BaseCommand { const SYSTEM_USER_ROOT = "\x72\157\x6f\x74"; private SiteEntityManager $siteEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private SshUserEntityManager $sshUserEntityManager; private CommandExecutor $commandExecutor; public function __construct(SiteEntityManager $siteEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, SshUserEntityManager $sshUserEntityManager) { goto E8918; ffca8: parent::__construct(); goto B7649; ded42: $this->databaseEntityManager = $databaseEntityManager; goto c9787; c0eb5: $this->sshUserEntityManager = $sshUserEntityManager; goto e243e; E8918: $this->siteEntityManager = $siteEntityManager; goto ded42; c9787: $this->databaseServerEntityManager = $databaseServerEntityManager; goto c0eb5; e243e: $this->commandExecutor = new CommandExecutor(); goto ffca8; B7649: } protected function configure() : void { goto bea32; bea32: $this->setName("\144\142\72\x69\x6d\160\157\x72\x74"); goto Eeeda; dd2ce: $this->addOption("\144\x61\x74\141\142\141\163\x65\116\141\x6d\145", null, InputOption::VALUE_REQUIRED); goto e3287; Eeeda: $this->setDescription("\143\x6c\x70\143\x74\x6c\x20\x64\142\72\x69\155\160\157\x72\164\x20\55\x2d\x64\141\164\141\x62\141\163\x65\116\x61\155\145\75\x6d\x79\55\x64\x61\x74\141\142\141\x73\145\40\55\55\x66\151\154\145\75\x64\165\x6d\160\56\163\x71\154\56\x67\x7a"); goto dd2ce; e3287: $this->addOption("\146\x69\154\x65", null, InputOption::VALUE_REQUIRED); goto d4ad2; d4ad2: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto E20bf; B4a90: $importFile = $input->getOption("\x66\x69\154\145"); goto de23a; c34d4: $siteUser = self::SYSTEM_USER_ROOT; goto Ca441; Ca146: $siteEntity = $this->siteEntityManager->findOneByUser($systemUserName); goto F7c24; Afe6f: D91d8: goto a80ee; E3a36: if (!(true === $userIsAllowedToImport && false === is_null($siteUser))) { goto Fa520; } goto ad149; F91f9: $isSuperUser = true; goto c34d4; Cdac8: $userIsAllowedToImport = true === $isSuperUser || true === $userBelongsToSite; goto E3a36; Ec8f1: if (false === is_null($databaseEntity)) { goto F469a; } goto c3e48; Ca441: de077: goto Cdac8; B798c: $siteEntity = $sshUserEntity->getSite(); goto D03c1; Faeb1: goto F0f6d; goto c5689; de23a: $systemUserName = $_SERVER["\123\x55\x44\x4f\137\x55\123\x45\122"] ?? ''; goto C00f5; c3e48: throw new \Exception(sprintf("\104\141\164\141\142\141\163\145\x20\x22\45\x73\x22\x20\144\x6f\x65\x73\40\x6e\x6f\164\40\145\170\151\163\x74\56", $databaseName)); goto Faeb1; bdf68: $databaseName = $input->getOption("\144\x61\164\141\x62\x61\163\x65\116\141\155\x65"); goto B4a90; fbd98: D12b9: goto Ccb6f; a80ee: goto D12b9; goto C0ad1; dede1: return BaseCommand::SUCCESS; goto d7eab; a0692: $siteUser = $siteEntity->getUser(); goto fbd98; bc205: $databaseEntity = $this->databaseEntityManager->findOneByName($databaseName); goto Ec8f1; Fc0f4: e74d6: goto F3c31; F3c31: $this->checkIfFileExists($importFile); goto bc205; c6ea8: D8fab: goto fc01e; D03c1: $siteUser = $siteEntity->getUser(); goto Afe6f; C00f5: if (!("\144\x65\166" == $_ENV["\101\120\120\137\x45\116\x56"])) { goto D8fab; } goto E1326; E20bf: $this->validateInput($input); goto bdf68; E1326: $systemUserName = self::SYSTEM_USER_ROOT; goto c6ea8; fc01e: if (!(false === str_contains($importFile, "\57"))) { goto e74d6; } goto c2085; Ccb6f: $userBelongsToSite = false === is_null($siteEntity) && $siteUser === $databaseEntity->getSite()->getUser(); goto d8ba1; ad149: $databaseImporter = new DatabaseImporter($databaseEntity); goto A76e1; d8ba1: $isSuperUser = false; goto Fb5d2; d7eab: Fa520: goto F631a; c2085: $importFile = sprintf("\45\163\57\45\163", rtrim(getcwd(), "\x2f"), $importFile); goto Fc0f4; C0ad1: Fa795: goto a0692; F631a: F0f6d: goto a7fbd; D2a4e: if (false === is_null($siteEntity)) { goto Fa795; } goto A6712; A76e1: $databaseImporter->import($importFile); goto ba1fc; F7c24: $siteUser = null; goto D2a4e; a7fbd: return BaseCommand::FAILURE; goto D4691; A6712: $sshUserEntity = $this->sshUserEntityManager->findOneByUserName($systemUserName); goto Cd96e; c5689: F469a: goto Ca146; Cd96e: if (!(false === is_null($sshUserEntity))) { goto D91d8; } goto B798c; Fb5d2: if (!(self::SYSTEM_USER_ROOT == $systemUserName)) { goto de077; } goto F91f9; ba1fc: $output->writeln(sprintf("\x3c\x69\156\146\157\76\111\x6d\160\157\162\164\40\x69\x6e\x74\157\x20\144\x61\x74\141\142\141\x73\145\74\57\151\156\146\x6f\x3e\40\74\x63\x6f\155\155\x65\x6e\164\x3e\45\x73\x3c\x2f\143\x6f\x6d\155\145\156\164\76\40\74\x69\156\x66\157\76\x77\x61\163\40\x73\x75\x63\143\x65\x73\163\x66\165\154\56\74\x2f\x69\x6e\146\x6f\x3e", $databaseName)); goto dede1; D4691: } catch (\Exception $e) { goto eb12c; Ad951: return BaseCommand::FAILURE; goto e8517; B4407: $output->writeln(sprintf("\x3c\145\162\x72\x6f\162\x3e\45\163\74\x2f\x65\162\162\157\x72\x3e", $errorMessage)); goto Ad951; eb12c: $errorMessage = $this->maskString($e->getMessage()); goto B4407; e8517: } } private function checkIfFileExists(string $importFile) { try { goto d3064; d3064: $checkIfFileExistsCommand = new CheckIfFileExistsCommand(); goto A0b62; A0b62: $checkIfFileExistsCommand->setFile($importFile); goto Eb913; Eb913: $this->commandExecutor->execute($checkIfFileExistsCommand); goto Fac48; Fac48: } catch (\Exception $e) { throw new \Exception(sprintf("\x46\x69\154\145\x20\x22\x25\163\42\40\x64\x6f\x65\163\40\156\157\x74\x20\145\x78\x69\163\x74\x2e", $importFile)); } } }
