<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\Validator\ValidatorInterface; use App\Command\Command as BaseCommand; use App\System\CommandExecutor; use App\System\Command\WriteFileCommand; use App\System\Command\DeleteFileCommand; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Site as SiteEntity; use App\Entity\Notification; use App\Notification\NotificationQueue; use App\Backup\Rclone; use App\Backup\Dropbox\Client as DropboxClient; use App\Backup\Rclone\DropboxConfigTemplate; use App\Backup\Rclone\ConfigBuilder as RcloneConfigBuilder; use App\Backup\StorageProvider; use App\Backup\TarCreator; use App\Service\Logger; class RemoteBackupCreateCommand extends BaseCommand { private SiteEntityManager $siteEntityManager; private CommandExecutor $commandExecutor; private ValidatorInterface $validator; private ?\DateTime $serverDateTime = null; private array $excludes = []; private ?string $storageProvider = null; public function __construct(SiteEntityManager $siteEntityManager, Logger $logger, ValidatorInterface $validator) { goto Bf5b2; B9d9f: parent::__construct(); goto f75e7; Bf5b2: $this->siteEntityManager = $siteEntityManager; goto e5d06; e49fc: $this->validator = $validator; goto B9d9f; Bb2f9: $this->logger = $logger; goto e49fc; e5d06: $this->commandExecutor = new CommandExecutor(); goto Bb2f9; f75e7: } protected function configure() : void { goto b7028; b7028: $this->setName("\x72\145\x6d\157\164\145\55\x62\x61\143\x6b\165\160\72\x63\x72\x65\x61\x74\145"); goto F81a6; F81a6: $this->setDescription("\x63\154\x70\x63\x74\154\x20\162\x65\x6d\157\x74\145\x2d\x62\141\143\153\165\160\x3a\143\162\x65\141\x74\x65"); goto D5434; D5434: $this->addOption("\x64\x65\x6c\x61\171", null, InputOption::VALUE_OPTIONAL, false); goto D8aa8; D8aa8: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto f61c4; D1afb: cdb88: goto a1fa9; C21dc: $siteEntities = $this->siteEntityManager->findAll(); goto ad8bc; f3b1c: $this->refreshDropboxAccessToken($delay); goto d9326; f7f20: return BaseCommand::SUCCESS; goto E8e05; f61c4: $this->validateInput($input); goto Bb257; Cdce7: if (!(StorageProvider::DROPBOX == $this->storageProvider)) { goto b7fc5; } goto E9035; Ba74c: Fbb5f: goto f7f20; f98e5: $this->storageProvider = $this->getConfigValue("\x72\145\155\157\164\x65\137\x62\x61\143\x6b\x75\160\137\x73\x74\157\x72\x61\147\x65\137\x70\162\x6f\166\151\x64\145\162"); goto c567d; d8ce4: foreach ($siteEntities as $siteEntity) { $this->backupSite($siteEntity); fa015: } goto D1afb; d9326: b7fc5: goto d8ce4; d8fdc: $this->backupDatabases(clone $input, clone $output); goto Cdce7; a1fa9: d6c25: goto b2079; ad8bc: if (!count($siteEntities)) { goto d6c25; } goto d8fdc; E9035: $delay = (bool) $input->getOption("\x64\x65\154\141\171"); goto f3b1c; b2079: $this->cleanBackups(); goto Ba74c; c567d: if (!(true === $isEnabled && false === empty($this->storageProvider))) { goto Fbb5f; } goto C21dc; Bb257: $isEnabled = (bool) $this->getConfigValue("\162\x65\155\x6f\164\145\137\142\141\143\153\165\160\x5f\145\x6e\141\x62\x6c\x65\144"); goto f98e5; E8e05: } catch (\Exception $e) { goto a91e2; A4d71: return BaseCommand::FAILURE; goto B7403; E5019: $output->writeln(sprintf("\74\x65\162\x72\x6f\162\x3e\x25\163\x3c\x2f\145\x72\x72\x6f\x72\x3e", $errorMessage)); goto A4d71; a91e2: $errorMessage = $e->getMessage(); goto E5019; B7403: } } private function backupDatabases(InputInterface $input, OutputInterface $output) : void { try { goto c959e; b23b7: $exitCode = $command->run($input, $output); goto A3f53; f9102: $command = $application->find("\144\x62\x3a\x62\x61\143\x6b\x75\160"); goto b23b7; c959e: $application = $this->getApplication(); goto f9102; A3f53: } catch (\Exception $e) { $this->logger->exception($e); } } private function backupSite(SiteEntity $siteEntity) { goto Fc5fb; Fc5fb: $isSiteExcluded = $this->isSiteExcluded($siteEntity); goto Ebba2; e026c: a6ab6: goto F9aee; bb520: try { try { goto d6b35; B6429: if (!(false === empty($siteExcludes))) { goto C93f9; } goto f6666; caec8: $siteVhostFile = sprintf("\57\150\x6f\155\x65\57\x25\x73\x2f\x73\x69\164\x65\55\x76\150\157\x73\x74", $siteUser); goto d1e60; Ab0e1: $siteExcludes = $this->getSiteExcludes($siteEntity); goto B6429; ea07e: $destination = $this->getDestination($siteEntity); goto b85a8; b85a8: $rclone = new Rclone(); goto Faa62; b8e2b: $vhostFile = sprintf("\x2f\x65\x74\143\x2f\x6e\147\x69\156\x78\x2f\163\x69\164\x65\163\55\x65\x6e\141\x62\154\x65\x64\x2f\x25\x73\x2e\143\x6f\x6e\x66", $domainName); goto Dea48; d3218: $siteUser = $siteEntity->getUser(); goto a4ad3; Faa62: switch ($this->storageProvider) { case StorageProvider::GOOGLE_DRIVE: goto Ea05b; Ea05b: $email = $this->getConfigValue("\x72\x65\155\157\x74\x65\137\142\141\x63\153\x75\x70\137\x65\155\141\151\x6c"); goto F4cbe; cc300: goto C7aea; goto Ad91f; F4cbe: $rclone->addFlag("\x2d\55\144\x72\x69\166\x65\x2d\x69\155\x70\x65\x72\163\157\156\x61\164\145", $email); goto cc300; Ad91f: } goto D774e; D51ca: C7aea: goto bb6d7; C2441: $siteSettingsFile = sprintf("\57\x68\x6f\155\145\57\45\163\57\x73\151\x74\x65\x2d\163\145\164\164\x69\x6e\147\163\x2e\x6a\163\x6f\x6e", $siteUser); goto caec8; Dea48: $destinationFile = sprintf("\x2f\x68\157\155\x65\57\45\x73\x2f\164\x6d\160\57\x62\x61\x63\x6b\x75\160\56\x74\141\x72", $siteUser); goto C2441; a4ad3: $domainName = $siteEntity->getDomainName(); goto c0fa2; cb3fd: C93f9: goto d3218; ff27c: $sources = [$homeDirectory, $vhostFile]; goto D46cc; c0fa2: $homeDirectory = sprintf("\x2f\150\157\x6d\x65\57\x25\163\x2f", $siteUser); goto b8e2b; A88ed: $tarCreator->create($sources, $destinationFile, $excludes); goto ea07e; D774e: B5b14: goto D51ca; d1e60: $this->createSiteSettingsFile($siteSettingsFile, $siteEntity); goto Aff17; Aff17: $this->createSiteVhostFile($siteVhostFile, $siteEntity); goto ff27c; f6666: $excludes = array_merge($excludes, $siteExcludes); goto cb3fd; bb6d7: $rclone->copy($destinationFile, $destination); goto A1861; d6b35: $excludes = ["\x2e\163\x73\150", "\164\155\x70", "\154\x6f\147\163"]; goto Ab0e1; D46cc: $tarCreator = new TarCreator(); goto A88ed; A1861: } catch (\Exception $e) { throw $e; } finally { $files = [$destinationFile, $siteSettingsFile, $siteVhostFile]; foreach ($files as $file) { goto E5da1; D1c7b: $deleteFileCommand->setFile($file); goto c5f74; E5da1: $deleteFileCommand = new DeleteFileCommand(); goto D1c7b; Ff433: F1ac2: goto bf462; c5f74: $this->commandExecutor->execute($deleteFileCommand, 60); goto Ff433; bf462: } f427a: } } catch (\Exception $e) { goto bce89; D0c0f: $this->addNotification($subject, $errorMessage); goto d74c1; bce89: $errorMessage = $e->getMessage(); goto Db8d0; Db8d0: $subject = sprintf("\x52\x65\x6d\157\164\x65\x20\102\141\143\153\x75\x70\40\146\x61\151\154\145\x64\72\40\45\x73", $domainName); goto D0c0f; d74c1: } goto e026c; Ebba2: if (!(false === $isSiteExcluded)) { goto a6ab6; } goto bb520; F9aee: } private function createSiteSettingsFile(string $siteSettingsFile, SiteEntity $siteEntity) : void { goto C1a66; Da906: Cd3bb: goto f8de6; ce4a3: $this->commandExecutor->execute($writeFileCommand, 15); goto Bfe4b; Ed8ff: $writeFileCommand->setFile($siteSettingsFile); goto Db989; C3b41: $writeFileCommand = new WriteFileCommand(); goto Ed8ff; Db989: $writeFileCommand->setContent($fileContent); goto ce4a3; f8de6: D1a47: goto Cb013; f988a: $settings = ["\x74\x79\160\x65" => $siteType, "\144\157\155\x61\151\x6e\116\x61\x6d\x65" => $siteEntity->getDomainName(), "\x72\x6f\157\x74\104\x69\162\x65\143\164\x6f\162\171" => $siteEntity->getRootDirectory(), "\x73\x69\164\x65\125\163\x65\162" => $siteEntity->getUser(), "\160\x61\147\x65\123\x70\x65\x65\144" => $siteEntity->getPageSpeedSettings()]; goto a7d39; a7d39: switch ($siteType) { case SiteEntity::TYPE_NODEJS: goto B0193; Dc5a2: goto D1a47; goto Dfe76; E4c1b: $settings["\x6e\x6f\x64\145\x6a\163\x53\x65\x74\x74\x69\x6e\147\163"] = $nodejsSettings; goto Dc5a2; B0193: $nodejsSettingsEntity = $siteEntity->getNodejsSettings(); goto cd9af; cd9af: $nodejsSettings = ["\166\145\162\163\x69\x6f\x6e" => $nodejsSettingsEntity->getNodejsVersion(), "\160\157\162\x74" => $nodejsSettingsEntity->getPort()]; goto E4c1b; Dfe76: case SiteEntity::TYPE_PHP: goto f8dd5; f8dd5: $phpSettingsEntity = $siteEntity->getPhpSettings(); goto aee93; c0f53: goto D1a47; goto c617a; aee93: $phpSettings = ["\x76\145\162\163\x69\x6f\156" => $phpSettingsEntity->getPhpVersion(), "\155\145\x6d\157\162\x79\114\x69\x6d\x69\x74" => $phpSettingsEntity->getMemoryLimit(), "\155\141\170\105\170\x65\x63\165\164\x69\x6f\156\x54\151\155\x65" => $phpSettingsEntity->getMaxExecutionTime(), "\x6d\x61\170\111\x6e\x70\165\x74\124\151\155\x65" => $phpSettingsEntity->getMaxInputTime(), "\x6d\x61\x78\111\156\x70\x75\x74\x56\141\x72\163" => $phpSettingsEntity->getMaxInputVars(), "\x70\157\163\164\115\x61\x78\x53\151\172\145" => $phpSettingsEntity->getPostMaxSize(), "\165\x70\x6c\x6f\x61\144\x4d\x61\170\106\151\x6c\x65\x53\151\172\x65" => $phpSettingsEntity->getUploadMaxFileSize(), "\141\x64\144\151\x74\151\157\156\x61\x6c\x43\x6f\x6e\146\151\x67\165\162\141\x74\x69\157\x6e" => $phpSettingsEntity->getAdditionalConfiguration()]; goto d21a4; d21a4: $settings["\x70\x68\160\x53\145\164\164\151\x6e\147\163"] = $phpSettings; goto c0f53; c617a: case SiteEntity::TYPE_PYTHON: goto D9908; D9908: $pythonSettingsEntity = $siteEntity->getPythonSettings(); goto De8d2; affc4: $settings["\x70\171\164\x68\x6f\156\123\145\x74\x74\x69\x6e\147\163"] = $pythonSettings; goto b55be; De8d2: $pythonSettings = ["\166\145\x72\x73\x69\x6f\156" => $pythonSettingsEntity->getPythonVersion(), "\x70\x6f\162\164" => $pythonSettingsEntity->getPort()]; goto affc4; b55be: goto D1a47; goto Bbcb1; Bbcb1: case SiteEntity::TYPE_REVERSE_PROXY: goto b5a8d; e97c3: goto D1a47; goto b47c4; b5a8d: $reverseProxySettings = ["\x75\x72\x6c" => $siteEntity->getReverseProxyUrl()]; goto Dfa9e; Dfa9e: $settings["\x72\145\166\145\x72\163\145\x50\x72\x6f\170\171\x53\x65\164\x74\151\156\147\163"] = $reverseProxySettings; goto e97c3; b47c4: } goto Da906; Cb013: $fileContent = json_encode($settings, JSON_PRETTY_PRINT); goto C3b41; C1a66: $siteType = $siteEntity->getType(); goto f988a; Bfe4b: } private function createSiteVhostFile(string $siteVhostFile, SiteEntity $siteEntity) : void { goto aa200; fce41: $writeFileCommand->setContent($vhost); goto B0609; aa200: $vhost = $siteEntity->getVhostTemplate(); goto ce0d2; ce0d2: $writeFileCommand = new WriteFileCommand(); goto e8032; e8032: $writeFileCommand->setFile($siteVhostFile); goto fce41; B0609: $this->commandExecutor->execute($writeFileCommand, 15); goto B3dbb; B3dbb: } private function isSiteExcluded(SiteEntity $siteEntity) : bool { goto E9205; dca3e: if (!(false === empty($excludes))) { goto b5a77; } goto C0ceb; E9205: $isSiteExcluded = false; goto b54b7; b54b7: $excludes = $this->getExcludes(); goto dca3e; Ddcea: return $isSiteExcluded; goto f0676; ea0d3: D1ab8: goto B4c5f; C0ceb: $siteUser = $siteEntity->getUser(); goto Dbe10; B4c5f: b5a77: goto Ddcea; ab360: foreach ($excludes as $exclude) { goto ed6ac; fbb99: if (!($homeDirectory == $exclude)) { goto d8638; } goto Aa5fc; c937d: goto D1ab8; goto E644f; D22dd: bd195: goto E8d9a; ed6ac: $exclude = rtrim($exclude, "\57"); goto fbb99; E644f: d8638: goto D22dd; Aa5fc: $isSiteExcluded = true; goto c937d; E8d9a: } goto ea0d3; Dbe10: $homeDirectory = sprintf("\x2f\x68\x6f\x6d\145\x2f\45\x73", $siteUser); goto ab360; f0676: } private function getExcludes() : array { goto bf285; Cf332: Ee36e: goto B00fa; f5856: $this->excludes = json_decode($excludes); goto C5b06; bf285: if (!(true === empty($this->excludes))) { goto Ee36e; } goto E4e08; a1a9e: if (!(false === empty($excludes))) { goto bdccb; } goto f5856; E4e08: $excludes = $this->getConfigValue("\x72\145\x6d\157\x74\145\137\142\141\143\x6b\x75\x70\137\x65\x78\x63\x6c\x75\x64\145\163"); goto a1a9e; B00fa: return $this->excludes; goto A08c0; C5b06: bdccb: goto Cf332; A08c0: } private function getSiteExcludes(SiteEntity $siteEntity) : array { goto Ba8cd; aaebf: $excludes = $this->getExcludes(); goto Cf66f; e76c1: return $siteExcludes; goto Acde3; C1189: a2f62: goto E522f; E522f: Cd7eb: goto e76c1; A4d1a: $homeDirectory = sprintf("\x2f\150\x6f\155\x65\x2f\45\x73\x2f", $siteUser); goto D0e11; D0e11: foreach ($excludes as $exclude) { goto aba1c; Fe268: if (!(false === empty($exclude))) { goto E0dfd; } goto E2291; E2291: $siteExcludes[] = rtrim(ltrim($exclude, "\x2f"), "\57"); goto Fa37e; Ead6a: bfb36: goto c0252; aba1c: if (!($homeDirectory == substr($exclude, 0, strlen($homeDirectory)))) { goto A64c5; } goto eaa2e; Fa37e: E0dfd: goto fe49f; fe49f: A64c5: goto Ead6a; eaa2e: $exclude = substr($exclude, strlen($homeDirectory) - 1); goto Fe268; c0252: } goto C1189; Ba8cd: $siteExcludes = []; goto aaebf; Cf66f: if (!(false === empty($excludes))) { goto Cd7eb; } goto ab86f; ab86f: $siteUser = $siteEntity->getUser(); goto A4d1a; Acde3: } private function getServerDateTime() : \DateTime { goto ae2c7; c4c14: e4cac: goto A84c7; c6b59: $this->serverDateTime = new \DateTime("\156\x6f\x77"); goto Dd574; A84c7: E2138: goto B6f1a; Afbb1: if (!(false === empty($timezone))) { goto e4cac; } goto dafae; ede83: $timezone = $this->getConfigValue("\164\151\x6d\x65\172\x6f\x6e\145"); goto c6b59; ae2c7: if (!(true === is_null($this->serverDateTime))) { goto E2138; } goto ede83; Dd574: $this->serverDateTime->setTimezone(new \DateTimeZone("\x55\x54\103")); goto Afbb1; dafae: $this->serverDateTime->setTimezone(new \DateTimeZone($timezone)); goto c4c14; B6f1a: return $this->serverDateTime; goto d1df3; d1df3: } private function getDestination(SiteEntity $siteEntity) : string { goto d82e1; a05a5: if (!(StorageProvider::DROPBOX == $this->storageProvider)) { goto C4a75; } goto D9477; daba7: $storageDirectory = $this->getConfigValue("\162\x65\x6d\x6f\164\145\x5f\x62\141\x63\153\x75\160\x5f\163\164\x6f\x72\141\147\x65\137\x64\x69\x72\x65\143\x74\157\x72\171"); goto A553a; D9477: $destination = ltrim($destination, "\x2f"); goto Effea; d82e1: $destination = ''; goto B30c4; Ba039: $destination = sprintf("\45\x73\x2f\x25\x73\x2f\45\x73\57\x25\163\57\150\157\x6d\x65\57\45\163\57", $destination, rtrim(ltrim($storageDirectory, "\x2f"), "\x2f"), $serverDateTime->format("\x59\55\155\55\x64"), $serverDateTime->format("\110\x2e\x69"), $siteUser); goto a05a5; d75b4: Fde6e: goto Bf7fe; ac980: return $destination; goto d3324; Bf7fe: Aea99: goto C59e9; C59e9: $siteUser = $siteEntity->getUser(); goto daba7; B30c4: switch ($this->storageProvider) { case StorageProvider::AMAZON_S3: case StorageProvider::WASABI: $destination = $this->getConfigValue("\x72\x65\155\x6f\164\x65\x5f\142\141\143\x6b\165\160\137\x62\165\x63\x6b\145\164"); goto Aea99; case StorageProvider::DIGITAL_OCEAN_SPACES: $destination = $this->getConfigValue("\162\x65\x6d\x6f\164\145\x5f\142\141\x63\x6b\165\160\x5f\x73\160\141\x63\145"); goto Aea99; } goto d75b4; A553a: $serverDateTime = $this->getServerDateTime(); goto Ba039; Effea: C4a75: goto ac980; d3324: } private function cleanBackups() : void { goto ac9cc; E929d: $storageDirectory = $this->getConfigValue("\162\145\155\x6f\164\x65\x5f\142\x61\x63\x6b\x75\160\137\x73\164\157\x72\141\147\145\137\x64\151\162\x65\143\164\157\x72\171"); goto bde95; ac9cc: $retentionPeriod = (int) $this->getConfigValue("\162\145\155\x6f\164\x65\x5f\142\x61\143\153\x75\160\137\162\145\x74\145\x6e\164\x69\157\x6e\x5f\x70\145\162\x69\157\x64"); goto E929d; E8dcc: try { goto A62a6; D9248: e9fb2: goto C586b; da25b: $deleteDateTime->setTimezone(new \DateTimeZone("\x55\124\x43")); goto F5e31; de67d: A84a5: goto B87e0; B87e0: Daea4: goto c5f20; ba167: $remotePath = ''; goto Defe9; C586b: cd9c9: goto E6610; c2648: if (!(StorageProvider::DROPBOX == $this->storageProvider)) { goto b0d7a; } goto e252d; A271e: b0d7a: goto debd7; e3eec: $deleteDateTime = clone $dateTime; goto F2b2f; A62a6: $dateTime = new \DateTime(); goto e3eec; f55a8: if (!(false === empty($directories))) { goto Daea4; } goto a5547; F5e31: $deleteDateTime->setTime(0, 0, 0, 0); goto ba167; F2b2f: $deleteDateTime->modify(sprintf("\x2d\x25\x73\x20\144\141\171\x73", $retentionPeriod)); goto da25b; debd7: $directories = (array) $rclone->lsJson($remotePath, true); goto f55a8; E6610: $remotePath = sprintf("\x25\x73\x2f\x25\163\x2f", $remotePath, rtrim(ltrim($storageDirectory, "\x2f"), "\57")); goto c2648; e252d: $remotePath = ltrim($remotePath, "\57"); goto A271e; Defe9: $rclone = new Rclone(); goto A2bb5; a5547: foreach ($directories as $directory) { goto E8f50; Edbfa: if (!(true === $isValidDate)) { goto C5f7e; } goto D66b8; B7de0: $purgeRemotePath = sprintf("\45\163\57\45\163\57", rtrim(ltrim($remotePath, "\x2f"), "\x2f"), $directoryName); goto C9b03; F4e88: A7a0a: goto b971f; d05f9: d24ff: goto d9a00; Fdaa1: try { $isValidDate = true; $directoryDate = new \DateTime($directoryName); } catch (\Exception $e) { $isValidDate = false; } goto Edbfa; C9b03: if (!(StorageProvider::DROPBOX == $this->storageProvider)) { goto d24ff; } goto bbb6d; E8f50: $directoryName = $directory["\116\x61\x6d\145"] ?? null; goto C88d8; F5244: E7f9d: goto Ec2c5; f34f4: cd05e: goto D0df1; d9a00: if (!(StorageProvider::SFTP == $this->storageProvider)) { goto cd05e; } goto e2aa7; D66b8: if (!(true === isset($directoryDate) && $directoryDate <= $deleteDateTime)) { goto E7f9d; } goto B7de0; D0df1: $rclone->purge($purgeRemotePath); goto F5244; bbb6d: $purgeRemotePath = ltrim($purgeRemotePath, "\x2f"); goto d05f9; e2aa7: $purgeRemotePath = sprintf("\x2f\45\163", ltrim($purgeRemotePath, "\x2f")); goto f34f4; C88d8: if (!(false === is_null($directoryName))) { goto A7a0a; } goto Fdaa1; b971f: D3f26: goto D9fb9; Ec2c5: C5f7e: goto F4e88; D9fb9: } goto de67d; A2bb5: switch ($this->storageProvider) { case StorageProvider::AMAZON_S3: case StorageProvider::WASABI: $remotePath = $this->getConfigValue("\x72\145\x6d\x6f\x74\145\x5f\142\141\143\153\165\x70\x5f\x62\165\x63\153\x65\164"); goto cd9c9; case StorageProvider::DIGITAL_OCEAN_SPACES: $remotePath = $this->getConfigValue("\162\145\155\x6f\x74\x65\137\x62\x61\143\153\x75\x70\137\163\160\x61\x63\145"); goto cd9c9; case StorageProvider::GOOGLE_DRIVE: goto ac08a; c76ba: goto cd9c9; goto dc0e6; ac08a: $email = $this->getConfigValue("\x72\x65\155\157\164\x65\137\x62\x61\x63\x6b\x75\160\x5f\145\x6d\141\151\x6c"); goto a882b; a882b: $rclone->addFlag("\55\x2d\x64\162\x69\166\x65\x2d\x69\155\x70\145\162\x73\x6f\156\141\164\145", $email); goto c76ba; dc0e6: } goto D9248; c5f20: } catch (\Exception $e) { goto b37ae; f0977: $subject = sprintf("\x52\x65\x6d\x6f\164\145\40\102\141\143\153\x75\160\40\x63\x6c\145\x61\x6e\165\x70\40\146\x61\151\x6c\145\x64\56"); goto Dd1b7; b37ae: $errorMessage = $e->getMessage(); goto f0977; Dd1b7: $this->addNotification($subject, $errorMessage); goto c8e18; c8e18: } goto ef688; ef688: f4f32: goto e9ce5; bde95: if (!($retentionPeriod && false === empty($storageDirectory))) { goto f4f32; } goto E8dcc; e9ce5: } private function refreshDropboxAccessToken(bool $delay) { try { goto Bc110; Fc607: $rcloneConfigTemplate = new DropboxConfigTemplate(); goto B29f7; Bc110: if (!(true === $delay)) { goto ddc62; } goto be877; a9616: $dropboxClient = new DropboxClient(); goto b1a93; f3a89: goto D8b72; goto e31ad; be877: sleep(rand(5, 60)); goto ff597; D09a1: $rcloneConfig = $rcloneConfigBuilder->build(); goto fde30; b4667: $rcloneConfigBuilder = new RcloneConfigBuilder($rcloneConfigTemplate); goto D09a1; ebe76: $refreshToken = $this->getConfigValue("\162\145\x6d\157\x74\x65\x5f\x62\x61\143\x6b\165\160\137\x72\x65\x66\x72\x65\x73\x68\x5f\164\157\153\145\156"); goto a9616; e31ad: f927a: goto Fc607; ff597: ddc62: goto ebe76; e3416: throw new \Exception("\x41\x63\x63\145\x73\163\x20\x54\x6f\x6b\x65\x6e\x20\x63\141\x6e\156\157\x74\40\142\x65\40\x65\x6d\x70\x74\171\56"); goto f3a89; C4b59: D8b72: goto A1bda; A8d96: if (false === empty($token)) { goto f927a; } goto e3416; B29f7: $rcloneConfigTemplate->setToken($token); goto b4667; b1a93: $token = $dropboxClient->getAccessToken($refreshToken); goto A8d96; D7d8b: $rclone->writeConfig($rcloneConfig); goto C4b59; fde30: $rclone = new Rclone(); goto D7d8b; A1bda: } catch (\Exception $e) { $errorMessage = $e->getMessage(); $this->addNotification("\x52\145\146\x72\145\x73\150\x69\x6e\x67\x20\104\162\157\160\x62\157\170\40\101\143\x63\145\163\x73\40\x54\x6f\x6b\145\156\40\x46\x61\x69\154\x65\x64", $errorMessage); } } private function addNotification(string $subject, string $errorMessage) : void { goto Ff2a5; E88f3: $notification->setSeverity(Notification::SEVERITY_CRITICAL); goto e3d64; Ff2a5: $notification = new Notification(); goto b462e; b462e: $notification->setSubject($subject); goto E42ca; E42ca: $notification->setMessage($errorMessage); goto E88f3; e3d64: NotificationQueue::addNotification($notification); goto B2281; B2281: } }
