<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\ConstraintViolationList; use App\Command\SiteCommand as SiteCommand; use App\Entity\Site as SiteEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\NodejsSettings as NodejsSettingsEntity; use App\Site\NodejsSite; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\Util\Openssl; use App\Site\Nginx\Vhost\NodejsTemplate as NodejsVhostTemplate; use App\Site\Creator\NodejsSite as NodejsSiteCreator; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; class SiteAddNodejsCommand extends SiteCommand { private const VHOST_TEMPLATE_NAME = "\x4e\x6f\x64\145\152\x73"; protected function configure() : void { goto c02d2; d2af9: $this->setDescription("\x63\x6c\160\143\164\154\40\163\x69\x74\145\x3a\x61\144\x64\72\x6e\x6f\x64\145\x6a\x73\40\55\x2d\144\157\155\141\151\x6e\x4e\x61\155\145\x3d\167\x77\x77\56\x64\x6f\x6d\x61\x69\156\56\143\157\x6d\40\55\x2d\156\157\144\x65\x6a\x73\126\x65\162\x73\151\x6f\x6e\x3d\x32\62\x20\55\x2d\141\160\160\x50\x6f\162\x74\x3d\x33\x30\60\60\40\x2d\x2d\163\x69\164\x65\125\163\x65\x72\75\x6a\157\x68\156\40\x2d\55\163\x69\x74\x65\125\163\145\162\120\141\x73\163\167\157\x72\144\x3d\47\x21\163\145\x63\162\145\x74\120\x61\x73\x73\167\157\162\x64\41\x27"); goto e4947; c02d2: $this->setName("\163\151\164\x65\x3a\141\144\144\72\x6e\157\144\x65\152\163"); goto d2af9; Ededd: $this->addOption("\x73\x69\164\x65\x55\163\x65\x72", null, InputOption::VALUE_REQUIRED); goto C49a3; C49a3: $this->addOption("\x73\x69\164\x65\125\x73\145\162\x50\141\163\x73\x77\157\162\144", null, InputOption::VALUE_REQUIRED); goto A2358; e4947: $this->setComment("\x41\144\144\x69\156\x67\40\x61\40\116\x6f\144\x65\56\152\163\x20\x53\151\x74\x65"); goto F66a5; A93eb: $this->addOption("\x61\x70\160\x50\157\162\x74", null, InputOption::VALUE_REQUIRED); goto Ededd; C8647: $this->addOption("\156\x6f\144\145\x6a\163\126\x65\162\163\151\157\156", null, InputOption::VALUE_REQUIRED); goto A93eb; F66a5: $this->addOption("\x64\x6f\155\141\x69\x6e\x4e\141\x6d\145", null, InputOption::VALUE_REQUIRED); goto C8647; A2358: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto fad2b; F0725: $vhostTemplate->addProcessor(new RedirectDomainProcessor()); goto Ad770; adbe4: $redirectionVhostTemplate = file_get_contents($redirectionVhostTemplateFile); goto e4791; fd400: $domainName = mb_strtolower(trim($input->getOption("\144\x6f\155\x61\151\x6e\116\141\155\145"))); goto e7f8e; c3984: $nodejsSite->setNodejsSettings($nodejsSettingsEntity); goto E18a8; Dc922: $nodejsSite->setUser($siteEntity->getUser()); goto Ea1a7; A1929: $certificateEntity->setCsr($csr); goto f2532; cf63a: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto e7323; E0b73: if (!(false === is_null($subdomain) && "\x77\167\x77" == $subdomain)) { goto E4d26; } goto B559e; e7f8e: $vhostTemplate = self::VHOST_TEMPLATE_NAME; goto B1d2d; b1a80: $siteEntity->setUser($siteUser); goto E5309; D6c9f: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto d4779; d34f8: f8e9a: goto b7268; c0600: $nodejsVersion = (int) $input->getOption("\156\x6f\x64\145\152\163\126\x65\162\163\x69\157\156"); goto E6666; bf07c: E5ea6: goto b771c; B478d: $nodejsSiteCreator = new NodejsSiteCreator($nodejsSite); goto E1225; d4779: $subdomain = $resolvedDomainName->subDomain()->toString(); goto A3c30; Dd28c: $subjectAlternativeNames = []; goto Bcf5d; c3d10: $nodejsSiteCreator->createRootDirectory(); goto fd592; Eb759: dd1ca: goto A2c00; f8d77: $subjectAlternativeNames[] = sprintf("\x77\167\167\x2e\x25\163", $domainName); goto fbc2d; Ff2cd: throw new \Exception(sprintf("\126\x68\x6f\163\164\x20\x54\x65\x6d\160\154\141\x74\145\40\42\45\x73\x22\x20\144\157\145\x73\x20\x6e\x6f\x74\40\x65\x78\x69\163\x74\x2e", $vhostTemplate)); goto B9f2a; Dac1d: $vhostTemplate->addProcessor(new RedirectServerNameProcessor()); goto F0725; be5e9: if (true === isset($_ENV["\x41\x50\120\x5f\110\124\124\120\x33"]) && "\164\162\165\145" === $_ENV["\x41\x50\120\x5f\110\x54\124\120\63"]) { goto f8e9a; } goto ea741; E18a8: $nodejsSite->setCertificate($certificateEntity); goto f7bc2; f89be: $nodejsSite->setDomainName($domainName); goto B5411; ed474: $output->writeln(sprintf("\74\151\x6e\146\157\76\x53\x69\164\145\74\57\151\x6e\x66\157\76\40\74\143\x6f\155\x6d\145\156\x74\76\45\163\74\x2f\143\x6f\x6d\x6d\x65\156\x74\x3e\x20\x3c\x69\x6e\146\157\x3e\150\141\x73\40\142\145\x65\156\x20\141\144\144\145\x64\x2e\74\x2f\151\x6e\x66\157\x3e", $domainName)); goto E2c5f; Bcf5d: if (!(true === is_null($subdomain))) { goto b668a; } goto f8d77; A57f7: $siteEntity->setApplication($vhostTemplateEntity->getName()); goto D311e; Ccf8f: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto Dd28c; a3e48: $constraints->addAll($nodejsSettingsConstraints); goto fb02f; c11f7: $nodejsSettingsEntity = new NodejsSettingsEntity(); goto F8662; ea741: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\57\x2e\x2e\57\x2e\56\57\162\x65\x73\157\x75\x72\143\145\x73\x2f\x6e\x67\151\x6e\170\x2f\166\150\157\163\164\137\164\145\155\x70\x6c\141\x74\x65\x2f\x72\145\144\151\162\x65\x63\x74"); goto fd8f2; B16b2: $nodejsSettingsEntity->setSite($siteEntity); goto F2f8b; B9f2a: goto bffba; goto bf07c; F25f1: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto D6c9f; E5309: $siteEntity->setUserPassword($siteUserPassword); goto D85b6; D85b6: if (!(true === is_null($subdomain) || "\x77\x77\167" == $subdomain)) { goto A8bfe; } goto be5e9; A2c00: A8bfe: goto eb9e4; E5871: $nodejsSettingsEntity->setPort($appPort); goto B16b2; E1225: $nodejsSiteCreator->createUser(); goto c3d10; Cb743: $nodejsSiteCreator->createNvmDirectory(); goto cda5c; D7dbd: $selfSignedCertificate = Openssl::createSelfSignedCertificate($privateKey, $csr); goto b24b5; D311e: $this->siteEntityManager->updateEntity($siteEntity); goto ed474; Ec977: if (0 == count($siteConstraints) && 0 == count($nodejsSettingsConstraints)) { goto E3ba2; } goto Ad7f5; C5e87: $siteUser = trim($input->getOption("\163\151\x74\x65\x55\x73\145\x72")); goto a30d9; eae79: if (false === is_null($vhostTemplateEntity)) { goto E5ea6; } goto Ff2cd; d0e3b: $certificateEntity->setSite($siteEntity); goto a19f7; Ad770: $vhostTemplate->build(); goto Aab8e; f4356: $nodejsSiteCreator->createNginxVhost(); goto C10a3; B559e: $subjectAlternativeNames[] = $registrableDomain; goto Ffa41; F8662: $siteEntity->setNodejsSettings($nodejsSettingsEntity); goto F66fb; A067e: $siteEntity->setRootDirectory($rootDirectory); goto b1a80; C69a0: $siteEntity->setType(SiteEntity::TYPE_NODEJS); goto aaaef; B5411: $nodejsSite->setRegistrableDomain($registrableDomain); goto A2310; c7db6: bffba: goto c3586; f1b3d: $nodejsSiteCreator->resetPermissions(); goto e1241; C10a3: $nodejsSiteCreator->reloadNginxService(); goto f1b3d; E2c5f: return SiteCommand::SUCCESS; goto B6b24; B6b24: B38a0: goto c7db6; a19f7: $rsaKeyGenerator = new RsaKeyGenerator(); goto Ccf8f; b771c: $vhostTemplate = $vhostTemplateEntity->getTemplate(); goto F8834; B1d2d: $rootDirectory = $domainName; goto c0600; A2310: $nodejsSite->setSubdomain($subdomain); goto f4cd0; F66fb: $nodejsSettingsEntity->setNodejsVersion($nodejsVersion); goto E5871; fb02f: return $this->renderConstraints($constraints, $output); goto Fb103; B1bba: $nodejsSiteCreator->createPrivateKeyAndCertificate(); goto f4356; e1241: $vhostTemplate = new NodejsVhostTemplate($nodejsSite); goto E1f5f; Aab8e: $siteEntity->setVhostTemplate($vhostTemplate->getContent()); goto A57f7; fbc2d: b668a: goto E0b73; a0c49: $certificateEntity->setCertificate($selfSignedCertificate); goto c3675; fd592: $nodejsSiteCreator->createLogrotateFile(); goto Cb743; F37e3: $constraints->addAll($siteConstraints); goto a3e48; eb9e4: $siteEntity->setVhostTemplate($vhostTemplate); goto c11f7; f4cd0: $nodejsSite->setRootDirectory($siteEntity->getRootDirectory()); goto c3984; ca516: C2bb4: goto adbe4; fd8f2: goto C2bb4; goto d34f8; Daa98: E3ba2: goto a939b; ed061: $certificateEntity->setType(CertificateEntity::TYPE_SELF_SIGNED); goto A1929; d3a88: $vhostTemplate->addProcessor(new ServerNameProcessor()); goto Dac1d; F8834: $siteEntity = $this->siteEntityManager->createEntity(); goto C69a0; e4791: if (!(false === empty($redirectionVhostTemplate))) { goto dd1ca; } goto a579b; F2f8b: $siteConstraints = $this->validator->validate($siteEntity); goto B6bba; E1f5f: $vhostTemplate->setContent($siteEntity->getVhostTemplate()); goto d80ae; E6666: $appPort = (int) $input->getOption("\141\x70\160\120\x6f\x72\x74"); goto C5e87; e7323: $csr = $csrGenerator->generate(); goto D7dbd; a579b: $vhostTemplate = sprintf("\x25\x73\x25\163", $redirectionVhostTemplate, $vhostTemplate); goto Eb759; Ea1a7: $nodejsSite->setUserPassword($siteEntity->getUserPassword()); goto f89be; a30d9: $siteUserPassword = trim($input->getOption("\x73\x69\x74\145\x55\x73\x65\162\x50\141\x73\x73\x77\157\162\x64")); goto F25f1; A3c30: $subdomain = false === empty($subdomain) ? $subdomain : null; goto e00ed; Ad7f5: $constraints = new ConstraintViolationList(); goto F37e3; f2532: $certificateEntity->setPrivateKey($privateKey->getPEM()); goto a0c49; Ffa41: E4d26: goto c5323; Fb103: goto B38a0; goto Daa98; A5d06: $nodejsSite = new NodejsSite(); goto Dc922; c3675: $siteEntity->setCertificate($certificateEntity); goto A5d06; c5323: $distinguishedName = new DistinguishedName($domainName, $subjectAlternativeNames); goto cf63a; b24b5: $certificateEntity->setDefaultCertificate(true); goto ed061; a939b: $certificateEntity = $this->certificateEntityManager->createEntity(); goto d0e3b; b7268: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\57\56\x2e\57\56\x2e\57\x72\145\163\x6f\165\162\x63\145\163\x2f\156\x67\151\x6e\170\57\x76\150\x6f\x73\164\137\164\x65\155\160\154\141\164\145\57\162\145\144\x69\x72\x65\x63\x74\55\150\x74\164\160\63"); goto ca516; cda5c: $nodejsSiteCreator->installNodejs(); goto B1bba; B6bba: $nodejsSettingsConstraints = $this->validator->validate($nodejsSettingsEntity); goto Ec977; fad2b: $this->validateInput($input); goto fd400; e00ed: $vhostTemplateEntity = $this->vhostTemplateEntityManager->findOneByName($vhostTemplate); goto eae79; aaaef: $siteEntity->setDomainName($domainName); goto A067e; f7bc2: $nodejsSite->setVhostTemplate($siteEntity->getVhostTemplate()); goto B478d; d80ae: $vhostTemplate->resetProcessors(); goto d3a88; c3586: } catch (\Exception $e) { goto E19a4; ae7bd: $output->writeln(sprintf("\74\x65\162\x72\x6f\162\76\x25\163\74\57\145\x72\x72\x6f\x72\x3e", $errorMessage)); goto bf173; bf173: return SiteCommand::FAILURE; goto dd102; E19a4: $errorMessage = $e->getMessage(); goto ae7bd; dd102: } } }
