<?php
 namespace App\Command; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Output\OutputInterface; use Symfony\Component\Validator\ConstraintViolationList; use App\Command\SiteCommand as SiteCommand; use App\Entity\Site as SiteEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\PythonSettings as PythonSettingsEntity; use App\Site\PythonSite; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\Util\Openssl; use App\Site\Nginx\Vhost\PythonTemplate as PythonVhostTemplate; use App\Site\Creator\PythonSite as PythonSiteCreator; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; class SiteAddPythonCommand extends SiteCommand { private const VHOST_TEMPLATE_NAME = "\x50\171\164\150\x6f\x6e"; protected function configure() : void { goto b88b3; E0cf7: $this->addOption("\160\171\x74\x68\x6f\x6e\x56\x65\162\163\151\x6f\156", null, InputOption::VALUE_REQUIRED); goto c8df7; c8df7: $this->addOption("\141\x70\160\120\x6f\162\164", null, InputOption::VALUE_REQUIRED); goto F09a4; E3385: $this->setDescription("\x63\x6c\160\143\164\x6c\40\163\x69\164\x65\72\141\x64\144\72\160\x79\x74\150\x6f\156\x20\x2d\x2d\x64\157\x6d\141\x69\156\116\141\x6d\x65\x3d\167\x77\167\x2e\144\157\x6d\x61\151\x6e\56\x63\157\155\x20\x2d\55\x70\171\164\150\x6f\x6e\126\x65\162\x73\x69\157\x6e\x3d\x33\x2e\61\x32\40\x2d\x2d\141\x70\160\120\157\x72\164\x3d\70\x30\70\x30\40\55\55\x73\x69\164\145\125\163\x65\162\75\152\x6f\150\x6e\x20\x2d\x2d\163\151\x74\x65\125\163\145\x72\120\x61\x73\163\x77\x6f\162\144\x3d\x27\x21\163\145\143\162\x65\x74\x50\x61\163\163\167\157\x72\x64\41\x27"); goto e054c; d956e: $this->addOption("\163\151\x74\145\x55\163\x65\162\120\x61\x73\163\167\x6f\x72\144", null, InputOption::VALUE_REQUIRED); goto A7592; F09a4: $this->addOption("\163\151\164\145\x55\x73\x65\162", null, InputOption::VALUE_REQUIRED); goto d956e; b88b3: $this->setName("\163\151\164\x65\72\141\144\x64\72\x70\171\164\150\157\x6e"); goto E3385; f1180: $this->addOption("\144\x6f\x6d\141\151\x6e\116\x61\x6d\145", null, InputOption::VALUE_REQUIRED); goto E0cf7; e054c: $this->setComment("\101\x64\x64\151\x6e\147\x20\141\x20\x50\x79\x74\x68\x6f\x6e\x20\x53\x69\164\x65"); goto f1180; A7592: } protected function execute(InputInterface $input, OutputInterface $output) : int { try { goto ac198; E5228: efdc9: goto Dab06; F0ffc: $pythonSiteCreator->reloadNginxService(); goto de3f0; dcae3: $pythonSiteCreator = new PythonSiteCreator($pythonSite); goto eafba; a980f: $certificateEntity->setDefaultCertificate(true); goto Fe124; d76bf: c56f2: goto ba0e9; B6a39: $appPort = (int) $input->getOption("\141\160\x70\x50\157\x72\x74"); goto Ab2a0; Ce9fd: cb8ee: goto E5228; Ee3c4: $vhostTemplate->addProcessor(new RedirectServerNameProcessor()); goto b9fa7; ba192: $certificateEntity = $this->certificateEntityManager->createEntity(); goto A219f; b1b05: $vhostTemplate->setContent($siteEntity->getVhostTemplate()); goto A199f; ac198: $this->validateInput($input); goto B3163; eafba: $pythonSiteCreator->createUser(); goto Bc807; A9034: $pythonSettingsEntity->setSite($siteEntity); goto E77da; B4d9f: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto a7d92; b881d: $pythonSiteCreator->createLogrotateFile(); goto b4145; Ab2a0: $siteUser = trim($input->getOption("\163\151\x74\145\125\163\145\x72")); goto Ecac7; A52af: goto cb8ee; goto fd877; Dc6de: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto A15ba; Ecac7: $siteUserPassword = trim($input->getOption("\163\151\164\x65\x55\163\145\162\x50\x61\x73\x73\167\157\x72\144")); goto B4d9f; D3a6d: $pythonSite->setSubdomain($subdomain); goto A4504; Fd6dc: $pythonSite->setUserPassword($siteEntity->getUserPassword()); goto D39f9; A219f: $certificateEntity->setSite($siteEntity); goto A4651; c51c5: $pythonSite->setCertificate($certificateEntity); goto ecd29; A6660: de301: goto bdfdd; aa185: F6f30: goto fd265; E51b0: $rootDirectory = $domainName; goto B0bc0; b7ded: $vhostTemplate->build(); goto cf945; c4473: goto b95e8; goto aa185; eda5e: $vhostTemplate = self::VHOST_TEMPLATE_NAME; goto E51b0; Ac292: $csr = $csrGenerator->generate(); goto eca61; fd265: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\57\56\56\57\x2e\56\57\162\145\x73\157\165\x72\x63\x65\x73\57\156\147\151\x6e\170\x2f\x76\150\157\x73\x74\137\x74\x65\155\160\x6c\141\x74\x65\57\x72\x65\144\x69\162\x65\x63\164\55\x68\164\164\x70\63"); goto ca80d; cf945: $siteEntity->setVhostTemplate($vhostTemplate->getContent()); goto Fb065; A3aff: if (true === isset($_ENV["\x41\120\x50\137\x48\124\124\120\x33"]) && "\x74\162\x75\145" === $_ENV["\101\120\x50\x5f\x48\124\x54\120\63"]) { goto F6f30; } goto efd05; F6431: $siteEntity->setUser($siteUser); goto cf88b; E509a: $subjectAlternativeNames[] = sprintf("\167\x77\x77\56\45\163", $domainName); goto f2c45; cf88b: $siteEntity->setUserPassword($siteUserPassword); goto b21ba; F1db6: $pythonSite->setRegistrableDomain($registrableDomain); goto D3a6d; ecd29: $pythonSite->setVhostTemplate($siteEntity->getVhostTemplate()); goto dcae3; Fbf82: $pythonSite->setPythonSettings($pythonSettingsEntity); goto c51c5; Ffbfc: $certificateEntity->setPrivateKey($privateKey->getPEM()); goto babd9; e2450: $siteEntity->setCertificate($certificateEntity); goto F73fe; f2276: return $this->renderConstraints($constraints, $output); goto A52af; C965e: $vhostTemplate = sprintf("\45\163\x25\163", $redirectionVhostTemplate, $vhostTemplate); goto A8def; b21ba: if (!(true === is_null($subdomain) || "\167\167\x77" == $subdomain)) { goto de301; } goto A3aff; Bfea0: if (!(false === is_null($subdomain) && "\x77\x77\167" == $subdomain)) { goto a81b1; } goto dc1ec; B0c3f: $siteEntity->setType(SiteEntity::TYPE_PYTHON); goto d4f9a; B2cd9: if (!(false === empty($redirectionVhostTemplate))) { goto d943a; } goto C965e; E8543: return SiteCommand::SUCCESS; goto Ce9fd; c67d1: a81b1: goto C6346; eac26: $pythonSite->setUser($siteEntity->getUser()); goto Fd6dc; A2e7f: $constraints->addAll($pythonSettingsConstraints); goto f2276; F95ea: $output->writeln(sprintf("\x3c\151\x6e\146\157\76\123\151\x74\x65\x3c\x2f\x69\x6e\146\157\76\40\x3c\x63\157\x6d\155\145\x6e\x74\x3e\x25\163\x3c\57\143\x6f\155\x6d\x65\156\164\76\40\74\x69\x6e\146\x6f\76\x68\x61\163\x20\142\145\x65\x6e\40\141\144\x64\x65\144\56\x3c\57\151\x6e\146\157\x3e", $domainName)); goto E8543; Cf7b7: $subdomain = false === empty($subdomain) ? $subdomain : null; goto A7bab; b8cd5: goto efdc9; goto d76bf; D6729: $siteEntity = $this->siteEntityManager->createEntity(); goto B0c3f; cf300: $vhostTemplate->addProcessor(new ServerNameProcessor()); goto Ee3c4; Facf1: $siteEntity->setPythonSettings($pythonSettingsEntity); goto da9e3; efd05: $redirectionVhostTemplateFile = realpath(dirname(__FILE__) . "\x2f\x2e\56\57\x2e\x2e\57\162\x65\163\157\165\x72\x63\145\x73\x2f\156\x67\x69\x6e\170\x2f\x76\x68\157\x73\x74\137\x74\x65\155\x70\154\141\x74\145\57\x72\x65\144\x69\x72\x65\x63\164"); goto c4473; a7d92: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto fd9f1; da9e3: $pythonSettingsEntity->setPythonVersion($pythonVersion); goto F9e16; b9fa7: $vhostTemplate->addProcessor(new RedirectDomainProcessor()); goto b7ded; f1b17: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto Ac292; c97c6: throw new \Exception(sprintf("\126\x68\157\163\x74\x20\124\145\x6d\x70\x6c\x61\164\145\x20\x22\x25\x73\x22\40\144\x6f\145\163\x20\156\x6f\x74\x20\x65\170\151\163\164\x2e", $vhostTemplate)); goto b8cd5; b48d6: $redirectionVhostTemplate = file_get_contents($redirectionVhostTemplateFile); goto B2cd9; eca61: $selfSignedCertificate = Openssl::createSelfSignedCertificate($privateKey, $csr); goto a980f; B5428: if (0 == count($siteConstraints) && 0 == count($pythonSettingsConstraints)) { goto c6bdf; } goto E7f99; A2225: $pythonSiteCreator->createNginxVhost(); goto F0ffc; A8def: d943a: goto A6660; c2f80: $pythonSiteCreator->createPrivateKeyAndCertificate(); goto A2225; c03d0: if (false === is_null($vhostTemplateEntity)) { goto c56f2; } goto c97c6; Fb065: $siteEntity->setApplication($vhostTemplateEntity->getName()); goto B4162; B3163: $domainName = mb_strtolower(trim($input->getOption("\144\157\155\x61\151\x6e\x4e\141\155\145"))); goto eda5e; ba0e9: $vhostTemplate = $vhostTemplateEntity->getTemplate(); goto D6729; babd9: $certificateEntity->setCertificate($selfSignedCertificate); goto e2450; B4162: $this->siteEntityManager->updateEntity($siteEntity); goto F95ea; fd9f1: $subdomain = $resolvedDomainName->subDomain()->toString(); goto Cf7b7; d4f9a: $siteEntity->setDomainName($domainName); goto aa06a; Bc807: $pythonSiteCreator->createRootDirectory(); goto b881d; b4145: $pythonSiteCreator->writePythonVersionFile(); goto c2f80; F9e16: $pythonSettingsEntity->setPort($appPort); goto A9034; B0bc0: $pythonVersion = $input->getOption("\x70\171\164\150\157\156\126\x65\162\163\151\157\x6e"); goto B6a39; F181e: $pythonSettingsEntity = new PythonSettingsEntity(); goto Facf1; fd581: $certificateEntity->setCsr($csr); goto Ffbfc; f2c45: f465b: goto Bfea0; dc1ec: $subjectAlternativeNames[] = $registrableDomain; goto c67d1; E77da: $siteConstraints = $this->validator->validate($siteEntity); goto C9aeb; cdf56: $constraints->addAll($siteConstraints); goto A2e7f; A7bab: $vhostTemplateEntity = $this->vhostTemplateEntityManager->findOneByName($vhostTemplate); goto c03d0; A4504: $pythonSite->setRootDirectory($siteEntity->getRootDirectory()); goto Fbf82; C6346: $distinguishedName = new DistinguishedName($domainName, $subjectAlternativeNames); goto f1b17; bdfdd: $siteEntity->setVhostTemplate($vhostTemplate); goto F181e; Fe124: $certificateEntity->setType(CertificateEntity::TYPE_SELF_SIGNED); goto fd581; ca80d: b95e8: goto b48d6; C9aeb: $pythonSettingsConstraints = $this->validator->validate($pythonSettingsEntity); goto B5428; A199f: $vhostTemplate->resetProcessors(); goto cf300; aa06a: $siteEntity->setRootDirectory($rootDirectory); goto F6431; F73fe: $pythonSite = new PythonSite(); goto eac26; fd877: c6bdf: goto ba192; dda08: if (!(true === is_null($subdomain))) { goto f465b; } goto E509a; A15ba: $subjectAlternativeNames = []; goto dda08; A4651: $rsaKeyGenerator = new RsaKeyGenerator(); goto Dc6de; de3f0: $pythonSiteCreator->resetPermissions(); goto A5d70; A5d70: $vhostTemplate = new PythonVhostTemplate($pythonSite); goto b1b05; E7f99: $constraints = new ConstraintViolationList(); goto cdf56; D39f9: $pythonSite->setDomainName($domainName); goto F1db6; Dab06: } catch (\Exception $e) { goto D1421; b6847: $output->writeln(sprintf("\74\145\162\x72\157\162\76\x25\163\74\57\x65\162\x72\x6f\x72\76", $errorMessage)); goto Ebf81; Ebf81: return SiteCommand::FAILURE; goto C79f4; D1421: $errorMessage = $e->getMessage(); goto b6847; C79f4: } } }
