<?php
 namespace App\Command; use Symfony\Component\Validator\Validator\ValidatorInterface; use Symfony\Component\Validator\ConstraintViolationList; use Doctrine\Common\Collections\ArrayCollection; use App\Command\Command as BaseCommand; use App\Entity\Site as SiteEntity; use App\Site\Site; use App\Site\NodejsSite; use App\Site\StaticSite; use App\Site\PhpSite; use App\Site\PythonSite; use App\Site\ReverseProxySite; use App\Site\Deleter as SiteDeleter; use App\Site\Updater as SiteUpdater; use App\Site\Updater\NodejsSite as NodejsSiteUpdater; use App\Site\Updater\StaticSite as StaticSiteUpdater; use App\Site\Updater\PhpSite as PhpSiteUpdater; use App\Site\Updater\PythonSite as PythonSiteUpdater; use App\Site\Updater\ReverseProxySite as ReverseProxySiteUpdater; use App\Site\Deleter\NodejsSite as NodejsSiteDeleter; use App\Site\Deleter\StaticSite as StaticSiteDeleter; use App\Site\Deleter\PhpSite as PhpSiteDeleter; use App\Site\Deleter\PythonSite as PythonSiteDeleter; use App\Site\Deleter\ReverseProxySite as ReverseProxySiteDeleter; use App\Site\Parser\DomainName as DomainNameParser; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\CertificateManager as CertificateEntityManager; use App\Entity\Manager\VhostTemplateManager as VhostTemplateEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; class SiteCommand extends BaseCommand { protected DomainNameParser $domainNameParser; protected SiteEntityManager $siteEntityManager; protected CertificateEntityManager $certificateEntityManager; protected DatabaseServerEntityManager $databaseServerEntityManager; protected VhostTemplateEntityManager $vhostTemplateEntityManager; protected ValidatorInterface $validator; public function __construct(DomainNameParser $domainNameParser, SiteEntityManager $siteEntityManager, CertificateEntityManager $certificateEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, VhostTemplateEntityManager $vhostTemplateEntityManager, ValidatorInterface $validator) { goto d6e3f; Aca19: parent::__construct(); goto Ff2b5; Fc899: $this->certificateEntityManager = $certificateEntityManager; goto b7716; C153f: $this->siteEntityManager = $siteEntityManager; goto Fc899; d6e3f: $this->domainNameParser = $domainNameParser; goto C153f; df1df: $this->validator = $validator; goto Aca19; b7716: $this->databaseServerEntityManager = $databaseServerEntityManager; goto B56d4; B56d4: $this->vhostTemplateEntityManager = $vhostTemplateEntityManager; goto df1df; Ff2b5: } protected function configure() : void { $this->setName("\x73\x69\164\145\x3a\164\x6d\x70"); } protected function getSite(string $domainName) : ?Site { goto C9c8b; b7dd8: $site->setBlockedIps($siteEntity->getBlockedIps()); goto Bf79a; cb33c: if (false === is_null($siteEntity)) { goto A14da; } goto b1ded; E9680: $site->setUser($siteEntity->getUser()); goto C1677; C1677: $site->setDomainName($siteEntity->getDomainName()); goto Cbabe; b4dca: goto f1333; goto f4e05; E7afd: $siteType = $siteEntity->getType(); goto d5dcd; E6d9e: $siteEntity = $this->getSiteEntity($domainName); goto cb33c; Bf566: if (!(false === is_null($site))) { goto b2ed2; } goto a5589; f737a: $site->setSubdomain($subdomain); goto a0fb5; f4e05: A14da: goto E7afd; a5568: $site->setBlockedBots($siteEntity->getBlockedBots()); goto b7dd8; dae8b: $site->setCertificates($siteEntity->getCertificates()); goto E3763; Fbb31: $site->setVhostTemplate($siteEntity->getVhostTemplate()); goto d9ca0; C686f: $site->setSshUsers($siteEntity->getSshUsers()); goto Fbb31; fe914: $site->setPageSpeedEnabled($siteEntity->getPageSpeedEnabled()); goto Aebf9; Aebf9: $site->setPageSpeedSettings($siteEntity->getPageSpeedSettings()); goto a04be; Cbabe: $site->setRegistrableDomain($registrableDomain); goto f737a; a0fb5: $site->setRootDirectory($siteEntity->getRootDirectory()); goto A3807; F77ec: return $site; goto Dde33; A4edc: $site->setBasicAuth($siteEntity->getBasicAuth()); goto a5568; D2aaa: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto E091b; d9ca0: $site->setAllowTrafficFromCloudflareOnly($siteEntity->allowTrafficFromCloudflareOnly()); goto fe914; E091b: $subdomain = $resolvedDomainName->subDomain()->toString(); goto edd1f; e4bb5: $siteDatabases = $this->getSiteDatabases($siteEntity); goto E9680; C9c8b: $site = null; goto E6d9e; b1ded: throw new \Exception(sprintf("\123\151\164\145\x20\x22\x25\x73\42\40\144\157\145\163\40\156\157\164\40\145\170\151\163\164\x2e", $domainName)); goto b4dca; A3807: $site->setDatabases($siteDatabases); goto A4edc; d5dcd: switch ($siteType) { case SiteEntity::TYPE_NODEJS: goto e8683; C673b: goto F681a; goto Ae4eb; e8683: $site = new NodejsSite(); goto baaca; baaca: $site->setNodejsSettings($siteEntity->getNodejsSettings()); goto C673b; Ae4eb: case SiteEntity::TYPE_STATIC: $site = new StaticSite(); goto F681a; case SiteEntity::TYPE_PHP: goto c3d02; c3d02: $site = new PhpSite(); goto d70f2; Dac95: goto F681a; goto bf78b; d70f2: $site->setPhpSettings($siteEntity->getPhpSettings()); goto B3c60; B3c60: $site->setVarnishCache($siteEntity->getVarnishCache()); goto Dac95; bf78b: case SiteEntity::TYPE_PYTHON: goto e03bf; b4303: goto F681a; goto c4f7f; Ce83c: $site->setPythonSettings($siteEntity->getPythonSettings()); goto b4303; e03bf: $site = new PythonSite(); goto Ce83c; c4f7f: case SiteEntity::TYPE_REVERSE_PROXY: goto fbd6c; e19cb: $site->setReverseProxyUrl($siteEntity->getReverseProxyUrl()); goto D9663; fbd6c: $site = new ReverseProxySite(); goto e19cb; D9663: goto F681a; goto c9bab; c9bab: } goto f4349; C6b5e: F681a: goto Bf566; f4349: d80b2: goto C6b5e; a5589: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto D2aaa; E3763: $site->setCronJobs($siteEntity->getCronJobs()); goto Bc6fe; Bc6fe: $site->setFtpUsers($siteEntity->getFtpUsers()); goto C686f; edd1f: $subdomain = false === empty($subdomain) ? $subdomain : null; goto e4bb5; e4e63: f1333: goto F77ec; Bf79a: $site->setCertificate($siteEntity->getCertificate()); goto dae8b; a04be: b2ed2: goto e4e63; Dde33: } private function getSiteDatabases(SiteEntity $siteEntity) : ?ArrayCollection { goto Ad931; c79c6: return $siteDatabases; goto e8905; Dbc30: foreach ($databaseEntities as $databaseEntity) { goto f41ec; f41ec: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto E665c; Fb866: F9a7e: goto c73f7; c73f7: ac114: goto b7815; d5d8e: $siteDatabases->add($databaseEntity); goto Fb866; E665c: if (!($databaseServerEntity->getId() == $activeDatabaseServerEntity->getId())) { goto F9a7e; } goto d5d8e; b7815: } goto B4af6; Ad931: $siteDatabases = new ArrayCollection(); goto ca08a; Cdc24: $databaseEntities = $siteEntity->getDatabases(); goto Dbc30; B4af6: A38ae: goto c79c6; ca08a: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto Cdc24; e8905: } protected function getSiteDeleter(Site $site) : ?SiteDeleter { goto c035f; Cd4ec: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteDeleter = new NodejsSiteDeleter($site); goto Ea425; case SiteEntity::TYPE_STATIC: $siteDeleter = new StaticSiteDeleter($site); goto Ea425; case SiteEntity::TYPE_PHP: $siteDeleter = new PhpSiteDeleter($site); goto Ea425; case SiteEntity::TYPE_PYTHON: $siteDeleter = new PythonSiteDeleter($site); goto Ea425; case SiteEntity::TYPE_REVERSE_PROXY: $siteDeleter = new ReverseProxySiteDeleter($site); goto Ea425; } goto C5e64; ce0cd: return $siteDeleter; goto B8501; Ef19e: Ea425: goto ce0cd; D3854: $siteType = $site->getType(); goto Cd4ec; c035f: $siteDeleter = null; goto D3854; C5e64: f413f: goto Ef19e; B8501: } protected function getSiteUpdater(Site $site) : ?SiteUpdater { goto fa646; dda9a: A34fb: goto Cc548; e1b6b: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteUpdater = new NodejsSiteUpdater($site); goto fdae6; case SiteEntity::TYPE_STATIC: $siteUpdater = new StaticSiteUpdater($site); goto fdae6; case SiteEntity::TYPE_PHP: $siteUpdater = new PhpSiteUpdater($site); goto fdae6; case SiteEntity::TYPE_PYTHON: $siteUpdater = new PythonSiteUpdater($site); goto fdae6; case SiteEntity::TYPE_REVERSE_PROXY: $siteUpdater = new ReverseProxySiteUpdater($site); goto fdae6; } goto dda9a; f204c: $siteType = $site->getType(); goto e1b6b; fa646: $siteUpdater = null; goto f204c; Cc548: fdae6: goto Bc5bd; Bc5bd: return $siteUpdater; goto Fb518; Fb518: } protected function getSiteEntity(string $domainName) : ?SiteEntity { $siteEntity = $this->siteEntityManager->findOneByDomainName($domainName); return $siteEntity; } protected function getSiteEntityBySiteUser(string $siteUser) : ?SiteEntity { $siteEntity = $this->siteEntityManager->findOneByUser($siteUser); return $siteEntity; } protected function prepareConstraints(ConstraintViolationList $constraints) : void { $this->changePropertyPath("\165\163\145\x72", "\x73\x69\164\145\125\163\x65\162", $constraints); $this->changePropertyPath("\x75\163\x65\x72\120\141\163\x73\x77\157\162\144", "\x73\151\164\x65\x55\163\x65\162\x50\x61\x73\x73\x77\x6f\162\x64", $constraints); } }
