<?php
 namespace App\Controller\Admin; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Component\Form\Extension\Core\Type\SubmitType; use Symfony\Component\Form\Form; use App\Controller\Controller; use Symfony\Contracts\Translation\TranslatorInterface; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\UserManager as UserEntityManager; use App\Entity\Manager\TimezoneManager as TimezoneEntityManager; use App\Entity\User as UserEntity; use App\Event\EventQueue; use App\Service\Logger; class UserController extends Controller { private UserEntityManager $userEntityManager; private SiteEntityManager $siteEntityManager; private TimezoneEntityManager $timezoneEntityManager; public function __construct(UserEntityManager $userEntityManager, SiteEntityManager $siteEntityManager, TimezoneEntityManager $timezoneEntityManager, TranslatorInterface $translator, Logger $logger) { goto c0650; Aa309: $this->siteEntityManager = $siteEntityManager; goto C2b00; edbdb: parent::__construct($translator, $logger); goto ebfe4; C2b00: $this->timezoneEntityManager = $timezoneEntityManager; goto edbdb; c0650: $this->userEntityManager = $userEntityManager; goto Aa309; ebfe4: } public function index(Request $request) : Response { goto A4968; C4532: $users = $this->userEntityManager->findAll([], ["\165\x73\x65\162\x4e\x61\155\145" => "\x61\163\143"]); goto f59a7; E5f25: return $response; goto F4552; A4968: $currentUser = $this->getUser(); goto C4532; f59a7: $users = array_filter($users, function ($user) use($currentUser) { return $currentUser->getId() != $user->getId(); }); goto a421d; a421d: $response = $this->render("\x41\144\155\x69\x6e\57\125\163\145\162\x2f\151\x6e\144\145\170\x2e\150\164\155\154\x2e\164\167\x69\x67", ["\165\x73\145\x72\163" => $users]); goto E5f25; F4552: } public function new(Request $request) : Response { goto Fbae6; Fd662: fea9b: goto ab62d; ab62d: df956: goto b19d3; B9e35: return $response; goto a9284; a9284: Ac150: goto Fd662; d4f28: if (!(true === $form->isSubmitted())) { goto fea9b; } goto D826d; C76cd: $userEntity->setTimezone($defaultTimezone); goto b0c2c; D826d: $response = $this->handleUserForm($request, $form); goto Ccf45; E7f61: if (!(true === $request->isMethod("\120\117\x53\124"))) { goto df956; } goto e3415; Ccf45: if (!(false === is_null($response))) { goto Ac150; } goto B9e35; b0c2c: $form = $this->createUserForm($userEntity); goto E7f61; b19d3: $response = $this->render("\101\x64\155\151\x6e\57\x55\x73\145\162\57\x6e\x65\x77\56\x68\164\155\x6c\56\164\167\151\x67", ["\x75\x73\145\162" => $userEntity, "\x73\x69\164\145\163" => $sites, "\146\157\162\155" => $form->createView(), "\146\x6f\162\x6d\105\x72\x72\157\162\x73" => $this->formErrors]); goto ee63b; E510b: $sites = $this->siteEntityManager->findAll([], ["\x64\x6f\x6d\141\151\156\x4e\x61\x6d\145" => "\x41\123\x43"]); goto C76cd; Fbae6: $userEntity = $this->userEntityManager->createEntity(); goto Eb18a; ee63b: return $response; goto F7402; Eb18a: $defaultTimezone = $this->timezoneEntityManager->findOneByName(UserEntity::DEFAULT_TIMEZONE); goto E510b; e3415: $form->handleRequest($request); goto d4f28; F7402: } private function createUserForm(UserEntity $userEntity) : Form { goto D0d06; E2742: return $form; goto Be17d; D94a9: $form->add("\x73\x75\x62\x6d\151\x74", SubmitType::class, ["\141\164\x74\162" => ["\x63\x6c\141\163\x73" => "\142\164\156\40\x62\164\x6e\55\x62\x6c\165\145\40\142\x74\156\x2d\x6c\x67"], "\x6c\x61\x62\145\154" => "\x41\144\144\40\125\163\x65\x72"]); goto E2742; D0d06: $form = $this->createForm("\101\160\x70\134\x46\x6f\162\155\x5c\x41\x64\155\151\156\x55\x73\145\162\x54\x79\160\x65", $userEntity, ["\x61\x63\x74\x69\157\156" => $this->generateUrl("\x63\x6c\160\x5f\141\144\155\151\x6e\x5f\x75\x73\145\x72\137\x6e\x65\167"), "\155\145\164\150\157\144" => "\120\x4f\x53\124", "\x61\164\164\x72" => []]); goto D94a9; Be17d: } private function handleUserForm(Request $request, Form $form) { goto c246d; E7e19: goto A4eb8; goto c09f3; D6dd6: try { goto e06c1; Feb7c: $session->getFlashBag()->set("\163\165\x63\143\145\163\x73", $this->translator->trans("\x55\x73\x65\162\x20\150\x61\x73\x20\x62\x65\x65\x6e\x20\x61\x64\x64\x65\x64\56")); goto D1c46; e06c1: $currentUser = $this->getUser(); goto ebebc; e1c74: return $response; goto A2b55; A29de: b1dde: goto bf4c6; bf4c6: sort($domainNames); goto cc499; D1c46: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\141\x64\x6d\x69\156\137\165\163\145\x72\x73")); goto e1c74; D42e6: if (!(count($sites) && UserEntity::ROLE_USER == $userEntity->getRole())) { goto b1dde; } goto B26a9; bc0dc: $userEntity = $form->getData(); goto d9d47; B26a9: foreach ($sites as $site) { $domainNames[] = $site->getDomainName(); Aae10: } goto f81fd; ebebc: $session = $request->getSession(); goto bc0dc; Bb673: $eventData = ["\165\163\145\x72\116\141\x6d\145" => $userEntity->getUserName(), "\x66\151\x72\163\x74\116\141\x6d\x65" => $userEntity->getFirstName(), "\x6c\141\x73\x74\x4e\x61\x6d\145" => $userEntity->getLastName(), "\145\x6d\141\x69\154" => $userEntity->getEMail(), "\162\157\154\x65" => $userEntity->getRole(), "\x73\x69\164\145\x73" => implode("\x2c\40", $domainNames)]; goto Dd02b; ae859: $domainNames = []; goto D42e6; d9d47: $sites = $userEntity->getSites(); goto ae859; Dd02b: EventQueue::addEvent(EventQueue::EVENT_ADMIN_USER_ADD, $currentUser, $eventData, $request); goto Feb7c; f81fd: Ed0ff: goto A29de; cc499: $this->userEntityManager->updateUser($userEntity); goto Bb673; A2b55: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\x6e\147\x65\x72", $this->translator->trans("\x41\x6e\x20\145\162\x72\x6f\162\40\x68\x61\x73\40\x6f\x63\x63\x75\162\x72\145\x64\x2c\40\x65\162\162\157\x72\40\x6d\x65\x73\x73\141\147\x65\72\x20\x25\x65\162\162\x6f\x72\115\145\x73\163\x61\147\145\x25", ["\45\145\162\x72\x6f\162\115\145\163\163\141\147\x65\45" => $e->getMessage()])); } goto F9fc2; c246d: if (true === $form->isValid()) { goto Eef28; } goto E730e; F9fc2: A4eb8: goto E3d42; E730e: $this->formErrors = $this->getErrorMessages($form); goto E7e19; c09f3: Eef28: goto D6dd6; E3d42: } public function edit(Request $request) : Response { goto D10b8; F7851: $response = $this->handleUserEditForm($request, $form); goto e7c1f; f740c: f8f9d: goto E44e5; e7c1f: if (!(false === is_null($response))) { goto d3214; } goto c1888; D6821: $response = $this->render("\x41\144\155\151\x6e\x2f\125\x73\x65\162\x2f\x65\x64\x69\x74\x2e\150\x74\x6d\154\x2e\164\167\151\x67", ["\165\x73\x65\162" => $userEntity, "\163\151\164\145\x73" => $sites, "\x66\157\x72\x6d" => $form->createView(), "\x66\x6f\x72\155\x45\x72\x72\x6f\162\163" => $this->formErrors]); goto f740c; Aecca: if (!(true === $request->isMethod("\120\117\x53\x54"))) { goto B6967; } goto A80d2; E44e5: return $response; goto bf9b5; A80d2: $form->handleRequest($request); goto f5127; Fb440: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\141\144\x6d\x69\x6e\137\165\163\145\162\x73")); goto Cf44b; c0473: B6967: goto D6821; Cf44b: goto f8f9d; goto Eb2e6; C1ac1: $userEntity = $this->userEntityManager->findOneById($id); goto E9e2e; D10b8: $id = (int) $request->get("\x69\144"); goto C1ac1; Eb2e6: Be226: goto Ac3ec; B2453: d3214: goto b8805; c71bc: $form = $this->createUserEditForm($userEntity); goto Aecca; E9e2e: if (false === is_null($userEntity)) { goto Be226; } goto Fb440; f5127: if (!(true === $form->isSubmitted())) { goto cd9fa; } goto F7851; c1888: return $response; goto B2453; b8805: cd9fa: goto c0473; Ac3ec: $sites = $this->siteEntityManager->findAll([], ["\x64\x6f\155\141\x69\x6e\x4e\141\155\x65" => "\x41\x53\x43"]); goto c71bc; bf9b5: } private function createUserEditForm(UserEntity $userEntity) : Form { goto d9084; d9084: $form = $this->createForm("\101\160\x70\134\x46\157\162\x6d\x5c\101\x64\155\x69\156\125\163\x65\x72\x45\144\151\164\124\171\x70\145", $userEntity, ["\141\x63\164\151\157\156" => $this->generateUrl("\x63\x6c\160\x5f\141\x64\x6d\x69\x6e\x5f\x75\163\145\162\x5f\x65\x64\151\x74", ["\151\x64" => $userEntity->getId()]), "\x6d\x65\164\150\x6f\144" => "\x50\117\x53\x54", "\x61\164\x74\x72" => []]); goto D37bc; Cc62a: return $form; goto E4a4b; D37bc: $form->add("\163\165\x62\155\151\x74", SubmitType::class, ["\x61\x74\x74\x72" => ["\143\x6c\141\x73\x73" => "\x62\x74\156\40\142\164\156\x2d\142\154\165\x65\40\142\164\x6e\x2d\154\x67"], "\x6c\x61\142\x65\x6c" => "\x53\x61\166\x65"]); goto Cc62a; E4a4b: } private function handleUserEditForm(Request $request, Form $form) { goto fe764; Fa0fa: a426d: goto afd49; ef696: f1d4c: goto Ccc29; a7993: goto f1d4c; goto Fa0fa; afd49: try { goto F3191; f0b6f: EventQueue::addEvent(EventQueue::EVENT_ADMIN_USER_UPDATE, $currentUser, $eventData, $request); goto D4369; aadc6: $domainNames = []; goto Fdf84; F3191: $currentUser = $this->getUser(); goto a8486; E1c48: $userEntity = $form->getData(); goto e76d6; a8486: $session = $request->getSession(); goto E1c48; Cb2f2: $sites = $userEntity->getSites(); goto aadc6; C3bfd: fe31f: goto f889d; E34b6: $eventData = ["\x75\163\145\x72\116\141\155\145" => $userEntity->getUserName(), "\146\x69\162\x73\x74\x4e\141\155\145" => $userEntity->getFirstName(), "\x6c\141\x73\x74\x4e\x61\155\x65" => $userEntity->getLastName(), "\145\x6d\141\151\154" => $userEntity->getEMail(), "\x72\x6f\x6c\145" => $userEntity->getRole(), "\163\x74\x61\164\165\163" => (int) $userEntity->getStatus(), "\163\x69\164\145\163" => implode("\54\40", $domainNames)]; goto f0b6f; D07a6: if (false === empty($plainPassword)) { goto fe31f; } goto Db132; Fdf84: if (!(count($sites) && UserEntity::ROLE_USER == $userEntity->getRole())) { goto e76b3; } goto Fd9d7; e76d6: $plainPassword = $userEntity->getPlainPassword(); goto Cb2f2; cd7d8: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\141\144\x6d\151\x6e\x5f\x75\163\x65\162\137\145\144\151\x74", ["\x69\x64" => $userEntity->getId()])); goto D345f; Ae955: goto A72e7; goto C3bfd; Db132: $this->userEntityManager->updateUser($userEntity); goto Ae955; D2e36: e76b3: goto bddf6; bddf6: sort($domainNames); goto D07a6; D345f: return $response; goto C25ce; Fd9d7: foreach ($sites as $site) { $domainNames[] = $site->getDomainName(); E75c0: } goto Cb2e4; Cb2e4: F1b6b: goto D2e36; F3cda: A72e7: goto E34b6; f889d: $this->userEntityManager->updateUser($userEntity, true, true); goto F3cda; D4369: $session->getFlashBag()->set("\x73\165\143\x63\x65\x73\x73", $this->translator->trans("\125\163\x65\x72\x20\x68\x61\163\x20\142\145\x65\156\40\165\x70\144\x61\x74\x65\x64\x2e")); goto cd7d8; C25ce: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\147\x65\162", $this->translator->trans("\101\x6e\40\x65\x72\x72\157\162\40\x68\141\163\x20\x6f\143\x63\x75\162\162\x65\x64\54\40\145\x72\x72\x6f\162\x20\155\x65\163\163\x61\x67\x65\72\x20\x25\x65\162\162\157\162\x4d\145\163\x73\141\147\145\x25", ["\x25\145\x72\162\157\162\x4d\x65\163\163\141\147\145\45" => $e->getMessage()])); } goto ef696; d269e: $this->formErrors = $this->getErrorMessages($form); goto a7993; fe764: if (true === $form->isValid()) { goto a426d; } goto d269e; Ccc29: } public function delete(Request $request) : Response { goto D9823; D035c: return $response; goto fadc0; F121f: $eventData = ["\x75\x73\x65\x72\x4e\141\x6d\145" => $userEntity->getUserName(), "\146\151\x72\163\164\x4e\x61\155\x65" => $userEntity->getFirstName(), "\154\141\163\164\x4e\x61\155\145" => $userEntity->getLastName(), "\145\155\141\151\154" => $userEntity->getEMail(), "\x72\157\x6c\145" => $userEntity->getRole()]; goto Bb643; cfb9c: $userEntity = $this->userEntityManager->findOneById($id); goto af9ca; bcc31: if (!(true === isset($id) && $id != $currentUser->getId())) { goto c72fb; } goto cfb9c; Ab831: c72fb: goto d622b; d622b: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x61\144\155\x69\x6e\137\x75\163\x65\x72\163")); goto D035c; Abe6e: $session->getFlashBag()->set("\163\165\143\143\x65\x73\163", $this->translator->trans("\x55\163\x65\162\40\x68\141\x73\x20\142\x65\x65\x6e\40\x64\145\154\x65\164\x65\x64\56")); goto De032; D9823: $currentUser = $this->getUser(); goto F46d0; A21bf: $this->userEntityManager->deleteUser($userEntity); goto Abe6e; af9ca: if (!(false === is_null($userEntity))) { goto e1857; } goto db635; De032: e1857: goto Ab831; F46d0: $id = (int) $request->get("\151\144"); goto c3fcc; c3fcc: $this->checkCsrfToken($request, "\144\x65\x6c\145\164\x65\55\165\163\x65\162"); goto bcc31; db635: $session = $request->getSession(); goto F121f; Bb643: EventQueue::addEvent(EventQueue::EVENT_ADMIN_USER_DELETE, $currentUser, $eventData, $request); goto A21bf; fadc0: } }
