<?php
 namespace App\Controller\Frontend; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Contracts\Translation\TranslatorInterface; use App\Controller\Controller; use App\Entity\Manager\InstanceCpuManager as InstanceCpuEntityManager; use App\Entity\Manager\InstanceMemoryManager as InstanceMemoryEntityManager; use App\Entity\Manager\InstanceDiskUsageManager as InstanceDiskUsageEntityManager; use App\Entity\Manager\InstanceLoadAverageManager as InstanceLoadAverageEntityManager; use App\System\CommandExecutor; use App\System\Command\MemoryInformationCommand; use App\System\Command\ProcessorCoresCommand; use App\Entity\InstanceDiskUsage as InstanceDiskUsageEntity; use App\Entity\InstanceLoadAverage as InstanceLoadAverageEntity; use App\Monitoring\Chart; use App\Monitoring\LoadAverageChart; use App\Util\HumanFileSize as HumanFileSizeUtil; use App\Util\Time as TimeUtil; use App\Service\Logger; use App\Entity\User; class DashboardController extends Controller { public const TIME_RANGE_LAST_THIRTY_MINUTES = 1; public const TIME_RANGE_LAST_HOUR = 2; public const TIME_RANGE_LAST_THREE_HOURS = 3; public const TIME_RANGE_LAST_SIX_HOURS = 4; public const TIME_RANGE_LAST_TWELVE_HOURS = 5; private static array $timeRanges = [self::TIME_RANGE_LAST_THIRTY_MINUTES, self::TIME_RANGE_LAST_HOUR, self::TIME_RANGE_LAST_THREE_HOURS, self::TIME_RANGE_LAST_SIX_HOURS, self::TIME_RANGE_LAST_TWELVE_HOURS]; private InstanceCpuEntityManager $instanceCpuEntityManager; private InstanceMemoryEntityManager $instanceMemoryEntityManager; private InstanceDiskUsageEntityManager $instanceDiskUsageEntityManager; private InstanceLoadAverageEntityManager $instanceLoadAverageEntityManager; public function __construct(InstanceCpuEntityManager $instanceCpuEntityManager, InstanceMemoryEntityManager $instanceMemoryEntityManager, InstanceDiskUsageEntityManager $instanceDiskUsageEntityManager, InstanceLoadAverageEntityManager $instanceLoadAverageEntityManager, TranslatorInterface $translator, Logger $logger) { goto A2cea; Aa078: $this->instanceDiskUsageEntityManager = $instanceDiskUsageEntityManager; goto C6b86; A2cea: $this->instanceCpuEntityManager = $instanceCpuEntityManager; goto f778e; f778e: $this->instanceMemoryEntityManager = $instanceMemoryEntityManager; goto Aa078; Dd0e4: parent::__construct($translator, $logger); goto Bc2a1; C6b86: $this->instanceLoadAverageEntityManager = $instanceLoadAverageEntityManager; goto Dd0e4; Bc2a1: } public function index(Request $request) : Response { goto bdbc0; E41ac: $loadAverageChart->setData($loadAverageData); goto Cbbd6; B8014: $timeRange = true === is_null($timeRange) ? self::TIME_RANGE_LAST_THIRTY_MINUTES : (true === in_array($timeRange, self::$timeRanges) ? $timeRange : self::TIME_RANGE_LAST_THIRTY_MINUTES); goto Cd134; Ddf87: $loadAverageChart->setInformation($loadAverageChartInformation); goto E41ac; d9c9e: cf4b3: goto b28ee; b28ee: Ddb15: goto b5935; d1fd4: $environment = $instance->getEnvironment(); goto Deb97; bdbc0: $user = $this->getUser(); goto ece6d; Ae05d: $memoryChart->setCategories($categories); goto a782c; d0d19: if ($homeDiskSize != $rootDiskSize) { goto d1c22; } goto e407e; Dbd62: b44b6: goto Cd191; F8aa1: $cpuChart = new Chart("\x43\x50\x55\40\x55\x73\x61\147\145"); goto Aadf0; C1f77: $endTime = TimeUtil::roundToNearestMinuteInterval($dateTime, 5); goto Ff711; F41a4: $rootDiskSizeInBytes = disk_total_space(InstanceDiskUsageEntity::DISK_ROOT); goto fc8f2; e8f07: $diskData = [["\x6e\x61\155\x65" => sprintf("\57\40\x28\x25\163\x29", $rootDiskSize), "\143\157\x6c\157\162" => "\43\x37\63\x62\146\64\143", "\x64\141\164\141" => $diskData["\x72\157\x6f\x74"] ?: []], ["\156\x61\x6d\x65" => sprintf("\x2f\x68\157\x6d\x65\x20\x28\45\x73\x29", $homeDiskSize), "\x63\157\154\157\x72" => "\43\146\63\142\x66\x30\60", "\144\141\x74\x61" => $diskData["\x68\157\155\145"] ?: []]]; goto Dbd62; cf576: $memoryChart = new Chart("\115\145\155\157\x72\171\x20\x55\x73\x61\147\145"); goto f192d; dd037: $cpuChart->setCategories($categories); goto cf576; Ff711: switch ($timeRange) { case self::TIME_RANGE_LAST_THIRTY_MINUTES: goto Ac2bc; Ac2bc: $minuteInterval = 5; goto F9682; e2e74: goto Ddb15; goto a507d; F9682: $startTime = (clone $endTime)->modify("\55\x33\60\x20\x6d\151\156\165\x74\145\x73"); goto e2e74; a507d: case self::TIME_RANGE_LAST_HOUR: goto bf012; Efb53: $startTime = (clone $endTime)->modify("\55\x31\40\150\157\x75\x72"); goto Ce381; Ce381: goto Ddb15; goto C8b70; bf012: $minuteInterval = 10; goto Efb53; C8b70: case self::TIME_RANGE_LAST_THREE_HOURS: goto Ce6d1; E2b15: goto Ddb15; goto ebd99; Ce6d1: $minuteInterval = 30; goto C9a8d; C9a8d: $startTime = (clone $dateTime)->modify("\55\63\x20\x68\157\165\x72\163"); goto E2b15; ebd99: case self::TIME_RANGE_LAST_SIX_HOURS: goto b98ff; b98ff: $minuteInterval = 60; goto aad88; a9166: goto Ddb15; goto e4dc2; aad88: $startTime = (clone $dateTime)->modify("\55\x36\40\x68\x6f\x75\x72\x73"); goto a9166; e4dc2: case self::TIME_RANGE_LAST_TWELVE_HOURS: goto c22f9; C1d4b: goto Ddb15; goto a836f; c22f9: $minuteInterval = 120; goto f2630; f2630: $startTime = (clone $dateTime)->modify("\55\61\x32\x20\150\x6f\165\162\163"); goto C1d4b; a836f: } goto d9c9e; Aadf0: $cpuChart->setInformation($cpuInformation); goto A5f56; Db10d: $diskChart->setData($diskData); goto B9b4f; Cd134: $totalMemory = ''; goto C8db8; b5935: $categories = $this->getCategoriesForTimeRange($user, $startTime, $endTime, $minuteInterval); goto Bc89b; B2a6c: $dateTime = new \DateTime(); goto C1f77; Ed9d1: $timeRange = $request->get("\164\151\x6d\145\122\x61\156\147\x65"); goto B8014; e6972: try { goto bd699; Cd17c: $totalMemory = HumanFileSizeUtil::convert($totalMemoryInBytes, "\x47\x42", 0); goto bdfcc; dca67: $memoryInformationCommand = new MemoryInformationCommand(); goto e7ad9; Cc4c8: $numberOfProcessorCores = $processorCoresCommand->getNumberOfProcessorCores(); goto f7af2; e7ad9: $commandExecutor->execute($memoryInformationCommand); goto F02c7; F02c7: $totalMemoryInBytes = $memoryInformationCommand->getTotalMemoryInBytes(); goto Cd17c; bdfcc: $processorCoresCommand = new ProcessorCoresCommand(); goto ebb35; bd699: $commandExecutor = new CommandExecutor(); goto dca67; ebb35: $commandExecutor->execute($processorCoresCommand); goto Cc4c8; f7af2: } catch (\Exception $e) { $this->logger->exception($e); } goto F41a4; f192d: $memoryChart->setInformation($totalMemory); goto d4963; A8460: $memoryData = $this->getMemoryDataForTimeRange($startTime, $endTime, $minuteInterval); goto c753f; Deb97: $cloud = $environment->getCloudProvider(); goto Ed9d1; A5f56: $cpuChart->setData($cpuData); goto dd037; C8db8: $numberOfProcessorCores = 0; goto e6972; d4963: $memoryChart->setData($memoryData); goto Ae05d; a782c: $diskChart = new Chart("\104\151\163\x6b\x20\125\x73\x61\147\x65"); goto Db10d; c753f: $diskData = $this->getDiskDataForTimeRange($startTime, $endTime, $minuteInterval); goto d0d19; e5d89: $loadAverageChart = new LoadAverageChart("\x4c\x6f\x61\144\40\x41\x76\145\x72\141\x67\x65"); goto Ddf87; B9b4f: $diskChart->setCategories($categories); goto A14d9; df65c: d1c22: goto e8f07; E413b: $response = $this->render("\x46\162\157\x6e\164\x65\x6e\x64\57\104\141\x73\150\142\x6f\141\162\144\x2f\x69\x6e\x64\x65\x78\56\x68\x74\x6d\x6c\56\x74\167\151\x67", ["\x63\154\157\165\144" => $cloud, "\151\x6e\163\164\141\156\143\145" => $instance, "\165\x73\145\x72" => $user, "\x74\151\x6d\145\x52\141\156\147\x65" => $timeRange, "\x63\x70\x75\x43\150\x61\x72\164" => $cpuChart, "\x6d\x65\155\x6f\x72\171\103\x68\141\x72\164" => $memoryChart, "\144\x69\163\153\x43\x68\x61\162\x74" => $diskChart, "\x6c\x6f\x61\x64\x41\x76\145\x72\x61\x67\145\x43\x68\141\x72\x74" => $loadAverageChart]); goto Fa15b; Bc89b: $cpuData = $this->getCpuDataForTimeRange($startTime, $endTime, $minuteInterval); goto A8460; ece6d: $instance = $request->attributes->get("\x69\156\x73\x74\x61\x6e\143\x65"); goto d1fd4; de8e4: $cpuInformation = sprintf("\x25\x73\40\45\163", $numberOfProcessorCores, $this->translator->trans("\x43\x50\x55")); goto F8aa1; Cd191: $loadAverageRawData = $this->getLoadAverageDataForTimeRange($startTime, $endTime, $minuteInterval); goto Fc572; E1587: goto b44b6; goto df65c; e407e: $diskData = [["\x6e\x61\155\145" => sprintf("\x2f\x20\x28\x25\163\51", $rootDiskSize), "\x63\x6f\154\157\x72" => "\43\x37\x33\x62\146\x34\143", "\x64\x61\x74\141" => $diskData["\x72\157\x6f\164"] ?: []]]; goto E1587; Cbbd6: $loadAverageChart->setCategories($categories); goto E413b; Fa15b: return $response; goto Fe3da; Ae05f: $homeDiskSizeInBytes = disk_total_space(InstanceDiskUsageEntity::DISK_HOME); goto a94a7; A14d9: $loadAverageChartInformation = sprintf("\x25\x73\x20\x25\x73", $numberOfProcessorCores, $this->translator->trans("\103\x50\125")); goto e5d89; fc8f2: $rootDiskSize = HumanFileSizeUtil::convert($rootDiskSizeInBytes, "\107\102", 0); goto Ae05f; Fc572: $loadAverageData = [["\x6e\x61\x6d\145" => $this->translator->trans("\x31\40\115\151\x6e\x75\x74\x65"), "\143\157\154\x6f\162" => "\43\67\x37\64\x61\x61\x34", "\x64\141\x74\141" => $loadAverageRawData[InstanceLoadAverageEntity::PERIOD_ONE_MINUTE] ?? []], ["\x6e\141\155\145" => $this->translator->trans("\65\x20\115\151\x6e\165\x74\x65\x73"), "\x63\x6f\x6c\157\162" => "\43\145\x62\65\70\x36\143", "\144\141\164\x61" => $loadAverageRawData[InstanceLoadAverageEntity::PERIOD_FIVE_MINUTES] ?? []], ["\156\141\x6d\145" => $this->translator->trans("\x31\65\40\x4d\x69\x6e\165\x74\145\x73"), "\143\157\x6c\157\162" => "\43\x30\60\67\x38\x64\64", "\x64\x61\x74\141" => $loadAverageRawData[InstanceLoadAverageEntity::PERIOD_FIVETEEN_MINUTES] ?? []]]; goto de8e4; a94a7: $homeDiskSize = HumanFileSizeUtil::convert($homeDiskSizeInBytes, "\107\x42", 0); goto B2a6c; Fe3da: } private function getCategoriesForTimeRange(User $user, \DateTimeInterface $startTime, \DateTimeInterface $endTime, $minuteInterval) : array { goto f1c8f; F7d16: if (!($endDataDate <= $endTime)) { goto D535f; } goto f343c; D8fae: $endDataDate = clone $startTime; goto E3a52; d930f: goto F2ea2; goto A9781; E3a52: F2ea2: goto F7d16; c1447: $endDataDate->modify(sprintf("\x2b\x25\x30\65\144\40\x6d\151\156\165\164\x65\163", $minuteInterval)); goto d930f; A9781: D535f: goto b1ae9; C3813: $startDataDate = (clone $startTime)->modify(sprintf("\x2d\45\x30\x35\144\x20\155\x69\156\165\164\145\163", $minuteInterval)); goto D8fae; f343c: $categoryDateTime = clone $endDataDate; goto F7cc9; d54b3: $startDataDate->modify(sprintf("\53\x25\x30\x35\144\40\x6d\151\156\165\x74\145\163", $minuteInterval)); goto c1447; b1ae9: return $categories; goto D48d0; f1c8f: $categories = []; goto C3813; F7cc9: $categoryDateTime->setTimezone(new \DateTimeZone($user->getTimezone())); goto a7751; a7751: $categories[] = $categoryDateTime->format("\x48\x3a\151"); goto d54b3; D48d0: } private function getCpuDataForTimeRange(\DateTimeInterface $startTime, \DateTimeInterface $endTime, $minuteInterval) : array { goto Fb68e; D3f81: b6516: goto C1503; Fedb7: d3e94: goto d7c23; a1c34: $endDataDate->modify(sprintf("\x2b\x25\x30\65\144\40\155\x69\x6e\165\164\145\x73", $minuteInterval)); goto C8c09; D33a2: $startDataDate->modify(sprintf("\x2b\x25\x30\65\144\x20\x6d\x69\156\x75\x74\145\163", $minuteInterval)); goto a1c34; d2e4b: $cpuData[] = $averageCpuValue; goto D33a2; C1503: return $cpuData; goto a78db; e8064: $endDataDate = clone $startTime; goto Fedb7; C8c09: goto d3e94; goto D3f81; af5f4: $averageCpuValue = $this->instanceCpuEntityManager->getAverageCpuValue($startDataDate, $endDataDate); goto d2e4b; d7c23: if (!($endDataDate <= $endTime)) { goto b6516; } goto af5f4; e539d: $startDataDate = (clone $startTime)->modify(sprintf("\x2d\45\x30\65\144\x20\x6d\151\x6e\165\x74\145\x73", $minuteInterval)); goto e8064; Fb68e: $cpuData = []; goto e539d; a78db: } private function getMemoryDataForTimeRange(\DateTimeInterface $startTime, \DateTimeInterface $endTime, $minuteInterval) : array { goto Ab98c; De450: $startDataDate->modify(sprintf("\53\45\x30\x35\x64\40\155\151\x6e\165\x74\x65\163", $minuteInterval)); goto b1f96; Ebb6d: return $memoryData; goto b99eb; F49a6: goto B7a00; goto dbf5f; f5ffd: $endDataDate = clone $startTime; goto af7f6; b1f96: $endDataDate->modify(sprintf("\53\x25\x30\x35\144\40\155\x69\x6e\165\164\x65\x73", $minuteInterval)); goto F49a6; dcdab: $averageMemoryValue = $this->instanceMemoryEntityManager->getAverageMemoryValue($startDataDate, $endDataDate); goto d37ea; effd0: if (!($endDataDate <= $endTime)) { goto A829b; } goto dcdab; af7f6: B7a00: goto effd0; dbf5f: A829b: goto Ebb6d; Ab98c: $memoryData = []; goto c554e; d37ea: $memoryData[] = (int) $averageMemoryValue; goto De450; c554e: $startDataDate = (clone $startTime)->modify(sprintf("\55\45\60\x35\144\40\155\x69\156\165\164\145\x73", $minuteInterval)); goto f5ffd; b99eb: } private function getDiskDataForTimeRange($startTime, $endTime, $minuteInterval) : array { goto Ede68; E6f4f: foreach (["\57", "\x2f\x68\x6f\x6d\x65"] as $disk) { goto e45e2; e45e2: $averageDiskSizeValue = (int) $this->instanceDiskUsageEntityManager->getAverageDiskSizeValue($disk, $startDataDate, $endDataDate); goto A33d4; c2895: fb8c8: goto dc5d0; De7dd: $diskData["\150\x6f\x6d\145"][] = (int) $averageDiskSizeValue; goto F4c39; dc5d0: C4c47: goto c4ae5; F4c39: goto fb8c8; goto Bfcfe; A33d4: if ("\57" == $disk) { goto b75f3; } goto De7dd; A6b2f: $diskData["\162\x6f\157\x74"][] = (int) $averageDiskSizeValue; goto c2895; Bfcfe: b75f3: goto A6b2f; c4ae5: } goto F781e; Bbdd7: if (!($endDataDate <= $endTime)) { goto F20a2; } goto E6f4f; A3117: $endDataDate->modify(sprintf("\x2b\x25\x30\x35\x64\40\x6d\x69\156\x75\x74\145\x73", $minuteInterval)); goto fcca7; D82bd: aea87: goto Bbdd7; fcca7: goto aea87; goto d926a; F7fc6: $startDataDate->modify(sprintf("\53\45\x30\x35\144\x20\155\151\x6e\x75\164\x65\x73", $minuteInterval)); goto A3117; a1ed3: $startDataDate = (clone $startTime)->modify(sprintf("\x2d\x25\x30\x35\x64\x20\155\x69\156\x75\164\x65\163", $minuteInterval)); goto D5cfb; F781e: C47f7: goto F7fc6; d926a: F20a2: goto Edc6d; Edc6d: return $diskData; goto bf8ce; Ede68: $diskData = []; goto a1ed3; D5cfb: $endDataDate = clone $startTime; goto D82bd; bf8ce: } private function getLoadAverageDataForTimeRange($startTime, $endTime, $minuteInterval) : array { goto ecf83; D22e3: F625c: goto beeba; ecf83: $loadAverageData = []; goto ac1ec; b3c7c: $endDataDate->modify(sprintf("\x2b\x25\60\65\x64\40\x6d\151\x6e\165\164\145\163", $minuteInterval)); goto feffe; E96e3: A94d9: goto bbc24; feffe: goto F625c; goto E96e3; A0bcb: db4c9: goto c1d8f; bbc24: return $loadAverageData; goto A371c; b1de2: $endDataDate = clone $startTime; goto D22e3; ac1ec: $startDataDate = (clone $startTime)->modify(sprintf("\55\x25\x30\65\x64\x20\155\x69\156\165\164\x65\x73", $minuteInterval)); goto b1de2; B6116: foreach ([InstanceLoadAverageEntity::PERIOD_ONE_MINUTE, InstanceLoadAverageEntity::PERIOD_FIVE_MINUTES, InstanceLoadAverageEntity::PERIOD_FIVETEEN_MINUTES] as $period) { goto e01ab; A7d46: $loadAverageData[$period][] = round($loadAverageValue, 2); goto Ac419; e01ab: $loadAverageValue = $this->instanceLoadAverageEntityManager->getLoadAverageValue($period, $startDataDate, $endDataDate); goto A7d46; Ac419: B04d2: goto Ca816; Ca816: } goto A0bcb; beeba: if (!($endDataDate <= $endTime)) { goto A94d9; } goto B6116; c1d8f: $startDataDate->modify(sprintf("\x2b\x25\60\65\x64\x20\155\151\156\x75\164\145\163", $minuteInterval)); goto b3c7c; A371c: } }
