<?php
 namespace App\Controller\Frontend; use Symfony\Component\Form\FormError; use Symfony\Component\HttpFoundation\Request; use Symfony\Component\HttpFoundation\Response; use Symfony\Component\HttpFoundation\RedirectResponse; use Symfony\Component\Form\Extension\Core\Type\ButtonType; use Symfony\Component\Form\Extension\Core\Type\SubmitType; use Symfony\Component\Security\Core\Exception\InvalidCsrfTokenException; use Symfony\Contracts\Translation\TranslatorInterface; use Symfony\Component\HttpFoundation\Cookie; use Symfony\Component\Form\Form; use Twig\Environment as Twig; use Doctrine\Common\Collections\ArrayCollection; use App\Controller\Controller; use App\Event\EventQueue; use App\Service\Crypto; use App\Service\Logger; use App\Site\Site; use App\Site\NodejsSite; use App\Site\StaticSite; use App\Site\PhpSite; use App\Site\PythonSite; use App\Site\ReverseProxySite; use App\Entity\Site as SiteEntity; use App\Entity\NodejsSettings; use App\Entity\PhpSettings; use App\Entity\PythonSettings; use App\Entity\BasicAuth as BasicAuthEntity; use App\Entity\BlockedBot as BlockedBotEntity; use App\Entity\BlockedIp as BlockedIpEntity; use App\Entity\Database as DatabaseEntity; use App\Entity\DatabaseUser as DatabaseUserEntity; use App\Entity\User as UserEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\CronJob as CronJobEntity; use App\Entity\FtpUser as FtpUserEntity; use App\Entity\SshUser as SshUserEntity; use App\Site\Updater as SiteUpdater; use App\Site\Updater\NodejsSite as NodejsSiteUpdater; use App\Site\Updater\StaticSite as StaticSiteUpdater; use App\Site\Updater\PhpSite as PhpSiteUpdater; use App\Site\Updater\PythonSite as PythonSiteUpdater; use App\Site\Updater\ReverseProxySite as ReverseProxySiteUpdater; use App\Site\Deleter as SiteDeleter; use App\Site\Deleter\NodejsSite as NodejsSiteDeleter; use App\Site\Deleter\StaticSite as StaticSiteDeleter; use App\Site\Deleter\PhpSite as PhpSiteDeleter; use App\Site\Deleter\PythonSite as PythonSiteDeleter; use App\Site\Deleter\ReverseProxySite as ReverseProxySiteDeleter; use App\Database\Manager as DatabaseManager; use App\Entity\Manager\ConfigManager; use App\Entity\Manager\SiteManager as SiteEntityManager; use App\Entity\Manager\BasicAuthManager as BasicAuthEntityManager; use App\Entity\Manager\BlockedIpManager as BlockedIpEntityManager; use App\Entity\Manager\BlockedBotManager as BlockedBotEntityManager; use App\Entity\Manager\CertificateManager as CertificateEntityManager; use App\Entity\Manager\CronJobManager as CronJobEntityManager; use App\Entity\Manager\DatabaseManager as DatabaseEntityManager; use App\Entity\Manager\DatabaseUserManager as DatabaseUserEntityManager; use App\Entity\Manager\DatabaseServerManager as DatabaseServerEntityManager; use App\Entity\Manager\NodejsSettingsManager as NodejsSettingsEntityManager; use App\Entity\Manager\FtpUserManager as FtpUserEntityManager; use App\Entity\Manager\SshUserManager as SshUserEntityManager; use App\Log\LogfileReader; use App\Log\LogsFinder; use App\Log\Parser\NginxAccessLogParser; use App\Log\Parser\NginxErrorLogParser; use App\Log\Parser\PhpFpmErrorLogParser; use App\Site\Parser\DomainName as DomainNameParser; use App\Site\Nginx\Exception\InvalidVhostException; use App\Site\Ssl\DistinguishedName; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Site\Ssl\Generator\CsrGenerator; use App\Site\Ssl\PrivateKey; use App\Site\Ssl\LetsEncryptClient; use App\Site\VarnishCache\Client as VarnishCacheClient; class SitesController extends Controller { private const FILE_MANAGER_COOKIE_EXPIRATION = 3; private ConfigManager $configManager; private SiteEntityManager $siteEntityManager; private BasicAuthEntityManager $basicAuthEntityManager; private BlockedIpEntityManager $blockedIpEntityManager; private BlockedBotEntityManager $blockedBotEntityManager; private CertificateEntityManager $certificateEntityManager; private CronJobEntityManager $cronJobEntityManager; private DatabaseEntityManager $databaseEntityManager; private DatabaseUserEntityManager $databaseUserEntityManager; private DatabaseServerEntityManager $databaseServerEntityManager; private NodejsSettingsEntityManager $nodejsSettingsEntityManager; private FtpUserEntityManager $ftpUserEntityManager; private SshUserEntityManager $sshUserEntityManager; private DomainNameParser $domainNameParser; public function __construct(ConfigManager $configManager, SiteEntityManager $siteEntityManager, BasicAuthEntityManager $basicAuthEntityManager, BlockedIpEntityManager $blockedIpEntityManager, BlockedBotEntityManager $blockedBotEntityManager, CertificateEntityManager $certificateEntityManager, CronJobEntityManager $cronJobEntityManager, DatabaseEntityManager $databaseEntityManager, DatabaseUserEntityManager $databaseUserEntityManager, DatabaseServerEntityManager $databaseServerEntityManager, NodejsSettingsEntityManager $nodejsSettingsEntityManager, FtpUserEntityManager $ftpUserEntityManager, SshUserEntityManager $sshUserEntityManager, DomainNameParser $domainNameParser, TranslatorInterface $translator, Logger $logger) { goto f43e9; A21eb: $this->databaseUserEntityManager = $databaseUserEntityManager; goto b3468; Ca8dd: $this->nodejsSettingsEntityManager = $nodejsSettingsEntityManager; goto bf3c7; acd7e: $this->domainNameParser = $domainNameParser; goto F220a; b3468: $this->databaseServerEntityManager = $databaseServerEntityManager; goto Ca8dd; F220a: parent::__construct($translator, $logger); goto A3a73; Ee8b0: $this->blockedIpEntityManager = $blockedIpEntityManager; goto Cae12; a7b90: $this->basicAuthEntityManager = $basicAuthEntityManager; goto Ee8b0; f43e9: $this->configManager = $configManager; goto d751e; d9b80: $this->cronJobEntityManager = $cronJobEntityManager; goto A8b61; A8b61: $this->databaseEntityManager = $databaseEntityManager; goto A21eb; Ed932: $this->sshUserEntityManager = $sshUserEntityManager; goto acd7e; d751e: $this->siteEntityManager = $siteEntityManager; goto a7b90; Cae12: $this->blockedBotEntityManager = $blockedBotEntityManager; goto Cb063; Cb063: $this->certificateEntityManager = $certificateEntityManager; goto d9b80; bf3c7: $this->ftpUserEntityManager = $ftpUserEntityManager; goto Ed932; A3a73: } public function index(Request $request) : Response { goto A3653; A3653: $user = $this->getUser(); goto B797d; B797d: $sites = $this->siteEntityManager->getUserSites($user, ["\144\x6f\155\x61\151\156\x4e\141\155\x65" => "\141\x73\143"]); goto Fe908; Dbc13: return $response; goto E0ed5; Fe908: $response = $this->render("\x46\162\157\156\164\145\x6e\x64\57\x53\151\x74\145\57\x69\156\144\x65\170\56\x68\x74\155\x6c\x2e\164\167\x69\x67", ["\x75\163\145\162" => $user, "\x73\x69\x74\145\163" => $sites]); goto Dbc13; E0ed5: } public function fileManager(Request $request) : Response { goto D1146; e219c: $session->set("\143\154\x70\55\x66\x69\154\x65\55\155\x61\156\141\x67\x65\x72", $data); goto f72b2; B5ecb: $siteUser = $site->getUser(); goto bd94c; bd94c: $session = $request->getSession(); goto Fb965; E9f31: C19a3: goto B5ecb; d5f31: f1669: goto ef266; ce2bf: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\x73\151\164\145\x73")); goto fefa2; d1ce3: if (false === is_null($site)) { goto C19a3; } goto ce2bf; fefa2: goto f1669; goto E9f31; b5d73: $cookieExpirationDate = new \DateTime("\156\x6f\167"); goto c722e; f66fb: $response = $this->render("\106\162\157\156\164\145\x6e\144\57\x53\x69\164\x65\57\x66\x69\x6c\x65\x2d\x6d\x61\x6e\141\147\145\x72\x2e\150\x74\155\154\x2e\x74\167\x69\x67", ["\x73\151\x74\x65" => $site, "\146\151\x6c\145\115\x61\156\141\147\145\162\x55\162\x6c" => $fileManagerUrl, "\146\x6f\x72\x6d\x45\162\162\157\x72\x73" => $this->formErrors]); goto d5f31; ef266: return $response; goto e619e; c722e: $cookieExpirationDate->modify(sprintf("\x2b\x25\x73\40\150\157\165\162\163", self::FILE_MANAGER_COOKIE_EXPIRATION)); goto Bb841; Fb965: $locale = $request->getLocale(); goto b5d73; Bb841: $data = ["\165\163\145\162" => $siteUser, "\154\157\143\141\154\145" => $locale]; goto e219c; D1146: $site = $this->getSite($request); goto d1ce3; f72b2: $fileManagerUrl = sprintf("\x25\x73\57\x66\151\154\x65\x2d\x6d\x61\x6e\141\x67\145\x72\x2f", rtrim($request->getSchemeAndHttpHost(), "\x2f")); goto f66fb; e619e: } public function view(Request $request) : Response { goto Bbf86; E6e38: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x73\x69\x74\145\x5f\x73\145\x74\x74\151\156\x67\163", ["\144\157\x6d\141\151\x6e\116\141\155\x65" => $domainName])); goto E5838; Bbf86: $domainName = $request->get("\x64\x6f\155\x61\x69\156\116\141\155\145"); goto E6e38; E5838: return $response; goto E65d6; E65d6: } public function logs(Request $request) : Response { goto Ab1c2; bc7ee: $form = $this->createLogsForm($siteEntity); goto F279c; C1a36: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto bc7ee; c0022: if (false === is_null($site)) { goto Fd28e; } goto D21a9; cdab7: c82d5: goto af8a8; F279c: $response = $this->render("\x46\x72\x6f\x6e\164\145\x6e\144\x2f\123\x69\x74\145\x2f\154\x6f\147\x73\x2e\150\x74\x6d\154\56\164\x77\151\147", ["\x73\x69\x74\145" => $site, "\146\157\162\155\105\x72\x72\157\162\x73" => $this->formErrors, "\x66\157\x72\155" => $form->createView()]); goto cdab7; F33e2: Fd28e: goto C1a36; af8a8: return $response; goto d1e1b; Ab1c2: $site = $this->getSite($request); goto c0022; D21a9: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\151\x74\x65\163")); goto Ff3bb; Ff3bb: goto c82d5; goto F33e2; d1e1b: } private function createLogsForm(SiteEntity $siteEntity) : Form { goto F416c; F416c: $form = $this->createForm("\101\x70\x70\134\106\157\x72\x6d\x5c\x53\x69\164\x65\114\x6f\147\x73\124\171\x70\145", [], ["\x61\143\164\x69\x6f\x6e" => $this->generateUrl("\x63\x6c\x70\137\x73\151\164\x65\x5f\x6c\157\147\x73", ["\x64\157\155\x61\151\156\x4e\x61\x6d\x65" => $siteEntity->getDomainName()]), "\x6d\145\x74\x68\x6f\144" => "\120\x4f\123\x54", "\141\164\x74\162" => []]); goto aaa3d; aaa3d: $form->add("\165\x70\x64\x61\164\145", ButtonType::class, ["\141\164\x74\162" => ["\143\x6c\x61\163\163" => "\x62\164\x6e\40\142\x74\x6e\55\154\x67\x20\142\x74\156\x2d\x62\154\165\x65\x20\142\164\x6e\x2d\165\x70\x64\141\164\x65"], "\x6c\141\142\145\154" => "\x55\x70\144\141\164\x65"]); goto D894e; D894e: return $form; goto Ba71c; Ba71c: } public function logFileContent(Request $request, Twig $twig) : Response { goto fb483; fb483: $data = []; goto Ef008; A6050: b0ee8: goto C4183; a791d: if (!(false === empty($service) && false === empty($logfileName))) { goto f0d72; } goto c6c40; C4183: $response = $this->json($data); goto be79b; C1121: if (!(false === is_null($site))) { goto b0ee8; } goto e37d6; c6c40: try { goto d80ce; e2dc1: $phpFpmErrorLogParser = new PhpFpmErrorLogParser($logLines); goto e2c5d; B0008: $data["\154\x6f\147\115\145\x73\x73\x61\x67\x65\x73\110\x74\155\x6c"] = $logMessagesHtml; goto eb3ae; Bfdc3: $userTimezone = $user->getTimezone(); goto Fe12f; d9cd6: $logMessages = $nginxAccessLogParser->parse(); goto Bfb71; A2068: f9bd8: goto A5f25; f70a4: $logfile = sprintf("\57\x68\157\x6d\145\x2f\x25\163\x2f\154\157\x67\x73\57\x25\163\x2f\45\163", $site->getUser(), $service, $logfileName); goto Fc62b; b8f53: $nginxAccessLogParser = new NginxAccessLogParser($logLines); goto Ad77d; D46eb: $nginxErrorLogParser = new NginxErrorLogParser($logLines); goto f1198; d122a: a8707: goto A2068; Fc62b: $logfileReader = new LogfileReader($logfile); goto b9b2a; Ad77d: $nginxAccessLogParser->setTimezone($userTimezone->getName()); goto d9cd6; f1198: $logMessages = $nginxErrorLogParser->parse(); goto f72fd; Ad199: goto a8707; goto D2a35; f72fd: $logMessagesHtml = $twig->render("\x46\x72\x6f\x6e\x74\x65\x6e\144\x2f\x53\x69\164\145\57\114\157\x67\163\x2f\x6e\147\151\156\170\55\x65\x72\x72\157\162\55\154\157\147\55\x6d\x65\x73\163\x61\147\x65\163\x2e\x68\x74\x6d\x6c\56\164\167\x69\x67", ["\154\157\147\115\145\x73\163\141\147\x65\x73" => $logMessages]); goto Ad199; d80ce: $service = basename($service); goto f70a4; dc797: $user = $this->getUser(); goto a2ad9; e2c5d: $logMessages = $phpFpmErrorLogParser->parse(); goto E6a7b; A5f25: if (!("\x70\x68\x70" == $service)) { goto F51a0; } goto e2dc1; D2a35: fac4d: goto b8f53; d13a0: F51a0: goto B0008; a2ad9: if (!("\x6e\x67\x69\x6e\x78" == $service)) { goto f9bd8; } goto Bfdc3; b9b2a: $logLines = $logfileReader->getLines($numberOfLines); goto bf7b9; Fe12f: if ("\141\143\x63\145\x73\x73\56\x6c\157\147" == substr($logfileName, 0, 10)) { goto fac4d; } goto D46eb; bf7b9: $logMessagesHtml = ''; goto dc797; Bfb71: $logMessagesHtml = $twig->render("\x46\x72\x6f\156\164\x65\x6e\x64\57\123\151\164\x65\x2f\114\157\147\163\x2f\x6e\147\x69\x6e\170\55\141\x63\x63\x65\x73\x73\x2d\x6c\157\x67\55\155\145\163\163\x61\147\145\163\56\150\x74\155\x6c\56\x74\x77\151\147", ["\154\x6f\147\x4d\145\163\163\x61\x67\145\163" => $logMessages]); goto d122a; E6a7b: $logMessagesHtml = $twig->render("\106\162\157\x6e\164\145\156\x64\57\x53\151\164\145\57\x4c\157\147\x73\57\x70\150\160\55\x66\x70\155\x2d\145\x72\x72\157\162\x2d\154\x6f\147\55\x6d\145\163\163\x61\147\x65\163\56\150\x74\x6d\x6c\56\164\167\151\x67", ["\x6c\x6f\147\115\145\x73\x73\141\x67\145\x73" => $logMessages]); goto d13a0; eb3ae: } catch (\Exception $e) { $this->logger->exception($e); } goto C8661; e37d6: $service = trim($request->get("\163\145\162\166\x69\143\145")); goto d2eab; Ef008: $site = $this->getSite($request); goto C1121; be79b: return $response; goto e47dd; C8661: f0d72: goto A6050; d2eab: $logfileName = trim($request->get("\154\157\147\x46\151\154\x65")); goto c5701; c5701: $numberOfLines = (int) $request->get("\x6e\x75\155\x62\145\x72\x4f\146\114\x69\156\x65\163"); goto a791d; e47dd: } public function loadLogfilesForService(Request $request) : Response { goto F2ae9; Aa06a: D8e87: goto e1ad2; F2ae9: $data = []; goto ab522; e1ad2: a2474: goto A47ad; c12f9: $service = trim($request->get("\163\145\x72\x76\151\143\x65")); goto e77d0; F3172: if (!(false === is_null($site))) { goto a2474; } goto c12f9; A47ad: $response = $this->json($data); goto e2ec5; ab522: $site = $this->getSite($request); goto F3172; c0567: try { goto Aab9b; a5aa2: if (!(false === empty($logfiles))) { goto eaf7d; } goto E254d; Aab9b: $service = basename($service); goto d7660; B540f: $logsFinder = new LogsFinder($logfilesDirectory); goto a844e; a844e: $logfiles = $logsFinder->getLogfiles(); goto a5aa2; d7660: $logfilesDirectory = sprintf("\x2f\x68\x6f\155\145\57\x25\x73\57\154\x6f\x67\163\x2f\x25\163\x2f", $site->getUser(), $service); goto B540f; E254d: $data["\154\x6f\x67\x66\x69\154\x65\163"] = $logfiles; goto E74e7; E74e7: eaf7d: goto E613a; E613a: } catch (\Exception $e) { $this->logger->exception($e); } goto Aa06a; e77d0: if (!(false === empty($service))) { goto D8e87; } goto c0567; e2ec5: return $response; goto aa7af; aa7af: } public function cronJobs(Request $request) : Response { goto Eec31; cc4b7: E284d: goto F3d35; D28a0: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x73\x69\x74\x65\163")); goto ccc07; d26e7: B5c13: goto aa8a1; Eec31: $site = $this->getSite($request); goto b888e; b888e: if (false === is_null($site)) { goto B5c13; } goto D28a0; F3d35: return $response; goto F2bfc; aa8a1: $response = $this->render("\106\162\x6f\x6e\164\x65\x6e\144\57\123\151\x74\x65\x2f\143\x72\157\x6e\55\x6a\157\x62\163\56\x68\164\155\x6c\x2e\x74\x77\151\x67", ["\163\x69\x74\145" => $site, "\x66\157\162\155\105\x72\162\x6f\x72\x73" => $this->formErrors]); goto cc4b7; ccc07: goto E284d; goto d26e7; F2bfc: } public function newCronJob(Request $request) : Response { goto E7682; A92f5: db864: goto Fd11f; E7682: $site = $this->getSite($request); goto E6076; E6076: if (false === is_null($site)) { goto Beec0; } goto d5f30; Cae95: $cronJobEntity->setSite($siteEntity); goto Bfd8a; Cf2ff: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto c24b3; Bfd8a: $form = $this->createCronJobForm($cronJobEntity); goto ae559; b36f1: c4ea6: goto c6258; Fd11f: E9ded: goto Bf20d; Fb6a7: goto c4ea6; goto bc901; c4dea: if (!(true === $form->isSubmitted())) { goto db864; } goto f748e; c6258: return $response; goto fb226; ae559: if (!(true === $request->isMethod("\x50\x4f\x53\124"))) { goto E9ded; } goto da866; f439a: if (!(false === is_null($response))) { goto A0732; } goto Fd213; F0366: A0732: goto A92f5; Bf20d: $response = $this->render("\x46\x72\157\x6e\x74\145\x6e\x64\x2f\123\x69\164\x65\57\156\145\167\x2d\143\x72\157\x6e\x2d\x6a\x6f\x62\x2e\150\x74\155\x6c\x2e\164\x77\151\x67", ["\x73\151\164\x65" => $site, "\x66\157\x72\x6d" => $form->createView(), "\146\157\x72\x6d\105\162\162\157\x72\163" => $this->formErrors]); goto b36f1; f748e: $response = $this->handleCronJobForm($request, $form, $site); goto f439a; c24b3: $cronJobEntity = $this->cronJobEntityManager->createEntity(); goto Cae95; d5f30: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x73\151\x74\145\x73")); goto Fb6a7; bc901: Beec0: goto Cf2ff; da866: $form->handleRequest($request); goto c4dea; Fd213: return $response; goto F0366; fb226: } private function createCronJobForm(CronJobEntity $cronJobEntity) : Form { goto De3d1; f7eda: return $form; goto d716e; Fb1b1: $form->add("\163\165\x62\155\151\164", SubmitType::class, ["\x61\164\164\x72" => ["\143\x6c\x61\x73\163" => "\x62\164\x6e\40\142\x74\156\x2d\142\154\x75\145\40\142\164\156\55\x6c\147"], "\154\141\x62\145\154" => "\x41\144\x64\40\x43\162\157\156\40\112\157\142"]); goto f7eda; e9cd3: $form = $this->createForm("\101\160\160\x5c\x46\x6f\162\x6d\x5c\x53\151\164\145\103\162\x6f\x6e\x4a\x6f\142\x54\171\160\x65", $cronJobEntity, ["\x61\x63\x74\151\x6f\x6e" => $this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\145\137\143\x72\157\x6e\x5f\152\157\142\137\x6e\x65\167", ["\144\157\155\141\x69\156\x4e\141\155\145" => $siteEntity->getDomainName()]), "\155\145\x74\x68\x6f\x64" => "\x50\117\123\x54", "\x61\164\164\x72" => []]); goto Fb1b1; De3d1: $siteEntity = $cronJobEntity->getSite(); goto e9cd3; d716e: } private function handleCronJobForm(Request $request, Form $form, Site $site) { goto bbd86; Ce82b: try { goto Efdec; E5bc8: $siteEntity->addCronJob($cronJobEntity); goto Dcb53; ee0ad: EventQueue::addEvent(EventQueue::EVENT_SITE_CRON_JOB_ADD, $user, $eventData, $request); goto d5c9d; Ab404: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\x69\164\145\163")); goto D1159; dc773: $user = $this->getUser(); goto d73cf; a45a3: $siteUpdater = $this->getSiteUpdater($site); goto Bf926; c13d5: b0f01: goto dc773; b16e7: $this->siteEntityManager->updateEntity($siteEntity); goto a45a3; D1159: goto B8a80; goto c13d5; D0ded: B8a80: goto f17a7; d5c9d: $session->getFlashBag()->set("\163\x75\143\x63\x65\163\x73", $this->translator->trans("\x43\x72\157\156\x20\112\x6f\142\40\x68\x61\163\x20\x62\x65\x65\156\40\141\144\144\x65\144\x2e")); goto Fe3d7; Bf926: $siteUpdater->updateUserCrontab(); goto Fa256; f17a7: return $response; goto c275c; d73cf: $cronJobEntity = $form->getData(); goto E5bc8; fa217: $siteEntity = $this->getSiteEntity($domainName); goto a0f6a; a0f6a: if (false === is_null($siteEntity)) { goto b0f01; } goto Ab404; Efdec: $session = $request->getSession(); goto A7df5; A7df5: $domainName = $site->getDomainName(); goto fa217; Fe3d7: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\x73\151\x74\x65\x5f\143\x72\157\156\x5f\x6a\157\x62\163", ["\144\x6f\155\141\x69\156\116\141\x6d\145" => $site->getDomainName()])); goto D0ded; Fa256: $eventData = ["\163\x69\x74\x65" => $domainName, "\x63\x72\x6f\x6e\164\141\142\x45\x78\160\162\x65\163\x73\151\x6f\x6e" => $cronJobEntity->getCrontabExpression()]; goto ee0ad; Dcb53: $site->setCronJobs($siteEntity->getCronJobs()); goto b16e7; c275c: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\147\x65\x72", $this->translator->trans("\101\x6e\40\x65\x72\x72\x6f\162\x20\150\141\163\x20\x6f\143\143\x75\x72\x72\145\x64\54\40\145\162\162\x6f\x72\x20\155\x65\x73\163\x61\147\x65\x3a\x20\x25\145\x72\x72\x6f\x72\115\145\x73\163\x61\147\x65\45", ["\x25\x65\162\162\x6f\162\115\145\x73\163\x61\147\145\45" => $e->getMessage()])); } goto F31d3; ac40d: Cc00e: goto Ce82b; c5f27: goto e02a2; goto ac40d; bbd86: if (true === $form->isValid()) { goto Cc00e; } goto C47a0; C47a0: $this->formErrors = $this->getErrorMessages($form); goto c5f27; F31d3: e02a2: goto A0517; A0517: } public function deleteCronJob(Request $request) : Response { goto Da5b6; d2b3c: if (!(false === is_null($site))) { goto D7973; } goto A151a; A151a: try { goto e3bfb; F5f03: $siteEntity = $this->getSiteEntity($domainName); goto d7d4b; c27b3: $siteUpdater = $this->getSiteUpdater($site); goto Faa71; E199a: c9001: goto Bad72; D6427: $domainName = $site->getDomainName(); goto F5f03; e8d95: $user = $this->getUser(); goto fe3bd; a9a90: if (!($siteEntity->getDomainName() == $cronJobSiteEntity->getDomainName())) { goto C6971; } goto e8d95; c4ca2: $evenData = ["\163\x69\164\x65" => $domainName, "\x63\x6f\x6d\x6d\x61\156\144" => $cronJobEntity->getCommand()]; goto C23bb; d7d4b: $cronJobEntity = $this->cronJobEntityManager->findOneById($id); goto a531e; d248a: return $response; goto c8e66; eac98: $cronJobSiteEntity = $cronJobEntity->getSite(); goto a9a90; Faa71: $siteUpdater->updateUserCrontab(); goto c4ca2; Ce26d: $id = (int) $request->get("\x69\144"); goto D6427; e3bfb: $session = $request->getSession(); goto Ce26d; a531e: if (!(false === is_null($siteEntity) && false === is_null($cronJobEntity))) { goto c9001; } goto eac98; c8e66: C6971: goto E199a; fe3bd: $siteEntity->removeCronJob($cronJobEntity); goto A3b72; fcd9e: $this->siteEntityManager->updateEntity($siteEntity); goto c27b3; aaf4e: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\x69\x74\145\x5f\143\162\x6f\x6e\x5f\152\157\x62\x73", ["\144\x6f\155\x61\x69\156\x4e\141\x6d\x65" => $site->getDomainName()])); goto d248a; F009a: $session->getFlashBag()->set("\x73\x75\x63\x63\145\163\163", $this->translator->trans("\x43\162\x6f\156\40\112\x6f\142\40\150\141\x73\40\142\x65\145\156\40\x64\145\154\x65\x74\145\144\x2e")); goto aaf4e; A3b72: $site->setCronJobs($siteEntity->getCronJobs()); goto fcd9e; C23bb: EventQueue::addEvent(EventQueue::EVENT_SITE_CRON_JOB_DELETE, $user, $evenData, $request); goto F009a; Bad72: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\x65\x72", $this->translator->trans("\x41\x6e\x20\x65\x72\162\x6f\x72\x20\150\x61\163\x20\x6f\143\x63\x75\162\x72\145\144\x2c\x20\145\x72\162\157\162\40\155\x65\163\x73\141\x67\x65\x3a\x20\x25\x65\x72\162\x6f\x72\115\145\163\163\141\x67\145\x25", ["\45\x65\162\162\x6f\162\115\145\163\163\141\x67\145\x25" => $e->getMessage()])); } goto ffa5c; F3a0f: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\151\x74\145\x73")); goto Fabf8; Da5b6: $site = $this->getSite($request); goto c0d26; Fabf8: return $response; goto b769e; ffa5c: D7973: goto F3a0f; c0d26: $this->checkCsrfToken($request, "\143\x72\x6f\156\152\x6f\x62\55\x64\145\154\x65\x74\145"); goto d2b3c; b769e: } public function editCronJob(Request $request) : Response { goto fd804; A4066: $site = $this->getSite($request); goto C8b31; a8b4a: if (!(true === $request->isMethod("\x50\x4f\x53\124"))) { goto Aa0b8; } goto da9a3; bbe80: goto C372a; goto Fd9e7; B7227: C372a: goto E17b2; fd804: $id = (int) $request->get("\151\x64"); goto A4066; Fd9e7: f9c7b: goto e082c; ab095: return $response; goto ac7ae; E17b2: return $response; goto Cf9a6; eb47f: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\163\151\164\145\163")); goto bbe80; ac7ae: ab894: goto Cf9b5; B65f9: Aa0b8: goto b05c4; d22e1: if (!(true === $form->isSubmitted())) { goto b1513; } goto Cc080; D3904: if (!(false === is_null($response))) { goto ab894; } goto ab095; Cf9b5: b1513: goto B65f9; da9a3: $form->handleRequest($request); goto d22e1; b05c4: $response = $this->render("\106\x72\157\x6e\x74\x65\156\x64\57\123\151\164\x65\x2f\x65\144\x69\164\55\143\x72\x6f\156\x2d\x6a\x6f\x62\x2e\150\x74\x6d\154\x2e\x74\x77\151\147", ["\x73\151\164\145" => $site, "\146\157\x72\x6d" => $form->createView(), "\x66\x6f\x72\155\105\162\x72\x6f\162\163" => $this->formErrors]); goto B7227; e082c: $form = $this->createCronJobEditForm($cronJobEntity); goto a8b4a; C8b31: $cronJobEntity = $this->cronJobEntityManager->findOneById($id); goto fa747; Cc080: $response = $this->handleCronJobEditForm($request, $form, $site); goto D3904; fa747: if (false === is_null($cronJobEntity) && false === is_null($site) && $cronJobEntity->getSite()->getDomainName() == $site->getDomainName()) { goto f9c7b; } goto eb47f; Cf9a6: } private function createCronJobEditForm(CronJobEntity $cronJobEntity) : Form { goto a6631; Dc761: $form = $this->createForm("\x41\160\x70\x5c\x46\157\162\x6d\x5c\x53\151\x74\145\x43\x72\x6f\x6e\x4a\157\x62\105\144\151\164\124\x79\x70\x65", $cronJobEntity, ["\141\143\164\151\x6f\156" => $this->generateUrl("\143\x6c\x70\x5f\x73\151\164\x65\x5f\x63\162\x6f\x6e\137\x6a\157\142\137\145\x64\151\x74", ["\x64\157\x6d\141\151\x6e\116\141\155\145" => $siteEntity->getDomainName(), "\x69\x64" => $cronJobEntity->getId()]), "\x6d\145\x74\150\157\x64" => "\120\x4f\x53\x54", "\x61\164\164\162" => []]); goto eed30; eed30: $form->add("\x73\165\x62\155\x69\164", SubmitType::class, ["\x61\x74\164\x72" => ["\x63\154\x61\x73\x73" => "\142\x74\156\40\x62\164\x6e\55\142\x6c\x75\x65\x20\142\164\156\55\154\147"], "\154\141\x62\x65\x6c" => "\123\141\x76\x65"]); goto d9930; a6631: $siteEntity = $cronJobEntity->getSite(); goto Dc761; d9930: return $form; goto A2972; A2972: } private function handleCronJobEditForm(Request $request, Form $form, Site $site) { goto ee076; E16aa: try { goto e6ed5; Ab976: B2094: goto c6e9b; ad92b: $siteEntity->addCronJob($cronJobEntity); goto a82ff; C74a0: $cronJobEntity = $form->getData(); goto ad92b; a8990: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\163\x69\x74\x65\x5f\143\x72\x6f\156\137\152\x6f\142\x73", ["\144\157\x6d\x61\151\156\x4e\x61\x6d\x65" => $site->getDomainName()])); goto af9e8; c6e9b: $user = $this->getUser(); goto C74a0; Ab04b: EventQueue::addEvent(EventQueue::EVENT_SITE_CRON_JOB_EDIT, $user, $eventData, $request); goto cf79c; f8b92: $eventData = ["\163\151\x74\145" => $domainName, "\x63\162\157\x6e\x74\141\142\105\x78\x70\x72\145\x73\163\x69\157\156" => $cronJobEntity->getCrontabExpression()]; goto Ab04b; a826d: if (false === is_null($siteEntity)) { goto B2094; } goto Ab4b8; f8824: return $response; goto F58d7; eafd1: $siteUpdater->updateUserCrontab(); goto f8b92; c9351: $domainName = $site->getDomainName(); goto F57d4; cf79c: $session->getFlashBag()->set("\x73\x75\143\x63\x65\x73\x73", $this->translator->trans("\x43\x72\x6f\156\40\x4a\157\x62\40\x68\x61\163\x20\x62\x65\145\156\40\163\141\x76\x65\x64\x2e")); goto a8990; Ab4b8: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\163\151\x74\x65\163")); goto b0425; F57d4: $siteEntity = $this->getSiteEntity($domainName); goto a826d; D26d4: $this->siteEntityManager->updateEntity($siteEntity); goto bd83c; e6ed5: $session = $request->getSession(); goto c9351; af9e8: ba600: goto f8824; b0425: goto ba600; goto Ab976; a82ff: $site->setCronJobs($siteEntity->getCronJobs()); goto D26d4; bd83c: $siteUpdater = $this->getSiteUpdater($site); goto eafd1; F58d7: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\145\162", $this->translator->trans("\x41\156\x20\x65\162\162\x6f\162\40\150\141\x73\40\x6f\x63\143\165\x72\x72\x65\144\x2c\x20\x65\162\x72\x6f\x72\40\155\x65\x73\163\x61\147\x65\x3a\40\45\x65\x72\x72\157\162\x4d\x65\x73\163\x61\147\x65\45", ["\x25\x65\162\162\157\x72\115\145\x73\163\141\x67\x65\x25" => $e->getMessage()])); } goto bc5af; Fac22: $this->formErrors = $this->getErrorMessages($form); goto C3515; C3515: goto b001e; goto C20fc; C20fc: A8ca3: goto E16aa; ee076: if (true === $form->isValid()) { goto A8ca3; } goto Fac22; bc5af: b001e: goto ee974; ee974: } public function users(Request $request) : Response { goto C88e1; C88e1: $site = $this->getSite($request); goto E35a3; E35a3: if (false === is_null($site)) { goto E00cb; } goto E4929; A5dc8: eb71b: goto E8b24; bebb0: E00cb: goto B675b; E8b24: return $response; goto d3d61; d5fd6: goto eb71b; goto bebb0; E4929: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\163\x69\164\x65\x73")); goto d5fd6; B675b: $response = $this->render("\x46\162\x6f\156\164\145\156\x64\57\123\151\x74\x65\x2f\x75\x73\x65\162\163\x2e\x68\x74\x6d\154\56\x74\x77\x69\147", ["\x73\151\x74\x65" => $site, "\146\x6f\x72\x6d\105\162\x72\157\162\163" => $this->formErrors]); goto A5dc8; d3d61: } public function newFtpUser(Request $request) : Response { goto C3ff1; D1935: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto B72a9; C3ff1: $site = $this->getSite($request); goto f65b3; Cbe67: return $response; goto bfdd0; E8701: $form = $this->createFtpUserForm($ftpUserEntity); goto ea5ef; ea5ef: if (!(true === $request->isMethod("\x50\117\123\124"))) { goto C9ffa; } goto bd8ef; a21ad: if (!(false === is_null($response))) { goto db69e; } goto Cbe67; F0550: bbfdf: goto D1935; Caed3: if (!(true === $form->isSubmitted())) { goto Eee99; } goto C96d1; B72a9: $ftpUserEntity = $this->ftpUserEntityManager->createEntity(); goto b9a05; fdb88: C9ffa: goto D47c1; b1185: Cf561: goto Cb77b; bfdd0: db69e: goto eb2d6; a087f: goto Cf561; goto F0550; b9a05: $ftpUserEntity->setSite($siteEntity); goto E8701; eb2d6: Eee99: goto fdb88; c4d32: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\x69\164\145\163")); goto a087f; D47c1: $response = $this->render("\x46\x72\x6f\x6e\164\145\x6e\x64\x2f\123\x69\164\x65\57\x6e\x65\167\x2d\146\x74\160\55\x75\x73\x65\162\x2e\x68\164\x6d\154\56\x74\x77\x69\x67", ["\x73\151\164\145" => $site, "\x66\157\162\155" => $form->createView(), "\146\157\162\x6d\x45\162\162\157\162\163" => $this->formErrors]); goto b1185; Cb77b: return $response; goto E2e40; bd8ef: $form->handleRequest($request); goto Caed3; C96d1: $response = $this->handleFtpUserForm($request, $form, $site); goto a21ad; f65b3: if (false === is_null($site)) { goto bbfdf; } goto c4d32; E2e40: } private function createFtpUserForm(FtpUserEntity $ftpUserEntity) : Form { goto A81de; ef000: $form->add("\x73\x75\142\x6d\151\164", SubmitType::class, ["\x61\164\x74\x72" => ["\x63\x6c\x61\163\163" => "\142\x74\156\x20\142\164\x6e\55\142\x6c\165\x65\40\142\164\x6e\55\154\x67"], "\x6c\x61\x62\x65\154" => "\x41\x64\x64\40\125\x73\x65\162"]); goto f8934; f8934: return $form; goto D1ed6; b1e4c: $form = $this->createForm("\x41\x70\x70\134\x46\x6f\162\155\x5c\123\x69\x74\145\106\x74\x70\125\x73\145\162\x54\171\160\145", $ftpUserEntity, ["\141\x63\164\x69\x6f\156" => $this->generateUrl("\x63\154\x70\137\163\x69\164\145\137\146\x74\160\137\x75\163\145\162\137\x6e\145\167", ["\x64\157\155\x61\151\156\116\141\x6d\x65" => $siteEntity->getDomainName()]), "\155\x65\x74\150\x6f\144" => "\x50\117\123\x54", "\141\x74\x74\x72" => []]); goto ef000; A81de: $siteEntity = $ftpUserEntity->getSite(); goto b1e4c; D1ed6: } private function handleFtpUserForm(Request $request, Form $form, Site $site) { goto Dea24; Dea24: if (true === $form->isValid()) { goto Fac9d; } goto b0dc5; a7a15: ba719: goto a01b0; ca9b4: goto ba719; goto b734d; B2537: try { goto C4a9a; d7f76: EventQueue::addEvent(EventQueue::EVENT_SITE_FTP_USER_ADD, $user, $eventData, $request); goto a528b; cae5e: $ftpUserEntity = $form->getData(); goto fe781; dafc0: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\163\x69\x74\145\163")); goto d1a9e; Dff03: return $response; goto F6c26; d8de4: if (false === is_null($siteEntity)) { goto D40fa; } goto dafc0; ef37a: $siteEntity->addFtpUser($ftpUserEntity); goto D08b3; Ce552: D40fa: goto c23f2; d1a9e: goto d7837; goto Ce552; b1917: $siteEntity = $this->getSiteEntity($domainName); goto d8de4; fe781: $ftpUserName = $ftpUserEntity->getUserName(); goto e3f3e; a528b: $session->getFlashBag()->set("\163\165\x63\143\145\x73\163", $this->translator->trans("\x55\x73\145\x72\40\150\x61\163\40\x62\x65\x65\x6e\40\141\x64\x64\x65\144\56")); goto d7b09; Be636: $siteUpdater->createFtpUser($ftpUserEntity); goto D6613; Dc9eb: $domainName = $site->getDomainName(); goto b1917; d7b09: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\151\x74\145\137\165\163\x65\162\163", ["\144\157\x6d\x61\151\156\116\x61\155\145" => $site->getDomainName()])); goto E133f; Ddfa1: $ftpUserEntity->setPassword($ftpUserPassword); goto ef37a; d0eda: $siteUpdater = $this->getSiteUpdater($site); goto Be636; c23f2: $user = $this->getUser(); goto cae5e; E133f: d7837: goto Dff03; D6613: $eventData = ["\x73\151\x74\x65" => $domainName, "\x75\x73\145\x72\116\141\155\x65" => $ftpUserName, "\150\x6f\x6d\145\104\151\x72\x65\x63\x74\x6f\x72\171" => $ftpUserEntity->getHomeDirectory()]; goto d7f76; C4a9a: $session = $request->getSession(); goto Dc9eb; e3f3e: $ftpUserPassword = $form->get("\x70\141\x73\163\x77\x6f\x72\x64")->getData(); goto Ddfa1; D08b3: $this->siteEntityManager->updateEntity($siteEntity); goto d0eda; F6c26: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\156\147\145\x72", $this->translator->trans("\x41\156\x20\145\x72\162\x6f\x72\x20\150\141\163\40\x6f\143\x63\165\162\162\145\x64\54\40\145\162\162\157\162\x20\x6d\145\x73\x73\141\147\145\x3a\40\x25\145\x72\162\157\162\x4d\x65\x73\163\141\x67\145\45", ["\x25\x65\162\162\x6f\162\115\145\x73\x73\x61\x67\x65\x25" => $e->getMessage()])); } goto a7a15; b0dc5: $this->formErrors = $this->getErrorMessages($form); goto ca9b4; b734d: Fac9d: goto B2537; a01b0: } public function editFtpUser(Request $request) : Response { goto abac0; C64e4: C1f20: goto E450b; aeadd: return $response; goto ce429; c1703: d94d6: goto C64e4; a5223: return $response; goto B23fd; e733e: d3aa6: goto e34d5; c73a3: $ftpUserEntity = $this->ftpUserEntityManager->findOneByUserName($userName); goto B4123; c7b3d: if (!(false === is_null($response))) { goto aa894; } goto aeadd; e34d5: $form = $this->createFtpUserEditForm($ftpUserEntity); goto D766a; ce429: aa894: goto c1703; B4123: if (false === is_null($ftpUserEntity) && false === is_null($site) && $ftpUserEntity->getSite()->getDomainName() == $site->getDomainName()) { goto d3aa6; } goto d3f69; Cc06f: $form->handleRequest($request); goto ff2d9; E2507: $response = $this->handleFtpUserEditForm($request, $form, $site); goto c7b3d; ff2d9: if (!(true === $form->isSubmitted())) { goto d94d6; } goto E2507; D766a: if (!(true === $request->isMethod("\120\117\123\x54"))) { goto C1f20; } goto Cc06f; d3f69: $response = $this->redirect($this->generateUrl("\x63\154\160\137\x73\151\x74\145\163")); goto E481d; d03f6: $site = $this->getSite($request); goto c73a3; E481d: goto E37ab; goto e733e; abac0: $userName = $request->get("\x75\x73\x65\x72\x4e\141\x6d\x65"); goto d03f6; E450b: $response = $this->render("\106\162\x6f\x6e\164\145\x6e\144\57\x53\151\x74\145\x2f\145\144\x69\164\55\146\164\160\x2d\x75\163\145\162\56\150\164\x6d\154\56\164\x77\x69\x67", ["\163\151\164\145" => $site, "\146\157\162\155" => $form->createView(), "\146\x6f\162\x6d\105\162\x72\x6f\162\x73" => $this->formErrors]); goto d3df6; d3df6: E37ab: goto a5223; B23fd: } private function createFtpUserEditForm(FtpUserEntity $ftpUserEntity) : Form { goto ff6e8; e649c: $form = $this->createForm("\101\160\160\x5c\106\x6f\162\155\134\x53\x69\164\x65\106\x74\x70\x55\163\145\162\x45\144\151\x74\x54\171\x70\x65", $ftpUserEntity, ["\x61\x63\164\x69\157\156" => $this->generateUrl("\x63\154\x70\x5f\x73\151\164\x65\137\x66\164\160\x5f\x75\163\145\162\x5f\145\144\x69\164", ["\x64\x6f\155\x61\x69\156\x4e\141\x6d\145" => $siteEntity->getDomainName(), "\x75\x73\145\162\116\x61\x6d\x65" => $ftpUserEntity->getUserName()]), "\x6d\x65\x74\150\157\x64" => "\120\x4f\123\124", "\x61\x74\164\x72" => []]); goto F3a7b; A11a3: return $form; goto dd4f1; F3a7b: $form->add("\163\x75\142\155\x69\x74", SubmitType::class, ["\141\164\x74\x72" => ["\143\154\x61\x73\x73" => "\x62\x74\156\40\x62\164\156\x2d\142\x6c\165\145\x20\x62\164\156\x2d\154\147"], "\154\141\142\x65\154" => "\x53\x61\166\145"]); goto A11a3; ff6e8: $siteEntity = $ftpUserEntity->getSite(); goto e649c; dd4f1: } private function handleFtpUserEditForm(Request $request, Form $form, Site $site) { goto D5aea; D5aea: if (true === $form->isValid()) { goto B49ea; } goto Ca0f9; E6ff8: B49ea: goto F9e21; a16d3: goto F92b3; goto E6ff8; Ca0f9: $this->formErrors = $this->getErrorMessages($form); goto a16d3; aa95b: F92b3: goto F94a4; F9e21: try { goto f88c3; D0dca: $ftpUserHomeDirectory = $ftpUserEntity->getHomeDirectory(); goto ca8c6; E45e0: $siteUpdater->changeUserPassword($ftpUserName, $ftpUserPassword); goto b8983; b8983: Da381: goto C37c5; C37c5: $eventData = ["\x73\x69\x74\x65" => $domainName, "\165\x73\x65\162\x4e\x61\155\145" => $ftpUserName, "\150\x6f\x6d\145\104\151\162\145\x63\164\157\x72\171" => $ftpUserHomeDirectory]; goto E9527; d8338: if (false === is_null($siteEntity)) { goto efa25; } goto E6fad; E1591: Efcfe: goto Ebfd2; C6357: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\x73\151\x74\145\137\x75\x73\145\x72\x73", ["\x64\157\155\x61\151\156\116\141\155\x65" => $site->getDomainName()])); goto E1591; E2b51: goto Efcfe; goto E12b0; Db154: if (!(false === empty($ftpUserPassword))) { goto Da381; } goto E45e0; E6fad: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\x73\151\x74\145\163")); goto E2b51; f88c3: $session = $request->getSession(); goto fb5f6; ca8c6: $this->siteEntityManager->updateEntity($siteEntity); goto B92e3; cdd98: $ftpUserName = $ftpUserEntity->getUserName(); goto fd402; E12b0: efa25: goto f9aa3; B92e3: $siteUpdater = $this->getSiteUpdater($site); goto db2f5; fd402: $ftpUserPassword = $form->get("\160\x61\163\x73\167\x6f\162\x64")->getData(); goto D0dca; f9aa3: $user = $this->getUser(); goto ad08f; db2f5: $siteUpdater->changeUserHomeDirectory($ftpUserName, $ftpUserHomeDirectory); goto Db154; ad08f: $ftpUserEntity = $form->getData(); goto cdd98; Ebfd2: return $response; goto e7c63; fb5f6: $domainName = $site->getDomainName(); goto B86e7; E9527: EventQueue::addEvent(EventQueue::EVENT_SITE_FTP_USER_EDIT, $user, $eventData, $request); goto f146a; B86e7: $siteEntity = $this->getSiteEntity($domainName); goto d8338; f146a: $session->getFlashBag()->set("\163\x75\143\143\x65\163\x73", $this->translator->trans("\125\x73\x65\162\x20\150\141\x73\x20\142\x65\145\x6e\x20\163\x61\166\x65\x64\56")); goto C6357; e7c63: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\147\145\162", $this->translator->trans("\x41\156\x20\x65\162\162\157\162\40\150\x61\163\40\x6f\143\143\165\162\x72\x65\144\54\x20\x65\x72\162\157\x72\x20\x6d\145\x73\x73\141\147\145\72\40\45\145\162\162\157\162\x4d\x65\x73\163\x61\147\x65\x25", ["\x25\x65\x72\162\x6f\162\x4d\x65\163\x73\141\x67\x65\x25" => $e->getMessage()])); } goto aa95b; F94a4: } public function deleteFtpUser(Request $request) : Response { goto e5c99; e5c99: $site = $this->getSite($request); goto e0465; Aa8dc: if (!(false === is_null($site))) { goto E7d9f; } goto d0c68; e0465: $this->checkCsrfToken($request, "\165\163\x65\x72\x2d\x64\x65\x6c\x65\x74\x65"); goto Aa8dc; B89e3: $response = $this->redirect($this->generateUrl("\x63\154\160\137\x73\151\164\145\x73")); goto ffebf; d0c68: try { goto E44c0; E9117: $siteUpdater->deleteUser($userName, false); goto c459d; c459d: $evenData = ["\163\x69\x74\145" => $domainName, "\x75\x73\x65\162\116\x61\x6d\x65" => $userName]; goto Fea0e; Cc760: $userName = $request->get("\x75\163\x65\162\116\x61\155\x65"); goto da7a9; E44c0: $session = $request->getSession(); goto Cc760; E8855: $this->siteEntityManager->updateEntity($siteEntity); goto Fe266; Bf701: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\x69\x74\145\137\165\x73\x65\162\x73", ["\x64\157\155\141\151\156\116\x61\155\x65" => $site->getDomainName()])); goto D50ae; E6d44: $userName = $ftpUserEntity->getUserName(); goto Db1af; Fe266: $siteUpdater = $this->getSiteUpdater($site); goto E9117; C3ec0: $user = $this->getUser(); goto E6d44; bde2e: $siteEntity = $this->getSiteEntity($domainName); goto bcf20; f4e2c: if (!(false === is_null($siteEntity) && false === empty($userName) && false === is_null($ftpUserEntity))) { goto e2baa; } goto Db508; D50ae: return $response; goto e3100; E6c3d: $session->getFlashBag()->set("\x73\x75\x63\x63\x65\x73\x73", $this->translator->trans("\x55\x73\x65\x72\x20\x68\141\163\40\142\x65\x65\x6e\40\144\x65\154\x65\164\145\x64\x2e")); goto Bf701; B8dbf: if (!($siteEntity->getDomainName() == $ftpUserSiteEntity->getDomainName())) { goto D7345; } goto C3ec0; Fea0e: EventQueue::addEvent(EventQueue::EVENT_SITE_FTP_USER_DELETE, $user, $evenData, $request); goto E6c3d; B3c00: e2baa: goto Dfcc6; Db1af: $siteEntity->removeFtpUser($ftpUserEntity); goto E8855; Db508: $ftpUserSiteEntity = $ftpUserEntity->getSite(); goto B8dbf; da7a9: $domainName = $site->getDomainName(); goto bde2e; bcf20: $ftpUserEntity = $this->ftpUserEntityManager->findOneByUserName($userName); goto f4e2c; e3100: D7345: goto B3c00; Dfcc6: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\147\145\x72", $this->translator->trans("\101\x6e\x20\145\162\x72\157\162\40\150\141\x73\x20\157\143\x63\x75\x72\162\145\x64\54\x20\145\x72\x72\x6f\x72\40\155\x65\x73\x73\x61\x67\x65\x3a\x20\45\x65\x72\x72\x6f\162\115\145\x73\x73\141\x67\145\45", ["\x25\145\x72\162\x6f\162\x4d\145\163\x73\141\x67\x65\45" => $e->getMessage()])); } goto b0d3d; b0d3d: E7d9f: goto B89e3; ffebf: return $response; goto Bc341; Bc341: } public function newSshUser(Request $request) : Response { goto f139e; ae43d: A58d0: goto Bda38; B6604: $response = $this->render("\x46\162\x6f\156\164\145\x6e\144\57\x53\x69\164\145\57\x6e\145\167\x2d\163\163\150\x2d\x75\x73\145\162\x2e\150\164\x6d\154\x2e\x74\x77\151\x67", ["\x73\151\x74\145" => $site, "\x66\x6f\x72\x6d" => $form->createView(), "\146\157\x72\155\x45\162\162\x6f\162\163" => $this->formErrors]); goto ae43d; A5fe5: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\x73\151\164\x65\163")); goto cf6a1; a230b: $response = $this->handleSshUserForm($request, $form, $site); goto be99b; A69d9: fbe1b: goto f584a; F985e: if (!(true === $form->isSubmitted())) { goto fbe1b; } goto a230b; e7ebe: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto cdfc8; cdfc8: $sshUserEntity = $this->sshUserEntityManager->createEntity(); goto Fe417; Ddf1e: return $response; goto c7133; Fe417: $sshUserEntity->setSite($siteEntity); goto F65b5; F65b5: $form = $this->createSshUserForm($sshUserEntity); goto d83ed; Acc76: d0571: goto e7ebe; cf6a1: goto A58d0; goto Acc76; fdcfd: $form->handleRequest($request); goto F985e; d83ed: if (!(true === $request->isMethod("\120\x4f\x53\124"))) { goto fbcbd; } goto fdcfd; f139e: $site = $this->getSite($request); goto D6029; Bda38: return $response; goto d733c; f584a: fbcbd: goto B6604; be99b: if (!(false === is_null($response))) { goto ebdf6; } goto Ddf1e; c7133: ebdf6: goto A69d9; D6029: if (false === is_null($site)) { goto d0571; } goto A5fe5; d733c: } private function createSshUserForm(SshUserEntity $sshUserEntity) : Form { goto aabf9; A7478: $form->add("\163\x75\142\155\x69\x74", SubmitType::class, ["\x61\x74\x74\x72" => ["\x63\x6c\141\x73\163" => "\x62\x74\156\x20\142\164\156\55\x62\x6c\x75\145\x20\x62\x74\156\x2d\x6c\147"], "\154\141\142\145\154" => "\101\x64\x64\40\x55\163\145\x72"]); goto ffe91; aabf9: $siteEntity = $sshUserEntity->getSite(); goto Cd671; Cd671: $form = $this->createForm("\101\x70\160\x5c\x46\x6f\x72\x6d\134\123\151\164\145\x53\x73\x68\125\x73\x65\162\124\171\160\145", $sshUserEntity, ["\141\x63\164\151\157\x6e" => $this->generateUrl("\x63\x6c\160\x5f\x73\x69\164\145\x5f\x73\163\x68\137\x75\x73\x65\162\x5f\x6e\x65\x77", ["\x64\157\155\x61\x69\156\116\x61\155\x65" => $siteEntity->getDomainName()]), "\x6d\x65\x74\x68\157\144" => "\x50\x4f\x53\x54", "\x61\x74\164\162" => []]); goto A7478; ffe91: return $form; goto C5fb7; C5fb7: } private function handleSshUserForm(Request $request, Form $form, Site $site) { goto a1392; abfcc: try { goto dd7d9; Dfce8: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\151\x74\x65\x5f\x75\x73\145\162\x73", ["\144\x6f\155\141\151\156\x4e\141\x6d\x65" => $site->getDomainName()])); goto F2db2; Bb6d5: $session->getFlashBag()->set("\x73\x75\143\x63\145\x73\163", $this->translator->trans("\125\x73\145\162\40\150\141\x73\x20\x62\x65\x65\156\40\141\144\144\x65\144\56")); goto Dfce8; D6410: return $response; goto c2254; Af262: $sshUserEntity->setPassword($sshUserPassword); goto Ddf2f; e4d17: $siteUpdater = $this->getSiteUpdater($site); goto C29cc; bb294: if (!(false === empty($sshKeys))) { goto a020e; } goto A999f; A290b: $user = $this->getUser(); goto a7058; a7058: $sshUserEntity = $form->getData(); goto cebad; Ed838: E5651: goto A290b; cfc5a: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\x73\151\164\145\x73")); goto B0044; F8ec4: if (false === is_null($siteEntity)) { goto E5651; } goto cfc5a; B0044: goto E2ada; goto Ed838; d959f: $eventData = ["\x73\151\x74\x65" => $domainName, "\x75\x73\x65\162\116\x61\x6d\145" => $sshUserName, "\x73\163\150\x4b\x65\171\x73" => $sshKeys]; goto C38b6; A999f: $siteUpdater->updateUserSShKeys($sshUserName, $sshKeys); goto f059c; cebad: $sshUserName = $sshUserEntity->getUserName(); goto b8557; a2ebc: $domainName = $site->getDomainName(); goto Ee88f; Fd694: $siteEntity->addSshUser($sshUserEntity); goto b1420; dd7d9: $session = $request->getSession(); goto a2ebc; C38b6: EventQueue::addEvent(EventQueue::EVENT_SITE_SSH_USER_ADD, $user, $eventData, $request); goto Bb6d5; Ddf2f: $sshKeys = $sshUserEntity->getSshKeys(); goto Fd694; F2db2: E2ada: goto D6410; Ee88f: $siteEntity = $this->getSiteEntity($domainName); goto F8ec4; b1420: $this->siteEntityManager->updateEntity($siteEntity); goto e4d17; C29cc: $siteUpdater->createSshUser($sshUserEntity); goto bb294; b8557: $sshUserPassword = $form->get("\160\141\163\163\x77\157\x72\x64")->getData(); goto Af262; f059c: a020e: goto d959f; c2254: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\x65\162", $this->translator->trans("\101\x6e\x20\x65\162\x72\x6f\162\x20\x68\141\163\x20\x6f\x63\x63\x75\162\x72\145\x64\x2c\x20\145\x72\x72\x6f\x72\x20\x6d\x65\x73\x73\141\147\x65\x3a\40\45\145\x72\x72\157\x72\115\x65\x73\x73\x61\x67\x65\45", ["\x25\x65\162\x72\157\x72\115\145\x73\x73\x61\x67\x65\x25" => $e->getMessage()])); } goto F058c; a7511: $this->formErrors = $this->getErrorMessages($form); goto E7f22; a1392: if (true === $form->isValid()) { goto ee646; } goto a7511; F058c: Bdacb: goto a4353; E7f22: goto Bdacb; goto a8cd8; a8cd8: ee646: goto abfcc; a4353: } public function editSshUser(Request $request) : Response { goto C50fa; c0d1f: $form->handleRequest($request); goto Eb667; C50fa: $userName = $request->get("\165\x73\x65\x72\116\x61\x6d\x65"); goto Df9dd; cdf48: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\151\x74\x65\x73")); goto Cd2f7; Df9dd: $site = $this->getSite($request); goto D9bff; Eb667: if (!(true === $form->isSubmitted())) { goto cd7fe; } goto D8661; D64f5: return $response; goto a11ff; D6711: if (!(true === $request->isMethod("\120\x4f\x53\x54"))) { goto Eedb0; } goto c0d1f; Cd2f7: goto Da6ff; goto c1e81; F5d68: if (!(false === is_null($response))) { goto B6b70; } goto Cd6d0; E670c: if (false === is_null($sshUserEntity) && false === is_null($site) && $sshUserEntity->getSite()->getDomainName() == $site->getDomainName()) { goto Ee6ac; } goto cdf48; E2adf: $response = $this->render("\x46\x72\x6f\x6e\x74\x65\156\x64\57\x53\151\164\145\57\x65\144\x69\164\55\x73\x73\x68\55\165\x73\x65\162\56\x68\164\155\x6c\56\164\x77\151\147", ["\163\x69\x74\145" => $site, "\x66\x6f\x72\x6d" => $form->createView(), "\146\x6f\x72\x6d\105\x72\x72\x6f\x72\163" => $this->formErrors]); goto a91c1; D9bff: $sshUserEntity = $this->sshUserEntityManager->findOneByUserName($userName); goto E670c; A1621: $form = $this->createSshUserEditForm($sshUserEntity); goto D6711; F0cf7: Eedb0: goto E2adf; D8661: $response = $this->handleSshUserEditForm($request, $form, $site); goto F5d68; Cd6d0: return $response; goto E9b4f; D9e32: cd7fe: goto F0cf7; c1e81: Ee6ac: goto A1621; E9b4f: B6b70: goto D9e32; a91c1: Da6ff: goto D64f5; a11ff: } private function createSshUserEditForm(SshUserEntity $sshUserEntity) : Form { goto E002d; Edd7e: return $form; goto fc0ba; Fbfb8: $form->add("\163\165\142\x6d\x69\164", SubmitType::class, ["\141\x74\164\x72" => ["\x63\x6c\141\163\163" => "\x62\x74\156\40\x62\164\156\x2d\x62\154\165\145\40\x62\164\156\55\x6c\147"], "\x6c\x61\142\x65\154" => "\x53\141\x76\145"]); goto Edd7e; E002d: $siteEntity = $sshUserEntity->getSite(); goto f8721; f8721: $form = $this->createForm("\x41\x70\x70\x5c\x46\157\162\x6d\x5c\x53\151\164\x65\x53\x73\150\x55\163\x65\x72\x45\x64\x69\x74\124\x79\x70\x65", $sshUserEntity, ["\x61\x63\x74\x69\x6f\156" => $this->generateUrl("\143\x6c\160\137\x73\x69\x74\x65\137\163\x73\150\137\165\163\x65\162\x5f\x65\x64\151\x74", ["\144\x6f\x6d\x61\151\156\116\x61\155\x65" => $siteEntity->getDomainName(), "\165\163\145\x72\116\x61\x6d\x65" => $sshUserEntity->getUserName()]), "\x6d\145\x74\150\x6f\144" => "\x50\117\123\x54", "\141\x74\x74\162" => []]); goto Fbfb8; fc0ba: } private function handleSshUserEditForm(Request $request, Form $form, Site $site) { goto f77e0; a0a60: Db170: goto d2277; A0c5b: $this->formErrors = $this->getErrorMessages($form); goto f73b9; Cc465: be7ac: goto ad504; f73b9: goto Db170; goto Cc465; ad504: try { goto be23e; Cbb5c: $user = $this->getUser(); goto a4022; e3b61: d9508: goto da140; E8b3c: goto d9508; goto dfc04; b3c24: $this->siteEntityManager->updateEntity($siteEntity); goto adf5a; e2cb2: $siteUpdater->updateUserSShKeys($sshUserName, $sshKeys); goto c9c89; Aac82: EventQueue::addEvent(EventQueue::EVENT_SITE_SSH_USER_EDIT, $user, $eventData, $request); goto Fc076; a4022: $sshUserEntity = $form->getData(); goto Ebff0; bb6fe: $sshKeys = false === is_null($sshUserEntity->getSshKeys()) ? $sshUserEntity->getSshKeys() : ''; goto b3c24; C8fa8: $domainName = $site->getDomainName(); goto ab134; c9c89: $eventData = ["\163\x69\x74\x65" => $domainName, "\165\x73\145\162\116\141\x6d\x65" => $sshUserName, "\x73\163\x68\113\x65\x79\163" => $sshKeys]; goto Aac82; Ebff0: $sshUserName = $sshUserEntity->getUserName(); goto E8a13; ab134: $siteEntity = $this->getSiteEntity($domainName); goto A0433; Fc076: $session->getFlashBag()->set("\163\165\x63\143\145\163\x73", $this->translator->trans("\x55\163\145\162\40\x68\x61\x73\40\x62\x65\x65\156\x20\x73\141\x76\145\x64\x2e")); goto dae73; a6c7d: if (!(false === empty($sshUserPassword))) { goto adf02; } goto E13f6; adf5a: $siteUpdater = $this->getSiteUpdater($site); goto a6c7d; E8a13: $sshUserPassword = $form->get("\x70\x61\163\163\167\x6f\162\144")->getData(); goto bb6fe; da140: return $response; goto c883d; Aaf6b: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\x73\x69\164\145\163")); goto E8b3c; E13f6: $siteUpdater->changeUserPassword($sshUserName, $sshUserPassword); goto a4d1e; dfc04: c82b8: goto Cbb5c; a4d1e: adf02: goto e2cb2; be23e: $session = $request->getSession(); goto C8fa8; dae73: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\x73\151\164\145\x5f\x75\x73\x65\162\x73", ["\144\x6f\x6d\x61\151\156\x4e\141\155\x65" => $site->getDomainName()])); goto e3b61; A0433: if (false === is_null($siteEntity)) { goto c82b8; } goto Aaf6b; c883d: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\x67\x65\x72", $this->translator->trans("\x41\156\x20\x65\162\x72\157\162\x20\150\141\x73\x20\157\x63\143\165\162\162\x65\x64\x2c\x20\145\162\x72\157\x72\40\x6d\145\163\x73\x61\x67\145\72\40\x25\145\x72\x72\157\162\x4d\145\163\x73\x61\x67\145\x25", ["\x25\145\x72\x72\x6f\162\115\145\x73\163\141\x67\x65\x25" => $e->getMessage()])); } goto a0a60; f77e0: if (true === $form->isValid()) { goto be7ac; } goto A0c5b; d2277: } public function deleteSshUser(Request $request) : Response { goto b05bd; c3a59: return $response; goto a0ed1; e0eed: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x73\151\164\145\163")); goto c3a59; B358b: $this->checkCsrfToken($request, "\x75\163\x65\x72\x2d\x64\145\154\x65\x74\145"); goto B8d4b; b05bd: $site = $this->getSite($request); goto B358b; B8d4b: if (!(false === is_null($site))) { goto dfa93; } goto aa3b1; A229d: dfa93: goto e0eed; aa3b1: try { goto F3b13; f4da3: $userName = $request->get("\x75\163\x65\x72\116\141\x6d\x65"); goto c63cd; Fef89: $sshUserSiteEntity = $sshUserEntity->getSite(); goto Fd75c; a89d0: EventQueue::addEvent(EventQueue::EVENT_SITE_SSH_USER_DELETE, $user, $evenData, $request); goto Bc7a4; F3b13: $session = $request->getSession(); goto f4da3; de66a: $siteUpdater->deleteUser($userName, true); goto b8cc0; C41ab: $siteEntity->removeSshUser($sshUserEntity); goto b612f; beef0: $userName = $sshUserEntity->getUserName(); goto C41ab; B2e50: $user = $this->getUser(); goto beef0; fef36: $siteEntity = $this->getSiteEntity($domainName); goto Ad2f7; Bc7a4: $session->getFlashBag()->set("\163\165\x63\x63\145\x73\x73", $this->translator->trans("\x55\163\145\x72\40\150\x61\163\x20\x62\x65\145\156\x20\144\x65\154\145\164\x65\144\x2e")); goto F6665; Ad2f7: $sshUserEntity = $this->sshUserEntityManager->findOneByUserName($userName); goto B8106; B8106: if (!(false === is_null($siteEntity) && false === empty($userName) && false === is_null($sshUserEntity))) { goto b3fbb; } goto Fef89; Fd75c: if (!($siteEntity->getDomainName() == $sshUserSiteEntity->getDomainName())) { goto Bcb2d; } goto B2e50; c63cd: $domainName = $site->getDomainName(); goto fef36; Aa598: Bcb2d: goto bd0d4; b612f: $this->siteEntityManager->updateEntity($siteEntity); goto a8086; F6665: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\163\151\164\x65\137\165\163\145\x72\163", ["\144\x6f\x6d\x61\151\156\116\x61\x6d\x65" => $site->getDomainName()])); goto d893f; a8086: $siteUpdater = $this->getSiteUpdater($site); goto de66a; d893f: return $response; goto Aa598; bd0d4: b3fbb: goto Ca516; b8cc0: $evenData = ["\163\x69\164\x65" => $domainName, "\165\163\x65\162\x4e\x61\x6d\145" => $userName]; goto a89d0; Ca516: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\147\x65\x72", $this->translator->trans("\101\x6e\40\145\x72\162\x6f\x72\x20\150\x61\x73\40\x6f\143\x63\x75\x72\162\x65\x64\54\x20\145\162\162\157\x72\x20\x6d\x65\163\x73\141\147\145\72\x20\x25\145\x72\x72\157\162\x4d\145\163\x73\x61\x67\x65\x25", ["\x25\145\x72\x72\x6f\162\x4d\145\163\163\141\x67\145\x25" => $e->getMessage()])); } goto A229d; a0ed1: } public function security(Request $request) : Response { goto d824f; De11f: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto Eebf5; C3c2b: if (!(true === $request->isMethod("\x50\x4f\123\124"))) { goto a277f; } goto d3a72; d7560: $basicAuthEntity = $this->basicAuthEntityManager->createEntity(); goto fa190; e9314: $response = $this->handleBasicAuthForm($request, $basicAuthForm, $site); goto e8619; f0570: goto b2490; goto Dcacd; c6dae: $blockedBots = $site->getBlockedBots(); goto A5a4f; d3a72: $basicAuthForm->handleRequest($request); goto A9dca; A1004: $basicAuthForm = $this->createBasicAuthForm($basicAuthEntity); goto f8143; d2af4: d4c83: goto a9440; Cfbab: bf04a: goto Ecd3b; Ecd3b: Bbda0: goto Dae24; d47b1: if (!(true === $basicAuthForm->isSubmitted())) { goto A1447; } goto e9314; aa899: $response = $this->handleCloudflareForm($request, $cloudflareForm, $site); goto e03db; ebd27: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\151\x74\x65\x73")); goto f0570; Dae24: a277f: goto Ff8bc; A9dca: $cloudflareForm->handleRequest($request); goto d47b1; d2789: $basicAuthEntity = $site->getBasicAuth(); goto a107b; e03db: if (!(false === is_null($response))) { goto bf04a; } goto C2bbd; e247d: if (false === is_null($site)) { goto E1ba6; } goto ebd27; f8143: $cloudflareForm = $this->createCloudflareForm($siteEntity, $cloudflareData); goto C3c2b; c816c: return $response; goto d2af4; e8619: if (!(false === is_null($response))) { goto d4c83; } goto c816c; C901c: $basicAuthEntity->setSite($siteEntity); goto A1004; E24fa: b2490: goto ce4a4; b8b94: if (!(true === $cloudflareForm->isSubmitted())) { goto Bbda0; } goto aa899; Eebf5: $cloudflareData = ["\x61\x6c\x6c\x6f\167\x54\x72\141\146\146\x69\x63\106\x72\157\155\x43\154\x6f\165\144\146\x6c\x61\162\145\x4f\x6e\154\x79" => $siteEntity->allowTrafficFromCloudflareOnly()]; goto c6dae; a107b: if (!(true === is_null($basicAuthEntity))) { goto a2edf; } goto d7560; C2bbd: return $response; goto Cfbab; ce4a4: return $response; goto cbf03; d824f: $site = $this->getSite($request); goto e247d; fa190: a2edf: goto C901c; Dcacd: E1ba6: goto De11f; A5a4f: $blockedIps = $site->getBlockedIps(); goto d2789; Ff8bc: $response = $this->render("\x46\x72\x6f\156\x74\145\x6e\144\57\x53\151\164\145\x2f\163\145\143\x75\162\151\x74\171\56\150\164\x6d\x6c\x2e\x74\x77\x69\x67", ["\163\x69\164\145" => $site, "\142\154\x6f\x63\x6b\145\144\x49\160\163" => $blockedIps, "\x62\x6c\x6f\x63\x6b\x65\144\x42\x6f\x74\163" => $blockedBots, "\142\141\163\x69\143\x41\x75\x74\150\x46\157\x72\155" => $basicAuthForm->createView(), "\143\x6c\x6f\x75\144\x66\154\141\x72\145\106\x6f\162\155" => $cloudflareForm->createView(), "\x66\x6f\162\155\x45\162\x72\x6f\162\x73" => $this->formErrors]); goto E24fa; a9440: A1447: goto b8b94; cbf03: } private function createCloudflareForm(SiteEntity $siteEntity, array $data) : Form { goto d1f8e; f9c95: $form->add("\x73\165\x62\155\x69\164", SubmitType::class, ["\x61\x74\164\162" => ["\x63\x6c\x61\x73\163" => "\x62\164\156\40\142\164\x6e\x2d\x62\154\x75\x65\40\142\164\156\x2d\154\147"], "\154\141\142\145\154" => "\123\141\x76\x65"]); goto B7cad; B7cad: return $form; goto B2c3f; d1f8e: $form = $this->createForm("\101\x70\160\134\106\x6f\x72\x6d\x5c\x53\x69\x74\145\103\x6c\157\x75\x64\x66\x6c\x61\x72\145\x54\171\160\145", $data, ["\x61\143\x74\x69\157\156" => $this->generateUrl("\x63\x6c\160\137\163\151\164\145\137\x73\x65\143\x75\x72\151\x74\171", ["\144\157\x6d\x61\151\156\x4e\x61\x6d\x65" => $siteEntity->getDomainName()]), "\x6d\145\164\x68\157\144" => "\120\117\123\124", "\x61\x74\x74\162" => []]); goto f9c95; B2c3f: } private function createBasicAuthForm(BasicAuthEntity $basicAuthEntity) : Form { goto E3fc3; E3fc3: $siteEntity = $basicAuthEntity->getSite(); goto E55b8; E55b8: $form = $this->createForm("\101\x70\160\x5c\x46\157\162\155\x5c\123\151\x74\145\x42\141\163\151\143\101\165\164\150\124\x79\x70\x65", $basicAuthEntity, ["\x61\x63\164\x69\157\x6e" => $this->generateUrl("\x63\x6c\160\137\163\x69\x74\145\137\x73\145\x63\x75\x72\151\x74\171", ["\x64\x6f\x6d\141\151\x6e\x4e\141\155\x65" => $siteEntity->getDomainName()]), "\155\x65\164\x68\157\x64" => "\120\x4f\123\x54", "\x61\164\x74\162" => []]); goto c513b; c513b: $form->add("\x73\x75\x62\155\151\164", SubmitType::class, ["\x61\x74\x74\x72" => ["\143\x6c\141\x73\x73" => "\142\x74\x6e\x20\142\164\156\55\x62\154\165\x65\x20\142\164\156\x2d\154\x67"], "\154\141\x62\145\x6c" => "\123\x61\x76\145"]); goto Ca473; Ca473: return $form; goto A344b; A344b: } private function handleBasicAuthForm(Request $request, Form $form, Site $site) { goto dfcce; e5e3d: f805f: goto Afedf; Aa758: goto C976e; goto e5e3d; dfcce: if (true === $form->isValid()) { goto f805f; } goto ff958; ff958: $this->formErrors = $this->getErrorMessages($form); goto Aa758; Afedf: try { goto E0900; D9357: $siteUpdater->createBasicAuthFile($basicAuthEntity); goto eed38; Fa5aa: $user = $this->getUser(); goto d38c9; c6e3d: Be7d4: goto Fa5aa; A2017: $site->setBasicAuth($basicAuthEntity); goto ce60e; F628f: $siteEntity->setBasicAuth($basicAuthEntity); goto A2017; cdfea: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\163\x69\x74\x65\x5f\163\x65\x63\165\162\151\164\x79", ["\144\x6f\155\141\x69\156\x4e\141\155\145" => $site->getDomainName()])); goto bd85c; d38f3: $eventData = ["\x73\x69\164\x65" => $domainName, "\141\x63\x74\151\x76\x65" => true === $basicAuthEntity->getIsActive() ? "\x31" : "\x30", "\x75\x73\145\162\x4e\x61\x6d\x65" => $basicAuthEntity->getUserName(), "\167\x68\151\164\145\154\151\x73\x74\145\x64\111\160\163" => $basicAuthEntity->getWhitelistedIps()]; goto f85a4; ce60e: $this->siteEntityManager->updateEntity($siteEntity); goto e513d; e513d: $siteUpdater = $this->getSiteUpdater($site); goto D9357; E0900: $session = $request->getSession(); goto f1142; Cbb9c: return $response; goto e5ad4; d38c9: $basicAuthEntity = $form->getData(); goto F628f; ea784: goto Ac0c2; goto c6e3d; bd85c: Ac0c2: goto Cbb9c; cdad2: if (false === is_null($siteEntity)) { goto Be7d4; } goto c83a3; C8055: $session->getFlashBag()->set("\x73\x75\x63\143\x65\163\x73", $this->translator->trans("\102\141\163\x69\143\x20\101\x75\164\x68\x65\156\x74\x69\143\x61\164\x69\157\x6e\x20\x73\x65\164\164\151\156\x67\x73\x20\x68\x61\x76\x65\x20\142\x65\145\156\x20\163\141\x76\145\144\56")); goto cdfea; f85a4: EventQueue::addEvent(EventQueue::EVENT_SITE_BASIC_AUTHENTIFICATION_SETTINGS, $user, $eventData, $request); goto C8055; f1142: $domainName = $site->getDomainName(); goto ee867; ee867: $siteEntity = $this->getSiteEntity($domainName); goto cdad2; Ac461: $siteUpdater->reloadNginxService(); goto d38f3; c83a3: $response = $this->redirect($this->generateUrl("\x63\154\160\137\163\151\x74\x65\163")); goto ea784; eed38: $siteUpdater->updateNginxVhost(); goto Ac461; e5ad4: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\x67\x65\162", $this->translator->trans("\x41\x6e\x20\x65\162\162\x6f\x72\40\150\x61\x73\x20\x6f\x63\143\165\162\162\x65\x64\54\40\x65\162\162\157\x72\x20\155\145\x73\163\x61\147\145\x3a\x20\x25\145\x72\162\157\162\115\145\x73\163\141\147\x65\45", ["\45\145\162\162\157\162\x4d\145\x73\163\141\147\145\45" => $e->getMessage()])); } goto a02ff; a02ff: C976e: goto B44eb; B44eb: } private function handleCloudflareForm(Request $request, Form $form, Site $site) { goto Fd872; A87e5: E486c: goto C4c3b; Fd872: if (true === $form->isValid()) { goto E486c; } goto e05cf; E18ac: goto F079f; goto A87e5; f235a: F079f: goto d85b4; e05cf: $this->formErrors = $this->getErrorMessages($form); goto E18ac; C4c3b: try { goto e9d6c; cf07d: EventQueue::addEvent(EventQueue::EVENT_SITE_CLOUDFLARE_SETTINGS, $user, $eventData, $request); goto De96d; C1760: C6377: goto e6db7; E5ceb: $siteUpdater = $this->getSiteUpdater($site); goto B6e08; b3afb: if (false === is_null($siteEntity)) { goto C6377; } goto Be8be; De96d: $session->getFlashBag()->set("\163\x75\143\143\x65\x73\163", $this->translator->trans("\x43\154\x6f\x75\144\x66\154\x61\x72\145\x20\x73\x65\x74\x74\x69\x6e\x67\x73\x20\x68\141\166\x65\x20\142\145\145\x6e\40\163\x61\166\145\x64\56")); goto deb4e; Adfda: goto B7d93; goto C1760; e16ec: $siteEntity = $this->getSiteEntity($domainName); goto b3afb; c098f: $eventData = ["\163\x69\x74\145" => $domainName, "\141\154\154\157\x77\124\162\141\146\146\x69\x63\106\x72\157\x6d\103\x6c\x6f\165\x64\146\x6c\141\x72\145\117\156\x6c\x79" => true === $allowTrafficFromCloudflareOnly ? "\x31" : "\60"]; goto cf07d; Ad346: $domainName = $site->getDomainName(); goto e16ec; Ed6ad: $this->siteEntityManager->updateEntity($siteEntity); goto E5ceb; B6e08: $siteUpdater->updateNginxVhost(); goto f9af5; F19bf: $allowTrafficFromCloudflareOnly = $form->get("\141\154\154\x6f\x77\x54\x72\141\x66\146\151\143\x46\x72\x6f\x6d\x43\154\x6f\x75\144\146\x6c\x61\x72\145\117\x6e\x6c\171")->getData(); goto Dda5c; e6db7: $user = $this->getUser(); goto F19bf; deb4e: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\163\x69\164\x65\x5f\x73\x65\x63\x75\x72\151\164\x79", ["\144\157\x6d\141\x69\156\x4e\141\x6d\145" => $site->getDomainName()])); goto f2f14; f9af5: $siteUpdater->reloadNginxService(); goto c098f; Aaf66: return $response; goto cc7b5; f2f14: B7d93: goto Aaf66; Dda5c: $siteEntity->setAllowTrafficFromCloudflareOnly($allowTrafficFromCloudflareOnly); goto daf5c; Be8be: $response = $this->redirect($this->generateUrl("\143\154\x70\137\163\x69\164\x65\163")); goto Adfda; e9d6c: $session = $request->getSession(); goto Ad346; daf5c: $site->setAllowTrafficFromCloudflareOnly($allowTrafficFromCloudflareOnly); goto Ed6ad; cc7b5: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\x65\x72", $this->translator->trans("\x41\x6e\x20\145\162\162\157\x72\40\x68\141\163\x20\157\x63\x63\165\x72\162\145\x64\54\40\x65\x72\x72\157\x72\x20\155\x65\163\163\141\x67\x65\72\x20\45\x65\x72\x72\x6f\x72\115\x65\x73\x73\141\x67\x65\45", ["\45\145\162\x72\x6f\162\115\145\163\x73\x61\x67\145\45" => $e->getMessage()])); } goto f235a; d85b4: } public function newBlockedIp(Request $request) : Response { goto De6ff; De6ff: $site = $this->getSite($request); goto B3d32; F070d: $blockedIpEntity = $this->blockedIpEntityManager->createEntity(); goto A341f; e3ee2: a8959: goto F733c; F2afd: F05e8: goto Ddeda; a8b57: $response = $this->handleBlockedIpForm($request, $form, $site); goto ca4bd; ca4bd: if (!(false === is_null($response))) { goto b2d6a; } goto cc87d; dc3b4: return $response; goto D21f4; A341f: $blockedIpEntity->setSite($siteEntity); goto B0927; F733c: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto F070d; eebbd: $response = $this->render("\x46\x72\157\156\164\x65\x6e\144\57\x53\x69\164\x65\x2f\x6e\x65\167\x2d\x62\154\157\x63\153\145\144\55\151\x70\x2e\150\164\x6d\154\x2e\x74\167\151\x67", ["\163\x69\164\145" => $site, "\146\157\162\155" => $form->createView(), "\146\157\x72\155\105\162\162\157\x72\163" => $this->formErrors]); goto Bb1df; D4f06: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\163\151\164\145\163")); goto a945b; Bb1df: cdbdf: goto dc3b4; B3d32: if (false === is_null($site)) { goto a8959; } goto D4f06; cc87d: return $response; goto F6052; F6052: b2d6a: goto F2afd; Ddeda: c05f0: goto eebbd; a1899: $form->handleRequest($request); goto E9b7c; B0927: $form = $this->createBlockedIpForm($blockedIpEntity); goto be5b1; a945b: goto cdbdf; goto e3ee2; be5b1: if (!(true === $request->isMethod("\120\117\x53\124"))) { goto c05f0; } goto a1899; E9b7c: if (!(true === $form->isSubmitted())) { goto F05e8; } goto a8b57; D21f4: } private function createBlockedIpForm(BlockedIpEntity $blockedIpEntity) : Form { goto cddf5; a58f6: $form->add("\163\x75\142\155\151\164", SubmitType::class, ["\141\x74\164\x72" => ["\143\x6c\x61\x73\163" => "\x62\164\x6e\x20\142\164\156\x2d\142\x6c\x75\145\40\x62\x74\156\55\x6c\x67"], "\x6c\x61\x62\145\x6c" => "\101\x64\144\40\x49\x50"]); goto b0771; cddf5: $siteEntity = $blockedIpEntity->getSite(); goto fa3c5; b0771: return $form; goto c9fe4; fa3c5: $form = $this->createForm("\x41\160\x70\x5c\106\157\162\x6d\134\x53\x69\x74\145\102\154\x6f\x63\x6b\145\144\111\120\124\x79\x70\145", $blockedIpEntity, ["\141\143\x74\151\x6f\x6e" => $this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\x65\x5f\x73\145\x63\165\162\151\164\171\x5f\x62\154\x6f\x63\153\145\144\137\x69\x70\x5f\156\x65\x77", ["\144\157\x6d\x61\151\156\116\141\155\145" => $siteEntity->getDomainName()]), "\155\145\x74\x68\x6f\x64" => "\x50\x4f\123\124", "\x61\164\x74\x72" => []]); goto a58f6; c9fe4: } private function handleBlockedIpForm(Request $request, Form $form, Site $site) { goto B4344; afb50: A899b: goto f9b0c; B4344: if (true === $form->isValid()) { goto A899b; } goto F42eb; bbbfc: a0b64: goto D3077; B57e9: goto a0b64; goto afb50; f9b0c: try { goto fcc99; Ed2c7: $siteUpdater = $this->getSiteUpdater($site); goto Aaba8; cbda8: $eventData = ["\x73\x69\x74\145" => $domainName, "\x69\x70" => $blockedIp->getIp()]; goto cdddc; D41b1: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\163\151\x74\145\x73")); goto E5152; D1d89: $this->siteEntityManager->updateEntity($siteEntity); goto Ed2c7; a9486: cfc08: goto d954c; c8174: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\163\x69\x74\145\x5f\x73\x65\x63\165\x72\x69\x74\171", ["\x64\157\155\141\x69\x6e\116\x61\155\145" => $site->getDomainName()])); goto a9486; C842b: $blockedIp = $form->getData(); goto dddfd; b0d02: $siteEntity = $this->getSiteEntity($domainName); goto d838f; dddfd: $siteEntity->addBlockedIp($blockedIp); goto D1d89; E5152: goto cfc08; goto e47e5; fcc99: $session = $request->getSession(); goto e814f; d838f: if (false === is_null($siteEntity)) { goto fc6f1; } goto D41b1; cdddc: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_IP_ADD, $user, $eventData, $request); goto c8fb3; Ba8de: $siteUpdater->reloadNginxService(); goto cbda8; e814f: $domainName = $site->getDomainName(); goto b0d02; A0b5d: $user = $this->getUser(); goto C842b; d954c: return $response; goto a090e; e47e5: fc6f1: goto A0b5d; Aaba8: $siteUpdater->updateNginxVhost(); goto Ba8de; c8fb3: $session->getFlashBag()->set("\x73\165\143\143\x65\x73\163", $this->translator->trans("\111\x50\x20\x68\x61\x73\x20\142\145\x65\x6e\40\141\x64\144\x65\144\x2e")); goto c8174; a090e: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\147\145\162", $this->translator->trans("\101\156\x20\x65\x72\162\157\x72\40\x68\141\163\x20\157\143\x63\x75\162\162\x65\144\54\x20\145\x72\x72\x6f\x72\40\x6d\145\163\x73\x61\x67\x65\x3a\x20\45\x65\162\162\157\x72\115\x65\163\x73\x61\x67\145\x25", ["\x25\x65\x72\x72\x6f\x72\115\145\163\x73\x61\147\x65\45" => $e->getMessage()])); } goto bbbfc; F42eb: $this->formErrors = $this->getErrorMessages($form); goto B57e9; D3077: } public function deleteBlockedIp(Request $request) : Response { goto d5beb; d5beb: $site = $this->getSite($request); goto Ca162; C263a: if (!(false === is_null($site))) { goto E1984; } goto Ded3c; f91ad: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\x73\151\164\x65\163")); goto c1e19; c1e19: return $response; goto b3bb4; B9d1f: E1984: goto f91ad; Ca162: $this->checkCsrfToken($request, "\151\160\55\144\x65\x6c\x65\164\145"); goto C263a; Ded3c: try { goto f944f; Ba88a: $session->getFlashBag()->set("\163\x75\x63\x63\145\x73\x73", $this->translator->trans("\x49\120\40\x68\141\x73\x20\142\145\x65\x6e\x20\144\145\x6c\145\x74\145\x64\56")); goto E5da2; d4aab: $siteEntity->removeBlockedIp($blockedIpEntity); goto fc231; A5e63: if (!(false === is_null($siteEntity) && false === empty($id) && false === is_null($blockedIpEntity) && $siteEntity == $blockedIpEntity->getSite())) { goto Bdaa0; } goto Ff7db; f944f: $session = $request->getSession(); goto C004c; C004c: $id = (int) $request->get("\151\x64"); goto e5471; Edcdd: $eventData = ["\163\151\x74\145" => $domainName, "\151\160" => $blockedIpEntity->getIp()]; goto b2999; A8b2e: $siteUpdater->reloadNginxService(); goto Edcdd; Fd7a6: return $response; goto ee41b; E5da2: $response = $this->redirect($this->generateUrl("\143\154\160\137\x73\151\164\145\137\x73\145\143\x75\x72\x69\164\x79", ["\144\157\x6d\x61\151\x6e\116\141\155\145" => $site->getDomainName()])); goto Fd7a6; Ff7db: $user = $this->getUser(); goto d4aab; b2999: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_IP_DELETE, $user, $eventData, $request); goto Ba88a; Bf5df: $siteUpdater = $this->getSiteUpdater($site); goto Ffd06; ee41b: Bdaa0: goto e05c4; Ffd06: $siteUpdater->updateNginxVhost(); goto A8b2e; d5dc7: $blockedIpEntity = $this->blockedIpEntityManager->findOneById($id); goto A5e63; ba862: $siteEntity = $this->getSiteEntity($domainName); goto d5dc7; fc231: $this->siteEntityManager->updateEntity($siteEntity); goto Bf5df; e5471: $domainName = $site->getDomainName(); goto ba862; e05c4: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\x65\162", $this->translator->trans("\101\x6e\40\145\162\162\157\x72\40\x68\x61\x73\40\x6f\143\143\x75\162\162\x65\144\54\x20\x65\x72\162\x6f\x72\x20\155\x65\163\x73\141\147\x65\x3a\40\45\x65\x72\x72\x6f\x72\115\145\x73\163\x61\147\x65\x25", ["\45\x65\162\x72\157\x72\115\x65\x73\x73\x61\x67\x65\x25" => $e->getMessage()])); } goto B9d1f; b3bb4: } public function newBlockedBot(Request $request) : Response { goto C98f4; E62a0: $response = $this->handleBlockedBotForm($request, $form, $site); goto e1810; e64e4: $form->handleRequest($request); goto B5827; D5c89: if (false === is_null($site)) { goto Ff835; } goto Bc93e; e9b8f: if (!(true === $request->isMethod("\120\117\x53\x54"))) { goto E3073; } goto e64e4; Bc93e: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\x69\164\x65\x73")); goto Bf207; dc171: Ff835: goto d2ef8; da279: $response = $this->render("\x46\162\x6f\x6e\164\x65\x6e\144\x2f\123\x69\x74\145\57\x6e\145\167\x2d\x62\154\x6f\x63\153\145\144\55\142\157\164\56\x68\164\155\x6c\56\x74\x77\x69\147", ["\x73\x69\x74\x65" => $site, "\x66\x6f\162\x6d" => $form->createView(), "\x66\x6f\162\155\105\162\x72\157\162\163" => $this->formErrors]); goto d10eb; C98f4: $site = $this->getSite($request); goto D5c89; Bf207: goto E4f86; goto dc171; B5827: if (!(true === $form->isSubmitted())) { goto Aa195; } goto E62a0; ebc0e: e7b26: goto bba12; d2ef8: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto D468f; bba12: Aa195: goto Ab025; Ab025: E3073: goto da279; fa0ea: return $response; goto ebc0e; d10eb: E4f86: goto fdac9; fdac9: return $response; goto ad283; a8631: $blockedBotEntity->setSite($siteEntity); goto ef560; ef560: $form = $this->createBlockedBotForm($blockedBotEntity); goto e9b8f; D468f: $blockedBotEntity = $this->blockedBotEntityManager->createEntity(); goto a8631; e1810: if (!(false === is_null($response))) { goto e7b26; } goto fa0ea; ad283: } private function createBlockedBotForm(BlockedBotEntity $blockedBotEntity) : Form { goto f7e81; f7e81: $siteEntity = $blockedBotEntity->getSite(); goto D2699; D2699: $form = $this->createForm("\x41\160\x70\x5c\x46\x6f\x72\x6d\134\123\151\x74\x65\x42\x6c\x6f\143\153\x65\144\102\x6f\164\x54\171\160\x65", $blockedBotEntity, ["\x61\143\164\151\x6f\156" => $this->generateUrl("\x63\154\160\x5f\x73\x69\x74\x65\137\163\x65\143\x75\162\x69\164\x79\137\142\x6c\x6f\x63\153\x65\144\x5f\x62\157\x74\x5f\x6e\x65\167", ["\144\157\155\x61\151\x6e\x4e\141\x6d\x65" => $siteEntity->getDomainName()]), "\x6d\145\164\150\157\144" => "\x50\117\x53\124", "\x61\x74\x74\x72" => []]); goto Febae; f7bc3: return $form; goto C1a4a; Febae: $form->add("\x73\x75\142\155\x69\x74", SubmitType::class, ["\141\164\x74\162" => ["\x63\154\141\x73\163" => "\x62\x74\156\40\x62\164\x6e\x2d\x62\x6c\x75\x65\x20\142\x74\156\55\154\x67"], "\x6c\141\x62\145\154" => "\101\144\x64\40\x42\157\x74"]); goto f7bc3; C1a4a: } private function handleBlockedBotForm(Request $request, Form $form, Site $site) { goto C14cd; C14cd: if (true === $form->isValid()) { goto c0d78; } goto Fe801; F9190: E2c91: goto B2dfe; d4869: try { goto Dee5c; Dee5c: $session = $request->getSession(); goto Eac6c; db04d: $user = $this->getUser(); goto Aad7d; Cd248: fc0fa: goto db04d; e7b05: $eventData = ["\x73\x69\x74\145" => $domainName, "\x6e\x61\x6d\145" => $blockedBot->getName()]; goto a24e4; b3171: return $response; goto ac309; Aad7d: $blockedBot = $form->getData(); goto e1536; D98d0: ee496: goto b3171; Db550: $session->getFlashBag()->set("\x73\x75\143\x63\x65\x73\x73", $this->translator->trans("\102\157\x74\x20\x68\x61\163\x20\x62\x65\x65\x6e\x20\x61\x64\x64\145\x64\x2e")); goto B594f; B24e2: $siteUpdater->updateNginxVhost(); goto e9429; E05bc: goto ee496; goto Cd248; adf66: $siteEntity = $this->getSiteEntity($domainName); goto bddf3; C9000: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\163\151\x74\x65\163")); goto E05bc; B594f: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\x69\164\145\137\x73\145\143\165\162\151\x74\x79", ["\144\x6f\x6d\x61\x69\x6e\116\x61\155\145" => $site->getDomainName()])); goto D98d0; ed870: $siteUpdater = $this->getSiteUpdater($site); goto B24e2; e1536: $siteEntity->addBlockedBot($blockedBot); goto c18a4; bddf3: if (false === is_null($siteEntity)) { goto fc0fa; } goto C9000; a24e4: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_BOT_ADD, $user, $eventData, $request); goto Db550; Eac6c: $domainName = $site->getDomainName(); goto adf66; e9429: $siteUpdater->reloadNginxService(); goto e7b05; c18a4: $this->siteEntityManager->updateEntity($siteEntity); goto ed870; ac309: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\145\162", $this->translator->trans("\101\156\x20\145\162\x72\157\x72\40\x68\x61\x73\x20\157\x63\143\x75\162\x72\x65\144\x2c\40\x65\162\x72\x6f\162\40\155\x65\x73\x73\141\x67\x65\x3a\x20\45\x65\162\162\x6f\x72\115\x65\163\x73\x61\147\145\45", ["\45\145\x72\162\x6f\x72\115\145\x73\x73\x61\x67\145\45" => $e->getMessage()])); } goto F9190; C4668: goto E2c91; goto ab739; ab739: c0d78: goto d4869; Fe801: $this->formErrors = $this->getErrorMessages($form); goto C4668; B2dfe: } public function deleteBlockedBot(Request $request) : Response { goto b0e41; A606f: if (!(false === is_null($site))) { goto e97f8; } goto f02c6; f02c6: try { goto b7280; ed8b8: $user = $this->getUser(); goto C9b02; Abf09: $siteUpdater->updateNginxVhost(); goto A244b; ad014: $domainName = $site->getDomainName(); goto E2508; A244b: $siteUpdater->reloadNginxService(); goto b95de; C439c: $session->getFlashBag()->set("\163\165\x63\x63\x65\x73\x73", $this->translator->trans("\102\x6f\164\40\x68\x61\x73\40\x62\145\145\156\40\x64\145\154\x65\x74\x65\144\56")); goto dfea9; Dc7e4: EventQueue::addEvent(EventQueue::EVENT_SITE_BLOCKED_BOT_DELETE, $user, $eventData, $request); goto C439c; f1445: return $response; goto Bf493; E2508: $siteEntity = $this->getSiteEntity($domainName); goto Ad073; dfea9: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\x69\164\145\137\x73\145\143\165\162\151\x74\171", ["\144\157\155\x61\x69\x6e\x4e\141\155\x65" => $site->getDomainName()])); goto f1445; dd331: $id = (int) $request->get("\x69\x64"); goto ad014; Bf493: A114e: goto Dfa74; baffc: $this->siteEntityManager->updateEntity($siteEntity); goto C5609; b7280: $session = $request->getSession(); goto dd331; Ebfe0: if (!(false === is_null($siteEntity) && false === empty($id) && false === is_null($blockedBotEntity) && $siteEntity == $blockedBotEntity->getSite())) { goto A114e; } goto ed8b8; b95de: $eventData = ["\163\151\x74\145" => $domainName, "\156\x61\155\x65" => $blockedBotEntity->getName()]; goto Dc7e4; C9b02: $siteEntity->removeBlockedBot($blockedBotEntity); goto baffc; Ad073: $blockedBotEntity = $this->blockedBotEntityManager->findOneById($id); goto Ebfe0; C5609: $siteUpdater = $this->getSiteUpdater($site); goto Abf09; Dfa74: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\156\147\145\162", $this->translator->trans("\101\156\40\x65\x72\x72\157\x72\x20\150\x61\163\x20\x6f\x63\143\165\162\x72\145\144\x2c\x20\x65\x72\x72\x6f\x72\40\x6d\x65\x73\163\141\147\145\72\x20\x25\x65\x72\162\157\x72\x4d\145\x73\163\x61\x67\145\x25", ["\45\x65\162\162\157\x72\x4d\145\x73\163\x61\147\145\45" => $e->getMessage()])); } goto C077b; C077b: e97f8: goto D88d9; b0e41: $site = $this->getSite($request); goto E5427; E5427: $this->checkCsrfToken($request, "\x62\157\164\55\x64\145\x6c\x65\164\145"); goto A606f; cb69f: return $response; goto cd068; D88d9: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\x69\x74\x65\x73")); goto cb69f; cd068: } public function certificates(Request $request) : Response { goto cfc2d; c1778: F98fe: goto df366; cfc2d: $site = $this->getSite($request); goto F8d92; df366: return $response; goto fe853; adb56: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\x69\x74\x65\163")); goto Eff38; B2b74: B0ad5: goto f6e6e; f056d: $certificates = $site->getCertificates(); goto E3cd5; f6e6e: $installedCertificate = $site->getCertificate(); goto f056d; E3cd5: $response = $this->render("\106\x72\157\x6e\164\145\x6e\x64\x2f\123\151\164\145\57\x63\145\162\x74\x69\146\x69\x63\x61\x74\145\163\56\x68\x74\x6d\154\56\x74\x77\x69\x67", ["\163\x69\164\x65" => $site, "\x69\x6e\x73\x74\x61\x6c\x6c\145\144\x43\x65\x72\x74\x69\x66\151\x63\141\164\145" => $installedCertificate, "\143\x65\162\164\x69\146\151\x63\x61\x74\x65\163" => $certificates]); goto c1778; Eff38: goto F98fe; goto B2b74; F8d92: if (false === is_null($site)) { goto B0ad5; } goto adb56; fe853: } public function importCertificate(Request $request) : Response { goto f9399; C8fab: if (!(true === $request->isMethod("\x50\117\x53\x54"))) { goto cca76; } goto ee79c; Fbe6f: acfb7: goto e6763; A96a9: $response = $this->render("\106\x72\x6f\156\164\145\x6e\x64\x2f\123\151\164\145\x2f\x69\x6d\160\157\162\x74\55\x63\145\162\x74\151\146\x69\x63\x61\164\145\56\150\x74\x6d\x6c\56\164\167\x69\147", ["\163\151\164\145" => $site, "\x66\157\x72\x6d" => $form->createView(), "\146\157\162\x6d\105\x72\162\x6f\162\x73" => $this->formErrors]); goto b73ee; aef31: return $response; goto De386; f9399: $site = $this->getSite($request); goto B7121; e6763: cca76: goto A96a9; D54f5: $response = $this->handleImportCertificateForm($request, $form, $site); goto F1f98; cc4ea: f6e2d: goto B1005; B1005: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto D5257; B7121: if (false === is_null($site)) { goto f6e2d; } goto c91ea; b73ee: Fc8bc: goto aef31; fb232: $form = $this->createImportCertificateForm($certificateEntity); goto C8fab; bfe86: return $response; goto E13d9; ee79c: $form->handleRequest($request); goto d97c8; d42cd: $certificateEntity->setSite($siteEntity); goto fb232; E13d9: bb821: goto Fbe6f; F1f98: if (!(false === is_null($response))) { goto bb821; } goto bfe86; fd5ca: goto Fc8bc; goto cc4ea; c91ea: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\163\x69\164\x65\163")); goto fd5ca; d97c8: if (!(true === $form->isSubmitted())) { goto acfb7; } goto D54f5; C9688: $certificateEntity->setType(CertificateEntity::TYPE_IMPORTED); goto d42cd; D5257: $certificateEntity = $this->certificateEntityManager->createEntity(); goto C9688; De386: } private function createImportCertificateForm(CertificateEntity $certificateEntity) : Form { goto D0531; ea42f: return $form; goto c9d33; D0531: $siteEntity = $certificateEntity->getSite(); goto f9bfd; D1db8: $form->add("\x73\x75\x62\155\x69\x74", SubmitType::class, ["\x61\x74\x74\162" => ["\143\x6c\x61\x73\163" => "\x62\164\156\x20\x62\164\156\55\x62\154\x75\145\x20\142\164\156\x2d\154\147"], "\x6c\141\x62\145\x6c" => "\x49\x6d\160\157\162\164\40\x61\156\144\40\x49\x6e\x73\164\x61\154\x6c"]); goto ea42f; f9bfd: $form = $this->createForm("\x41\x70\x70\134\106\x6f\162\155\134\x53\151\x74\145\x49\x6d\x70\x6f\x72\x74\x43\145\162\164\x69\146\x69\143\141\164\x65\x54\171\160\145", $certificateEntity, ["\141\x63\164\151\x6f\x6e" => $this->generateUrl("\x63\x6c\160\x5f\x73\x69\x74\145\137\143\x65\162\x74\151\x66\x69\x63\141\164\145\x5f\151\155\x70\157\162\164", ["\x64\157\x6d\x61\151\156\x4e\141\155\145" => $siteEntity->getDomainName()]), "\x6d\x65\164\x68\x6f\x64" => "\x50\117\x53\124", "\x61\164\164\162" => []]); goto D1db8; c9d33: } private function handleImportCertificateForm(Request $request, Form $form, Site $site) { goto a1fd8; a4a9d: try { goto A8dfc; A3c0e: $this->siteEntityManager->updateEntity($siteEntity); goto cb145; A8dfc: $session = $request->getSession(); goto A35c7; Fc5ca: return $response; goto E726a; cf69d: $siteEntity->addCertificate($certificateEntity); goto A3c0e; Fb9ef: D0350: goto Fc5ca; F5fb4: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_INSTALL, $user, $evenData, $request); goto d1919; ec3a5: if (false === is_null($siteEntity)) { goto F4170; } goto C03e7; f2e0c: goto D0350; goto C475e; C475e: F4170: goto Feea3; f26ad: $siteEntity->setCertificate($certificateEntity); goto cf69d; Feea3: $user = $this->getUser(); goto a289e; e698e: $siteUpdater = $this->getSiteUpdater($site); goto e9fdd; cb145: $evenData = ["\x73\151\164\x65" => $domainName]; goto F5fb4; d1919: $session->getFlashBag()->set("\163\x75\143\x63\145\163\x73", $this->translator->trans("\x43\145\x72\x74\151\146\x69\143\141\x74\145\x20\150\x61\x73\40\142\x65\145\156\40\x69\x6e\x73\164\x61\x6c\x6c\145\x64\x2e")); goto e1382; A35c7: $domainName = $site->getDomainName(); goto b4fdf; C03e7: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\163\151\164\145\163")); goto f2e0c; b4fdf: $siteEntity = $this->getSiteEntity($domainName); goto ec3a5; a289e: $certificateEntity = $form->getData(); goto e698e; e1382: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\x73\151\164\145\137\x63\145\162\x74\x69\146\x69\143\x61\x74\x65\163", ["\144\x6f\155\141\151\156\116\141\x6d\x65" => $site->getDomainName()])); goto Fb9ef; e9fdd: $siteUpdater->installCertificate($certificateEntity); goto f26ad; E726a: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\147\x65\x72", $this->translator->trans("\x41\x6e\x20\145\x72\x72\157\x72\40\150\x61\x73\40\157\143\143\165\162\x72\x65\144\x2c\40\145\162\162\x6f\162\x20\155\145\163\163\141\147\145\x3a\40\45\145\x72\x72\157\162\115\145\x73\x73\x61\147\145\x25", ["\45\x65\x72\x72\x6f\x72\x4d\145\163\x73\141\x67\x65\x25" => $e->getMessage()])); } goto fc756; Ef211: Cf3fc: goto a4a9d; a1fd8: if (true === $form->isValid()) { goto Cf3fc; } goto C26f8; a619d: goto f9f9a; goto Ef211; fc756: f9f9a: goto d24f0; C26f8: $this->formErrors = $this->getErrorMessages($form); goto a619d; d24f0: } public function newLetsEncryptCertificate(Request $request) : Response { goto d42b8; b513b: if (true === $request->isMethod("\120\117\x53\x54")) { goto E9cf1; } goto a45e4; F5853: Ed773: goto c5ad9; A8888: $subdomain = $resolvedDomainName->subDomain()->toString(); goto fca0e; Fa946: goto fb04e; goto fc101; b61af: if (!(true === $form->isSubmitted())) { goto C206e; } goto C10ed; c5ad9: $domains = [$registrableDomain, sprintf("\x77\167\x77\56\x25\x73", $registrableDomain)]; goto f2262; D8e37: $domains = array_unique($domains); goto e7a3f; fc101: E9cf1: goto af71f; C9442: goto c86e8; goto F5853; C83a5: if (true === is_null($subdomain) || "\167\x77\167" == $subdomain) { goto Ed773; } goto b0ebc; D3b79: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\x69\164\x65\163")); goto A874e; Ddb6f: $domains = []; goto b513b; e7a3f: $response = $this->handleLetsEncryptCertificateForm($request, $form, $site, $domains); goto Cbe24; bcbd6: return $response; goto f34d7; fca0e: $subdomain = false === empty($subdomain) ? $subdomain : null; goto C83a5; Cbe24: if (!(false === is_null($response))) { goto A1410; } goto F571f; F571f: return $response; goto b9235; fa299: C206e: goto A582d; b9235: A1410: goto fa299; e3517: b5058: goto bcbd6; ed2fb: $domains = array_map("\164\162\151\155", $domains); goto D8e37; C3190: $form = $this->createLetsEncryptCertificateForm($domainName); goto Ddb6f; A582d: fb04e: goto Fde2e; Fe248: $domains = array_filter($domains, function ($value) { return false === empty(trim($value)); }); goto ed2fb; be43e: $domainName = $site->getDomainName(); goto C3190; A9d0f: if (false === is_null($site)) { goto c4999; } goto D3b79; C10ed: $domains = (array) $request->get("\x64\157\155\141\151\156\x73"); goto Fe248; f2262: c86e8: goto Fa946; a45e4: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto e9793; Fde2e: $response = $this->render("\x46\x72\157\x6e\164\145\156\144\57\123\151\x74\145\x2f\x6e\145\167\55\x6c\145\x74\x73\55\x65\x6e\x63\x72\171\160\164\x2d\143\x65\x72\x74\x69\x66\x69\x63\x61\x74\x65\x2e\x68\164\x6d\154\x2e\x74\x77\x69\x67", ["\163\151\x74\x65" => $site, "\144\x6f\155\141\151\156\163" => $domains, "\146\157\162\155" => $form->createView(), "\x66\x6f\162\155\105\x72\x72\157\x72\163" => $this->formErrors]); goto e3517; d42b8: $site = $this->getSite($request); goto A9d0f; A874e: goto b5058; goto da6c1; da6c1: c4999: goto be43e; e9793: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto A8888; af71f: $form->handleRequest($request); goto b61af; b0ebc: $domains = [$domainName]; goto C9442; f34d7: } private function createLetsEncryptCertificateForm(string $domainName) : Form { goto Bc5c2; B6e72: return $form; goto E9f30; d338a: $form->add("\163\x75\x62\x6d\151\164", SubmitType::class, ["\x61\x74\x74\162" => ["\x63\x6c\141\x73\163" => "\x62\x74\156\40\x62\164\156\x2d\142\x6c\x75\145\x20\142\x74\156\x2d\x6c\x67"], "\154\141\x62\x65\x6c" => "\x43\x72\x65\x61\164\145\40\141\x6e\x64\x20\x49\156\163\164\141\154\154"]); goto B6e72; Bc5c2: $form = $this->createForm("\101\160\160\134\x46\x6f\x72\155\134\123\151\164\x65\x4c\145\164\163\105\156\143\162\171\x70\x74\x43\145\162\x74\x69\x66\x69\143\141\164\x65\124\x79\160\145", [], ["\141\143\x74\x69\x6f\x6e" => $this->generateUrl("\143\154\x70\137\163\x69\x74\x65\137\x6c\x65\164\163\x5f\x65\x6e\x63\162\x79\x70\x74\137\143\x65\x72\x74\151\146\151\143\141\164\x65\x5f\156\x65\167", ["\144\157\x6d\x61\151\x6e\x4e\141\155\145" => $domainName]), "\155\145\164\x68\157\144" => "\120\x4f\x53\124", "\x61\164\x74\x72" => ["\x69\144" => "\143\162\x65\141\x74\x65\55\154\x65\164\x73\x2d\x65\156\143\162\x79\x70\x74\x2d\143\145\x72\164\x69\x66\151\143\141\164\145\55\x66\x6f\162\x6d"]]); goto d338a; E9f30: } private function handleLetsEncryptCertificateForm(Request $request, Form $form, Site $site, array $domains) { goto d2627; d2627: if (!(true === $form->isValid())) { goto d7c95; } goto f8d7d; A2742: d7c95: goto Afa04; Afa04: $this->formErrors = $this->getErrorMessages($form); goto dfd45; f8d7d: try { goto b5e9c; bbc71: return $response; goto Ed8f8; Fda1d: $domainName = $site->getDomainName(); goto d2979; da5ec: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x73\151\164\x65\163")); goto ae418; D1600: $certificateEntity = $this->certificateEntityManager->createEntity(); goto fb414; Fd7c9: d8d66: goto cec68; Fcefa: $distinguishedName = new DistinguishedName($commonName, $distinguishedNameDomains); goto acc01; Fd7d8: $privateKey = new PrivateKey($letsEncryptPrivateKey); goto E9f23; Ac0ab: $letsEncryptClient = new LetsEncryptClient($privateKey); goto cac9e; b7b08: $siteUpdater->deleteLetsEncryptChallengeDirectory(); goto D047c; F84ba: $siteUpdater->createLetsEncryptChallengeFiles($certificateOrder); goto Bdf34; c3a75: $certificateEntity->setSite($siteEntity); goto Db8a6; b5e9c: $session = $request->getSession(); goto Fda1d; fd6ea: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto C4c1f; ae418: return $response; goto F6d81; Cdaf9: E5394: goto Dfe05; Fc9f2: $letsEncryptClient->setDryRun(true); goto E9e34; Db8a6: $certificateEntity->setCsr($certificate->getCsr()); goto B9a01; acbaa: $siteUpdater->installCertificate($certificateEntity); goto cc26d; a7f4f: $distinguishedNameDomains = $domains; goto F46d4; C672b: $certificateEntity->setCertificateChain($certificate->getCertificateChain()); goto aaf41; Ce4df: $certificateEntity->setCertificate($certificate->getCertificate()); goto C672b; Bdf34: $validationErrors = $letsEncryptClient->validateDomains($certificateOrder); goto Fd7c9; E9f23: $letsEncryptClient = new LetsEncryptClient($privateKey); goto Fc9f2; fa246: $siteUpdater = $this->getSiteUpdater($site); goto Fdb3d; F46d4: $commonName = array_shift($distinguishedNameDomains); goto Fcefa; Dfe05: goto e83ef; goto a7479; E9e34: $letsEncryptClient->registerAccount(); goto bc49c; E43e6: $session->getFlashBag()->set("\x73\165\x63\143\x65\163\x73", $this->translator->trans("\103\145\162\x74\151\146\x69\x63\141\164\x65\x20\150\141\163\40\x62\x65\x65\156\x20\151\156\x73\x74\141\154\x6c\x65\144\x2e")); goto a3674; F6d81: goto Bf8b5; goto fe1cc; E7847: $csr = $csrGenerator->generate(); goto Fa104; da8f4: Bf8b5: goto f01af; aaf41: $siteUpdater = $this->getSiteUpdater($site); goto acbaa; fbba1: $evenData = ["\163\x69\164\145" => $domainName]; goto A772d; C4c1f: $csrGenerator = new CsrGenerator($privateKey, $distinguishedName); goto E7847; cec68: if (true === empty($validationErrors)) { goto a6d0c; } goto F4a98; dc969: $siteUpdater = $this->getSiteUpdater($site); goto b7b08; Ff161: $user = $this->getUser(); goto A9172; A9172: $letsEncryptPrivateKey = $this->configManager->get("\x6c\x65\x5f\160\x72\151\166\141\164\145\137\153\145\171"); goto Fd7d8; Fdb3d: $siteUpdater->deleteLetsEncryptChallengeDirectory(); goto F84ba; bc49c: $certificateOrder = $letsEncryptClient->requestOrder($domains); goto dc969; d2979: $siteEntity = $this->getSiteEntity($domainName); goto ed115; Ed8f8: e83ef: goto da8f4; ed115: if (false === is_null($siteEntity)) { goto Fef22; } goto da5ec; cc26d: $siteEntity->setCertificate($certificateEntity); goto c6636; fe1cc: Fef22: goto Ff161; d6058: $this->siteEntityManager->updateEntity($siteEntity); goto fbba1; a3674: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\x73\x69\x74\145\137\143\145\x72\164\151\x66\x69\x63\x61\x74\145\x73", ["\x64\157\x6d\x61\151\x6e\x4e\141\x6d\145" => $site->getDomainName()])); goto bbc71; acc01: $rsaKeyGenerator = new RsaKeyGenerator(); goto fd6ea; c75ec: $validationErrors = $letsEncryptClient->validateDomains($certificateOrder); goto b25af; Fa104: $certificate = $letsEncryptClient->finalizeOrder($certificateOrder, $privateKey, $csr); goto D1600; A772d: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_INSTALL, $user, $evenData, $request); goto E43e6; F4a98: foreach ($validationErrors as $domain => $validationErrorMessage) { $form->addError(new FormError(sprintf("\x25\163\72\40\x25\x73", $domain, $validationErrorMessage))); Aeedc: } goto Cdaf9; fb414: $certificateEntity->setType(CertificateEntity::TYPE_LETS_ENCRYPT); goto c3a75; F5ea6: $certificateOrder = $letsEncryptClient->requestOrder($domains); goto fa246; c6636: $siteEntity->addCertificate($certificateEntity); goto d6058; b25af: if (!(true === empty($validationErrors))) { goto d8d66; } goto Ac0ab; cac9e: $letsEncryptClient->registerAccount(); goto F5ea6; B9a01: $certificateEntity->setPrivateKey($certificate->getPrivateKey()); goto Ce4df; a7479: a6d0c: goto a7f4f; D047c: $siteUpdater->createLetsEncryptChallengeFiles($certificateOrder); goto c75ec; f01af: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\147\x65\162", $this->translator->trans("\x41\156\40\x65\x72\x72\157\162\40\x68\x61\x73\x20\x6f\143\x63\165\162\162\x65\x64\54\x20\x65\x72\x72\157\162\x20\x6d\x65\163\163\x61\x67\145\72\x20\x25\145\162\x72\157\x72\115\x65\163\163\x61\x67\x65\x25", ["\x25\x65\x72\162\157\x72\x4d\145\x73\163\141\147\x65\45" => $e->getMessage()])); } finally { if (!(true === isset($siteUpdater))) { goto B6ac5; } $siteUpdater->deleteLetsEncryptChallengeDirectory(); B6ac5: } goto A2742; dfd45: } public function installCertificate(Request $request) : Response { goto Faf35; A6fbf: A6e09: goto da981; a464a: return $response; goto b60cb; E1c5a: if (!(false === is_null($site))) { goto A6e09; } goto Dc93a; Dc93a: try { goto Ae240; Ae240: $session = $request->getSession(); goto a06b5; c5e56: $siteUpdater->installCertificate($certificateEntity); goto e5802; F3429: $siteUpdater = $this->getSiteUpdater($site); goto c5e56; f2921: b5093: goto B0468; d8f69: $domainName = $site->getDomainName(); goto Ad88e; C4f89: $certificateSiteEntity = $certificateEntity->getSite(); goto F0dbe; F1e94: $user = $this->getUser(); goto F3429; f32be: $session->getFlashBag()->set("\x73\x75\143\143\x65\163\163", $this->translator->trans("\x43\145\x72\164\151\146\x69\x63\141\x74\145\40\150\141\163\40\x62\145\145\x6e\x20\151\156\163\164\141\154\x6c\x65\x64\x2e")); goto Bf776; a06b5: $uid = $request->get("\165\x69\x64"); goto d8f69; Ad88e: $siteEntity = $this->getSiteEntity($domainName); goto e38ff; e5802: $siteEntity->setCertificate($certificateEntity); goto B30c2; B30c2: $this->siteEntityManager->updateEntity($siteEntity); goto e6ede; e6ede: $evenData = ["\163\151\x74\145" => $domainName]; goto f03a3; F0dbe: if (!($siteEntity->getDomainName() == $certificateSiteEntity->getDomainName() && $siteEntity->getCertificate() != $certificateSiteEntity)) { goto b5093; } goto F1e94; Bf776: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\151\x74\x65\x5f\143\x65\162\x74\x69\x66\151\x63\141\164\145\x73", ["\144\157\155\x61\x69\156\x4e\141\x6d\x65" => $site->getDomainName()])); goto eedde; eedde: return $response; goto f2921; B0468: fff1a: goto Df92f; e38ff: $certificateEntity = $this->certificateEntityManager->findOneByUid($uid); goto c29f3; c29f3: if (!(false === is_null($siteEntity) && false === empty($uid) && false === is_null($certificateEntity))) { goto fff1a; } goto C4f89; f03a3: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_INSTALL, $user, $evenData, $request); goto f32be; Df92f: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\147\x65\162", $this->translator->trans("\101\x6e\x20\145\x72\x72\157\x72\x20\150\x61\x73\x20\157\143\x63\x75\162\x72\x65\x64\54\40\x65\x72\x72\157\x72\x20\x6d\145\163\163\x61\147\x65\x3a\x20\45\x65\x72\x72\157\162\x4d\x65\x73\x73\141\x67\145\x25", ["\x25\145\162\162\157\162\x4d\x65\163\x73\x61\x67\x65\x25" => $e->getMessage()])); } goto A6fbf; da981: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\x73\x69\x74\x65\x73")); goto a464a; Faf35: $site = $this->getSite($request); goto E1c5a; b60cb: } public function deleteCertificate(Request $request) : Response { goto Fa94f; E465a: return $response; goto e2f81; C7ce1: ca809: goto f3b47; c6a12: try { goto dfb14; e2142: if (!($siteEntity->getDomainName() == $certificateSiteEntity->getDomainName() && $siteEntity->getCertificate() != $certificateSiteEntity)) { goto b7d40; } goto E73a9; Fbc96: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\x73\x69\x74\x65\137\x63\x65\x72\x74\x69\146\x69\143\141\164\x65\x73", ["\x64\157\155\x61\x69\x6e\x4e\x61\x6d\145" => $site->getDomainName()])); goto B3b33; E73a9: $user = $this->getUser(); goto D03f2; Fb3c0: if (!(false === is_null($siteEntity) && false === empty($uid) && false === is_null($certificateEntity) && false === $certificateEntity->getDefaultCertificate())) { goto efc92; } goto A6c11; b45cd: $siteEntity = $this->getSiteEntity($domainName); goto C001a; E9671: efc92: goto E787c; ea39e: $evenData = ["\163\151\x74\x65" => $domainName]; goto E5f33; B2736: $domainName = $site->getDomainName(); goto b45cd; D03f2: $siteEntity->removeCertificate($certificateEntity); goto C3f62; E5f33: EventQueue::addEvent(EventQueue::EVENT_SITE_CERTIFICATE_DELETE, $user, $evenData, $request); goto D237d; D237d: $session->getFlashBag()->set("\x73\165\x63\143\145\x73\x73", $this->translator->trans("\x43\145\x72\164\x69\x66\x69\143\x61\164\145\40\150\x61\163\x20\142\x65\x65\156\x20\x64\x65\154\x65\164\145\x64\x2e")); goto Fbc96; A6c11: $certificateSiteEntity = $certificateEntity->getSite(); goto e2142; dfb14: $session = $request->getSession(); goto ab80b; C3f62: $this->siteEntityManager->updateEntity($siteEntity); goto ea39e; ab80b: $uid = $request->get("\165\151\x64"); goto B2736; C001a: $certificateEntity = $this->certificateEntityManager->findOneByUid($uid); goto Fb3c0; B3b33: return $response; goto feea6; feea6: b7d40: goto E9671; E787c: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\x67\145\162", $this->translator->trans("\101\156\40\x65\162\162\157\162\40\150\141\x73\x20\157\x63\x63\165\162\162\x65\x64\54\40\x65\162\x72\157\x72\x20\x6d\145\x73\x73\141\x67\x65\x3a\40\x25\145\x72\162\157\x72\115\x65\x73\163\141\147\x65\45", ["\x25\145\162\162\157\162\115\145\x73\163\x61\x67\x65\x25" => $e->getMessage()])); } goto C7ce1; f3b47: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\163\x69\x74\145\x73")); goto E465a; B54db: if (!(false === is_null($site))) { goto ca809; } goto c6a12; Fa94f: $site = $this->getSite($request); goto e54ce; e54ce: $this->checkCsrfToken($request, "\143\145\162\x74\151\146\151\x63\141\164\x65\55\144\x65\154\x65\164\x65"); goto B54db; e2f81: } public function databases(Request $request) : Response { goto b25a6; C9919: goto fe3b0; goto Df8c2; b25a6: $site = $this->getSite($request); goto A6644; d8850: fe3b0: goto bdf39; Df8c2: C752c: goto Efb11; b09b8: $databaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto B2f29; b3d5f: $response = $this->redirect($this->generateUrl("\143\154\160\137\x73\151\x74\x65\x73")); goto C9919; bdf39: return $response; goto A4c07; A6644: if (false === is_null($site)) { goto C752c; } goto b3d5f; Efb11: $databases = $site->getDatabases(); goto b09b8; Cc69f: $response = $this->render("\106\x72\157\x6e\164\x65\x6e\x64\57\123\x69\x74\x65\57\144\x61\164\x61\x62\x61\x73\x65\163\x2e\150\x74\155\x6c\x2e\164\167\151\147", ["\x73\151\x74\145" => $site, "\144\141\x74\x61\x62\141\x73\x65\163" => $databases, "\156\x75\155\142\x65\x72\x4f\146\x44\x61\x74\x61\x62\141\x73\145\125\163\x65\162\163" => $numberOfDatabaseUsers, "\x64\x61\164\141\x62\141\x73\x65\123\145\162\166\145\162" => $databaseServerEntity]); goto d8850; c6b20: foreach ($databases as $database) { $numberOfDatabaseUsers += count($database->getUsers()); ed918: } goto fa597; B2f29: $numberOfDatabaseUsers = 0; goto c6b20; fa597: D970e: goto Cc69f; A4c07: } public function newDatabase(Request $request) : Response { goto c0778; Bdf67: if (false === is_null($site)) { goto F1c77; } goto F8ed9; e9fa6: if (!(true === $form->isSubmitted())) { goto E0d81; } goto Ed9fc; F8ed9: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\151\164\145\163")); goto e387a; b9534: return $response; goto e6f5a; ee34d: F1c77: goto e920f; c0778: $site = $this->getSite($request); goto Bdf67; Eedf0: $response = $this->render("\106\162\x6f\x6e\164\145\x6e\144\57\123\151\x74\145\57\156\x65\x77\55\144\x61\x74\x61\142\141\163\145\x2e\150\x74\x6d\x6c\56\164\x77\x69\147", ["\x73\151\x74\x65" => $site, "\x66\157\162\155" => $form->createView(), "\x66\x6f\162\155\105\162\162\157\x72\x73" => $this->formErrors]); goto f4516; D6288: D4800: goto Eedf0; c03d3: E0d81: goto D6288; e387a: goto e4738; goto ee34d; e920f: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto f3aa7; c1517: $databaseEntity->setSite($siteEntity); goto e7784; c9878: $form->handleRequest($request); goto e9fa6; Ed9fc: $response = $this->handleDatabaseForm($request, $form, $site); goto dd051; f4516: e4738: goto C4824; A4490: if (!(true === $request->isMethod("\120\x4f\x53\124"))) { goto D4800; } goto c9878; C4824: return $response; goto f5d14; e6f5a: f09db: goto c03d3; e7784: $form = $this->createDatabaseForm($site, $databaseEntity); goto A4490; f3aa7: $databaseEntity = $this->databaseEntityManager->createEntity(); goto c1517; dd051: if (!(false === is_null($response))) { goto f09db; } goto b9534; f5d14: } private function createDatabaseForm(Site $site, DatabaseEntity $databaseEntity) : Form { goto C887c; C887c: $form = $this->createForm("\x41\160\160\x5c\x46\x6f\x72\155\x5c\123\x69\x74\x65\104\x61\x74\x61\142\x61\x73\145\124\x79\160\x65", $databaseEntity, ["\x61\143\164\x69\157\156" => $this->generateUrl("\143\154\x70\x5f\x73\x69\164\145\x5f\x64\141\x74\141\142\x61\163\x65\137\x6e\x65\x77", ["\144\x6f\x6d\x61\151\156\116\141\155\x65" => $site->getDomainName()]), "\x6d\145\164\x68\x6f\x64" => "\x50\x4f\x53\x54", "\141\164\x74\x72" => []]); goto a0980; cf73d: return $form; goto Bdf52; a0980: $form->add("\163\165\142\155\151\x74", SubmitType::class, ["\x61\x74\x74\162" => ["\x63\x6c\x61\x73\x73" => "\142\164\156\x20\x62\x74\x6e\55\142\x6c\165\145\40\142\164\156\55\154\147"], "\x6c\141\x62\145\x6c" => "\x41\144\144\40\x44\x61\164\141\x62\x61\x73\145"]); goto cf73d; Bdf52: } private function handleDatabaseForm(Request $request, Form $form, Site $site) { goto B2703; fe3bb: Ab70d: goto bc4ca; bc4ca: try { goto efc30; E4ce6: $eventData = ["\x73\151\164\x65" => $domainName, "\x64\141\164\141\x62\x61\x73\x65" => $databaseEntity->getName(), "\144\x61\164\x61\x62\x61\163\x65\125\163\x65\x72\116\141\x6d\145" => $databaseUserEntity->getUserName()]; goto F879b; Da5ad: $siteEntity = $this->getSiteEntity($domainName); goto B6e41; b4e11: goto F938d; goto ae054; e041b: $databaseUserEntity->setDatabase($databaseEntity); goto Aac1b; A9aaa: $databaseEntity->setSite($siteEntity); goto e9bf8; A5e9d: $databaseUserEntity->setPassword(Crypto::encrypt($databaseUserPassword)); goto F3c1d; efc30: $user = $this->getUser(); goto ef8cc; B6e41: if (false === is_null($siteEntity)) { goto Cde44; } goto E629e; F3c1d: $databaseUserEntity->setPermissions(DatabaseUserEntity::PERMISSIONS_READ_WRITE); goto e041b; C6072: $databaseUserEntity->setUserName($databaseUserName); goto A5e9d; E629e: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\163\151\164\145\x5f\144\141\x74\141\x62\141\163\145\137\x6e\145\x77", ["\144\x6f\155\141\x69\156\x4e\141\x6d\x65" => $site->getDomainName()])); goto b4e11; ae054: Cde44: goto dfa20; aa261: $response = $this->redirect($this->generateUrl("\143\154\x70\x5f\163\x69\x74\145\137\144\141\164\141\142\141\163\145\163", ["\144\157\x6d\x61\x69\x6e\x4e\141\x6d\145" => $site->getDomainName()])); goto C0cff; Ba091: $this->siteEntityManager->updateEntity($siteEntity); goto E4ce6; F003e: $databaseUserEntity = $this->databaseUserEntityManager->createEntity(); goto C6072; A1b69: $domainName = $site->getDomainName(); goto Da5ad; aaf51: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto A913b; ef765: $siteEntity->addDatabase($databaseEntity); goto F5d1c; Dfbc8: $databaseManager->createUser($databaseUserEntity); goto Ba091; f12cf: $databaseUserPassword = $form->get("\x75\163\145\x72\x50\x61\x73\x73\167\x6f\x72\144")->getData(); goto F003e; F5d1c: $databaseManager->createDatabase($databaseEntity); goto Dfbc8; e9bf8: $databaseUserName = $form->get("\x75\x73\x65\162\x4e\x61\155\145")->getData(); goto f12cf; F4f16: return $response; goto b75b0; add08: $session->getFlashBag()->set("\163\165\x63\143\x65\163\163", $this->translator->trans("\104\141\x74\x61\x62\x61\x73\x65\40\x68\141\x73\x20\142\145\x65\x6e\x20\x61\x64\x64\145\x64\x2e")); goto aa261; dfa20: $databaseEntity = $form->getData(); goto b7619; C0cff: F938d: goto F4f16; ef8cc: $session = $request->getSession(); goto A1b69; A913b: $databaseEntity->setDatabaseServer($activeDatabaseServerEntity); goto A9aaa; F879b: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_ADD, $user, $eventData, $request); goto add08; b7619: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto aaf51; Aac1b: $databaseEntity->addUser($databaseUserEntity); goto ef765; b75b0: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\141\156\147\x65\x72", $this->translator->trans("\101\156\x20\x65\x72\x72\x6f\x72\x20\x68\x61\x73\40\157\143\x63\165\x72\162\x65\x64\x2c\40\145\162\162\157\162\x20\155\x65\163\x73\x61\x67\145\72\40\x25\145\x72\x72\x6f\162\115\145\x73\x73\141\x67\x65\x25", ["\x25\145\162\x72\157\x72\115\145\163\x73\x61\147\145\45" => $e->getMessage()])); } goto b0f27; dc960: goto aea58; goto fe3bb; ff3fa: $this->formErrors = $this->getErrorMessages($form); goto dc960; B2703: if (true === $form->isValid()) { goto Ab70d; } goto ff3fa; b0f27: aea58: goto b877d; b877d: } public function deleteDatabase(Request $request) : Response { goto ee7c4; B2387: try { goto c9207; d70b2: $this->siteEntityManager->updateEntity($siteEntity); goto b809e; ca679: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_DELETE, $user, $eventData, $request); goto c7eaf; c7eaf: $session->getFlashBag()->set("\163\165\x63\143\145\163\x73", $this->translator->trans("\104\x61\164\x61\142\141\163\x65\40\x68\141\x73\x20\x62\x65\145\x6e\x20\x64\x65\x6c\x65\164\x65\x64\56")); goto Fad71; c25c3: $session = $request->getSession(); goto b9afb; D9e61: $databaseManager = new DatabaseManager($databaseServerEntity); goto edcb3; b9afb: $domainName = $site->getDomainName(); goto Bca21; b3dbb: $siteEntity->removeDatabase($databaseEntity); goto d70b2; b809e: $eventData = ["\x73\x69\x74\145" => $domainName, "\144\x61\x74\141\x62\141\x73\145" => $databaseEntity->getName()]; goto ca679; c9207: $user = $this->getUser(); goto c25c3; Bca21: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto D9e61; edcb3: $databaseManager->deleteDatabase($databaseEntity, true); goto b3dbb; Fad71: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\147\145\x72", $this->translator->trans("\x41\x6e\40\x65\x72\162\157\x72\40\x68\141\163\40\x6f\x63\143\x75\x72\162\x65\144\54\x20\x65\x72\162\157\162\40\155\145\163\163\141\147\x65\72\40\x25\145\x72\x72\157\162\115\145\x73\163\141\147\145\x25", ["\x25\x65\x72\x72\x6f\162\x4d\x65\163\163\x61\147\145\45" => $e->getMessage()])); } goto D1eb2; ee7c4: $site = $this->getSite($request); goto da48b; c05e7: E54da: goto D7705; d7d6c: if (!(false === is_null($site))) { goto A081c; } goto fc1c8; ab514: $response = $this->redirect($this->generateUrl("\143\154\x70\137\163\x69\164\x65\163")); goto E1b05; E1b05: return $response; goto bacb7; f509b: $siteEntity = $this->getSiteEntity($site->getDomainName()); goto ea685; ad74b: $databaseEntity = $this->databaseEntityManager->findOneByName($databaseName); goto f509b; ea685: if (!(false === is_null($databaseEntity) && $site->getDomainName() == $databaseEntity->getSite()->getDomainName() && false === is_null($siteEntity))) { goto E54da; } goto B2387; fc1c8: $databaseName = $request->get("\x64\x61\164\141\x62\x61\x73\x65\x4e\141\155\x65"); goto ad74b; e1658: return $response; goto c05e7; da48b: $this->checkCsrfToken($request, "\144\x61\164\141\x62\x61\x73\145\x2d\x64\x65\x6c\145\x74\145"); goto d7d6c; D7705: A081c: goto ab514; D1eb2: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\x69\x74\x65\x5f\x64\x61\164\x61\x62\x61\x73\145\163", ["\144\x6f\x6d\x61\151\x6e\116\x61\155\x65" => $site->getDomainName()])); goto e1658; bacb7: } public function phpMyAdmin(Request $request) : Response { goto D9c3b; D9c3b: $domainName = $request->get("\x64\157\x6d\x61\x69\156\x4e\x61\x6d\145"); goto efc00; D6de0: $data = ["\150\157\x73\164" => $activeDatabaseServerEntity->getHost(), "\165\163\145\162\x4e\x61\155\x65" => $databaseUserEntity->getUserName(), "\x70\x61\163\163\167\x6f\x72\144" => $databaseUserEntity->getDecryptedPassword(), "\x70\x6f\x72\x74" => $activeDatabaseServerEntity->getPort()]; goto c8a2b; B1fa6: return $response; goto Ba52e; b16f2: $phpMyAdminUrl = sprintf("\x68\164\164\x70\163\x3a\x2f\57\45\163\72\x25\163\x2f\160\x68\160\155\171\x61\144\155\x69\156\x2f\x6c\x6f\147\151\156\x2e\160\150\x70", $request->getHost(), $request->getPort()); goto D6de0; cb9f3: Eaf55: goto f31fd; d2de8: $response = new RedirectResponse($phpMyAdminUrl); goto D939a; Ecffe: $databaseEntity = $databaseUserEntity->getDatabase(); goto e5548; B0bdc: $data = ["\150\x6f\x73\164" => $activeDatabaseServerEntity->getHost(), "\160\157\x72\x74" => $activeDatabaseServerEntity->getPort()]; goto Abb84; a2258: if (false === is_null($domainName)) { goto Eaf55; } goto b31fd; Eb9f2: $response->headers->clearCookie("\x70\x6d\141\101\165\164\x68\x2d\61\x5f\x68\x74\x74\x70\x73"); goto A79d4; f31fd: $site = $this->getSite($request); goto c69b8; c69b8: if (!(false === is_null($site))) { goto abe13; } goto E60d4; D5971: $databaseUserEntity = $this->databaseUserEntityManager->findOneByUserName($databaseUserName); goto C63d2; efc00: $session = $request->getSession(); goto a2258; d1a00: abe13: goto Ddea8; e5548: if (!(false === is_null($databaseEntity) && $site->getDomainName() == $databaseEntity->getSite()->getDomainName())) { goto Ecd7a; } goto b16f2; D939a: $response->headers->clearCookie("\x63\x6c\160\55\160\x6d\x61"); goto d9ec6; d9ec6: $response->headers->clearCookie("\x70\x68\x70\115\x79\101\144\x6d\151\156\137\x68\164\164\x70\163"); goto Eb9f2; Abb84: $session->set("\x63\x6c\160\55\x70\155\x61", $data); goto d2de8; efc05: $phpMyAdminUrl = sprintf("\150\164\164\160\x73\72\57\x2f\x25\163\x3a\45\x73\x2f\160\150\x70\x6d\x79\x61\x64\155\151\156\57\x6c\x6f\147\151\x6e\x2e\160\x68\x70", $request->getHost(), $request->getPort()); goto B0bdc; C63d2: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto F2470; E60d4: $databaseUserName = $request->get("\144\141\164\141\142\141\163\145\125\x73\145\162\x4e\141\x6d\x65"); goto D5971; e55f9: $response = new RedirectResponse($phpMyAdminUrl); goto Fd5a4; A79d4: $response->headers->clearCookie("\x53\151\147\156\x6f\x6e\123\x65\163\x73\x69\157\156"); goto e76c5; b31fd: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto ff872; f3b6f: goto b2131; goto cb9f3; c8a2b: $session->set("\x63\x6c\160\x2d\x70\x6d\141", $data); goto e55f9; ff872: if (!(false === is_null($activeDatabaseServerEntity))) { goto f8806; } goto efc05; e76c5: return $response; goto Ac8fd; F2470: if (!(false === is_null($activeDatabaseServerEntity) && false === is_null($activeDatabaseServerEntity))) { goto d6cee; } goto Ecffe; ba450: Ecd7a: goto f897c; Fd5a4: return $response; goto ba450; d5c28: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\163\151\164\x65\163")); goto B1fa6; Ddea8: b2131: goto d5c28; Ac8fd: f8806: goto f3b6f; f897c: d6cee: goto d1a00; Ba52e: } public function phpMyAdminLogout(Request $request) { goto fa40e; fa40e: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\151\x74\145\163")); goto cd35a; Ef109: $response->headers->clearCookie("\160\x68\160\115\x79\101\144\x6d\151\x6e\137\150\164\x74\160\x73"); goto d3fe5; cd35a: $response->headers->clearCookie("\143\x6c\x70\x2d\160\155\x61"); goto Ef109; Ceb97: return $response; goto C00ca; Eea91: $response->headers->clearCookie("\123\151\147\156\157\x6e\123\x65\x73\163\x69\x6f\156"); goto Ceb97; d3fe5: $response->headers->clearCookie("\x70\x6d\141\101\x75\164\150\55\x31\x5f\150\x74\164\x70\x73"); goto Eea91; C00ca: } public function newDatabaseUser(Request $request) : Response { goto de4ee; C299c: if (!(false === is_null($response))) { goto C2afe; } goto F0f8f; a49e6: if (!(true === $request->isMethod("\120\x4f\123\x54"))) { goto B1859; } goto c0a4a; Cc2a9: if (count($databases) && false === is_null($siteEntity)) { goto B2e9d; } goto a3e41; cdc30: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\163\x69\x74\x65\x5f\x64\141\164\x61\x62\x61\163\145\x73", ["\144\x6f\x6d\141\151\156\x4e\141\155\145" => $site->getDomainName()])); goto c5249; f2b8b: $domainName = $site->getDomainName(); goto e2723; Dbf78: goto efc29; goto B98ba; e6538: if (!(true === $form->isSubmitted())) { goto edb5a; } goto e982d; c98a5: efc29: goto c5177; a3e41: $session = $request->getSession(); goto Cb037; ef703: $databaseUserEntity = $this->databaseUserEntityManager->createEntity(); goto B614c; c5177: return $response; goto f00d7; cd031: edb5a: goto D89a8; de4ee: $site = $this->getSite($request); goto ca8d9; B614c: $databaseUserEntity->setSite($siteEntity); goto fc59b; a7db2: C2afe: goto cd031; e982d: $response = $this->handleDatabaseUserForm($request, $form, $site); goto C299c; c0a4a: $form->handleRequest($request); goto e6538; e2723: $siteEntity = $this->getSiteEntity($domainName); goto Cc2a9; fc59b: $form = $this->createDatabaseUserForm($site, $databaseUserEntity); goto a49e6; F0f8f: return $response; goto a7db2; cd7b2: $databases = $site->getDatabases(); goto f2b8b; c5249: goto ea078; goto edeb2; faf87: $response = $this->redirect($this->generateUrl("\x63\154\160\137\163\x69\164\x65\163")); goto Dbf78; c3705: ea078: goto c98a5; Cb037: $session->getFlashBag()->set("\144\141\156\x67\145\162", $this->translator->trans("\116\157\40\x64\141\164\x61\142\141\x73\145\x20\146\157\165\x6e\x64\x3b\40\143\x72\145\x61\x74\x65\x20\141\40\144\x61\x74\141\142\141\163\x65\x20\146\x69\162\x73\x74\56")); goto cdc30; edeb2: B2e9d: goto ef703; B98ba: aff54: goto cd7b2; C7ffd: $response = $this->render("\106\162\157\156\x74\145\156\144\57\x53\x69\x74\x65\x2f\x6e\145\x77\x2d\144\141\x74\x61\x62\x61\x73\x65\x2d\x75\x73\145\162\x2e\x68\x74\155\x6c\56\164\167\151\x67", ["\163\x69\x74\x65" => $site, "\144\141\x74\141\x62\141\163\145\x55\163\145\162" => $databaseUserEntity, "\144\x61\164\141\x62\141\x73\x65\x73" => $databases, "\146\x6f\162\155" => $form->createView(), "\146\157\162\155\x45\x72\x72\157\162\163" => $this->formErrors]); goto c3705; D89a8: B1859: goto C7ffd; ca8d9: if (false === is_null($site)) { goto aff54; } goto faf87; f00d7: } private function createDatabaseUserForm(Site $site, DatabaseUserEntity $databaseUserEntity) : Form { goto F84df; F84df: $form = $this->createForm("\x41\x70\x70\x5c\106\157\x72\x6d\134\x53\151\x74\145\104\141\164\x61\142\141\x73\145\x55\x73\x65\x72\124\x79\x70\x65", $databaseUserEntity, ["\x61\x63\164\x69\157\x6e" => $this->generateUrl("\x63\154\160\137\163\151\164\145\x5f\x64\x61\x74\x61\x62\x61\x73\x65\x5f\x75\x73\145\162\137\156\145\x77", ["\x64\157\155\141\151\156\x4e\141\x6d\x65" => $site->getDomainName()]), "\x6d\x65\164\x68\157\x64" => "\x50\117\123\124", "\141\164\x74\162" => []]); goto B2623; D82b1: return $form; goto A42a2; B2623: $form->add("\163\x75\x62\155\x69\x74", SubmitType::class, ["\x61\164\164\x72" => ["\x63\x6c\141\163\x73" => "\142\164\x6e\40\x62\164\x6e\55\142\154\165\145\40\x62\x74\156\x2d\x6c\147"], "\154\141\142\x65\x6c" => "\x41\x64\144\x20\104\141\164\x61\142\x61\163\145\x20\125\163\145\162"]); goto D82b1; A42a2: } private function handleDatabaseUserForm(Request $request, Form $form, Site $site) { goto F9a05; B8a8a: $this->formErrors = $this->getErrorMessages($form); goto B4ef7; Eb05d: ff7e1: goto Aea36; e2369: try { goto cc855; b18fb: goto c22c9; goto D3593; a932d: if (false === is_null($siteEntity)) { goto E39c3; } goto E2a4e; D3593: E39c3: goto E6c8d; f63e3: $session->getFlashBag()->set("\163\x75\143\143\145\x73\x73", $this->translator->trans("\x44\141\x74\x61\x62\x61\x73\145\x20\x55\x73\x65\162\x20\150\x61\163\x20\142\x65\x65\x6e\x20\x61\144\144\x65\x64\x2e")); goto f89b9; b77cb: $siteEntity = $this->getSiteEntity($domainName); goto a932d; E2a4e: $response = $this->redirect($this->generateUrl("\143\154\x70\137\x73\151\164\145\137\x64\x61\164\x61\x62\141\x73\x65\137\x75\x73\x65\x72\137\156\145\167", ["\x64\x6f\x6d\141\151\x6e\x4e\x61\x6d\145" => $site->getDomainName()])); goto b18fb; E6c8d: $databaseUserEntity = $form->getData(); goto b63ce; b63ce: $encryptedPassword = Crypto::encrypt($databaseUserEntity->getPassword()); goto cd030; cd030: $databaseUserEntity->setPassword($encryptedPassword); goto d03b6; a91cf: $databaseEntity = $databaseUserEntity->getDatabase(); goto E26db; F4c12: return $response; goto Cbc25; f89b9: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\x69\164\145\137\144\141\x74\x61\142\141\163\145\x73", ["\x64\157\x6d\141\x69\156\x4e\141\x6d\x65" => $site->getDomainName()])); goto dc02a; F3279: $eventData = ["\163\x69\x74\x65" => $domainName, "\x64\141\164\141\x62\x61\163\145\x55\x73\x65\x72\x4e\x61\155\145" => $databaseUserEntity->getUserName(), "\x70\145\162\x6d\151\163\x73\151\157\x6e\163" => $databaseUserEntity->getPermissions(), "\x64\x61\x74\141\142\141\163\145" => $databaseName]; goto e7f92; dc02a: c22c9: goto F4c12; C560a: $this->databaseUserEntityManager->updateEntity($databaseUserEntity); goto a91cf; d03b6: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto D664a; cc855: $user = $this->getUser(); goto d315d; d0f63: $domainName = $site->getDomainName(); goto b77cb; e7f92: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_USER_ADD, $user, $eventData, $request); goto f63e3; E26db: $databaseName = $databaseEntity->getName(); goto F3279; A8a10: $databaseManager->createUser($databaseUserEntity); goto C560a; d315d: $session = $request->getSession(); goto d0f63; D664a: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto A8a10; Cbc25: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\x67\145\x72", $this->translator->trans("\101\x6e\x20\145\x72\162\157\162\x20\x68\141\163\40\157\x63\x63\x75\x72\162\x65\144\54\40\x65\x72\162\157\x72\40\155\145\x73\163\x61\x67\145\72\40\45\x65\x72\162\157\162\x4d\145\163\163\141\x67\x65\x25", ["\x25\x65\x72\x72\157\162\x4d\x65\x73\x73\x61\147\x65\45" => $e->getMessage()])); } goto Eb05d; E1895: D3612: goto e2369; F9a05: if (true === $form->isValid()) { goto D3612; } goto B8a8a; B4ef7: goto ff7e1; goto E1895; Aea36: } public function editDatabaseUser(Request $request) : Response { goto Cc70b; cfdf3: $databaseUserEntity = $this->databaseUserEntityManager->findOneByUserName($databaseUserName); goto Db0a8; Db0a8: if (!(false === is_null($databaseUserEntity))) { goto d5e4b; } goto d0ec9; A6aad: goto c96d0; goto eaa58; eecd4: if (false === is_null($site)) { goto A2324; } goto D3cd7; D3cd7: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\x69\x74\x65\163")); goto A6aad; Ec73c: d9fbe: goto F59f3; D9857: goto e8233; goto e383d; E4b67: $response = $this->render("\x46\x72\157\x6e\x74\x65\x6e\144\57\123\151\164\x65\x2f\x65\144\151\x74\x2d\144\x61\164\141\142\141\x73\145\x2d\x75\163\x65\162\56\x68\x74\155\154\x2e\x74\167\x69\x67", ["\163\x69\164\x65" => $site, "\x64\141\164\141\142\141\x73\x65\125\163\x65\162" => $databaseUserEntity, "\146\x6f\x72\x6d" => $form->createView(), "\146\x6f\162\x6d\105\162\162\x6f\x72\x73" => $this->formErrors]); goto Ff055; b38d6: $form->handleRequest($request); goto df2d4; Fdb4c: $response = $this->redirect($this->generateUrl("\143\154\x70\137\x73\x69\164\145\x5f\x64\x61\164\141\x62\x61\163\145\x73", ["\144\157\x6d\141\x69\x6e\116\141\155\x65" => $site->getDomainName()])); goto D9857; Cc70b: $site = $this->getSite($request); goto eecd4; F59f3: F3d8c: goto E4b67; c9e26: $databaseUserName = $request->get("\144\141\x74\141\x62\141\x73\x65\125\163\x65\162\116\141\155\x65"); goto cfdf3; eaa58: A2324: goto be271; fbb68: $session = $request->getSession(); goto Ccb11; F1304: e8233: goto b5781; Ccb11: $session->getFlashBag()->set("\x64\141\156\147\x65\162", $this->translator->trans("\116\x6f\40\144\x61\x74\x61\142\141\x73\145\x20\x66\157\165\156\144\x3b\x20\143\x72\145\x61\164\145\x20\x61\x20\144\x61\164\x61\142\141\163\x65\x20\146\x69\162\x73\x74\x2e")); goto Fdb4c; df2d4: if (!(true === $form->isSubmitted())) { goto d9fbe; } goto Ac0e2; Eeb1d: return $response; goto b344b; D44f6: $domainName = $site->getDomainName(); goto Ffa56; A6e51: F5fca: goto Ec73c; e383d: C1a3b: goto c9e26; d0ec9: $databaseUserEntity->setPassword(''); goto dabe3; f6a11: if (!(true === $request->isMethod("\x50\x4f\123\124"))) { goto F3d8c; } goto b38d6; b3779: return $response; goto A6e51; Bbcc5: if (count($databases) && false === is_null($siteEntity)) { goto C1a3b; } goto fbb68; Ac0e2: $response = $this->handleDatabaseUserEditForm($request, $form, $site); goto E01bf; E01bf: if (!(false === is_null($response))) { goto F5fca; } goto b3779; be271: $databases = $site->getDatabases(); goto D44f6; dabe3: $form = $this->createDatabaseUserEditForm($site, $databaseUserEntity); goto f6a11; b5781: c96d0: goto Eeb1d; Ffa56: $siteEntity = $this->getSiteEntity($domainName); goto Bbcc5; Ff055: d5e4b: goto F1304; b344b: } private function createDatabaseUserEditForm(Site $site, DatabaseUserEntity $databaseUserEntity) : Form { goto cd236; cd236: $form = $this->createForm("\101\x70\x70\x5c\x46\157\162\x6d\x5c\x53\x69\x74\x65\104\x61\x74\x61\x62\x61\163\145\125\163\x65\162\105\x64\x69\x74\x54\171\x70\x65", $databaseUserEntity, ["\x61\x63\x74\x69\157\x6e" => $this->generateUrl("\143\154\160\x5f\x73\x69\164\145\x5f\144\141\x74\x61\142\x61\x73\x65\x5f\x75\163\145\x72\x5f\145\x64\151\164", ["\x64\x6f\x6d\x61\x69\x6e\116\x61\155\x65" => $site->getDomainName(), "\144\141\x74\141\142\141\x73\145\125\x73\x65\x72\x4e\x61\155\x65" => $databaseUserEntity->getUserName()]), "\x6d\x65\x74\x68\x6f\144" => "\120\117\x53\124", "\x61\x74\x74\x72" => []]); goto a75db; a75db: $form->add("\x73\165\x62\155\x69\164", SubmitType::class, ["\x61\x74\164\162" => ["\x63\154\141\163\x73" => "\142\164\156\40\x62\164\156\x2d\142\154\x75\145\x20\x62\x74\x6e\x2d\154\147"], "\154\141\x62\145\154" => "\123\141\166\145"]); goto Cf83b; Cf83b: return $form; goto Cd1a0; Cd1a0: } private function handleDatabaseUserEditForm(Request $request, Form $form, Site $site) { goto Ec883; Ebf83: bedc8: goto d27ca; f7129: try { goto be869; Ba077: $encryptedPassword = Crypto::encrypt($databaseUserEntity->getPassword()); goto cfe50; F3bc7: $siteEntity = $this->getSiteEntity($domainName); goto c7e53; ef87b: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto C4531; a01c7: $databaseName = $databaseEntity->getName(); goto b147b; b262e: $databaseUserEntity = $form->getData(); goto Ba077; f5e36: return $response; goto Fd1e3; b147b: $eventData = ["\x73\x69\x74\x65" => $domainName, "\144\141\164\141\142\x61\x73\x65\125\x73\x65\x72\116\141\155\145" => $databaseUserEntity->getUserName(), "\x70\145\x72\155\151\163\x73\151\x6f\156\163" => $databaseUserEntity->getPermissions(), "\144\141\164\x61\x62\x61\163\x65" => $databaseName]; goto Bb641; be869: $user = $this->getUser(); goto fc857; C4531: $databaseManager->createUser($databaseUserEntity); goto de309; C524c: $domainName = $site->getDomainName(); goto F3bc7; b582f: Cb4a9: goto f5e36; c7e53: if (false === is_null($siteEntity)) { goto F1623; } goto d9352; d9352: $response = $this->redirect($this->generateUrl("\143\x6c\x70\x5f\x73\x69\164\145\137\144\141\164\141\142\141\x73\145\137\165\163\x65\x72\x5f\x6e\145\x77", ["\144\x6f\x6d\x61\x69\x6e\116\x61\155\145" => $site->getDomainName()])); goto C1272; fc857: $session = $request->getSession(); goto C524c; e123c: $databaseEntity = $databaseUserEntity->getDatabase(); goto a01c7; fac73: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x73\151\164\x65\137\144\x61\164\141\x62\x61\x73\x65\163", ["\x64\157\x6d\x61\151\156\x4e\141\x6d\x65" => $site->getDomainName()])); goto b582f; de309: $this->databaseUserEntityManager->updateEntity($databaseUserEntity); goto e123c; F216a: F1623: goto b262e; C1272: goto Cb4a9; goto F216a; Bb641: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_USER_EDIT, $user, $eventData, $request); goto bcc6a; dfdb1: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto ef87b; cfe50: $databaseUserEntity->setPassword($encryptedPassword); goto dfdb1; bcc6a: $session->getFlashBag()->set("\x73\165\x63\143\x65\163\x73", $this->translator->trans("\104\141\164\x61\142\141\x73\x65\40\125\x73\x65\x72\40\x68\141\x73\x20\x62\x65\145\156\x20\165\x70\144\x61\164\145\144\x2e")); goto fac73; Fd1e3: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\x65\162", $this->translator->trans("\101\156\x20\145\x72\x72\x6f\x72\x20\x68\x61\163\x20\x6f\143\143\x75\x72\x72\145\144\x2c\40\145\162\x72\x6f\x72\40\x6d\145\x73\163\141\147\145\72\x20\45\x65\x72\162\x6f\162\115\145\163\x73\141\147\x65\x25", ["\x25\x65\x72\x72\x6f\162\115\x65\x73\163\x61\x67\145\x25" => $e->getMessage()])); } goto Ebf83; f7b57: c0bf7: goto f7129; Ec883: if (true === $form->isValid()) { goto c0bf7; } goto C825c; C825c: $this->formErrors = $this->getErrorMessages($form); goto a0ff7; a0ff7: goto bedc8; goto f7b57; d27ca: } public function deleteDatabaseUser(Request $request) : Response { goto b621a; Eed90: $databaseUserEntity = $this->databaseUserEntityManager->findOneByUserName($databaseUserName); goto ece20; A3a2b: return $response; goto Da64f; Da64f: C411d: goto Da1bc; b621a: $site = $this->getSite($request); goto C5ba7; Fc1b5: return $response; goto a77da; deefe: if (!(false === is_null($site))) { goto a3c86; } goto D1719; E7739: try { goto bdd4b; Eaae2: EventQueue::addEvent(EventQueue::EVENT_SITE_DATABASE_USER_DELETE, $user, $eventData, $request); goto E0dbd; cad14: $session = $request->getSession(); goto ddfb4; accdb: $this->databaseUserEntityManager->deleteEntity($databaseUserEntity); goto Afc07; ddfb4: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto b64c8; E0dbd: ffa5b: goto e9666; cdb12: if (!(false === is_null($databaseEntity) && $site->getDomainName() == $databaseEntity->getSite()->getDomainName())) { goto ffa5b; } goto a42c0; bdd4b: $databaseEntity = $databaseUserEntity->getDatabase(); goto cdb12; b21ea: $eventData = ["\x73\x69\x74\x65" => $domainName, "\144\x61\x74\x61\142\141\x73\145\x55\163\x65\162\x4e\x61\155\x65" => $databaseUserName]; goto Eaae2; a42c0: $user = $this->getUser(); goto ac570; b64c8: $databaseManager = new DatabaseManager($activeDatabaseServerEntity); goto C6f62; Afc07: $session->getFlashBag()->set("\163\165\143\143\x65\163\163", $this->translator->trans("\x44\x61\x74\141\x62\x61\x73\x65\x20\x55\x73\x65\x72\x20\x68\141\163\x20\x62\x65\145\x6e\x20\144\145\x6c\x65\x74\x65\144\56")); goto b21ea; C6f62: $databaseManager->deleteUser($databaseUserEntity); goto accdb; ac570: $domainName = $site->getDomainName(); goto cad14; e9666: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\x6e\147\x65\x72", $this->translator->trans("\101\156\40\x65\162\x72\157\x72\40\150\141\x73\40\157\143\143\x75\x72\162\x65\144\x2c\x20\145\x72\162\157\x72\x20\x6d\145\163\x73\x61\x67\145\x3a\40\x25\x65\x72\162\x6f\162\x4d\x65\x73\163\x61\147\145\45", ["\x25\145\x72\162\157\162\x4d\x65\x73\163\141\147\145\45" => $e->getMessage()])); } goto a354c; a354c: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\x69\164\145\137\x64\141\x74\x61\142\141\163\x65\x73", ["\144\157\155\141\151\x6e\116\141\155\x65" => $site->getDomainName()])); goto A3a2b; baabd: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\x69\164\145\163")); goto Fc1b5; Da1bc: a3c86: goto baabd; ece20: if (!(false === is_null($databaseUserEntity))) { goto C411d; } goto E7739; D1719: $databaseUserName = $request->get("\x64\x61\x74\x61\142\141\163\145\125\163\145\162\116\141\155\145"); goto Eed90; C5ba7: $this->checkCsrfToken($request, "\144\141\164\141\x62\141\163\x65\55\165\x73\x65\x72\55\x64\x65\x6c\x65\x74\x65"); goto deefe; a77da: } public function varnishCache(Request $request) : Response { goto ba8ee; bc011: if (!(true === $request->isMethod("\x50\117\x53\124"))) { goto E86d6; } goto F1d3e; F667d: if (!(true === $purgeCacheForm->isSubmitted())) { goto de8f6; } goto c75b4; dd745: E86d6: goto A0359; e9283: Ccdff: goto a5cbe; ba760: return $response; goto Fc79d; Ecab5: if (false === is_null($site) && true === $site->getVarnishCache()) { goto d70e0; } goto fba52; d0bfb: if (!(false === is_null($response))) { goto F4bfd; } goto dfe32; B154f: $purgeCacheForm->handleRequest($request); goto A52ef; dfe32: return $response; goto Dbc68; Cfa1c: $varnishCacheSettingsData = ["\x69\163\x45\156\x61\x62\x6c\x65\x64" => true === isset($varnishCacheSettings["\145\156\x61\142\154\145\144"]) && true === $varnishCacheSettings["\x65\x6e\141\x62\154\145\144"] ? true : false, "\x73\145\162\x76\x65\162" => true === isset($varnishCacheSettings["\x73\145\162\x76\145\162"]) ? $varnishCacheSettings["\x73\x65\x72\166\145\x72"] : "\x31\62\x37\x2e\60\x2e\60\x2e\61\x3a\66\60\x38\x31", "\143\141\x63\x68\x65\x54\141\147\120\162\145\146\151\170" => true === isset($varnishCacheSettings["\x63\x61\x63\150\x65\124\141\x67\120\162\145\146\151\x78"]) ? $varnishCacheSettings["\x63\x61\x63\150\145\124\141\x67\x50\162\x65\146\151\170"] : substr(md5(time()), 0, 4), "\x63\x61\143\150\145\x4c\151\146\145\164\151\x6d\145" => true === isset($varnishCacheSettings["\143\141\x63\150\x65\x4c\151\146\x65\x74\151\x6d\145"]) ? $varnishCacheSettings["\143\141\x63\150\145\114\151\146\145\x74\151\155\x65"] : "\66\x30\x34\x38\x30\60", "\145\170\x63\154\165\x64\x65\144\x50\141\x72\141\155\163" => true === isset($varnishCacheSettings["\x65\170\x63\154\165\x64\145\x64\x50\x61\x72\141\x6d\163"]) ? implode("\54", $varnishCacheSettings["\x65\170\x63\x6c\x75\144\145\x64\120\141\x72\141\x6d\x73"]) : "\137\x5f\123\111\x44\54\156\x6f\x43\x61\x63\150\145\x2c", "\x65\x78\143\154\165\144\145\163" => true === isset($varnishCacheSettings["\145\x78\143\154\165\x64\145\163"]) ? implode(PHP_EOL, $varnishCacheSettings["\x65\170\x63\154\x75\x64\145\163"]) : '']; goto Bf760; b5d2d: $response = $this->handleVarnishCacheSettingsForm($request, $settingsForm, $site); goto fafd5; F5262: return $response; goto e9283; fafd5: if (!(false === is_null($response))) { goto Ccdff; } goto F5262; F1d3e: $settingsForm->handleRequest($request); goto B154f; beaad: Be864: goto ba760; fba52: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\x69\164\x65\x73")); goto d4ac6; f110d: d70e0: goto Fad8f; A52ef: if (!(true === $settingsForm->isSubmitted())) { goto B4640; } goto b5d2d; ba8ee: $site = $this->getSite($request); goto Ecab5; Bf760: $settingsForm = $this->createVarnishCacheSettingsForm($site, $varnishCacheSettingsData); goto d9dd2; Dbc68: F4bfd: goto cede4; d4ac6: goto Be864; goto f110d; c75b4: $response = $this->handleVarnishCachePurgeCacheForm($request, $purgeCacheForm, $site); goto d0bfb; A0359: $response = $this->render("\106\162\x6f\x6e\x74\145\156\x64\57\x53\x69\164\145\57\x76\x61\162\x6e\x69\x73\x68\x2d\143\x61\143\150\145\x2e\x68\164\x6d\154\56\164\167\151\x67", ["\163\151\164\x65" => $site, "\163\145\164\x74\x69\x6e\147\x73\x46\x6f\162\x6d" => $settingsForm->createView(), "\x70\x75\162\x67\145\103\x61\143\x68\x65\x46\157\162\x6d" => $purgeCacheForm->createView(), "\146\157\162\x6d\x45\162\x72\157\162\x73" => $this->formErrors]); goto beaad; cede4: de8f6: goto dd745; Fad8f: $varnishCacheSettings = $site->getVarnishCacheSettings(); goto Cfa1c; d9dd2: $purgeCacheForm = $this->createVarnishCachePurgeCacheForm($site); goto bc011; a5cbe: B4640: goto F667d; Fc79d: } private function createVarnishCacheSettingsForm(Site $site, array $data) : Form { goto A4da3; E7758: $form->add("\163\x75\x62\x6d\151\x74", SubmitType::class, ["\x61\x74\164\x72" => ["\143\154\141\x73\x73" => "\x62\164\156\40\142\164\156\x2d\142\154\165\x65\x20\142\x74\x6e\x2d\154\x67"], "\x6c\141\x62\x65\154" => "\123\x61\x76\145"]); goto ea060; A4da3: $form = $this->createForm("\101\x70\x70\134\106\157\x72\155\134\123\151\164\145\126\141\x72\156\151\163\x68\x43\x61\x63\x68\x65\x53\x65\x74\x74\x69\156\147\x73\x54\x79\160\x65", $data, ["\141\x63\x74\x69\157\x6e" => $this->generateUrl("\143\154\160\x5f\163\151\x74\145\137\x76\x61\162\x6e\151\163\150\x5f\x63\x61\x63\150\145", ["\144\157\155\141\x69\x6e\x4e\x61\155\145" => $site->getDomainName()]), "\155\x65\164\x68\157\x64" => "\120\x4f\x53\x54", "\141\x74\x74\162" => []]); goto E7758; ea060: return $form; goto E251b; E251b: } private function createVarnishCachePurgeCacheForm(Site $site) : Form { goto e8ab6; e8ab6: $form = $this->createForm("\101\x70\160\x5c\106\x6f\162\155\134\x53\x69\x74\145\126\x61\x72\x6e\151\163\150\103\141\x63\150\145\x50\x75\162\x67\145\x43\x61\143\x68\x65\124\171\x70\x65", ["\163\x69\x74\x65" => $site], ["\x61\143\x74\x69\x6f\156" => $this->generateUrl("\143\x6c\x70\137\x73\x69\x74\x65\137\x76\141\x72\x6e\x69\x73\x68\x5f\143\141\x63\150\x65", ["\144\157\x6d\141\x69\x6e\116\141\155\145" => $site->getDomainName()]), "\155\x65\x74\150\157\x64" => "\x50\117\x53\124", "\141\x74\x74\x72" => []]); goto B9b37; B9b37: $form->add("\x73\x75\142\155\x69\164", SubmitType::class, ["\141\x74\x74\x72" => ["\x63\x6c\141\163\x73" => "\142\x74\x6e\40\142\x74\156\55\x62\x6c\165\145\40\142\x74\x6e\x2d\x6c\147"], "\154\x61\142\145\x6c" => "\x50\165\x72\147\x65\x20\x43\141\x63\150\x65"]); goto dad57; dad57: return $form; goto A08e7; A08e7: } private function handleVarnishCacheSettingsForm(Request $request, Form $form, Site $site) { goto aeaa8; cad1a: D9e36: goto E69ad; f047e: C3c69: goto d5f93; d5f93: try { goto Aae6a; Afabc: $server = $form->get("\163\145\x72\166\x65\x72")->getData(); goto f050b; F8444: $site->setVarnishCacheSettings($varnishCacheSettings); goto E5656; F9bf7: $siteEntity = $this->getSiteEntity($domainName); goto Da490; d50e7: $eventData = ["\x73\151\x74\x65" => $domainName, "\x76\x61\x72\156\151\163\150\x43\141\x63\150\145\105\156\141\142\154\x65\144" => $isEnabled, "\x73\145\162\166\145\x72" => $server, "\143\141\143\x68\145\124\x61\147\x50\x72\x65\146\x69\x78" => $cacheTagPrefix, "\143\141\x63\150\x65\x4c\x69\146\145\x74\151\x6d\145" => $cacheLifetime, "\x65\x78\x63\x6c\x75\x64\145\x73" => $excludes, "\145\170\x63\x6c\x75\x64\145\x64\x50\x61\x72\141\155\x73" => $excludedParams]; goto F61ee; E5656: $siteUpdater = $this->getSiteUpdater($site); goto f8108; f050b: $cacheLifetime = $form->get("\x63\x61\x63\x68\145\x4c\151\146\x65\164\151\x6d\145")->getData(); goto c50f2; B0446: cb6fe: goto Ab465; e00ef: E056e: goto e292e; B6f82: goto cb6fe; goto e00ef; Fe29d: $varnishCacheSettings = ["\x65\x6e\x61\x62\x6c\x65\144" => $isEnabled, "\163\x65\162\x76\145\162" => $server, "\x63\x61\x63\x68\x65\124\141\x67\x50\162\x65\146\151\170" => $cacheTagPrefix, "\x63\x61\x63\x68\145\114\x69\x66\145\x74\x69\x6d\145" => $cacheLifetime, "\145\170\143\x6c\x75\144\145\x73" => $excludes, "\145\170\x63\x6c\x75\x64\145\144\120\x61\162\x61\155\163" => $excludedParams]; goto F8444; Da490: if (false === is_null($siteEntity)) { goto E056e; } goto C92a4; E1064: $excludes = array_map("\x74\x72\x69\x6d", array_filter(explode(PHP_EOL, trim($form->get("\x65\x78\143\x6c\165\144\x65\x73")->getData())))); goto Fe29d; B7163: $excludedParams = array_map("\164\162\x69\x6d", array_filter(explode("\x2c", trim($form->get("\145\170\143\154\x75\144\145\x64\x50\x61\x72\x61\x6d\163")->getData())))); goto E1064; c50f2: $cacheTagPrefix = $form->get("\143\x61\143\x68\x65\124\141\x67\120\162\145\x66\x69\170")->getData(); goto B7163; F61ee: EventQueue::addEvent(EventQueue::EVENT_SITE_VARNISH_CACHE_SETTINGS_UPDATE, $user, $eventData, $request); goto aa6f1; c363a: $domainName = $site->getDomainName(); goto F9bf7; a016c: $isEnabled = $form->get("\x69\x73\x45\x6e\x61\x62\154\145\x64")->getData(); goto Afabc; Ab465: return $response; goto A96f5; Aae6a: $session = $request->getSession(); goto c363a; C92a4: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\151\164\145\163")); goto B6f82; e292e: $user = $this->getUser(); goto a016c; aa6f1: $session->getFlashBag()->set("\163\165\143\x63\x65\x73\163", $this->translator->trans("\126\141\162\156\x69\x73\150\x20\103\141\x63\150\145\x20\123\145\x74\164\x69\156\147\163\x20\150\x61\166\x65\40\x62\145\145\156\x20\163\x61\x76\145\x64\56")); goto bbb8b; f8108: $siteUpdater->writeVarnishCacheSettingsFile($varnishCacheSettings); goto Bb731; Bb731: $siteUpdater->phpSettings(); goto d50e7; bbb8b: $response = $this->redirect($this->generateUrl("\x63\x6c\160\137\163\151\x74\145\137\166\141\x72\156\151\163\150\137\143\141\143\150\x65", ["\x64\x6f\155\x61\151\156\116\x61\x6d\145" => $site->getDomainName()])); goto B0446; A96f5: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\156\x67\x65\162", $this->translator->trans("\x41\x6e\40\145\x72\162\157\162\x20\x68\141\x73\x20\x6f\143\143\165\162\162\145\144\54\x20\x65\x72\x72\x6f\x72\40\x6d\x65\163\x73\x61\147\145\72\40\45\x65\x72\x72\157\162\115\145\x73\163\x61\147\145\x25", ["\x25\x65\x72\162\157\162\115\x65\163\x73\x61\x67\x65\x25" => $e->getMessage()])); } goto cad1a; A4ec2: goto D9e36; goto f047e; db39d: $this->formErrors = $this->getErrorMessages($form); goto A4ec2; aeaa8: if (true === $form->isValid()) { goto C3c69; } goto db39d; E69ad: } private function handleVarnishCachePurgeCacheForm(Request $request, Form $form, Site $site) { goto Baf6b; Baf6b: if (true === $form->isValid()) { goto Aa0e0; } goto cee75; e863d: goto cf902; goto D36bd; D36bd: Aa0e0: goto E30f6; F467f: cf902: goto E77cf; E30f6: try { goto f1747; E4985: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\x73\151\164\145\163")); goto a1fbd; B3592: goto b3df6; goto ce6f6; a8f28: if (false === is_null($siteEntity)) { goto Baab9; } goto E4985; b5e4e: $varnishCacheClient = new VarnishCacheClient(); goto E1dd5; E1dd5: $varnishCacheClient->setServer($varnishCacheSettings["\163\145\x72\x76\x65\x72"]); goto Aa657; c11ef: return $response; goto B6f5c; ce6f6: Fe730: goto b5e4e; Ca36b: $purgeValues = array_map("\164\162\151\x6d", array_filter(explode("\x2c", trim($form->get("\x76\141\x6c\165\x65")->getData())))); goto b17be; a16e6: b3df6: goto b9c74; f1747: $session = $request->getSession(); goto a2e76; a2e76: $domainName = $site->getDomainName(); goto c3bbe; acae4: dedc9: goto c11ef; a1fbd: goto dedc9; goto Be1ac; b9c74: $eventData = ["\163\x69\164\x65" => $domainName, "\x76\x61\x6c\x75\x65\x73" => implode("\x2c", $purgeValues)]; goto bab91; Aa657: foreach ($purgeValues as $purgeValue) { goto db620; C80fc: $varnishCacheClient->purgeUrl($purgeValue); goto D9733; db620: $purgeValue = trim($purgeValue); goto Dfe38; c0976: Bbc97: goto f6fda; f502a: $varnishCacheClient->purgeTag($purgeValue); goto d3354; Be4d7: Bb01d: goto C80fc; B7b7e: f465d: goto c0976; D9733: Cfbef: goto B7b7e; d3354: goto Cfbef; goto Be4d7; Dfe38: if (!(false === empty($purgeValue))) { goto f465d; } goto A6638; A6638: if (true === str_starts_with($purgeValue, "\x68\164\164\x70")) { goto Bb01d; } goto f502a; f6fda: } goto F0f21; bab91: EventQueue::addEvent(EventQueue::EVENT_SITE_VARNISH_CACHE_PURGE, $user, $eventData, $request); goto be265; a8a2d: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\163\151\164\145\x5f\x76\x61\x72\x6e\x69\163\x68\x5f\143\141\x63\150\x65", ["\x64\x6f\x6d\141\151\x6e\x4e\x61\155\x65" => $site->getDomainName()])); goto acae4; Def90: $varnishCacheSettings = $site->getVarnishCacheSettings(); goto Ca36b; c3bbe: $siteEntity = $this->getSiteEntity($domainName); goto a8f28; be265: $session->getFlashBag()->set("\163\165\143\x63\x65\163\x73", $this->translator->trans("\126\141\x72\156\x69\163\x68\x20\103\141\x63\x68\x65\x20\x68\141\x73\40\x62\145\x65\156\x20\x70\x75\162\x67\145\144\x2e")); goto a8a2d; b17be: if (false === empty($purgeValues) && true === isset($varnishCacheSettings["\163\145\162\x76\x65\162"]) && false === empty($varnishCacheSettings["\x73\x65\162\x76\x65\162"])) { goto Fe730; } goto B8358; a3a46: $user = $this->getUser(); goto Def90; F0f21: F61d2: goto a16e6; Be1ac: Baab9: goto a3a46; B8358: throw new \Exception("\x56\141\162\156\x69\x73\x68\40\103\x61\143\150\145\40\x53\x65\164\x74\151\x6e\x67\163\x20\x63\141\156\156\x6f\164\40\142\x65\40\145\x6d\160\164\x79\56"); goto B3592; B6f5c: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\x67\x65\x72", $this->translator->trans("\x41\156\40\x65\x72\162\x6f\x72\40\x68\141\163\40\x6f\x63\143\165\x72\162\145\x64\54\x20\x65\162\x72\157\162\x20\155\145\x73\163\x61\147\145\72\40\45\x65\162\x72\157\x72\115\x65\x73\163\x61\147\145\45", ["\x25\145\162\162\157\162\115\x65\163\163\x61\x67\145\x25" => $e->getMessage()])); } goto F467f; cee75: $this->formErrors = $this->getErrorMessages($form); goto e863d; E77cf: } public function purgeVarnishCache(Request $request) : Response { goto Eab20; D0fbb: return $response; goto Be2bb; aa90f: try { goto d203a; D51b8: $varnishCacheSettings = $site->getVarnishCacheSettings(); goto efa18; d203a: $user = $this->getUser(); goto e638e; efa18: if (!(true === isset($varnishCacheSettings["\x73\145\162\x76\145\x72"]) && true === isset($varnishCacheSettings["\143\x61\x63\150\x65\x54\x61\x67\120\162\145\x66\x69\x78"]) && false === empty($varnishCacheSettings["\x63\141\143\x68\x65\x54\141\147\x50\x72\x65\146\x69\170"]))) { goto e4fef; } goto adec0; ee1b0: $session->getFlashBag()->set("\163\165\x63\143\x65\x73\163", $this->translator->trans("\x56\141\162\x6e\151\x73\150\x20\103\141\x63\150\x65\x20\150\x61\163\x20\x62\x65\145\156\40\160\x75\162\147\x65\x64\56")); goto f1dc2; bdef5: $varnishCacheClient->setServer($varnishCacheSettings["\x73\x65\x72\x76\145\162"]); goto Da3ef; adec0: $cacheTagPrefix = $varnishCacheSettings["\143\141\143\x68\145\x54\141\x67\120\x72\145\146\151\170"]; goto c8baa; e638e: $session = $request->getSession(); goto e6487; e6487: $domainName = $site->getDomainName(); goto D51b8; c8baa: $varnishCacheClient = new VarnishCacheClient(); goto bdef5; Da3ef: $varnishCacheClient->purgeTag($cacheTagPrefix); goto B8bae; e7244: EventQueue::addEvent(EventQueue::EVENT_SITE_VARNISH_CACHE_PURGE, $user, $eventData, $request); goto ee1b0; B9113: e4fef: goto C6aa3; C6aa3: $eventData = ["\163\151\164\x65" => $domainName, "\x70\x75\162\147\x65" => "\x66\x75\154\154"]; goto e7244; B8bae: $varnishCacheClient->purgeHost($domainName); goto B9113; f1dc2: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\147\145\x72", $this->translator->trans("\x41\156\40\145\x72\162\x6f\162\x20\x68\x61\x73\40\x6f\143\143\165\x72\162\x65\144\54\x20\x65\x72\162\x6f\162\x20\155\145\x73\163\141\x67\x65\72\x20\x25\x65\x72\162\157\162\x4d\x65\163\163\141\x67\x65\45", ["\x25\145\162\x72\x6f\x72\115\145\x73\163\x61\147\x65\x25" => $e->getMessage()])); } goto c3978; c3978: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\137\163\x69\x74\145\137\x76\x61\x72\x6e\151\163\x68\x5f\143\141\x63\x68\145", ["\144\x6f\155\141\151\156\x4e\141\155\145" => $site->getDomainName()])); goto C8c7b; C8c7b: return $response; goto F00a5; B9e77: if (false === is_null($site)) { goto da1f6; } goto d3e2d; Acf12: goto Bbf12; goto F18b8; F18b8: da1f6: goto aa90f; Eab20: $site = $this->getSite($request); goto B9e77; d3e2d: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\x69\x74\145\163")); goto Acf12; F00a5: Bbf12: goto D0fbb; Be2bb: } public function vhost(Request $request) : Response { goto a4617; a73a8: return $response; goto ffb30; a4617: $site = $this->getSite($request); goto c2153; b46ad: a49bc: goto C5722; B1e4f: eac56: goto a7a2e; Cacbf: $domainName = $site->getDomainName(); goto Ff528; Df1ef: $oldVhostTemplate = $siteEntity->getVhostTemplate(); goto C004a; a7a2e: $vhostTemplate = trim($request->get("\166\x68\157\163\164\55\164\145\155\x70\x6c\141\164\x65")); goto Fde0a; c2153: if (false === is_null($site)) { goto a49bc; } goto ff838; ff265: if (!(false === $isCsrfTokenValid)) { goto eac56; } goto ceb99; d11af: goto E8fc9; goto b46ad; C3724: E8fc9: goto a73a8; ff838: $response = $this->redirect($this->generateUrl("\143\154\x70\137\163\x69\x74\145\163")); goto d11af; Fa80c: if (!(false === is_null($response))) { goto f64b5; } goto d9367; Fde0a: if (!(false === empty($vhostTemplate))) { goto C044f; } goto Cacbf; f7a2d: C044f: goto f93c1; A08c1: $response = $this->render("\106\162\157\x6e\x74\145\x6e\144\x2f\x53\x69\164\x65\x2f\x76\150\x6f\x73\164\x2e\150\x74\155\x6c\56\164\167\151\147", ["\163\151\164\145" => $site]); goto C3724; C004a: $site->setVhostTemplate($vhostTemplate); goto ee94e; Ff528: $siteEntity = $this->getSiteEntity($domainName); goto Df1ef; ee94e: $response = $this->handleVhostUpdate($request, $site, $siteEntity, $oldVhostTemplate); goto Fa80c; ceb99: throw new InvalidCsrfTokenException("\x54\150\145\x20\103\123\x52\x46\40\164\x6f\x6b\145\156\x20\151\163\40\151\156\x76\141\154\151\x64\x2e"); goto B1e4f; d9367: return $response; goto D926a; D926a: f64b5: goto f7a2d; C5722: if (!(true === $request->isMethod("\x50\117\x53\124"))) { goto Ee5c0; } goto d7e3b; f93c1: Ee5c0: goto A08c1; d7e3b: $isCsrfTokenValid = $this->isCsrfTokenValid("\x76\150\x6f\x73\x74\x2d\x75\160\x64\141\x74\x65", (string) $request->get("\x74\x6f\153\145\x6e")); goto ff265; ffb30: } private function handleVhostUpdate(Request $request, Site $site, SiteEntity $siteEntity, string $oldVhostTemplate) { try { goto a67d3; d9ccd: throw new InvalidVhostException("\x64\x69\163\141\142\154\145\x5f\163\x79\155\x6c\151\156\x6b\x73\40\151\163\x20\156\157\164\40\141\154\154\x6f\167\145\144\56"); goto E10d8; d00fc: $response = $this->redirect($this->generateUrl("\143\x6c\160\137\x73\151\x74\145\x5f\166\x68\x6f\163\164", ["\x64\x6f\155\141\151\156\x4e\141\155\145" => $domainName])); goto b72f8; E10d8: Ccf19: goto F878b; a397b: EventQueue::addEvent(EventQueue::EVENT_SITE_VHOST_UPDATE, $user, $eventData, $request); goto d00fc; c5ef6: $siteEntity->setVhostTemplate($vhostTemplate); goto E7f90; Aa050: $siteUpdater->updateNginxVhostWithRollback(); goto c5ef6; b72f8: return $response; goto B94a2; Acb04: $vhostTemplate = $site->getVhostTemplate(); goto f0597; a67d3: $user = $this->getUser(); goto e3bf1; Cc871: $eventData = ["\x73\151\x74\x65" => $domainName, "\166\x68\157\x73\164" => $vhostTemplate, "\x6f\154\x64\126\x68\x6f\163\x74" => $oldVhostTemplate]; goto a397b; F878b: $domainName = $site->getDomainName(); goto Acb04; E7f90: $this->siteEntityManager->updateEntity($siteEntity); goto Fd1f7; Fd1f7: $session->getFlashBag()->set("\x73\x75\x63\143\145\x73\163", $this->translator->trans("\126\x68\x6f\x73\x74\40\150\x61\x73\40\x62\145\145\156\40\x73\x61\x76\x65\144\x2e")); goto Cc871; D6db6: if (!(true === str_contains($site->getVhostTemplate(), "\x64\151\x73\x61\142\154\x65\137\x73\171\155\154\151\x6e\x6b\163"))) { goto Ccf19; } goto d9ccd; e3bf1: $session = $request->getSession(); goto D6db6; f0597: $siteUpdater = $this->getSiteUpdater($site); goto Aa050; B94a2: } catch (InvalidVhostException $e) { $session->getFlashBag()->set("\144\141\156\x67\145\x72", $this->translator->trans("\126\x68\x6f\x73\x74\40\151\x73\x20\156\x6f\x74\x20\166\x61\154\151\144\x2c\x20\x65\162\x72\157\162\x20\155\145\163\x73\141\x67\145\x3a\x20\45\x65\162\162\157\162\x4d\x65\x73\163\141\x67\x65\45", ["\x25\x65\162\162\x6f\x72\115\145\x73\163\141\x67\145\x25" => $e->getMessage()])); } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\x67\145\x72", $this->translator->trans("\x41\x6e\40\145\x72\x72\157\x72\40\150\141\163\x20\x6f\143\143\x75\162\x72\145\x64\54\40\x65\x72\162\157\162\40\x6d\145\x73\163\x61\x67\x65\x3a\x20\45\145\162\x72\157\x72\x4d\145\163\163\x61\147\145\45", ["\x25\145\x72\162\x6f\162\115\x65\x73\x73\x61\x67\145\45" => $e->getMessage()])); } } public function settings(Request $request) : Response { goto Ce727; e50a5: if (!(false === is_null($response))) { goto C21e5; } goto E963e; Ce727: $site = $this->getSite($request); goto Fccbb; Ddb43: Ff4d8: goto d51f1; Bb05f: $response = $this->handleDomainSettingsForm($request, $domainSettingsForm, $site); goto b8b1d; c757a: if (!(SiteEntity::TYPE_PYTHON == $site->getType())) { goto Da068; } goto d9d70; E36e3: F23a0: goto a904c; Dfcb4: $pageSpeedSettingsForm = $this->createPageSpeedSettingsForm($site, $pageSpeedSettingsData); goto F824a; B09a2: D0ae5: goto B60b0; e03e1: ee587: goto F9f84; E963e: return $response; goto e38b9; B8392: if (!(true === $request->isMethod("\120\117\123\x54"))) { goto D2c5c; } goto D6525; C967c: $parameters["\162\145\166\145\162\163\145\120\x72\x6f\x78\171\x53\145\164\x74\x69\156\x67\x73\106\157\162\x6d"] = $reverseProxySettingsForm->createView(); goto D05ad; f57a6: $phpSettingsForm = $this->createPhpSettingsForm($site, $phpSettings); goto B8392; E06e1: if (!(SiteEntity::TYPE_NODEJS == $site->getType())) { goto Bf504; } goto f5c90; eaa34: $domainSettingsData = ["\x64\x6f\x6d\x61\151\x6e\x4e\x61\155\145" => $site->getDomainName(), "\x72\x6f\157\164\104\x69\x72\145\x63\x74\x6f\162\x79" => $site->getRootDirectory()]; goto Deb1e; F3436: b4204: goto Fd391; F9f84: $parameters = ["\163\151\x74\x65" => $site, "\144\x6f\x6d\x61\151\156\123\145\x74\164\x69\156\147\163\106\x6f\162\x6d" => $domainSettingsForm->createView(), "\x73\151\x74\x65\125\x73\145\x72\123\145\164\164\x69\156\147\163\106\x6f\x72\x6d" => $siteUserSettingsForm->createView(), "\160\141\x67\145\123\160\x65\145\144\123\x65\x74\164\x69\156\147\x73\106\157\162\x6d" => $pageSpeedSettingsForm->createView(), "\163\x69\164\x65\104\x65\x6c\145\164\145\106\157\x72\x6d" => $siteDeleteForm->createView()]; goto E06e1; fbf2f: $response = $this->handleSiteUserSettingsForm($request, $siteUserSettingsForm, $site); goto E36e3; F5913: return $response; goto Bb6ae; Ca3b3: if (!(false === is_null($response))) { goto db819; } goto Cc9a2; Dc7ac: $domainSettingsForm = $this->createDomainSettingsForm($site, $domainSettingsData); goto a9125; e9266: if (!(true === $siteUserSettingsForm->isSubmitted())) { goto F23a0; } goto fbf2f; Cf8ac: $siteUserSettingsForm->handleRequest($request); goto bf90a; f7123: if (!(false === is_null($response))) { goto Ff4d8; } goto E6f93; d51f1: Cafd4: goto f98ee; b3805: $response = $this->redirect($this->generateUrl("\143\x6c\160\x5f\x73\151\164\x65\x73")); goto Be467; Da0e4: return $response; goto F0eba; b799c: $siteDeleteData = ["\x64\x6f\x6d\x61\151\156\116\x61\155\145" => $site->getDomainName()]; goto c78a9; C2d41: $response = $this->handlePhpSettingsForm($request, $phpSettingsForm, $currentPhpSettings, $site); goto Ca3b3; b8b1d: d33ed: goto e9266; b05e9: b2e97: goto c757a; d27a4: $response = $this->handleReverseProxySettingsForm($request, $reverseProxySettingsForm, $site); goto dfa29; B60b0: if (!(false === is_null($response))) { goto d10ca; } goto F5913; F10f8: C3fbe: goto C967c; Fccbb: if (false === is_null($site)) { goto Db537; } goto b3805; e389d: e9bc9: goto d36bd; a604b: E3cad: goto fa4de; F824a: $siteDeleteForm = $this->createSiteDeleteForm($site, $siteDeleteData); goto ebfa2; ac3d1: if (!(true === $pythonSettingsForm->isSubmitted())) { goto Cafd4; } goto a94f4; Fcfc2: Da068: goto dbf86; B5281: $phpSettings = $site->getPhpSettings(); goto f57a6; Fd391: $parameters["\x6e\x6f\144\x65\x6a\163\123\145\164\x74\x69\x6e\147\x73\x46\157\162\155"] = $nodejsSettingsForm->createView(); goto Ea8d7; Af9e1: db819: goto Bb932; fb128: if (!(true === $request->isMethod("\120\117\123\124"))) { goto C2938; } goto Fd1b0; dbf86: if (!(SiteEntity::TYPE_REVERSE_PROXY == $site->getType())) { goto f752e; } goto cdb6e; Fbda7: if (!(SiteEntity::TYPE_PHP == $site->getType())) { goto b2e97; } goto B5281; E9e69: $pageSpeedSettingsForm->handleRequest($request); goto Db421; B8083: return $response; goto e389d; Fd455: $phpSettingsForm->handleRequest($request); goto Ffda0; ace13: if (!(true === $reverseProxySettingsForm->isSubmitted())) { goto fa880; } goto d27a4; Deb1e: $siteUserSettingsData = ["\x73\x69\164\x65\x55\163\145\162" => $site->getUser(), "\163\163\x68\113\x65\171\163" => $site->getSshKeys()]; goto b799c; a770b: Bf504: goto Fbda7; a94f4: $response = $this->handlePythonSettingsForm($request, $pythonSettingsForm, $site); goto f7123; Ffda0: if (!(true === $phpSettingsForm->isSubmitted())) { goto e958e; } goto C2d41; Ead58: $response = $this->render("\106\x72\x6f\x6e\164\145\x6e\x64\x2f\123\151\x74\x65\x2f\x73\145\164\164\151\x6e\x67\163\56\x68\x74\x6d\154\x2e\164\167\x69\147", $parameters); goto C3017; e08a9: D2c5c: goto B3e5d; a9125: $siteUserSettingsForm = $this->createSiteUserSettingsForm($site, $siteUserSettingsData); goto Dfcb4; Eecec: Db537: goto eaa34; F2a74: $response = $this->handlePageSpeedSettingsForm($request, $pageSpeedSettingsForm, $site); goto a604b; C3017: d75aa: goto Da0e4; A1328: $parameters["\146\x6f\x72\155\x45\x72\162\x6f\162\x73"] = $this->formErrors; goto Ead58; f32cb: $reverseProxySettingsForm->handleRequest($request); goto ace13; ea4c2: $response = $this->handleNodejsSettingsForm($request, $nodejsSettingsForm, $currentNodeSettings, $site); goto e50a5; dfa29: if (!(false === is_null($response))) { goto e9bc9; } goto B8083; f98ee: C2938: goto e748c; bf90a: $siteDeleteForm->handleRequest($request); goto E9e69; Db421: $response = null; goto Acbb0; cc753: $domainSettingsForm->handleRequest($request); goto Cf8ac; d36bd: fa880: goto F10f8; Bb6ae: d10ca: goto e03e1; Bb932: e958e: goto e08a9; Acbb0: if (!(true === $domainSettingsForm->isSubmitted())) { goto d33ed; } goto Bb05f; cf637: $response = $this->handleSiteDeleteForm($request, $siteDeleteForm, $site); goto B09a2; Fd1b0: $pythonSettingsForm->handleRequest($request); goto ac3d1; cdb6e: $reverseProxySettingsForm = $this->createReverseProxySettingsForm($site); goto Cf924; fe8b6: $nodejsSettingsForm = $this->createNodejsSettingsForm($site, $nodejsSettings); goto bee30; d9d70: $pythonSettings = $site->getPythonSettings(); goto e75b6; e75b6: $pythonSettingsForm = $this->createPythonSettingsForm($site, $pythonSettings); goto fb128; e030f: F1d0f: goto F3436; f5c90: $nodejsSettings = $site->getNodejsSettings(); goto fe8b6; E6f93: return $response; goto Ddb43; D05ad: unset($parameters["\160\141\147\145\123\160\145\x65\144\123\x65\x74\164\x69\x6e\147\163\106\x6f\x72\155"]); goto D28e1; bee30: if (!(true === $request->isMethod("\120\x4f\123\124"))) { goto b4204; } goto F4e5e; B3e5d: $parameters["\160\150\160\x53\145\x74\x74\151\156\x67\163\106\157\x72\155"] = $phpSettingsForm->createView(); goto b05e9; Ea8d7: unset($parameters["\x70\141\x67\145\x53\x70\x65\145\x64\123\x65\164\164\x69\x6e\147\163\x46\x6f\162\x6d"]); goto a770b; fa4de: if (!(true === $siteDeleteForm->isSubmitted())) { goto D0ae5; } goto cf637; Be467: goto d75aa; goto Eecec; e38b9: C21e5: goto e030f; F4e5e: $currentNodeSettings = clone $nodejsSettings; goto f0875; e748c: $parameters["\160\171\164\x68\x6f\x6e\123\145\x74\x74\x69\x6e\x67\163\106\157\162\155"] = $pythonSettingsForm->createView(); goto Fcfc2; D28e1: f752e: goto A1328; c78a9: $pageSpeedSettingsData = ["\151\163\x45\x6e\x61\142\x6c\145\x64" => $site->getPageSpeedEnabled(), "\x73\x65\164\164\151\156\147\x73" => $site->getPageSpeedSettings()]; goto Dc7ac; Cc9a2: return $response; goto Af9e1; f0875: $nodejsSettingsForm->handleRequest($request); goto Eef47; a904c: if (!(true === $pageSpeedSettingsForm->isSubmitted())) { goto E3cad; } goto F2a74; ebfa2: if (!(true === $request->isMethod("\120\117\123\124"))) { goto ee587; } goto cc753; Cf924: if (!(true === $request->isMethod("\120\117\123\124"))) { goto C3fbe; } goto f32cb; D6525: $currentPhpSettings = clone $phpSettings; goto Fd455; Eef47: if (!(true === $nodejsSettingsForm->isSubmitted())) { goto F1d0f; } goto ea4c2; F0eba: } public function purgePageSpeedCache(Request $request) : Response { goto f2a89; a641f: $response = $this->redirect($this->generateUrl("\x63\154\x70\x5f\x73\x69\164\145\163")); goto Aa427; Bc6aa: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\x73\x69\164\145\137\x73\x65\164\164\151\x6e\x67\163", ["\144\x6f\x6d\x61\x69\156\116\x61\x6d\x65" => $site->getDomainName()])); goto Bac5c; f2a89: $site = $this->getSite($request); goto f225a; A378b: cda52: goto a4137; a4137: return $response; goto Ae3fe; Aa427: goto cda52; goto a54cc; e1ccb: try { goto eea98; fc4cd: EventQueue::addEvent(EventQueue::EVENT_SITE_PAGE_SPEED_CACHE_PURGE, $user, $eventData, $request); goto bad4d; b5d5f: $session = $request->getSession(); goto D123f; D123f: $siteUpdater = $this->getSiteUpdater($site); goto F85dc; eea98: $user = $this->getUser(); goto b5d5f; bad4d: $session->getFlashBag()->set("\163\x75\x63\x63\x65\163\163", $this->translator->trans("\x50\x61\147\x65\40\123\x70\x65\x65\144\x20\x43\141\143\x68\x65\x20\150\x61\163\x20\142\x65\x65\x6e\40\x70\165\162\x67\145\144\x2e")); goto Dba3d; F85dc: $siteUpdater->purgePageSpeedCache(); goto c46ef; c46ef: $eventData = ["\163\x69\164\x65" => $site->getDomainName()]; goto fc4cd; Dba3d: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\x64\x61\156\147\x65\162", $this->translator->trans("\x41\x6e\40\145\162\162\x6f\x72\x20\150\141\x73\x20\157\143\x63\165\162\x72\x65\x64\54\40\145\x72\162\x6f\162\40\155\145\163\x73\141\147\x65\x3a\x20\45\145\162\162\x6f\x72\115\x65\163\x73\x61\147\x65\x25", ["\45\x65\x72\x72\x6f\162\x4d\145\x73\163\x61\147\x65\x25" => $e->getMessage()])); } goto Bc6aa; Bac5c: return $response; goto A378b; a54cc: D36f5: goto e1ccb; f225a: if (false === is_null($site)) { goto D36f5; } goto a641f; Ae3fe: } private function createDomainSettingsForm(Site $site, array $data) : Form { goto de5d7; de5d7: $form = $this->createForm("\x41\x70\x70\x5c\x46\x6f\x72\155\x5c\123\x69\x74\x65\104\x6f\x6d\x61\151\x6e\x53\145\x74\x74\151\156\147\x73\x54\x79\x70\x65", $data, ["\x61\143\x74\151\157\x6e" => $this->generateUrl("\143\x6c\x70\137\163\x69\x74\x65\137\x73\x65\x74\164\x69\x6e\x67\163", ["\144\x6f\155\x61\151\156\116\x61\155\x65" => $site->getDomainName()]), "\155\145\164\150\157\x64" => "\x50\x4f\x53\124", "\x61\x74\x74\x72" => []]); goto B9217; B9217: $form->add("\163\165\x62\x6d\151\x74", SubmitType::class, ["\x61\x74\164\x72" => ["\x63\154\141\x73\x73" => "\x62\x74\156\40\x62\x74\x6e\x2d\x62\x6c\x75\x65\x20\x62\x74\x6e\55\x6c\x67"], "\x6c\141\x62\x65\x6c" => "\123\141\x76\x65"]); goto Cbf6b; Cbf6b: return $form; goto c8f26; c8f26: } private function createSiteUserSettingsForm(Site $site, array $data) : Form { goto Cb547; C896e: $form->add("\x73\x75\x62\x6d\x69\164", SubmitType::class, ["\141\164\x74\162" => ["\x63\154\141\x73\x73" => "\142\164\x6e\x20\142\164\x6e\x2d\x62\154\165\145\40\142\x74\x6e\x2d\x6c\x67"], "\x6c\x61\x62\145\154" => "\x53\x61\166\145"]); goto b9cad; Cb547: $form = $this->createForm("\101\x70\160\134\106\x6f\162\x6d\134\123\151\164\x65\125\163\145\162\x53\145\x74\164\151\x6e\x67\x73\124\171\x70\x65", $data, ["\141\143\164\151\x6f\156" => $this->generateUrl("\x63\154\x70\x5f\x73\151\x74\x65\137\163\145\164\x74\151\x6e\147\x73", ["\144\157\x6d\x61\151\156\116\141\155\145" => $site->getDomainName()]), "\155\x65\x74\150\x6f\x64" => "\120\x4f\123\124", "\141\x74\164\x72" => []]); goto C896e; b9cad: return $form; goto a87fd; a87fd: } private function createPageSpeedSettingsForm(Site $site, array $data) : Form { goto A922a; ab94e: $form->add("\163\165\142\155\151\164", SubmitType::class, ["\x61\164\x74\x72" => ["\143\x6c\x61\163\163" => "\x62\x74\x6e\40\x62\164\x6e\x2d\x62\154\165\145\40\x62\164\156\55\154\x67"], "\x6c\x61\x62\145\x6c" => "\x53\141\166\145"]); goto fb905; fb905: return $form; goto ef513; A922a: $form = $this->createForm("\x41\160\x70\134\106\157\x72\155\134\x53\x69\164\145\120\x61\147\x65\123\160\145\145\144\123\145\164\164\x69\156\x67\163\124\171\160\x65", $data, ["\141\x63\x74\x69\157\156" => $this->generateUrl("\143\x6c\x70\x5f\x73\x69\x74\145\x5f\x73\145\x74\164\x69\156\147\163", ["\144\157\x6d\141\x69\x6e\x4e\141\x6d\145" => $site->getDomainName()]), "\x6d\145\x74\150\x6f\144" => "\x50\117\x53\x54", "\x61\x74\164\162" => []]); goto ab94e; ef513: } private function createReverseProxySettingsForm(Site $site) : Form { goto Be88e; Be88e: $data = ["\162\145\x76\x65\x72\x73\145\x50\x72\157\170\171\x55\162\x6c" => $site->getReverseProxyUrl()]; goto d8c25; dfab0: return $form; goto D97be; Ea02c: $form->add("\163\165\142\155\x69\164", SubmitType::class, ["\141\x74\164\x72" => ["\x63\x6c\x61\x73\x73" => "\x62\x74\156\x20\x62\164\x6e\55\x62\154\x75\145\40\142\164\156\55\x6c\x67"], "\x6c\141\x62\x65\x6c" => "\123\141\166\x65"]); goto dfab0; d8c25: $form = $this->createForm("\x41\x70\160\x5c\106\157\x72\x6d\134\123\151\164\145\122\145\x76\145\x72\163\x65\120\x72\157\170\x79\123\145\164\x74\151\156\x67\x73\124\171\160\x65", $data, ["\x61\x63\164\x69\157\x6e" => $this->generateUrl("\143\154\x70\x5f\x73\x69\164\x65\x5f\x73\x65\x74\x74\x69\x6e\147\x73", ["\x64\x6f\x6d\141\151\x6e\116\141\x6d\x65" => $site->getDomainName()]), "\x6d\145\164\150\157\144" => "\120\x4f\x53\124", "\x61\164\x74\x72" => ["\x69\144" => "\x72\145\166\x65\x72\x73\x65\55\x70\x72\x6f\x78\x79\x2d\x73\145\164\x74\151\x6e\147\x73\55\x66\157\162\x6d"]]); goto Ea02c; D97be: } private function createNodejsSettingsForm(Site $site, NodejsSettings $nodejsSettings) : Form { goto C7b2d; F8b04: $form->add("\163\x75\x62\155\151\164", SubmitType::class, ["\x61\164\164\x72" => ["\143\x6c\x61\x73\x73" => "\142\164\x6e\x20\142\164\156\55\142\154\x75\145\40\x62\164\x6e\55\x6c\147"], "\154\141\142\x65\x6c" => "\x53\141\x76\x65"]); goto fbee5; fbee5: return $form; goto Ef177; C7b2d: $form = $this->createForm("\101\160\160\x5c\x46\157\x72\155\134\123\x69\164\145\x4e\157\x64\145\152\x73\x53\x65\x74\x74\x69\x6e\147\x73\124\171\160\145", $nodejsSettings, ["\141\143\x74\x69\x6f\156" => $this->generateUrl("\x63\154\160\x5f\163\x69\x74\x65\x5f\x73\145\x74\164\151\x6e\x67\x73", ["\x64\157\x6d\x61\151\156\116\141\x6d\145" => $site->getDomainName()]), "\x6d\x65\x74\x68\x6f\x64" => "\120\x4f\123\x54", "\141\x74\x74\x72" => ["\x69\144" => "\156\157\144\145\x6a\163\x2d\x73\x65\x74\x74\151\156\147\x73\x2d\146\157\162\x6d"]]); goto F8b04; Ef177: } private function createPhpSettingsForm(Site $site, PhpSettings $phpSettings) : Form { goto A2d60; A2d60: $form = $this->createForm("\x41\160\x70\134\106\157\162\155\x5c\123\x69\164\145\x50\150\x70\x53\145\x74\164\x69\x6e\x67\163\x54\171\160\x65", $phpSettings, ["\141\143\164\x69\157\156" => $this->generateUrl("\x63\x6c\x70\137\x73\x69\x74\x65\137\163\145\164\x74\151\156\147\x73", ["\x64\157\155\x61\x69\x6e\116\141\155\x65" => $site->getDomainName()]), "\155\x65\164\150\157\144" => "\120\x4f\123\124", "\x61\164\164\162" => []]); goto f79c4; Eb679: return $form; goto f8ddc; f79c4: $form->add("\x73\x75\x62\x6d\x69\164", SubmitType::class, ["\141\x74\164\162" => ["\x63\154\x61\x73\163" => "\142\164\156\40\142\164\x6e\x2d\142\154\x75\x65\x20\x62\164\156\55\154\x67"], "\154\x61\142\145\154" => "\123\x61\x76\145"]); goto Eb679; f8ddc: } private function createPythonSettingsForm(Site $site, PythonSettings $pythonSettings) : Form { goto d5ca6; bf10f: $form->add("\x73\x75\x62\x6d\151\x74", SubmitType::class, ["\x61\x74\164\x72" => ["\143\x6c\x61\x73\163" => "\x62\x74\156\x20\142\x74\x6e\x2d\x62\x6c\165\x65\x20\x62\164\x6e\55\154\x67"], "\x6c\x61\142\145\154" => "\123\x61\166\145"]); goto C3ad2; d5ca6: $form = $this->createForm("\x41\160\x70\134\x46\x6f\x72\x6d\x5c\123\x69\164\145\120\x79\x74\x68\x6f\156\x53\145\x74\x74\x69\x6e\147\x73\124\x79\160\145", $pythonSettings, ["\141\143\164\151\x6f\156" => $this->generateUrl("\143\154\x70\x5f\163\x69\x74\145\137\x73\145\164\164\151\156\x67\163", ["\144\x6f\155\x61\x69\156\x4e\x61\x6d\x65" => $site->getDomainName()]), "\155\x65\x74\150\157\x64" => "\x50\117\x53\x54", "\x61\164\x74\x72" => []]); goto bf10f; C3ad2: return $form; goto D993f; D993f: } private function createSiteDeleteForm(Site $site, array $data) : Form { goto Bb531; D4f4d: return $form; goto C8c15; c1cc1: $form->add("\163\165\142\155\151\164", SubmitType::class, ["\x61\164\x74\x72" => ["\143\154\x61\163\163" => "\142\x74\156\40\142\164\x6e\55\x62\x6c\165\x65\x20\x62\164\x6e\55\154\x67", "\x64\151\x73\141\x62\x6c\x65\x64" => "\144\151\x73\141\142\x6c\x65\x64"], "\154\141\x62\145\x6c" => "\104\145\x6c\x65\x74\145\40\x53\x69\164\145"]); goto D4f4d; Bb531: $form = $this->createForm("\x41\x70\x70\134\106\157\162\155\x5c\x53\x69\164\145\x44\x65\x6c\x65\164\x65\124\x79\x70\x65", $data, ["\141\143\164\151\x6f\x6e" => $this->generateUrl("\143\154\x70\137\163\151\x74\x65\137\163\x65\x74\164\151\x6e\147\x73", ["\144\157\x6d\x61\151\156\x4e\141\x6d\145" => $site->getDomainName()]), "\155\145\x74\x68\x6f\144" => "\x50\117\x53\124", "\x61\x74\164\x72" => []]); goto c1cc1; C8c15: } private function handleDomainSettingsForm(Request $request, Form $form, Site $site) { goto ade48; C7e69: try { goto e5e0a; Ff2af: EventQueue::addEvent(EventQueue::EVENT_SITE_ROOT_DIRECTORY_UPDATE, $user, $eventData, $request); goto A7229; F8d91: $site->setRootDirectory($rootDirectory); goto D7e01; aa514: $domainName = $site->getDomainName(); goto C9818; Bd47f: $session = $request->getSession(); goto aa514; aa1b4: return $response; goto e0e65; B4f9a: $siteUpdater->domainSettings(); goto A1146; D7e01: $siteEntity->setRootDirectory($rootDirectory); goto e1376; Bdfcc: $response = $this->redirect($this->generateUrl("\143\x6c\x70\137\163\x69\164\145\137\163\145\164\x74\151\156\x67\x73", ["\x64\157\x6d\141\151\156\116\x61\x6d\145" => $site->getDomainName()])); goto aa1b4; E0806: $siteUpdater = $this->getSiteUpdater($site); goto B4f9a; e1376: $this->siteEntityManager->updateEntity($siteEntity); goto E0806; A1146: $eventData = ["\x73\151\x74\x65" => $domainName, "\x72\157\157\x74\x44\151\162\x65\x63\x74\x6f\x72\x79" => $rootDirectory]; goto Ff2af; F8b83: if (!(false === is_null($siteEntity))) { goto dcd86; } goto b2b6e; C9818: $siteEntity = $this->getSiteEntity($domainName); goto F8b83; e5e0a: $user = $this->getUser(); goto Bd47f; A7229: $session->getFlashBag()->set("\x73\165\143\143\x65\x73\163", $this->translator->trans("\122\157\157\164\x20\x44\151\162\x65\x63\x74\x6f\162\171\40\150\141\x73\x20\142\x65\x65\x6e\40\x73\x61\166\x65\x64\x2e")); goto ee2f9; ee2f9: dcd86: goto Bdfcc; b2b6e: $rootDirectory = rtrim($form->get("\162\157\157\164\x44\151\162\x65\x63\x74\x6f\x72\x79")->getData(), "\x2f"); goto F8d91; e0e65: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\x65\162", $this->translator->trans("\x41\x6e\40\x65\x72\162\x6f\162\40\150\x61\163\40\x6f\143\x63\165\x72\x72\x65\x64\x2c\x20\x65\162\162\157\162\x20\x6d\x65\163\x73\x61\147\x65\72\x20\45\x65\x72\162\x6f\x72\115\145\163\x73\x61\147\145\x25", ["\x25\145\162\162\x6f\162\115\145\x73\x73\x61\x67\145\45" => $e->getMessage()])); } goto D5a2b; fd1f5: $this->formErrors = $this->getErrorMessages($form); goto eabfd; a2c2a: D327e: goto C7e69; D5a2b: Be131: goto cc394; ade48: if (true === $form->isValid()) { goto D327e; } goto fd1f5; eabfd: goto Be131; goto a2c2a; cc394: } private function handleSiteUserSettingsForm(Request $request, Form $form, Site $site) { goto Bc04d; a7416: e6cb3: goto ca3f4; A01af: F6567: goto a9169; D297f: goto F6567; goto a7416; ca3f4: try { goto Ec036; fd612: $domainName = $site->getDomainName(); goto cda86; f36ec: return $response; goto C801c; B0cf6: $siteUser = $site->getUser(); goto b5b2d; b5b2d: $sshKeys = trim($form->get("\163\x73\150\113\145\x79\x73")->getData()); goto e90d9; cda86: $siteEntity = $this->getSiteEntity($domainName); goto C9a43; C0963: $siteUpdater->updateUserSShKeys($siteUser, $sshKeys); goto B0f8c; C9a43: if (!(false === is_null($siteEntity))) { goto cfcfb; } goto B0cf6; B6597: $siteUpdater = $this->getSiteUpdater($site); goto C0963; Cf7e1: $response = $this->redirect($this->generateUrl("\x63\x6c\160\x5f\163\x69\164\x65\x5f\x73\145\x74\164\x69\156\x67\x73", ["\144\x6f\x6d\141\151\x6e\x4e\x61\x6d\145" => $site->getDomainName()])); goto f36ec; F9f79: cfcfb: goto Cf7e1; Ab3fd: $siteEntity->setSshKeys($sshKeys); goto af097; e90d9: $password = trim($form->get("\160\141\x73\x73\167\x6f\x72\144")->getData()); goto Ab3fd; E1b43: $session->getFlashBag()->set("\x73\x75\143\143\145\x73\163", $this->translator->trans("\123\x69\164\x65\x20\125\163\x65\x72\x20\123\145\164\164\151\x6e\147\x73\40\x68\141\166\x65\40\142\x65\x65\156\40\163\x61\x76\x65\x64\56")); goto F9f79; C8315: $siteUpdater->changeUserPassword($siteUser, $password); goto bf454; Ec036: $user = $this->getUser(); goto B4cef; E155d: EventQueue::addEvent(EventQueue::EVENT_SITE_USER_SETTINGS_UPDATE, $user, $eventData, $request); goto E1b43; af097: $this->siteEntityManager->updateEntity($siteEntity); goto B6597; B4cef: $session = $request->getSession(); goto fd612; B0f8c: if (!(false === empty($password))) { goto Be157; } goto C8315; c4552: $eventData = ["\x73\151\x74\145" => $domainName, "\163\163\x68\x4b\145\x79\x73" => $sshKeys]; goto E155d; bf454: Be157: goto c4552; C801c: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\147\145\162", $this->translator->trans("\101\156\40\145\162\x72\x6f\x72\40\150\x61\163\40\x6f\143\143\x75\x72\x72\x65\x64\54\40\x65\162\x72\x6f\162\40\155\x65\163\x73\x61\147\x65\72\40\x25\145\x72\162\157\162\x4d\x65\163\x73\141\147\145\x25", ["\x25\x65\x72\162\x6f\x72\115\145\x73\x73\141\147\145\x25" => $e->getMessage()])); } goto A01af; Bc04d: if (true === $form->isValid()) { goto e6cb3; } goto dbcfc; dbcfc: $this->formErrors = $this->getErrorMessages($form); goto D297f; a9169: } private function handlePageSpeedSettingsForm(Request $request, Form $form, Site $site) { goto F863c; d8cf6: Bc07b: goto Dc7e0; F863c: if (true === $form->isValid()) { goto B9c86; } goto ae645; B665c: try { goto Cd35f; e5296: $settings = trim($form->get("\x73\145\x74\164\151\x6e\x67\163")->getData()); goto B2a24; F4ed1: $eventData = ["\163\x69\x74\145" => $domainName, "\x70\141\x67\x65\123\160\x65\145\x64\x45\x6e\x61\x62\154\145\144" => $isEnabled, "\x70\x61\147\x65\123\160\145\145\x64\x53\145\x74\164\151\x6e\x67\x73" => $settings]; goto Ba751; Ac359: $response = $this->redirect($this->generateUrl("\x63\154\x70\137\163\x69\164\x65\x5f\x73\145\x74\x74\151\156\x67\163", ["\x64\x6f\155\141\151\156\116\141\155\145" => $site->getDomainName()])); goto Df494; Fb390: $siteEntity->setPageSpeedEnabled($isEnabled); goto a4279; eb0bd: $site->setPageSpeedSettings($settings); goto ed135; d3e07: $session->getFlashBag()->set("\163\x75\143\x63\145\163\163", $this->translator->trans("\120\141\x67\x65\40\x53\x70\x65\145\x64\40\123\x65\164\x74\151\x6e\147\x73\40\x68\141\x76\x65\40\x62\x65\145\x6e\40\x73\x61\x76\x65\144\x2e")); goto Fb411; B2a24: $site->setPageSpeedEnabled($isEnabled); goto eb0bd; ed135: $siteUpdater = $this->getSiteUpdater($site); goto Fe5d1; C7390: $siteUpdater->purgePageSpeedCache(); goto Fb390; Cd35f: $user = $this->getUser(); goto Ed0fb; fbe04: $siteEntity = $this->getSiteEntity($domainName); goto ea066; Ed0fb: $session = $request->getSession(); goto c1849; a4279: $siteEntity->setPageSpeedSettings($settings); goto C9b57; c1849: $domainName = $site->getDomainName(); goto fbe04; Ba751: EventQueue::addEvent(EventQueue::EVENT_SITE_PAGE_SPEED_SETTINGS_UPDATE, $user, $eventData, $request); goto d3e07; Df494: return $response; goto D7b96; Fe5d1: $siteUpdater->updateNginxVhostWithRollback(); goto C7390; ea066: if (!(false === is_null($siteEntity))) { goto C5125; } goto d6c10; Fb411: C5125: goto Ac359; C9b57: $this->siteEntityManager->updateEntity($siteEntity); goto F4ed1; d6c10: $isEnabled = $form->get("\x69\163\x45\156\x61\x62\x6c\145\x64")->getData(); goto e5296; D7b96: } catch (InvalidVhostException $e) { $session->getFlashBag()->set("\144\x61\x6e\x67\145\x72", $this->translator->trans("\120\x61\x67\145\123\160\x65\145\144\40\123\x65\x74\164\x69\x6e\x67\40\141\162\145\40\x6e\x6f\164\40\166\141\x6c\x69\x64\54\40\145\x72\x72\x6f\162\40\x6d\145\163\x73\141\x67\x65\x3a\40\45\x65\x72\x72\157\162\x4d\x65\163\x73\x61\147\x65\45", ["\45\x65\162\162\x6f\162\115\x65\163\x73\x61\147\x65\x25" => $e->getMessage()])); } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\x67\x65\162", $this->translator->trans("\101\156\40\145\162\x72\157\x72\40\x68\141\163\x20\x6f\143\x63\x75\x72\162\x65\x64\x2c\40\x65\162\x72\x6f\x72\40\x6d\x65\163\x73\x61\x67\x65\72\x20\45\x65\162\162\157\x72\x4d\x65\x73\x73\x61\x67\x65\45", ["\45\x65\x72\162\157\x72\x4d\x65\x73\x73\x61\x67\145\x25" => $e->getMessage()])); } goto d8cf6; ae645: $this->formErrors = $this->getErrorMessages($form); goto C7aca; db7b4: B9c86: goto B665c; C7aca: goto Bc07b; goto db7b4; Dc7e0: } private function handleSiteDeleteForm(Request $request, Form $form, Site $site) { goto F9e1f; a6bc8: De923: goto aaee8; f0e19: try { goto ce107; cb183: return $response; goto a8c30; Aca42: $siteEntity = $this->getSiteEntity($domainName); goto Ad0e6; Fd7f0: $siteDeleter = $this->getSiteDeleter($site); goto Af4d7; ce107: $user = $this->getUser(); goto Ea284; aa01a: $response = $this->redirect($this->generateUrl("\x63\154\160\137\x73\x69\x74\x65\x73")); goto cb183; D170d: EventQueue::addEvent(EventQueue::EVENT_SITE_DELETE, $user, $eventData, $request); goto bdce6; bdce6: $session->getFlashBag()->set("\x73\x75\143\143\x65\163\x73", $this->translator->trans("\123\x69\x74\145\40\150\x61\x73\x20\142\145\x65\156\x20\x64\145\x6c\x65\164\x65\144\x2e")); goto efaab; efaab: Bfee0: goto aa01a; Af4d7: $siteDeleter->delete(); goto C60a5; ad048: $eventData = ["\163\151\164\x65" => $domainName, "\164\x79\x70\145" => $site->getType()]; goto D170d; f1bf0: $domainName = $site->getDomainName(); goto Aca42; Ad0e6: if (!(false === is_null($siteEntity))) { goto Bfee0; } goto Fd7f0; C60a5: $this->siteEntityManager->deleteEntity($siteEntity); goto ad048; Ea284: $session = $request->getSession(); goto f1bf0; a8c30: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\x67\x65\x72", $this->translator->trans("\101\156\x20\x65\162\162\x6f\x72\x20\x68\x61\163\40\157\143\x63\x75\x72\x72\x65\144\54\x20\145\162\x72\x6f\162\x20\x6d\145\163\163\141\x67\145\72\x20\x25\145\x72\162\157\162\x4d\145\163\163\141\x67\x65\45", ["\45\x65\x72\162\x6f\162\x4d\145\x73\x73\141\147\145\x25" => $e->getMessage()])); } goto a6bc8; A5519: F63a9: goto f0e19; C800b: goto De923; goto A5519; F9e1f: if (true === $form->isValid()) { goto F63a9; } goto f8730; f8730: $this->formErrors = $this->getErrorMessages($form); goto C800b; aaee8: } private function handleNodejsSettingsForm(Request $request, Form $form, NodejsSettings $currentNodejsSettings, Site $site) { goto Ebb8a; C7a93: goto e9a02; goto Dfbfb; d9a44: $this->formErrors = $this->getErrorMessages($form); goto C7a93; dcd59: try { goto d4d26; D2043: $hasNodejsVersionChanged = $currentNodejsSettings->getNodejsVersion() != $nodejsVersion; goto c6fb5; c9f33: EventQueue::addEvent(EventQueue::EVENT_SITE_NODEJS_SETTINGS_UPDATE, $user, $eventData, $request); goto Fe776; Cddc7: $domainName = $site->getDomainName(); goto dcf55; ed1b9: $siteUpdater->installNodejsVersion(); goto ec283; c6fb5: $siteUpdater = $this->getSiteUpdater($site); goto d5581; D52de: $this->siteEntityManager->updateEntity($siteEntity); goto Adbb1; f995e: $nodejsSettings = $form->getData(); goto d83b2; d5581: if (!(true === $hasNodejsVersionChanged)) { goto Ea62d; } goto ed1b9; dcf55: $siteEntity = $this->getSiteEntity($domainName); goto dc4c4; f0e05: f6953: goto dbd5e; B9a17: return $response; goto d4aa4; e0a51: $siteUpdater->nodejsSettings(); goto D52de; ec283: Ea62d: goto e0a51; dbd5e: $response = $this->redirect($this->generateUrl("\143\154\160\137\163\x69\164\145\x5f\163\x65\164\164\x69\x6e\147\163", ["\x64\157\x6d\x61\x69\156\x4e\141\x6d\145" => $site->getDomainName()])); goto B9a17; D3c72: $session = $request->getSession(); goto Cddc7; dc4c4: if (!(false === is_null($siteEntity))) { goto f6953; } goto f995e; Adbb1: $eventData = ["\163\x69\164\x65" => $domainName, "\156\157\144\x65\x6a\163\x56\x65\162\163\151\x6f\x6e" => $nodejsVersion, "\x70\157\162\x74" => $nodejsSettings->getPort()]; goto c9f33; d83b2: $nodejsVersion = $nodejsSettings->getNodejsVersion(); goto D2043; d4d26: $user = $this->getUser(); goto D3c72; Fe776: $session->getFlashBag()->set("\163\x75\143\143\x65\163\x73", $this->translator->trans("\116\157\x64\x65\x2e\152\163\40\x53\x65\x74\164\151\x6e\x67\163\40\150\x61\x76\145\x20\142\x65\x65\x6e\x20\x73\x61\166\145\x64\x2e")); goto f0e05; d4aa4: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\x67\145\162", $this->translator->trans("\101\x6e\x20\x65\162\162\x6f\x72\x20\150\141\x73\40\x6f\x63\143\165\x72\162\x65\x64\x2c\40\145\162\162\157\x72\40\x6d\145\x73\163\141\147\145\72\x20\x25\145\162\x72\x6f\162\115\x65\163\x73\141\x67\145\45", ["\x25\145\x72\x72\157\x72\x4d\x65\x73\x73\141\147\x65\x25" => $e->getMessage()])); } goto a8d3f; Dfbfb: A1725: goto dcd59; a8d3f: e9a02: goto Dfa77; Ebb8a: if (true === $form->isValid()) { goto A1725; } goto d9a44; Dfa77: } private function handlePythonSettingsForm(Request $request, Form $form, Site $site) { goto cdd14; Ebf54: goto E67cb; goto Db467; c4e60: E67cb: goto C12a7; Db467: fadf2: goto Fdbd9; cdd14: if (true === $form->isValid()) { goto fadf2; } goto F98ce; Fdbd9: try { goto bc02b; Fd0bc: $domainName = $site->getDomainName(); goto e16d2; c457c: $siteUpdater->pythonSettings(); goto bf7af; e1065: $pythonVersion = $pythonSettings->getPythonVersion(); goto a907d; Cff29: $session = $request->getSession(); goto Fd0bc; bf7af: $this->siteEntityManager->updateEntity($siteEntity); goto Ae7e2; a907d: $siteUpdater = $this->getSiteUpdater($site); goto d503c; E5a71: $response = $this->redirect($this->generateUrl("\x63\x6c\x70\x5f\163\151\x74\x65\137\163\145\164\164\x69\x6e\x67\163", ["\144\157\x6d\141\151\x6e\116\141\155\145" => $site->getDomainName()])); goto c0d9e; f6b5e: if (!(false === is_null($siteEntity))) { goto bf75a; } goto A4b72; A4b72: $pythonSettings = $form->getData(); goto e1065; e7fc3: bf75a: goto E5a71; d503c: $siteUpdater->writePythonVersionFile(); goto c457c; e16d2: $siteEntity = $this->getSiteEntity($domainName); goto f6b5e; bc02b: $user = $this->getUser(); goto Cff29; Ae7e2: $eventData = ["\163\151\164\x65" => $domainName, "\160\171\164\x68\x6f\156\126\145\x72\x73\151\x6f\x6e" => $pythonVersion, "\160\x6f\x72\x74" => $pythonSettings->getPort()]; goto d8e7f; df347: $session->getFlashBag()->set("\x73\x75\143\143\145\x73\x73", $this->translator->trans("\120\x79\164\150\x6f\x6e\40\x53\145\x74\x74\151\x6e\147\163\x20\x68\141\x76\145\x20\142\145\145\156\x20\163\141\166\x65\x64\x2e")); goto e7fc3; c0d9e: return $response; goto d215c; d8e7f: EventQueue::addEvent(EventQueue::EVENT_SITE_PYTHON_SETTINGS_UPDATE, $user, $eventData, $request); goto df347; d215c: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\x6e\147\145\x72", $this->translator->trans("\x41\x6e\x20\x65\162\162\157\x72\40\150\141\163\40\157\143\143\x75\162\162\x65\144\x2c\x20\x65\x72\x72\157\x72\x20\155\x65\x73\x73\x61\147\145\72\40\x25\x65\x72\x72\157\x72\x4d\145\x73\x73\141\147\x65\x25", ["\45\145\162\x72\x6f\162\115\145\163\x73\141\x67\145\x25" => $e->getMessage()])); } goto c4e60; F98ce: $this->formErrors = $this->getErrorMessages($form); goto Ebf54; C12a7: } private function handleReverseProxySettingsForm(Request $request, Form $form, Site $site) { goto D466d; D3b44: A89d9: goto f9929; f9929: try { goto cf679; De91d: $session = $request->getSession(); goto B54e1; e6022: EventQueue::addEvent(EventQueue::EVENT_SITE_REVERSE_PROXY_SETTINGS_UPDATE, $user, $eventData, $request); goto C0f4c; B54e1: $domainName = $site->getDomainName(); goto fed2d; Cf8ad: $response = $this->redirect($this->generateUrl("\x63\154\160\x5f\x73\x69\x74\145\x5f\163\x65\x74\x74\x69\156\147\x73", ["\x64\157\x6d\x61\151\x6e\116\141\x6d\x65" => $site->getDomainName()])); goto C8b36; C0f4c: $session->getFlashBag()->set("\x73\165\x63\143\x65\163\x73", $this->translator->trans("\x52\145\166\x65\x72\163\x65\40\x50\x72\157\x78\171\40\x53\x65\164\x74\x69\156\x67\163\40\x68\x61\166\x65\40\x62\x65\x65\156\40\163\141\166\145\x64\56")); goto e4288; B5431: $reverseProxyUrl = $form->get("\162\145\x76\145\162\x73\145\120\162\x6f\170\x79\125\x72\154")->getData(); goto a3496; c6198: $siteEntity->setReverseProxyUrl($reverseProxyUrl); goto db288; A7982: if (!(false === is_null($siteEntity))) { goto Ff98f; } goto B5431; e4bb3: $eventData = ["\163\x69\164\x65" => $domainName, "\162\145\166\x65\162\x73\x65\x50\x72\157\170\x79\125\162\154" => $reverseProxyUrl]; goto e6022; fed2d: $siteEntity = $this->getSiteEntity($domainName); goto A7982; e4288: Ff98f: goto Cf8ad; f51a4: $this->siteEntityManager->updateEntity($siteEntity); goto e4bb3; cf679: $user = $this->getUser(); goto De91d; a3496: $site->setReverseProxyUrl($reverseProxyUrl); goto c6198; C8b36: return $response; goto D0eb6; E8d5a: $siteUpdater->updateNginxVhostWithRollback(); goto f51a4; db288: $siteUpdater = $this->getSiteUpdater($site); goto E8d5a; D0eb6: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\141\156\x67\x65\162", $this->translator->trans("\101\156\x20\x65\x72\x72\x6f\162\40\x68\x61\163\40\x6f\x63\143\165\x72\162\x65\144\54\x20\145\x72\x72\x6f\162\40\155\145\x73\x73\141\147\145\72\40\45\x65\x72\162\x6f\x72\x4d\145\163\x73\141\147\145\x25", ["\45\x65\162\x72\x6f\162\115\145\163\163\141\147\x65\45" => $e->getMessage()])); } goto Fd9ba; D466d: if (true === $form->isValid()) { goto A89d9; } goto bb874; bb874: $this->formErrors = $this->getErrorMessages($form); goto c0e97; c0e97: goto e696b; goto D3b44; Fd9ba: e696b: goto edadb; edadb: } private function handlePhpSettingsForm(Request $request, Form $form, PhpSettings $currentPhpSettings, Site $site) { goto Dcca2; a83bf: goto Af8c3; goto ecd24; ecd24: e68d5: goto ad7c9; ad7c9: try { goto Cc365; F7b93: $session->getFlashBag()->set("\163\x75\x63\143\145\163\163", $this->translator->trans("\120\110\120\x20\123\x65\x74\164\x69\156\147\x73\40\x68\x61\166\145\40\x62\145\x65\x6e\40\163\141\x76\145\144\x2e")); goto Be7f1; eb63a: $siteUpdater->phpSettings(); goto F24c8; de4bc: $siteUpdater = $this->getSiteUpdater($site); goto e4ce8; bc152: $phpSettings = $form->getData(); goto ec4fc; Be7f1: cabe5: goto b4d2a; Cc365: $user = $this->getUser(); goto c6351; ebb79: if (!(false === is_null($siteEntity))) { goto cabe5; } goto bc152; e4ce8: if (!(true === $hasPhpVersionChanged)) { goto f6279; } goto d21c7; Daf9f: f6279: goto eb63a; f0c69: EventQueue::addEvent(EventQueue::EVENT_SITE_PHP_SETTINGS_UPDATE, $user, $eventData, $request); goto F7b93; d21c7: $siteUpdater->changePhpVersion($currentPhpSettings->getPhpVersion(), $phpSettings->getPhpVersion()); goto Daf9f; f924b: $eventData = ["\163\151\164\x65" => $domainName, "\160\x68\x70\126\x65\x72\163\151\157\156" => $phpSettings->getPhpVersion(), "\155\145\x6d\x6f\x72\171\x5f\x6c\x69\x6d\151\x74" => $phpSettings->getMemoryLimit(), "\155\141\170\137\x65\170\145\x63\165\164\151\157\x6e\137\164\x69\155\x65" => $phpSettings->getMaxExecutionTime(), "\x6d\x61\170\x5f\x69\156\x70\165\x74\x5f\164\x69\155\x65" => $phpSettings->getMaxInputTime(), "\x6d\141\170\x5f\151\156\x70\165\164\x5f\x76\141\162\163" => $phpSettings->getMaxInputVars(), "\x70\x6f\163\164\x5f\x6d\141\x78\137\x73\x69\x7a\145" => $phpSettings->getPostMaxSize(), "\165\x70\x6c\157\x61\x64\137\x6d\x61\x78\137\x66\x69\x6c\x65\163\151\172\145" => $phpSettings->getUploadMaxFileSize()]; goto f0c69; ec4fc: $hasPhpVersionChanged = $currentPhpSettings->getPhpVersion() != $phpSettings->getPhpVersion(); goto de4bc; F24c8: $this->siteEntityManager->updateEntity($siteEntity); goto f924b; C6e31: return $response; goto f9517; Bef91: $siteEntity = $this->getSiteEntity($domainName); goto ebb79; b4d2a: $response = $this->redirect($this->generateUrl("\143\154\160\x5f\x73\x69\x74\x65\x5f\163\x65\164\x74\151\156\147\163", ["\144\x6f\155\141\x69\x6e\116\141\x6d\x65" => $site->getDomainName()])); goto C6e31; c6351: $session = $request->getSession(); goto D2f2c; D2f2c: $domainName = $site->getDomainName(); goto Bef91; f9517: } catch (\Exception $e) { $this->logger->exception($e); $session->getFlashBag()->set("\144\x61\x6e\x67\145\162", $this->translator->trans("\x41\x6e\x20\145\162\162\x6f\162\40\x68\141\163\x20\x6f\x63\143\165\162\x72\x65\x64\x2c\40\x65\162\162\157\162\x20\155\x65\x73\163\141\147\x65\72\x20\45\x65\x72\162\x6f\x72\115\x65\163\163\141\147\145\45", ["\45\145\162\x72\157\162\x4d\145\163\x73\141\147\145\45" => $e->getMessage()])); } goto c8568; bcaed: $this->formErrors = $this->getErrorMessages($form); goto a83bf; Dcca2: if (true === $form->isValid()) { goto e68d5; } goto bcaed; c8568: Af8c3: goto e538c; e538c: } private function getSite(Request $request) : ?Site { goto f123b; d7c2e: $site->setRegistrableDomain($registrableDomain); goto a2922; d3a8b: $siteDatabases = $this->getSiteDatabases($siteEntity); goto C3b05; bc7b1: $site->setDatabases($siteDatabases); goto ebd1c; d27fe: $site->setPageSpeedEnabled($siteEntity->getPageSpeedEnabled()); goto c6bc2; Fe755: $siteType = $siteEntity->getType(); goto a1133; f123b: $user = $this->getUser(); goto C4906; F7df8: $siteEntity = $this->getSiteEntity($domainName); goto c2a9b; c192f: $site->setAllowTrafficFromCloudflareOnly($siteEntity->allowTrafficFromCloudflareOnly()); goto d27fe; C6bb7: $site->setSshKeys($siteEntity->getSshKeys()); goto C364c; Ce17f: $subdomain = false === empty($subdomain) ? $subdomain : null; goto d3a8b; f2771: $site->setCronJobs($siteEntity->getCronJobs()); goto fbf3b; C4906: $domainName = $request->get("\144\x6f\155\x61\x69\156\116\141\x6d\145"); goto F7df8; c8053: if (!(false === is_null($site))) { goto F51ef; } goto D4283; c2a9b: $site = null; goto C2295; C364c: $site->setVhostTemplate($siteEntity->getVhostTemplate()); goto c192f; Fef36: $site->setBlockedIps($siteEntity->getBlockedIps()); goto bc7b1; ebd1c: $site->setCertificate($siteEntity->getCertificate()); goto f6289; a1133: switch ($siteType) { case SiteEntity::TYPE_NODEJS: goto a301d; a301d: $site = new NodejsSite(); goto c3392; c3392: $site->setNodejsSettings($siteEntity->getNodejsSettings()); goto c65d3; c65d3: goto E4aa0; goto a28f1; a28f1: case SiteEntity::TYPE_STATIC: $site = new StaticSite(); goto E4aa0; case SiteEntity::TYPE_PHP: goto fde9c; fde9c: $site = new PhpSite(); goto F932c; F932c: $site->setPhpSettings($siteEntity->getPhpSettings()); goto e7f47; e7f47: $site->setVarnishCache($siteEntity->getVarnishCache()); goto a347f; a347f: goto E4aa0; goto d393f; d393f: case SiteEntity::TYPE_PYTHON: goto e4747; e4022: goto E4aa0; goto d94a3; C4d1f: $site->setPythonSettings($siteEntity->getPythonSettings()); goto e4022; e4747: $site = new PythonSite(); goto C4d1f; d94a3: case SiteEntity::TYPE_REVERSE_PROXY: goto fa346; fa346: $site = new ReverseProxySite(); goto C4069; C4069: $site->setReverseProxyUrl($siteEntity->getReverseProxyUrl()); goto D66c9; D66c9: goto E4aa0; goto ce2b8; ce2b8: } goto Fadd4; b3bb8: $subdomain = $resolvedDomainName->subDomain()->toString(); goto Ce17f; Ceb98: $site->setSshUsers($siteEntity->getSshUsers()); goto C6bb7; b176a: d8934: goto Ccb97; f6289: $site->setCertificates($siteEntity->getCertificates()); goto f2771; C2295: if (!(false === is_null($siteEntity))) { goto d8934; } goto cba3d; F0359: $site->setBlockedBots($siteEntity->getBlockedBots()); goto Fef36; B7f9f: E4aa0: goto c8053; Fcc49: $site->setRootDirectory($siteEntity->getRootDirectory()); goto Bd8ac; Fadd4: bd3b8: goto B7f9f; D4283: $resolvedDomainName = $this->domainNameParser->resolveDomainName($domainName); goto E3a6c; a2922: $site->setSubdomain($subdomain); goto Fcc49; c6bc2: $site->setPageSpeedSettings($siteEntity->getPageSpeedSettings()); goto a2d46; a2d46: F51ef: goto b176a; Bb2c5: $site->setDomainName($siteEntity->getDomainName()); goto d7c2e; cba3d: if (!(UserEntity::ROLE_USER == $user->getRole() && false === $user->hasSite($siteEntity))) { goto d3102; } goto Acd35; fbf3b: $site->setFtpUsers($siteEntity->getFtpUsers()); goto Ceb98; E3a6c: $registrableDomain = $resolvedDomainName->registrableDomain()->toString(); goto b3bb8; Acd35: return null; goto E8b23; Ccb97: return $site; goto Dc035; E8b23: d3102: goto Fe755; Bd8ac: $site->setBasicAuth($siteEntity->getBasicAuth()); goto F0359; C3b05: $site->setUser($siteEntity->getUser()); goto Bb2c5; Dc035: } private function getSiteDatabases(SiteEntity $siteEntity) : ?ArrayCollection { goto Aef7f; adccc: $databaseEntities = $siteEntity->getDatabases(); goto f33b5; f33b5: foreach ($databaseEntities as $databaseEntity) { goto f0b9b; b1079: B6f41: goto B47f2; B47f2: ea719: goto F5bef; C82a8: $siteDatabases->add($databaseEntity); goto b1079; f0b9b: $databaseServerEntity = $databaseEntity->getDatabaseServer(); goto ffb7e; ffb7e: if (!($databaseServerEntity->getId() == $activeDatabaseServerEntity->getId())) { goto B6f41; } goto C82a8; F5bef: } goto D9ad5; D9ad5: ed15f: goto F1072; Aef7f: $siteDatabases = new ArrayCollection(); goto A55cc; A55cc: $activeDatabaseServerEntity = $this->databaseServerEntityManager->getActiveDatabaseServer(); goto adccc; F1072: return $siteDatabases; goto ddb83; ddb83: } private function getSiteUpdater(Site $site) : ?SiteUpdater { goto cc08c; B169d: e093c: goto d0db0; E1d7c: $siteType = $site->getType(); goto Cb009; B0e57: return $siteUpdater; goto bfe15; Cb009: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteUpdater = new NodejsSiteUpdater($site); goto B1cf0; case SiteEntity::TYPE_STATIC: $siteUpdater = new StaticSiteUpdater($site); goto B1cf0; case SiteEntity::TYPE_PHP: $siteUpdater = new PhpSiteUpdater($site); goto B1cf0; case SiteEntity::TYPE_PYTHON: $siteUpdater = new PythonSiteUpdater($site); goto B1cf0; case SiteEntity::TYPE_REVERSE_PROXY: $siteUpdater = new ReverseProxySiteUpdater($site); goto B1cf0; } goto B169d; cc08c: $siteUpdater = null; goto E1d7c; d0db0: B1cf0: goto B0e57; bfe15: } protected function getSiteDeleter(Site $site) : ?SiteDeleter { goto b1bf1; f976e: switch ($siteType) { case SiteEntity::TYPE_NODEJS: $siteDeleter = new NodejsSiteDeleter($site); goto Aa263; case SiteEntity::TYPE_STATIC: $siteDeleter = new StaticSiteDeleter($site); goto Aa263; case SiteEntity::TYPE_PHP: $siteDeleter = new PhpSiteDeleter($site); goto Aa263; case SiteEntity::TYPE_PYTHON: $siteDeleter = new PythonSiteDeleter($site); goto Aa263; case SiteEntity::TYPE_REVERSE_PROXY: $siteDeleter = new ReverseProxySiteDeleter($site); goto Aa263; } goto B44a1; Bdf43: $siteType = $site->getType(); goto f976e; B44a1: C8dd5: goto F6cda; F6cda: Aa263: goto Bdbe1; b1bf1: $siteDeleter = null; goto Bdf43; Bdbe1: return $siteDeleter; goto dde87; dde87: } private function getSiteEntity(string $domainName) : ?SiteEntity { $siteEntity = $this->siteEntityManager->findOneByDomainName($domainName); return $siteEntity; } }
