<?php
 namespace App\EventListener; use Symfony\Component\HttpKernel\Event\RequestEvent; use Symfony\Component\EventDispatcher\EventSubscriberInterface; use Symfony\Component\Console\Event\ConsoleCommandEvent; use Symfony\Component\HttpKernel\KernelEvents; use Symfony\Component\Console\ConsoleEvents; use Symfony\Contracts\Cache\ItemInterface; use Psr\Cache\CacheItemPoolInterface as CachePool; use GuzzleHttp\Client as HttpClient; use GuzzleHttp\Psr7\Request; use Twig\Environment as TwigEnvironment; use App\Entity\Manager\ConfigManager; use App\Entity\Manager\UserManager; use App\Entity\Manager\DatabaseServerManager; use App\Command\Command; use App\Util\PasswordGenerator; use App\CloudPanel\Environment as CloudPanelEnvironment; use App\CloudPanel\Aws\Instance as AwsInstance; use App\CloudPanel\Do\Instance as DoInstance; use App\CloudPanel\Gce\Instance as GceInstance; use App\CloudPanel\Hetzner\Instance as HetznerInstance; use App\CloudPanel\Vultr\Instance as VultrInstance; use App\CloudPanel\Instance; use App\Do\Client as DoClient; use App\Gce\Client as GceClient; use App\Hetzner\Client as HetznerClient; use App\Vultr\Client as VultrClient; use App\System\CommandExecutor; use App\System\Command\ChangeDatabaseUserPasswordCommand; use App\Entity\DatabaseServer; use App\Service\Crypto; use App\Site\Ssl\Generator\RsaKeyGenerator; use App\Database\Connection as DatabaseConnection; use App\Util\Retry; class InitializeListener implements EventSubscriberInterface { private const IP_REQUEST_URL = "\x68\x74\x74\x70\x73\x3a\57\57\144\x33\161\156\144\65\64\161\70\x67\x62\63\x6a\x65\56\x63\x6c\157\x75\144\x66\162\157\x6e\x74\x2e\156\145\164\x2f"; private ConfigManager $configManager; private DatabaseServerManager $databaseServerManager; private UserManager $userManager; private CachePool $cachePool; private TwigEnvironment $twig; public function __construct(ConfigManager $configManager, DatabaseServerManager $databaseServerManager, UserManager $userManager, CachePool $cachePool, TwigEnvironment $twig) { goto F9eda; E1f23: $this->twig = $twig; goto D63be; dd34c: $this->databaseServerManager = $databaseServerManager; goto e6ef8; e6ef8: $this->userManager = $userManager; goto E921c; E921c: $this->cachePool = $cachePool; goto E1f23; F9eda: $this->configManager = $configManager; goto dd34c; D63be: } public function onKernelRequest(RequestEvent $event) : void { goto F07fa; F07fa: if (!(false === $event->isMainRequest())) { goto bbd15; } goto E5539; Babf4: bbd15: goto Cf14c; Cf14c: $this->initialize($event); goto Be733; E5539: return; goto Babf4; Be733: } public function onConsoleCommand(ConsoleCommandEvent $event) : void { goto Ec263; Ec263: $command = $event->getCommand(); goto E850d; E850d: if (!$command instanceof Command) { goto d7fd3; } goto cbfdb; cbfdb: $this->initialize($event); goto A1a01; A1a01: d7fd3: goto b5b20; b5b20: } private function initialize(RequestEvent|ConsoleCommandEvent $event) : void { goto D9dc9; C8223: $this->setDatabaseServer($event); goto B2787; B2787: $this->setEnvironment($event); goto C1850; D4b52: $this->setCloudPanelVersion(); goto Bf1e0; dc274: $this->setLetsEncryptPrivateKey(); goto C8223; D9dc9: $this->setTimezone(); goto D43a6; Bf1e0: $this->setCloudPanelReleaseChannel(); goto dc274; D43a6: $this->setInstanceUid(); goto D4b52; C1850: } private function setTimezone() : void { goto Defde; Defde: $timezone = $this->configManager->get("\x74\151\155\145\x7a\157\156\x65"); goto d699f; A6d52: $this->configManager->set("\164\151\x6d\145\x7a\x6f\156\x65", "\125\x54\x43"); goto E013c; E013c: F2c5f: goto Efa8f; d699f: if (!(true === is_null($timezone))) { goto F2c5f; } goto A6d52; Efa8f: } private function setInstanceUid() : void { goto c077d; c077d: $instanceUid = $this->configManager->get("\151\x6e\x73\164\141\x6e\x63\145\137\x75\x69\x64"); goto fe40a; b7ab8: ca49b: goto dd8b2; fe40a: if (!(true === is_null($instanceUid))) { goto ca49b; } goto E58ef; E58ef: $instanceUid = substr(sha1(uniqid(mt_rand(), true)), 0, 16); goto Fa31b; Fa31b: $this->configManager->set("\151\x6e\x73\164\141\x6e\143\x65\x5f\165\x69\x64", $instanceUid); goto b7ab8; dd8b2: } private function setCloudPanelVersion() : void { goto a6865; b182c: if (!(false === is_null($appVersion))) { goto c2f53; } goto f218f; a6865: $appVersion = $_ENV["\x41\x50\x50\137\126\105\x52\123\111\117\116"] ?? null; goto b182c; f218f: $this->configManager->set("\141\160\160\137\166\x65\162\163\x69\157\x6e", trim($appVersion)); goto ea191; ea191: c2f53: goto b7208; b7208: } private function setCloudPanelReleaseChannel() : void { goto Cf14e; Cf14e: $releaseChannel = $this->configManager->get("\x72\x65\154\x65\x61\x73\x65\x5f\x63\x68\x61\156\x6e\x65\154"); goto d7e0e; A06de: a4ba8: goto Dcb4b; d7e0e: if (!(true === is_null($releaseChannel))) { goto a4ba8; } goto b6c0f; b6c0f: $this->configManager->set("\x72\145\154\x65\x61\163\145\x5f\143\150\141\156\156\x65\154", CloudPanelEnvironment::RELEASE_CHANNEL_STABLE); goto A06de; Dcb4b: } private function setLetsEncryptPrivateKey() { goto e09f8; E641a: D59e2: goto E76f2; c4b09: $this->configManager->set("\154\145\137\160\162\x69\x76\141\164\x65\137\x6b\145\171", $privateKey->getPEM()); goto b72e2; aca5d: if (!(0 < $numberOfUsers)) { goto D59e2; } goto daf4e; F5922: $privateKey = $rsaKeyGenerator->generatePrivateKey(); goto c4b09; c9f5c: if (!(true === is_null($letsEncryptPrivateKey))) { goto a2f51; } goto c4aa4; b72e2: a2f51: goto E641a; c4aa4: $rsaKeyGenerator = new RsaKeyGenerator(); goto F5922; e09f8: $numberOfUsers = $this->userManager->countAll(); goto aca5d; daf4e: $letsEncryptPrivateKey = $this->configManager->get("\154\145\137\x70\x72\x69\166\x61\164\x65\x5f\153\x65\171"); goto c9f5c; E76f2: } private function setDatabaseServer(RequestEvent|ConsoleCommandEvent $event) : void { goto d22cb; a6c53: $tmpDatabaseServer = clone $databaseServer; goto D7aa1; e90d5: $changeDatabaseUserPasswordCommand = new ChangeDatabaseUserPasswordCommand(); goto B0408; b4416: $databaseServer->setHost("\61\62\x37\x2e\x30\56\60\x2e\x31"); goto bd083; cb373: $commandExecutor = new CommandExecutor(); goto e90d5; f7994: $databaseServer->setPassword(Crypto::encrypt("\162\157\157\164")); goto af4ca; e5c68: B04f0: goto a95ff; d97e8: $databaseServer->setVersion($databaseConnection->getVersion()); goto dbfec; F112f: $databaseServer->setEngine($databaseConnection->getEngine()); goto d97e8; df221: $this->databaseServerManager->updateEntity($databaseServer); goto be0bd; F4939: $commandExecutor->execute($changeDatabaseUserPasswordCommand); goto B406e; C8544: $databaseServers = $this->databaseServerManager->findAll(); goto F2d2e; Dad13: $password = $passwordGenerator->generate(); goto D7fc7; A84fc: $databaseServer->setIsDefault(true); goto Cc08e; B0408: $changeDatabaseUserPasswordCommand->setUserName("\x72\157\157\x74"); goto B7e7d; Efe3c: $password = "\162\x6f\x6f\164"; goto e5c68; F9636: $databaseServer->setIsActive(true); goto A84fc; Cc08e: $databaseConnection = new DatabaseConnection($databaseServer); goto F112f; d22cb: $numberOfUsers = $this->userManager->countAll(); goto C8544; B7e7d: $changeDatabaseUserPasswordCommand->setNewPassword($password); goto f596d; dbfec: $databaseServer->setPassword($encryptedPassword); goto E6844; bd083: $databaseServer->setUserName("\x72\157\x6f\164"); goto f7994; D7fc7: goto B04f0; goto f61f5; f596d: $changeDatabaseUserPasswordCommand->setDatabaseServer($tmpDatabaseServer); goto F4939; bbd5b: $databaseServer = $this->databaseServerManager->createEntity(); goto b4416; D7aa1: $tmpDatabaseServer->setPassword("\x72\157\157\x74"); goto cb373; B4ed6: $passwordGenerator = new PasswordGenerator(); goto Dad13; a95ff: $encryptedPassword = Crypto::encrypt($password); goto bbd5b; f61f5: ff33d: goto Efe3c; F7036: if ("\144\x65\166" == $_ENV["\x41\x50\120\137\105\116\126"]) { goto ff33d; } goto B4ed6; B406e: Ed27d: goto df221; F2d2e: if (!(0 < $numberOfUsers && 0 == count($databaseServers))) { goto ffebb; } goto F7036; E6844: if (!("\x64\145\166" != $_ENV["\101\x50\x50\x5f\105\116\126"])) { goto Ed27d; } goto a6c53; be0bd: ffebb: goto B765c; af4ca: $databaseServer->setPort(DatabaseServer::DEFAULT_PORT); goto F9636; B765c: } private function setEnvironment(RequestEvent|ConsoleCommandEvent $event) : void { goto fff0d; c0dea: $ipv4PublicIp = ''; goto d8af9; bca12: C3346: goto C3fe6; a1764: F420c: goto c48f8; bb049: goto C75dd; goto F197b; d1469: $instanceUid = $this->configManager->get("\151\156\x73\x74\141\x6e\x63\x65\x5f\165\x69\144"); goto c5019; fd7cf: $instance->setUid($instanceUid); goto bca12; a80d7: $isDarkMode = false === is_null($request->cookies->get("\x74\x68\145\x6d\145")) && "\x64\141\162\153" == $request->cookies->get("\164\150\145\x6d\x65") ? true : false; goto Ef0ff; cabf6: $host = $request->getHost(); goto a80d7; Ee82b: Dac09: goto d1469; c5019: if (!(false === is_null($instanceUid))) { goto C3346; } goto fd7cf; b2483: if ($event instanceof RequestEvent) { goto D5ed4; } goto Aaf21; b5f75: $hostname = gethostname(); goto ad97a; F197b: D5ed4: goto Cc6e1; af2f4: C75dd: goto Ff83a; A5d32: $command->setInstance($instance); goto bb049; c48f8: $request->attributes->set("\x69\x6e\x73\164\141\156\143\x65", $instance); goto E96ee; ad97a: $instance->setHostname($hostname); goto b2483; Cc6e1: $request = $event->getRequest(); goto cabf6; d8af9: try { $ipv4PublicIp = $this->cachePool->get("\151\160\166\x34\137\x70\165\x62\154\151\x63\137\x69\x70", function (ItemInterface $item) { goto c2e7d; c2e7d: $item->expiresAfter(3600); goto ad545; a0522: return $ipv4PublicIp; goto bd992; A74f8: $response = $this->retry(function () use($httpClient, $request) { $response = $httpClient->send($request); return $response; }); goto Fb585; da41a: $ipv4PublicIp = trim((string) $response->getBody()); goto bfcb9; fea95: if (!(200 == $responseStatusCode)) { goto a7fe4; } goto da41a; b224a: $config = ["\164\x69\x6d\145\x6f\165\x74" => 5, "\166\x65\162\x69\146\171" => false, "\150\145\x61\144\145\162\x73" => ["\x55\x73\145\x72\55\101\x67\145\156\164" => "\x43\154\157\x75\x64\120\141\156\145\x6c\40\166\62"]]; goto E3e28; bf9b9: $request = new Request("\x47\x45\124", self::IP_REQUEST_URL); goto A74f8; E3e28: $httpClient = new HttpClient($config); goto bf9b9; bfcb9: a7fe4: goto a0522; Fb585: $responseStatusCode = $response->getStatusCode(); goto fea95; ad545: $ipv4PublicIp = null; goto b224a; bd992: }); } catch (\Exception $e) { } goto Bb3d7; Cfa5f: $environment = new CloudPanelEnvironment(); goto A92e8; Aaf21: $command = $event->getCommand(); goto A5d32; Ef0ff: $ipv4PublicIp = $instance->getIpv4PublicIp(); goto A9c26; Bb3d7: $instance->setIpv4PublicIp($ipv4PublicIp); goto a1764; C3fe6: $instance->setEnvironment($environment); goto b5f75; A92e8: switch ($cloud) { case CloudPanelEnvironment::CLOUD_PROVIDER_AWS: goto b2968; B89a6: C4fce: goto E9739; Ae1df: $instance->setInstanceId($instanceId); goto a78e1; e7ccf: $instance->setRegion($region); goto B89a6; A069a: $instanceId = $_ENV["\x44\105\126\137\101\127\123\x5f\x49\116\123\x54\x41\116\103\105\x5f\111\x44"] ?? ''; goto Fc77d; f4d74: $instance = new AwsInstance(); goto e9578; b2968: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_AWS); goto f4d74; a78e1: $instance->setInstanceType("\x74\x33\56\x78\154\141\162\147\145"); goto e7ccf; e9578: if (!("\144\145\166" == $_ENV["\x41\120\x50\137\105\116\x56"])) { goto C4fce; } goto A069a; Fc77d: $region = $_ENV["\104\x45\126\x5f\101\x57\x53\137\x52\x45\107\x49\x4f\116"] ?? ''; goto Ae1df; E9739: goto Dac09; goto F8bf0; F8bf0: case CloudPanelEnvironment::CLOUD_PROVIDER_DO: goto A7136; Eb0d6: $doClient = new DoClient(); goto fe12e; ea1b3: $instance->setDropletId($dropletId); goto Fa037; E8ed7: $region = $_ENV["\104\x45\126\x5f\x44\x4f\x5f\x52\x45\x47\x49\x4f\x4e"] ?? ''; goto ea1b3; F30fd: $instance = new DoInstance($doClient); goto D7b68; Ce67c: $dropletId = $_ENV["\104\x45\x56\x5f\x44\117\x5f\x44\x52\117\x50\114\x45\124\137\111\x44"] ?? ''; goto E8ed7; A7136: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_DO); goto Eb0d6; fe12e: $token = $this->configManager->get("\144\x6f\137\141\x63\143\x65\163\163\x5f\x74\x6f\x6b\145\x6e"); goto dde7f; a6042: $doClient->setToken($token); goto E7799; e8068: goto Dac09; goto e5169; Ac668: E129d: goto e8068; Fa037: $instance->setRegion($region); goto a9ca6; D7b68: $doClient->setInstance($instance); goto fc044; b0e2a: $instance->setIpv4PublicIp("\x31\x32\x37\56\60\x2e\60\x2e\x31"); goto Ac668; dde7f: if (!(false === is_null($token))) { goto fe0d7; } goto a6042; a9ca6: $instance->setFloatingIp("\61\x32\x37\56\60\x2e\x30\x2e\x31"); goto b0e2a; E7799: fe0d7: goto F30fd; fc044: if (!("\x64\x65\x76" == $_ENV["\x41\x50\120\x5f\105\x4e\126"])) { goto E129d; } goto Ce67c; e5169: case CloudPanelEnvironment::CLOUD_PROVIDER_GCE: goto Addf7; D68b2: $instance->setProjectId($projectId); goto A02d6; c75bd: b7ed5: goto E4c91; f89d5: $instance->setZone($zone); goto da518; A02d6: $instance->setInstanceId($instanceId); goto De6bc; B604d: $serviceAccountKeys = $this->configManager->get("\x67\x63\145\x5f\163\x65\162\x76\x69\143\145\137\141\x63\143\157\165\x6e\x74\137\153\x65\x79\x73"); goto F855d; De6bc: $instance->setInstanceName($instanceName); goto aefca; F1536: $instanceId = $_ENV["\x44\105\126\x5f\107\103\105\137\x49\x4e\123\124\101\x4e\103\105\x5f\111\104"] ?? ''; goto C3b60; aefca: $instance->setMachineType($machineType); goto f89d5; Addf7: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_GCE); goto A9bdf; Ca366: $zone = $_ENV["\104\x45\x56\x5f\x47\x43\105\137\132\117\116\x45"] ?? ''; goto Bed31; A9bdf: $gceClient = new GceClient(); goto B604d; B7877: $projectId = $_ENV["\x44\105\x56\137\x47\103\x45\x5f\120\122\117\112\x45\103\124\x5f\x49\x44"] ?? ''; goto F1536; E4c91: $instance = new GceInstance($gceClient); goto a8e8e; fe593: $gceClient->setAuthConfig($serviceAccountKeys); goto c75bd; a8e8e: $gceClient->setGceInstance($instance); goto Db913; f229b: $machineType = $_ENV["\104\105\126\137\x47\x43\105\x5f\x4d\x41\103\110\111\116\x45\137\x54\x59\120\105"] ?? ''; goto Ca366; Dc799: $serviceAccountKeys = (array) json_decode($serviceAccountKeys, true); goto fe593; Ca53f: goto Dac09; goto D53a4; F855d: if (!(false === is_null($serviceAccountKeys))) { goto b7ed5; } goto Dc799; Db913: if (!("\x64\145\x76" == $_ENV["\101\x50\120\x5f\105\x4e\126"])) { goto dfb5b; } goto B7877; Bed31: $instance->setIpv4PublicIp("\x31\62\x37\x2e\60\x2e\60\x2e\61"); goto D68b2; da518: dfb5b: goto Ca53f; C3b60: $instanceName = $_ENV["\x44\x45\x56\137\x47\x43\x45\x5f\111\x4e\123\124\101\x4e\x43\x45\x5f\x4e\x41\115\105"] ?? ''; goto f229b; D53a4: case CloudPanelEnvironment::CLOUD_PROVIDER_HETZNER: goto C7927; d0e15: $instance = new HetznerInstance($hetznerClient); goto Ac064; f6bea: C1621: goto d0e15; C7927: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_HETZNER); goto Add49; c933a: $apiToken = $this->configManager->get("\x68\x65\x74\172\156\x65\162\137\x61\x70\151\x5f\164\x6f\153\145\x6e"); goto bddab; Add49: $hetznerClient = new HetznerClient(); goto c933a; C7227: $instanceId = $_ENV["\104\x45\126\137\110\105\x54\132\x4e\x45\x52\x5f\111\x4e\x53\x54\101\116\103\x45\x5f\x49\104"] ?? ''; goto f79fb; Ac064: $hetznerClient->setInstance($instance); goto b668d; bddab: if (!(false === is_null($apiToken))) { goto C1621; } goto ca1a7; b668d: if (!("\144\x65\166" == $_ENV["\101\x50\x50\137\105\116\126"])) { goto afc09; } goto C7227; f79fb: $instance->setIpv4PublicIp("\61\62\67\56\x30\x2e\60\56\61"); goto Fce29; d567c: afc09: goto C5d1f; Fce29: $instance->setInstanceId($instanceId); goto d567c; C5d1f: goto Dac09; goto e87c6; ca1a7: $hetznerClient->setToken($apiToken); goto f6bea; e87c6: case CloudPanelEnvironment::CLOUD_PROVIDER_VULTR: goto De563; cd2c8: if (!(false === is_null($apiKey))) { goto Fde97; } goto c2e4a; ef9b1: $vultrClient->setVultrInstance($instance); goto ec363; B1aa9: $instance->setInstanceId($instanceId); goto de6ff; B0ee2: Fde97: goto a5249; A0c0c: goto Dac09; goto abf4a; de844: $vultrClient = new VultrClient(); goto c65cc; Cddef: $instanceId = $_ENV["\x44\x45\x56\137\x56\125\114\x54\122\137\111\116\x53\x54\101\116\x43\x45\x5f\111\104"] ?? ''; goto bed12; d597e: $instance->setIpv4PublicIp($ipv4PublicIp); goto B1aa9; de6ff: A86b1: goto A0c0c; ec363: if (!("\x64\x65\x76" == $_ENV["\x41\x50\x50\137\105\116\126"])) { goto A86b1; } goto Cddef; c2e4a: $vultrClient->setApiKey($apiKey); goto B0ee2; c65cc: $apiKey = $this->configManager->get("\x76\165\154\x74\162\x5f\141\160\x69\137\153\145\x79"); goto cd2c8; bed12: $ipv4PublicIp = $_ENV["\104\x45\x56\x5f\126\x55\114\124\x52\137\111\120\x5f\126\x34\137\120\125\102\x4c\x49\x43"] ?? "\61\x32\67\56\60\x2e\60\x2e\x31"; goto d597e; a5249: $instance = new VultrInstance($vultrClient); goto ef9b1; De563: $environment->setCloudProvider(CloudPanelEnvironment::CLOUD_PROVIDER_VULTR); goto de844; abf4a: default: $instance = new Instance(); goto Dac09; } goto c6521; A9c26: if (!(true === empty($ipv4PublicIp))) { goto F420c; } goto c0dea; E96ee: $request->attributes->set("\x69\163\x44\x61\162\x6b\115\x6f\x64\145", $isDarkMode); goto Aaefc; c6521: d08c4: goto Ee82b; Aaefc: $this->twig->addGlobal("\x69\156\163\x74\x61\x6e\x63\145", $instance); goto a368d; a368d: $this->twig->addGlobal("\151\x73\104\x61\162\x6b\x4d\157\x64\x65", $isDarkMode); goto af2f4; fff0d: $cloud = $this->configManager->get("\x63\154\x6f\x75\144"); goto Cfa5f; Ff83a: } private function retry(callable $fn, $retries = 1, $delay = 3) { return Retry::retry($fn, $retries, $delay); } public static function getSubscribedEvents() : array { return [KernelEvents::REQUEST => [["\157\x6e\113\145\162\x6e\x65\x6c\x52\x65\x71\165\x65\163\x74", 25]], ConsoleEvents::COMMAND => [["\x6f\156\103\x6f\156\163\x6f\154\145\x43\x6f\155\155\141\156\144", 25]]]; } }
