<?php
 namespace App\Site\Nginx\Vhost; use App\Site\Site; use App\Site\Nginx\Vhost\Processor\Processor; use App\Site\Nginx\Vhost\Processor\RootDirectory as RootDirectoryProcessor; use App\Site\Nginx\Vhost\Processor\ServerName as ServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectServerName as RedirectServerNameProcessor; use App\Site\Nginx\Vhost\Processor\RedirectDomain as RedirectDomainProcessor; use App\Site\Nginx\Vhost\Processor\NginxAccessLog as NginxAccessLogProcessor; use App\Site\Nginx\Vhost\Processor\NginxErrorLog as NginxErrorLogProcessor; use App\Site\Nginx\Vhost\Processor\SslCertificateKey as NginxCertificateKeyProcessor; use App\Site\Nginx\Vhost\Processor\SslCertificate as NginxCertificateProcessor; use App\Site\Nginx\Vhost\Processor\Settings as SettingsProcessor; class Template { protected Site $site; protected ?string $content = null; protected array $placeholders = []; protected array $processors = []; public function __construct(Site $site) { $this->site = $site; $this->init(); } protected function init() : void { goto Fb900; a3b39: $this->addProcessor($settingsProcessor); goto D0da2; f5ea8: $nginxAccessLogProcessor = new NginxAccessLogProcessor(); goto B4265; Fba3f: $settingsProcessor = new SettingsProcessor(); goto A39c6; D63f3: $certificateProcessor = new NginxCertificateProcessor(); goto Fba3f; d53a0: $this->addProcessor($redirectServerNameProcessor); goto cc020; Bea86: $redirectServerNameProcessor = new RedirectServerNameProcessor(); goto ca15a; B4265: $nginxErrorLogProcessor = new NginxErrorLogProcessor(); goto A854d; C4f54: $this->addProcessor($serverNameProcessor); goto d53a0; aac36: $serverNameProcessor = new ServerNameProcessor(); goto Bea86; E0ef8: $this->addProcessor($certificateKeyProcessor); goto E2563; ab78e: $this->addProcessor($nginxAccessLogProcessor); goto ba1cc; E2563: $this->addProcessor($certificateProcessor); goto a3b39; Fb900: $rootDirectoryProcessor = new RootDirectoryProcessor(); goto aac36; A854d: $certificateKeyProcessor = new NginxCertificateKeyProcessor(); goto D63f3; A39c6: $this->addProcessor($rootDirectoryProcessor); goto C4f54; ba1cc: $this->addProcessor($nginxErrorLogProcessor); goto E0ef8; cc020: $this->addProcessor($redirectDomainProcessor); goto ab78e; ca15a: $redirectDomainProcessor = new RedirectDomainProcessor(); goto f5ea8; D0da2: } public function getSite() : Site { return $this->site; } public function setContent(string $content) : void { $this->content = $content; } public function getContent() : ?string { return $this->content; } public function build() : void { goto Fa5ce; a9d7e: $placeholders = $this->getPlaceholders(); goto dcf0b; Fa5ce: $processors = $this->getProcessors(); goto a9d7e; dcf0b: foreach ($placeholders as $placeholder) { goto Cb689; Fa8a6: $processor = $processors[$placeholder]; goto F7a92; A4f57: $this->removePlaceholder($placeholder); goto b769d; B238b: $this->content = $processor->process($this->content); goto A4f57; F7a92: $processor->setSite($this->site); goto B238b; Ffbb3: if (!(true === $hasProcessor)) { goto afa76; } goto Fa8a6; Cb689: $hasProcessor = $this->hasProcessor($placeholder); goto Ffbb3; b769d: afa76: goto E3c42; E3c42: Bfd66: goto dbf68; dbf68: } goto d7990; d7990: dafd3: goto Efa74; Efa74: } public function removeEmptyPlaceholders() : void { goto dd12a; ee74c: foreach ($placeholders as $placeholder) { $this->content = str_replace($placeholder, '', $this->content); Bae1d: } goto f4079; f4079: B729f: goto a6ae5; dd12a: $placeholders = $this->getPlaceholders(); goto ee74c; a6ae5: } protected function hasProcessor(string $placeholder) : bool { return isset($this->processors[$placeholder]); } protected function getProcessors() : array { return $this->processors; } public function addProcessor(Processor $processor) : void { $this->processors[$processor->getPlaceholder()] = $processor; } public function resetProcessors() : void { $this->processors = []; } public function getPlaceholders() : array { goto cb76c; Ee164: E6759: goto f4a39; D34ef: if (!(true === isset($placeholders[0]) && count($placeholders[0]))) { goto E6759; } goto c5d86; cb76c: if (!(true === empty($this->placeholders))) { goto f6d58; } goto b38a8; f4a39: f6d58: goto B95c9; C03af: a9c80: goto Ee164; b38a8: preg_match_all("\57\x5b\x7b\173\x5d\173\x32\x7d\50\133\134\x73\141\x2d\172\x41\x2d\x5a\x30\55\71\137\x5d\53\x29\133\x7d\x7d\x5d\x7b\62\175\57", $this->content, $placeholders); goto D34ef; c5d86: $placeholders = $placeholders[0]; goto e986e; B95c9: return $this->placeholders; goto e5d37; e986e: foreach ($placeholders as $placeholder) { goto d34f0; E60ca: $this->addPlaceholder($placeholder); goto edf41; d34f0: $placeholder = trim($placeholder); goto ce6cf; F5b1f: B5377: goto c3884; ce6cf: if (!(false === empty($placeholder))) { goto Fc3eb; } goto E60ca; edf41: Fc3eb: goto F5b1f; c3884: } goto C03af; e5d37: } private function addPlaceholder(string $placeholder) : void { $this->placeholders[$placeholder] = $placeholder; } private function removePlaceholder(string $placeholder) : void { goto B21a7; E2016: unset($this->placeholders[$placeholder]); goto Df5b6; Df5b6: e7a1f: goto B239a; B21a7: if (!(true === isset($this->placeholders[$placeholder]))) { goto e7a1f; } goto E2016; B239a: } }
