<?php
 namespace App\Site; use App\System\Command\CopyFileCommand; use App\System\Command\DeleteFileCommand; use App\System\Command\NginxConfigTestCommand; use App\System\CommandExecutor; use App\System\Command\ChownCommand; use App\System\Command\ChmodCommand; use App\System\Command\FindChmodCommand; use App\System\Command\WriteFileCommand; use App\System\Command\CreateDirectoryCommand; use App\System\Command\DeleteDirectoryCommand; use App\System\Command\ChangeUserHomeDirectoryCommand; use App\System\Command\CreateUserCommand; use App\System\Command\DeleteUserCommand; use App\System\Command\ChangeUserPasswordCommand; use App\System\Command\CreateSymlinkCommand; use App\System\Command\ServiceReloadCommand; use App\Entity\BasicAuth as BasicAuthEntity; use App\Entity\Certificate as CertificateEntity; use App\Entity\FtpUser as FtpUserEntity; use App\Entity\SshUser as SshUserEntity; use App\Entity\Site as SiteEntity; use App\Site\Ssl\LetsEncrypt\CertificateOrder; use App\Site\Nginx\Exception\InvalidVhostException; use App\Site\Nginx\Vhost\StaticTemplate; use App\Site\Nginx\Vhost\NodejsTemplate; use App\Site\Nginx\Vhost\PhpTemplate; use App\Site\Nginx\Vhost\PythonTemplate; use App\Site\Nginx\Vhost\ReverseProxyTemplate; abstract class Updater { public const NGINX_BASIC_AUTH_DIRECTORY = "\57\145\x74\143\x2f\156\x67\151\156\170\x2f\142\141\163\x69\143\55\141\165\164\x68\x2f"; public const NGINX_VHOST_DIRECTORY = "\x2f\145\164\x63\57\x6e\147\151\156\x78\57\x73\x69\164\145\x73\55\145\156\x61\142\154\x65\x64\x2f"; public const NGINX_SSL_CERTIFICATES_DIRECTORY = "\x2f\x65\164\x63\57\x6e\x67\151\x6e\170\57\x73\x73\154\55\x63\145\162\x74\x69\146\x69\143\141\x74\x65\163\x2f"; public const CRON_DIRECTORY = "\x2f\145\164\143\x2f\143\162\x6f\x6e\x2e\144\x2f"; protected Site $site; protected CommandExecutor $commandExecutor; public function __construct(Site $site) { $this->site = $site; $this->commandExecutor = new CommandExecutor(); } public function domainSettings() : void { $this->updateNginxVhost(); $this->reloadNginxService(); } public function updateNginxVhost() : void { goto Fd990; c2fe1: $writeVhostFileCommand->setFile($vhostFile); goto b3000; Fd990: $domainName = $this->site->getDomainName(); goto ffc31; b3000: $writeVhostFileCommand->setContent($vhostContent); goto f062d; cb59c: $vhostTemplate->build(); goto a2b01; c1dbb: b800e: goto E6556; a2b01: $vhostTemplate->removeEmptyPlaceholders(); goto Fde84; E6556: Eadb9: goto E9803; f062d: $this->commandExecutor->execute($writeVhostFileCommand); goto c191e; e821c: switch ($this->site->getType()) { case SiteEntity::TYPE_PHP: $vhostTemplate = new PhpTemplate($this->site); goto Eadb9; case SiteEntity::TYPE_NODEJS: $vhostTemplate = new NodejsTemplate($this->site); goto Eadb9; case SiteEntity::TYPE_STATIC: $vhostTemplate = new StaticTemplate($this->site); goto Eadb9; case SiteEntity::TYPE_PYTHON: $vhostTemplate = new PythonTemplate($this->site); goto Eadb9; case SiteEntity::TYPE_REVERSE_PROXY: $vhostTemplate = new ReverseProxyTemplate($this->site); goto Eadb9; } goto c1dbb; E9803: $vhostTemplate->setContent($vhostFileContent); goto c76e9; A5848: $writeVhostFileCommand = new WriteFileCommand(); goto c2fe1; Fde84: $vhostContent = $vhostTemplate->getContent(); goto A5848; ffc31: $vhostFileContent = $this->site->getVhostTemplate(); goto e821c; c76e9: $vhostFile = sprintf("\x25\163\x2f\45\163\x2e\143\157\x6e\x66", rtrim(self::NGINX_VHOST_DIRECTORY, "\57"), $domainName); goto cb59c; c191e: } public function updateNginxVhostWithRollback() : void { try { goto ee917; C7153: $this->commandExecutor->execute($writeVhostFileCommand); goto Cd83d; de9fd: aab70: goto B9e27; d17de: $vhostFileContent = $this->site->getVhostTemplate(); goto A6a16; C68b7: $vhostTemplate->build(); goto Ffa46; E6e31: $deleteVhostBackupFileCommand = new DeleteFileCommand(); goto Ffe6d; E58ab: $writeVhostFileCommand->setFile($vhostFile); goto F1440; F607e: if (!("\x64\x65\x76" != $_ENV["\x41\120\x50\137\105\x4e\126"])) { goto F7ac0; } goto f6f05; E5556: $this->commandExecutor->execute($deleteVhostBackupFileCommand); goto C96b5; c35ed: $copyVhostBackupFileCommand = new CopyFileCommand(); goto db795; A1016: $vhostBackupFile = sprintf("\x25\163\x2f\x25\163\x2e\143\157\156\146\x2e\142\141\x6b", rtrim(self::NGINX_VHOST_DIRECTORY, "\x2f"), $domainName); goto c35ed; e71e1: D7f30: goto de9fd; f6f05: $reloadNginxServiceCommand = new ServiceReloadCommand(); goto Fa026; f96fe: $nginxConfigTestCommand = new NginxConfigTestCommand(); goto E6e31; db795: $copyVhostBackupFileCommand->setSourceFile($vhostFile); goto B69f2; F1440: $writeVhostFileCommand->setContent($vhostContent); goto f96fe; Cd83d: $this->commandExecutor->execute($nginxConfigTestCommand); goto F607e; A0a17: F7ac0: goto E5556; A6a16: switch ($this->site->getType()) { case SiteEntity::TYPE_PHP: $vhostTemplate = new PhpTemplate($this->site); goto aab70; case SiteEntity::TYPE_NODEJS: $vhostTemplate = new NodejsTemplate($this->site); goto aab70; case SiteEntity::TYPE_STATIC: $vhostTemplate = new StaticTemplate($this->site); goto aab70; case SiteEntity::TYPE_PYTHON: $vhostTemplate = new PythonTemplate($this->site); goto aab70; case SiteEntity::TYPE_REVERSE_PROXY: $vhostTemplate = new ReverseProxyTemplate($this->site); goto aab70; } goto e71e1; B69f2: $copyVhostBackupFileCommand->setDestinationFile($vhostBackupFile); goto Ece12; Ece12: $writeVhostFileCommand = new WriteFileCommand(); goto E58ab; Ffa46: $vhostTemplate->removeEmptyPlaceholders(); goto b584c; f5492: $vhostFile = sprintf("\x25\163\57\x25\163\x2e\143\x6f\156\x66", rtrim(self::NGINX_VHOST_DIRECTORY, "\57"), $domainName); goto C68b7; b584c: $vhostContent = $vhostTemplate->getContent(); goto A1016; B9e27: $vhostTemplate->setContent($vhostFileContent); goto f5492; Ffe6d: $deleteVhostBackupFileCommand->setFile($vhostBackupFile); goto dab20; ee917: $domainName = $this->site->getDomainName(); goto d17de; dab20: $this->commandExecutor->execute($copyVhostBackupFileCommand); goto C7153; Fa026: $reloadNginxServiceCommand->setServiceName("\x6e\x67\x69\x6e\170"); goto cec4d; cec4d: $this->commandExecutor->execute($reloadNginxServiceCommand); goto A0a17; C96b5: } catch (\Exception $e) { goto ed7e5; c02be: $this->commandExecutor->execute($restoreBackupFileCommand); goto ac30f; B9f1e: $restoreBackupFileCommand->setDestinationFile($vhostFile); goto c02be; da672: $errorMessage = $nginxConfigTestCommand->getOutput(); goto b4d8d; c85d1: $restoreBackupFileCommand->setSourceFile($vhostBackupFile); goto B9f1e; db9ff: c527b: goto ea2aa; d4df0: if (!(true === isset($nginxConfigTestCommand))) { goto D09f4; } goto da672; ac30f: if (!(true === isset($reloadNginxServiceCommand))) { goto c527b; } goto da8bf; da8bf: $this->commandExecutor->execute($reloadNginxServiceCommand); goto db9ff; b4d8d: D09f4: goto ee376; ed7e5: $errorMessage = $e->getMessage(); goto d4df0; ee376: $restoreBackupFileCommand = new CopyFileCommand(); goto c85d1; ea2aa: $this->commandExecutor->execute($deleteVhostBackupFileCommand); goto cadc6; cadc6: throw new InvalidVhostException($errorMessage); goto ac82e; ac82e: } } public function createSshUser(SshUserEntity $sshUserEntity) : void { goto dde88; Ea88c: $createUserCommand->setHomeDirectory($homeDirectory); goto D11c2; Bb969: $this->commandExecutor->execute($changeSiteUserHomeDirectoryPermissionsCommand); goto E3828; dde88: $site = $sshUserEntity->getSite(); goto Bd2b1; ccc4d: $changeSiteUserHomeDirectoryPermissionsCommand->setFile($siteUserHomeDirectory); goto C2157; Ea4c7: $this->commandExecutor->execute($createUserCommand); goto Cbffd; Bc1a9: $createUserCommand->setUserName($sshUserName); goto Fcf9c; C2157: $changeSiteUserHomeDirectoryPermissionsCommand->setRecursive(false); goto da415; Fcf9c: $createUserCommand->setPassword($sshUserPassword); goto C62ad; ee845: $skeletonDirectory = realpath(dirname(__FILE__) . "\57\x2e\x2e\57\x2e\x2e\57\162\145\163\x6f\165\162\x63\x65\163\x2f\145\x74\143\57\x73\153\145\x6c\x2f\163\163\x68\55\x75\163\x65\162\57"); goto Da691; A9dbc: $sshUserPassword = $sshUserEntity->getPassword(); goto db295; D151a: $siteUserHomeDirectory = sprintf("\57\x68\157\x6d\x65\57\x25\x73", $siteUser); goto d069e; da415: $changeSiteUserHomeDirectoryPermissionsCommand->setChmod(750); goto D353f; Cbffd: $symlinkDirectories = ["\x62\141\x63\153\x75\x70\163", "\150\x74\x64\x6f\x63\163", "\154\157\147\163"]; goto b4226; Db0c8: $sshDirectoryChmodCommand = new FindChmodCommand(); goto B06fb; db295: $homeDirectory = sprintf("\x2f\150\x6f\x6d\x65\x2f\x25\x73", $sshUserName); goto ee845; Fefcb: $sshDirectoryChmodCommand->setDirectoryChmod(700); goto A863f; c9a09: $createUserCommand->setSkeletonDirectory($skeletonDirectory); goto Ea88c; B06fb: $sshDirectoryChmodCommand->setFile($sshDirectory); goto Fefcb; b4226: foreach ($symlinkDirectories as $symlinkDirectory) { goto baae3; d570a: $destination = sprintf("\x2f\x68\x6f\155\x65\x2f\x25\163\57\45\x73", $sshUserName, $symlinkDirectory); goto f15f9; ef263: $symlinkCommand->setSource($source); goto eb8b1; f15f9: $symlinkCommand = new CreateSymlinkCommand(); goto B25b8; eb8b1: $symlinkCommand->setDestination($destination); goto A43d3; D116f: $this->commandExecutor->execute($symlinkCommand); goto A14e8; baae3: $source = sprintf("\57\150\157\155\x65\57\x25\x73\57\x25\163", $siteUser, $symlinkDirectory); goto d570a; A14e8: c493e: goto d0ffa; B25b8: $symlinkCommand->setRunAsUser($sshUserName); goto ef263; A43d3: if (!("\x64\x65\166" != $_ENV["\x41\120\x50\x5f\x45\116\x56"])) { goto c493e; } goto D116f; d0ffa: b6603: goto C1fc4; C1fc4: } goto B0aa0; d4a72: $sshUserName = $sshUserEntity->getUserName(); goto A9dbc; C62ad: $createUserCommand->setGroup($siteUser); goto A58f6; D11c2: $createUserCommand->createHomeDirectory(true); goto Ea4c7; D353f: $this->commandExecutor->execute($sshDirectoryChmodCommand); goto Bb969; Ac466: $sshDirectory = sprintf("\x2f\x68\x6f\x6d\145\x2f\45\x73\57\56\163\x73\150", $sshUserName); goto Db0c8; A863f: $sshDirectoryChmodCommand->setFileChmod(600); goto D151a; Da691: $createUserCommand = new CreateUserCommand(); goto Bc1a9; B0aa0: e4ef6: goto Ac466; d069e: $changeSiteUserHomeDirectoryPermissionsCommand = new ChmodCommand(); goto ccc4d; A58f6: $createUserCommand->setShell("\x2f\x62\151\156\x2f\x62\x61\x73\x68"); goto c9a09; Bd2b1: $siteUser = $site->getUser(); goto d4a72; E3828: } public function createFtpUser(FtpUserEntity $ftpUserEntity) : void { goto C1332; C1332: $site = $ftpUserEntity->getSite(); goto C2401; D0027: $createUserCommand->setGroups(["\x66\164\160\55\x75\163\x65\x72"]); goto B78a3; Aeec7: $changeSiteUserHomeDirectoryPermissionsCommand->setFile($siteUserHomeDirectory); goto Be9ae; C2401: $siteUser = $site->getUser(); goto e0ee6; E4ccb: $this->commandExecutor->execute($changeSiteUserHomeDirectoryPermissionsCommand); goto A8d56; Be9ae: $changeSiteUserHomeDirectoryPermissionsCommand->setRecursive(false); goto b4537; Ff85a: $createUserCommand->setGroup($siteUser); goto D0027; e0ee6: $ftpUserName = $ftpUserEntity->getUserName(); goto d6a42; Cdf9a: $this->commandExecutor->execute($createUserCommand); goto E4ccb; ea19f: $createUserCommand->createHomeDirectory(false); goto a390e; Cefa9: $createUserCommand->setHomeDirectory($homeDirectory); goto ea19f; E19fd: $homeDirectory = $ftpUserEntity->getHomeDirectory(); goto A933c; d6a42: $ftpUserPassword = $ftpUserEntity->getPassword(); goto E19fd; Ede12: $createUserCommand->setUserName($ftpUserName); goto C1997; b4537: $changeSiteUserHomeDirectoryPermissionsCommand->setChmod(750); goto Cdf9a; fdfe5: $changeSiteUserHomeDirectoryPermissionsCommand = new ChmodCommand(); goto Aeec7; C1997: $createUserCommand->setPassword($ftpUserPassword); goto Ff85a; A933c: $createUserCommand = new CreateUserCommand(); goto Ede12; a390e: $siteUserHomeDirectory = sprintf("\57\150\157\155\x65\57\x25\x73", $siteUser); goto fdfe5; B78a3: $createUserCommand->setShell("\x2f\142\x69\x6e\57\x66\x61\x6c\x73\x65"); goto Cefa9; A8d56: } public function deleteUser(string $userName, $removeHomeDirectory = true) : void { goto F8b42; E585e: $deleteUserCommand->setUserName($userName); goto e2278; e2278: $deleteUserCommand->setRemoveHomeDirectory($removeHomeDirectory); goto F99a1; F8b42: $deleteUserCommand = new DeleteUserCommand(); goto E585e; F99a1: $this->commandExecutor->execute($deleteUserCommand); goto e38ec; e38ec: } public function installCertificate(CertificateEntity $certificateEntity) : void { goto bba3b; Ff7c0: $certificate .= sprintf("\x25\x73\x25\163", PHP_EOL, trim($certificateEntity->getCertificateChain())); goto A07c9; ccff3: $certificate = $certificateEntity->getCertificate(); goto c64db; Effe6: $writeCertificateFileCommand = new WriteFileCommand(); goto F3364; F3364: $writeCertificateFileCommand->setFile($certificateFile); goto E10e2; c64db: if (!(false === empty($certificateEntity->getCertificateChain()))) { goto c84bf; } goto Ff7c0; Bad44: $this->commandExecutor->execute($writeCertificateFileCommand); goto d04b6; E10e2: $writeCertificateFileCommand->setContent($certificate); goto E34c6; A5163: $writePrivateKeyFileCommand = new WriteFileCommand(); goto e6a74; A07c9: c84bf: goto A5163; E34c6: $this->commandExecutor->execute($writePrivateKeyFileCommand); goto Bad44; d04b6: $this->reloadService("\x6e\x67\151\156\x78"); goto Aaabe; Efc50: $privateKeyFile = sprintf("\45\163\57\45\163\x2e\x6b\145\x79", rtrim(self::NGINX_SSL_CERTIFICATES_DIRECTORY, "\57"), $domainName); goto F96e4; e6a74: $writePrivateKeyFileCommand->setFile($privateKeyFile); goto cdeed; F96e4: $certificateFile = sprintf("\x25\163\57\x25\163\56\x63\162\x74", rtrim(self::NGINX_SSL_CERTIFICATES_DIRECTORY, "\57"), $domainName); goto ccff3; bba3b: $domainName = $this->site->getDomainName(); goto Efc50; cdeed: $writePrivateKeyFileCommand->setContent($certificateEntity->getPrivateKey()); goto Effe6; Aaabe: } public function deleteLetsEncryptChallengeDirectory() : void { goto Ef2f8; C65a4: $deleteAcmeChallengeDirectoryCommand->setDirectory($acemeChallengeDirectory); goto C68eb; eb7b9: $acemeChallengeDirectory = sprintf("\x25\x73\x2f\x2e\x77\145\x6c\154\x2d\x6b\156\x6f\x77\156\57\141\x63\155\x65\x2d\143\150\141\x6c\x6c\x65\x6e\147\145\x2f", rtrim($rootDirectory, "\57")); goto ac3c4; Ef2f8: $rootDirectory = $this->getRootDirectory(); goto eb7b9; ac3c4: $deleteAcmeChallengeDirectoryCommand = new DeleteDirectoryCommand(); goto C65a4; C68eb: $this->commandExecutor->execute($deleteAcmeChallengeDirectoryCommand); goto E5106; E5106: } public function createBasicAuthFile(BasicAuthEntity $basicAuthEntity) : void { goto Ec481; F0edd: $writeBasicAuthFileCommand->setContent($basicAuthFileContent); goto B2470; C3926: $writeBasicAuthFileCommand->setFile($basicAuthFile); goto F0edd; B2470: $this->commandExecutor->execute($writeBasicAuthFileCommand); goto F0e5d; e1f66: $basicAuthFileContent = sprintf("\45\x73\72\x25\163", $basicAuthEntity->getUserName(), crypt($basicAuthEntity->getPassword(), base64_encode($basicAuthEntity->getPassword()))); goto D5b91; Ec481: $basicAuthFile = sprintf("\45\x73\x2f\45\x73", rtrim(self::NGINX_BASIC_AUTH_DIRECTORY, "\57"), $this->site->getDomainName()); goto e1f66; D5b91: $writeBasicAuthFileCommand = new WriteFileCommand(); goto C3926; F0e5d: } public function createLetsEncryptChallengeFiles(CertificateOrder $certificateOrder) : void { goto Dda9c; c1be3: $this->commandExecutor->execute($chownWellKnownDirectoryCommandCommand); goto c7b29; D88e5: foreach ($challenges as $challenge) { goto D5139; b479a: Dda37: goto aabd9; acd03: $challengeWriteFileCommand->setContent($verificationContent); goto E318f; a3fe2: $challengeWriteFileCommand = new WriteFileCommand(); goto f19e3; D5139: $token = $challenge["\x74\157\153\145\156"] ?? null; goto ae199; f19e3: $challengeWriteFileCommand->setFile($challengeFile); goto acd03; E318f: $this->commandExecutor->execute($challengeWriteFileCommand); goto be1c9; ae199: $verificationContent = $challenge["\x76\145\x72\x69\146\x69\x63\x61\x74\151\x6f\x6e\x43\x6f\x6e\164\145\x6e\x74"] ?? null; goto ef83e; be1c9: c687a: goto b479a; ef83e: if (!(false === is_null($token) && false === is_null($verificationContent))) { goto c687a; } goto A5c16; A5c16: $challengeFile = sprintf("\45\x73\57\x25\163", rtrim($acemeChallengeDirectory, "\57"), $token); goto a3fe2; aabd9: } goto a92f1; Fe402: $chmodWellKnownDirectoryCommand = new FindChmodCommand(); goto a41a3; ba1f9: $chownWellKnownDirectoryCommandCommand->setFile($wellKnownDirectory); goto d77ce; a41a3: $chmodWellKnownDirectoryCommand->setFile($wellKnownDirectory); goto F57ba; b9307: if (!count($challenges)) { goto Df05a; } goto D88e5; a92f1: bebbb: goto a3016; a3016: Df05a: goto Ba1b9; Ba1b9: $chownWellKnownDirectoryCommandCommand = new ChownCommand(); goto ba1f9; a0926: $challenges = $certificateOrder->getAuthorizationsChallenges(); goto e9f26; e9f26: $createAcmeChallengeDirectoryCommand = new CreateDirectoryCommand(); goto f29ff; d77ce: $chownWellKnownDirectoryCommandCommand->setRecursive(true); goto F09bf; c7b29: $this->commandExecutor->execute($chmodWellKnownDirectoryCommand); goto dd83e; Dda9c: $siteUser = $this->site->getUser(); goto bf5c8; D64d3: $chmodWellKnownDirectoryCommand->setFileChmod(770); goto c1be3; A5a8f: $acemeChallengeDirectory = sprintf("\x25\x73\x2f\56\x77\145\154\154\55\x6b\x6e\157\167\156\x2f\141\x63\155\x65\55\143\150\141\x6c\154\145\156\x67\x65\x2f", rtrim($rootDirectory, "\57")); goto a0926; f29ff: $createAcmeChallengeDirectoryCommand->setDirectory($acemeChallengeDirectory); goto F4b23; bf5c8: $rootDirectory = $this->getRootDirectory(); goto E3cfe; Babec: $chownWellKnownDirectoryCommandCommand->setGroup($siteUser); goto Fe402; F09bf: $chownWellKnownDirectoryCommandCommand->setUser($siteUser); goto Babec; F57ba: $chmodWellKnownDirectoryCommand->setDirectoryChmod(750); goto D64d3; F4b23: $this->commandExecutor->execute($createAcmeChallengeDirectoryCommand); goto b9307; E3cfe: $wellKnownDirectory = sprintf("\45\163\x2f\x2e\167\145\154\154\x2d\x6b\156\157\167\156\x2f", rtrim($rootDirectory, "\x2f")); goto A5a8f; dd83e: } public function updateUserCrontab() : void { goto ec1eb; c8afd: $writeCrontabFileCommand->setFile($crontabFile); goto F88c4; eaecc: $crontabFile = sprintf("\45\163\x2f\x25\163", rtrim(self::CRON_DIRECTORY, "\57"), $siteUser); goto E62d1; F2c1e: $this->commandExecutor->execute($writeCrontabFileCommand); goto E9815; d76a4: $writeCrontabFileCommand = new WriteFileCommand(); goto c8afd; f6bf8: $crontabContent = implode(PHP_EOL, $crontabEntries); goto d76a4; F88c4: $writeCrontabFileCommand->setContent($crontabContent); goto F2c1e; D3140: foreach ($cronJobs as $cronJob) { $crontabEntries[] = $cronJob->getCrontabExpression(); b765a: } goto F5199; F5199: E102d: goto Fbaba; E62d1: $crontabEntries = ["\x4d\101\111\x4c\x54\117\x3d\42\x22"]; goto cf1d4; cf1d4: $cronJobs = $this->site->getCronJobs(); goto Beb9e; ec1eb: $siteUser = $this->site->getUser(); goto eaecc; Beb9e: if (!count($cronJobs)) { goto A0b88; } goto D3140; Fbaba: A0b88: goto f6bf8; E9815: } public function purgePageSpeedCache() : void { goto f7208; D3031: $purgePageSpeedCacheFilesCommand = new DeleteDirectoryCommand(); goto c4435; a0f16: $this->commandExecutor->execute($purgePageSpeedCacheFilesCommand, 300); goto b4473; f7208: $siteUser = $this->site->getUser(); goto eee16; eee16: $cacheDirectory = sprintf("\x2f\x68\x6f\155\145\x2f\45\163\x2f\x74\x6d\x70\x2f\160\x61\x67\x65\x73\160\x65\145\144\137\143\x61\x63\150\x65", $siteUser); goto D3031; c4435: $purgePageSpeedCacheFilesCommand->setDirectory($cacheDirectory); goto a0f16; b4473: } public function updateUserSShKeys(string $userName, $sshKeys) : void { goto Cea3d; Cea3d: $authorizedKeysFile = sprintf("\57\x68\157\x6d\x65\57\x25\163\57\x2e\x73\163\150\x2f\141\165\164\150\157\162\151\172\145\144\x5f\153\x65\x79\163", $userName); goto D5bf8; a31bd: $writeAuthorizedKeysFileCommand->setFile($authorizedKeysFile); goto ede3b; ede3b: $writeAuthorizedKeysFileCommand->setContent($sshKeys); goto bc0a3; D5bf8: $writeAuthorizedKeysFileCommand = new WriteFileCommand(); goto a31bd; bc0a3: $this->commandExecutor->execute($writeAuthorizedKeysFileCommand); goto a6c9c; a6c9c: } public function changeUserHomeDirectory(string $userName, string $homeDirectory) : void { goto A4552; E127c: $changeUserHomeDirectoryCommand->setHomeDirectory($homeDirectory); goto e5402; A1083: $changeUserHomeDirectoryCommand->setUserName($userName); goto E127c; A4552: $changeUserHomeDirectoryCommand = new ChangeUserHomeDirectoryCommand(); goto A1083; e5402: $this->commandExecutor->execute($changeUserHomeDirectoryCommand); goto b044c; b044c: } public function changeUserPassword(string $userName, string $password) : void { goto ea3f9; f7170: $changeUserPasswordCommand->setUserName($userName); goto cece5; ea3f9: $changeUserPasswordCommand = new ChangeUserPasswordCommand(); goto f7170; cece5: $changeUserPasswordCommand->setPassword($password); goto a043f; a043f: $this->commandExecutor->execute($changeUserPasswordCommand); goto bdc60; bdc60: } protected function getRootDirectory() : string { goto c60d1; f37e8: return $rootDirectory; goto F0063; b037b: $rootDirectory = $this->site->getRootDirectory(); goto c1246; c1246: $rootDirectory = sprintf("\57\x68\x6f\155\x65\57\45\163\57\150\164\x64\157\x63\163\57\45\163", $siteUser, $rootDirectory); goto f37e8; c60d1: $siteUser = $this->site->getUser(); goto b037b; F0063: } public function reloadNginxService() : void { $this->reloadService("\x6e\147\x69\156\170"); } public function reloadService($serviceName) { goto F3f30; C5613: $reloadServiceCommand->setServiceName($serviceName); goto b47ba; b47ba: $this->commandExecutor->execute($reloadServiceCommand); goto C7968; C7968: Cfe2c: goto a0bff; F3f30: if (!("\144\145\x76" != $_ENV["\101\120\x50\137\105\x4e\126"])) { goto Cfe2c; } goto Ca94c; Ca94c: $reloadServiceCommand = new ServiceReloadCommand(); goto C5613; a0bff: } }
